﻿// C++/WinRT v1.0.171013.2
// Copyright (c) 2017 Microsoft Corporation. All rights reserved.

#pragma once

WINRT_EXPORT namespace winrt::Windows::ApplicationModel::Contacts {

struct Contact;

}

WINRT_EXPORT namespace winrt::Windows::ApplicationModel::DataTransfer {

enum class DataPackageOperation : unsigned;
struct DataPackage;

}

WINRT_EXPORT namespace winrt::Windows::ApplicationModel::Search {

struct LocalContentSuggestionSettings;
struct SearchQueryLinguisticDetails;
struct SearchSuggestionsRequest;

}

WINRT_EXPORT namespace winrt::Windows::Foundation {

struct Uri;

}

WINRT_EXPORT namespace winrt::Windows::Foundation::Collections {

struct IPropertySet;

}

WINRT_EXPORT namespace winrt::Windows::Globalization {

enum class DayOfWeek;

}

WINRT_EXPORT namespace winrt::Windows::Media::Capture {

struct MediaCapture;

}

WINRT_EXPORT namespace winrt::Windows::Media::Casting {

struct CastingSource;

}

WINRT_EXPORT namespace winrt::Windows::Media::Core {

struct IMediaSource;

}

WINRT_EXPORT namespace winrt::Windows::Media::PlayTo {

struct PlayToSource;

}

WINRT_EXPORT namespace winrt::Windows::Media::Playback {

struct IMediaPlaybackSource;
struct MediaPlayer;

}

WINRT_EXPORT namespace winrt::Windows::Media::Protection {

struct MediaProtectionManager;

}

WINRT_EXPORT namespace winrt::Windows::Storage::Streams {

struct IRandomAccessStream;

}

WINRT_EXPORT namespace winrt::Windows::System {

enum class VirtualKeyModifiers : unsigned;

}

WINRT_EXPORT namespace winrt::Windows::UI {

struct Color;

}

WINRT_EXPORT namespace winrt::Windows::UI::Composition {

struct CompositionBrush;

}

WINRT_EXPORT namespace winrt::Windows::UI::Core {

enum class CoreInputDeviceTypes : unsigned;
struct CoreIndependentInputSource;

}

WINRT_EXPORT namespace winrt::Windows::UI::Input::Inking {

struct InkDrawingAttributes;
struct InkPresenter;
struct InkPresenterProtractor;
struct InkPresenterRuler;

}

WINRT_EXPORT namespace winrt::Windows::UI::Text {

enum class FontStretch;
enum class FontStyle;
enum class TextDecorations : unsigned;
struct FontWeight;
struct ITextDocument;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml {

enum class ElementSoundMode;
enum class FocusState;
enum class HorizontalAlignment;
enum class LineStackingStrategy;
enum class OpticalMarginAlignment;
enum class TextAlignment;
enum class TextLineBounds;
enum class TextReadingOrder;
enum class TextTrimming;
enum class TextWrapping;
enum class VerticalAlignment;
enum class Visibility;
struct CornerRadius;
struct DataTemplate;
struct DependencyObject;
struct DependencyObjectCollection;
struct DependencyProperty;
struct DependencyPropertyChangedEventHandler;
struct DragEventArgs;
struct Duration;
struct ExceptionRoutedEventHandler;
struct FrameworkElement;
struct GridLength;
struct RoutedEventArgs;
struct RoutedEventHandler;
struct Style;
struct Thickness;
struct UIElement;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Controls::Primitives {

enum class GeneratorDirection;
enum class GroupHeaderPlacement;
enum class PlacementMode;
enum class SliderSnapsTo;
enum class SnapPointsAlignment;
enum class TickPlacement;
struct AppBarTemplateSettings;
struct CalendarViewTemplateSettings;
struct ComboBoxTemplateSettings;
struct CommandBarTemplateSettings;
struct FlyoutBase;
struct GeneratorPosition;
struct GridViewItemTemplateSettings;
struct ItemsChangedEventArgs;
struct ItemsChangedEventHandler;
struct ListViewItemTemplateSettings;
struct MenuFlyoutPresenterTemplateSettings;
struct ProgressBarTemplateSettings;
struct ProgressRingTemplateSettings;
struct SelectorItem;
struct SettingsFlyoutTemplateSettings;
struct SplitViewTemplateSettings;
struct ToggleSwitchTemplateSettings;
struct ToolTipTemplateSettings;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Data {

struct ICustomProperty;
struct IValueConverter;
struct ItemIndexRange;
struct LoadMoreItemsResult;
struct PropertyChangedEventHandler;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Documents {

struct BlockCollection;
struct InlineCollection;
struct TextHighlighter;
struct TextPointer;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Input {

enum class KeyboardNavigationMode;
struct CharacterReceivedRoutedEventArgs;
struct DoubleTappedRoutedEventArgs;
struct HoldingRoutedEventArgs;
struct ICommand;
struct InputScope;
struct KeyRoutedEventArgs;
struct ManipulationCompletedRoutedEventArgs;
struct ManipulationDeltaRoutedEventArgs;
struct ManipulationInertiaStartingRoutedEventArgs;
struct ManipulationStartedRoutedEventArgs;
struct ManipulationStartingRoutedEventArgs;
struct PointerRoutedEventArgs;
struct RightTappedRoutedEventArgs;
struct TappedRoutedEventArgs;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Interop {

struct TypeName;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Media {

enum class AudioCategory;
enum class AudioDeviceType;
enum class FastPlayFallbackBehaviour;
enum class MediaCanPlayResponse;
enum class MediaElementState;
enum class Stereo3DVideoPackingMode;
enum class Stereo3DVideoRenderMode;
enum class Stretch;
struct Brush;
struct FontFamily;
struct Geometry;
struct ImageSource;
struct MediaTransportControlsThumbnailRequestedEventArgs;
struct PartialMediaFailureDetectedEventArgs;
struct RateChangedRoutedEventHandler;
struct SolidColorBrush;
struct TimelineMarkerCollection;
struct TimelineMarkerRoutedEventHandler;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Media::Animation {

struct ConnectedAnimation;
struct NavigationTransitionInfo;
struct TransitionCollection;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Navigation {

enum class NavigationCacheMode;
struct LoadCompletedEventHandler;
struct NavigatedEventHandler;
struct NavigatingCancelEventArgs;
struct NavigatingCancelEventHandler;
struct NavigationEventArgs;
struct NavigationFailedEventHandler;
struct NavigationStoppedEventHandler;
struct PageStackEntry;

}

WINRT_EXPORT namespace winrt::Windows::Web {

enum class WebErrorStatus;
struct IUriToStreamResolver;

}

WINRT_EXPORT namespace winrt::Windows::Web::Http {

struct HttpRequestMessage;

}

WINRT_EXPORT namespace winrt::Windows::UI::Xaml::Controls {

enum class AppBarClosedDisplayMode : int32_t
{
    Compact = 0,
    Minimal = 1,
    Hidden = 2,
};

enum class AutoSuggestionBoxTextChangeReason : int32_t
{
    UserInput = 0,
    ProgrammaticChange = 1,
    SuggestionChosen = 2,
};

enum class CalendarViewDisplayMode : int32_t
{
    Month = 0,
    Year = 1,
    Decade = 2,
};

enum class CalendarViewSelectionMode : int32_t
{
    None = 0,
    Single = 1,
    Multiple = 2,
};

enum class CandidateWindowAlignment : int32_t
{
    Default = 0,
    BottomEdge = 1,
};

enum class CharacterCasing : int32_t
{
    Normal = 0,
    Lower = 1,
    Upper = 2,
};

enum class ClickMode : int32_t
{
    Release = 0,
    Press = 1,
    Hover = 2,
};

enum class ColorPickerHsvChannel : int32_t
{
    Hue = 0,
    Saturation = 1,
    Value = 2,
    Alpha = 3,
};

enum class ColorSpectrumComponents : int32_t
{
    HueValue = 0,
    ValueHue = 1,
    HueSaturation = 2,
    SaturationHue = 3,
    SaturationValue = 4,
    ValueSaturation = 5,
};

enum class ColorSpectrumShape : int32_t
{
    Box = 0,
    Ring = 1,
};

enum class ComboBoxSelectionChangedTrigger : int32_t
{
    Committed = 0,
    Always = 1,
};

enum class CommandBarDefaultLabelPosition : int32_t
{
    Bottom = 0,
    Right = 1,
    Collapsed = 2,
};

enum class CommandBarDynamicOverflowAction : int32_t
{
    AddingToOverflow = 0,
    RemovingFromOverflow = 1,
};

enum class CommandBarLabelPosition : int32_t
{
    Default = 0,
    Collapsed = 1,
};

enum class CommandBarOverflowButtonVisibility : int32_t
{
    Auto = 0,
    Visible = 1,
    Collapsed = 2,
};

enum class ContentDialogButton : int32_t
{
    None = 0,
    Primary = 1,
    Secondary = 2,
    Close = 3,
};

enum class ContentDialogPlacement : int32_t
{
    Popup = 0,
    InPlace = 1,
};

enum class ContentDialogResult : int32_t
{
    None = 0,
    Primary = 1,
    Secondary = 2,
};

enum class DisabledFormattingAccelerators : uint32_t
{
    None = 0x0,
    Bold = 0x1,
    Italic = 0x2,
    Underline = 0x4,
    All = 0xFFFFFFFF,
};

enum class IncrementalLoadingTrigger : int32_t
{
    None = 0,
    Edge = 1,
};

enum class InkToolbarButtonFlyoutPlacement : int32_t
{
    Auto = 0,
    Top = 1,
    Bottom = 2,
    Left = 3,
    Right = 4,
};

enum class InkToolbarFlyoutItemKind : int32_t
{
    Simple = 0,
    Radio = 1,
    Check = 2,
    RadioCheck = 3,
};

enum class InkToolbarInitialControls : int32_t
{
    All = 0,
    None = 1,
    PensOnly = 2,
    AllExceptPens = 3,
};

enum class InkToolbarMenuKind : int32_t
{
    Stencil = 0,
};

enum class InkToolbarStencilKind : int32_t
{
    Ruler = 0,
    Protractor = 1,
};

enum class InkToolbarToggle : int32_t
{
    Ruler = 0,
    Custom = 1,
};

enum class InkToolbarTool : int32_t
{
    BallpointPen = 0,
    Pencil = 1,
    Highlighter = 2,
    Eraser = 3,
    CustomPen = 4,
    CustomTool = 5,
};

enum class ItemsUpdatingScrollMode : int32_t
{
    KeepItemsInView = 0,
    KeepScrollOffset = 1,
    KeepLastItemInView = 2,
};

enum class LightDismissOverlayMode : int32_t
{
    Auto = 0,
    On = 1,
    Off = 2,
};

enum class ListPickerFlyoutSelectionMode : int32_t
{
    Single = 0,
    Multiple = 1,
};

enum class ListViewReorderMode : int32_t
{
    Disabled = 0,
    Enabled = 1,
};

enum class ListViewSelectionMode : int32_t
{
    None = 0,
    Single = 1,
    Multiple = 2,
    Extended = 3,
};

enum class NavigationViewDisplayMode : int32_t
{
    Minimal = 0,
    Compact = 1,
    Expanded = 2,
};

enum class Orientation : int32_t
{
    Vertical = 0,
    Horizontal = 1,
};

enum class PanelScrollingDirection : int32_t
{
    None = 0,
    Forward = 1,
    Backward = 2,
};

enum class ParallaxSourceOffsetKind : int32_t
{
    Absolute = 0,
    Relative = 1,
};

enum class PasswordRevealMode : int32_t
{
    Peek = 0,
    Hidden = 1,
    Visible = 2,
};

enum class PivotHeaderFocusVisualPlacement : int32_t
{
    ItemHeaders = 0,
    SelectedItemHeader = 1,
};

enum class PivotSlideInAnimationGroup : int32_t
{
    Default = 0,
    GroupOne = 1,
    GroupTwo = 2,
    GroupThree = 3,
};

enum class RequiresPointer : int32_t
{
    Never = 0,
    WhenEngaged = 1,
    WhenFocused = 2,
};

enum class RichEditClipboardFormat : int32_t
{
    AllFormats = 0,
    PlainText = 1,
};

enum class ScrollBarVisibility : int32_t
{
    Disabled = 0,
    Auto = 1,
    Hidden = 2,
    Visible = 3,
};

enum class ScrollIntoViewAlignment : int32_t
{
    Default = 0,
    Leading = 1,
};

enum class ScrollMode : int32_t
{
    Disabled = 0,
    Enabled = 1,
    Auto = 2,
};

enum class SelectionMode : int32_t
{
    Single = 0,
    Multiple = 1,
    Extended = 2,
};

enum class SnapPointsType : int32_t
{
    None = 0,
    Optional = 1,
    Mandatory = 2,
    OptionalSingle = 3,
    MandatorySingle = 4,
};

enum class SplitViewDisplayMode : int32_t
{
    Overlay = 0,
    Inline = 1,
    CompactOverlay = 2,
    CompactInline = 3,
};

enum class SplitViewPanePlacement : int32_t
{
    Left = 0,
    Right = 1,
};

enum class StretchDirection : int32_t
{
    UpOnly = 0,
    DownOnly = 1,
    Both = 2,
};

enum class SwipeBehaviorOnInvoked : int32_t
{
    Auto = 0,
    Close = 1,
    RemainOpen = 2,
};

enum class SwipeMode : int32_t
{
    Reveal = 0,
    Execute = 1,
};

enum class Symbol : int32_t
{
    Previous = 57600,
    Next = 57601,
    Play = 57602,
    Pause = 57603,
    Edit = 57604,
    Save = 57605,
    Clear = 57606,
    Delete = 57607,
    Remove = 57608,
    Add = 57609,
    Cancel = 57610,
    Accept = 57611,
    More = 57612,
    Redo = 57613,
    Undo = 57614,
    Home = 57615,
    Up = 57616,
    Forward = 57617,
    Back = 57618,
    Favorite = 57619,
    Camera = 57620,
    Setting = 57621,
    Video = 57622,
    Sync = 57623,
    Download = 57624,
    Mail = 57625,
    Find = 57626,
    Help = 57627,
    Upload = 57628,
    Emoji = 57629,
    TwoPage = 57630,
    LeaveChat = 57631,
    MailForward = 57632,
    Clock = 57633,
    Send = 57634,
    Crop = 57635,
    RotateCamera = 57636,
    People = 57637,
    OpenPane = 57638,
    ClosePane = 57639,
    World = 57640,
    Flag = 57641,
    PreviewLink = 57642,
    Globe = 57643,
    Trim = 57644,
    AttachCamera = 57645,
    ZoomIn = 57646,
    Bookmarks = 57647,
    Document = 57648,
    ProtectedDocument = 57649,
    Page = 57650,
    Bullets = 57651,
    Comment = 57652,
    MailFilled = 57653,
    ContactInfo = 57654,
    HangUp = 57655,
    ViewAll = 57656,
    MapPin = 57657,
    Phone = 57658,
    VideoChat = 57659,
    Switch = 57660,
    Contact = 57661,
    Rename = 57662,
    Pin = 57665,
    MusicInfo = 57666,
    Go = 57667,
    Keyboard = 57668,
    DockLeft = 57669,
    DockRight = 57670,
    DockBottom = 57671,
    Remote = 57672,
    Refresh = 57673,
    Rotate = 57674,
    Shuffle = 57675,
    List = 57676,
    Shop = 57677,
    SelectAll = 57678,
    Orientation = 57679,
    Import = 57680,
    ImportAll = 57681,
    BrowsePhotos = 57685,
    WebCam = 57686,
    Pictures = 57688,
    SaveLocal = 57689,
    Caption = 57690,
    Stop = 57691,
    ShowResults = 57692,
    Volume = 57693,
    Repair = 57694,
    Message = 57695,
    Page2 = 57696,
    CalendarDay = 57697,
    CalendarWeek = 57698,
    Calendar = 57699,
    Character = 57700,
    MailReplyAll = 57701,
    Read = 57702,
    Link = 57703,
    Account = 57704,
    ShowBcc = 57705,
    HideBcc = 57706,
    Cut = 57707,
    Attach = 57708,
    Paste = 57709,
    Filter = 57710,
    Copy = 57711,
    Emoji2 = 57712,
    Important = 57713,
    MailReply = 57714,
    SlideShow = 57715,
    Sort = 57716,
    Manage = 57720,
    AllApps = 57721,
    DisconnectDrive = 57722,
    MapDrive = 57723,
    NewWindow = 57724,
    OpenWith = 57725,
    ContactPresence = 57729,
    Priority = 57730,
    GoToToday = 57732,
    Font = 57733,
    FontColor = 57734,
    Contact2 = 57735,
    Folder = 57736,
    Audio = 57737,
    Placeholder = 57738,
    View = 57739,
    SetLockScreen = 57740,
    SetTile = 57741,
    ClosedCaption = 57744,
    StopSlideShow = 57745,
    Permissions = 57746,
    Highlight = 57747,
    DisableUpdates = 57748,
    UnFavorite = 57749,
    UnPin = 57750,
    OpenLocal = 57751,
    Mute = 57752,
    Italic = 57753,
    Underline = 57754,
    Bold = 57755,
    MoveToFolder = 57756,
    LikeDislike = 57757,
    Dislike = 57758,
    Like = 57759,
    AlignRight = 57760,
    AlignCenter = 57761,
    AlignLeft = 57762,
    Zoom = 57763,
    ZoomOut = 57764,
    OpenFile = 57765,
    OtherUser = 57766,
    Admin = 57767,
    Street = 57795,
    Map = 57796,
    ClearSelection = 57797,
    FontDecrease = 57798,
    FontIncrease = 57799,
    FontSize = 57800,
    CellPhone = 57801,
    ReShare = 57802,
    Tag = 57803,
    RepeatOne = 57804,
    RepeatAll = 57805,
    OutlineStar = 57806,
    SolidStar = 57807,
    Calculator = 57808,
    Directions = 57809,
    Target = 57810,
    Library = 57811,
    PhoneBook = 57812,
    Memo = 57813,
    Microphone = 57814,
    PostUpdate = 57815,
    BackToWindow = 57816,
    FullScreen = 57817,
    NewFolder = 57818,
    CalendarReply = 57819,
    UnSyncFolder = 57821,
    ReportHacked = 57822,
    SyncFolder = 57823,
    BlockContact = 57824,
    SwitchApps = 57825,
    AddFriend = 57826,
    TouchPointer = 57827,
    GoToStart = 57828,
    ZeroBars = 57829,
    OneBar = 57830,
    TwoBars = 57831,
    ThreeBars = 57832,
    FourBars = 57833,
    Scan = 58004,
    Preview = 58005,
    GlobalNavigationButton = 59136,
    Share = 59181,
    Print = 59209,
    XboxOneConsole = 59792,
};

enum class VirtualizationMode : int32_t
{
    Standard = 0,
    Recycling = 1,
};

enum class WebViewExecutionMode : int32_t
{
    SameThread = 0,
    SeparateThread = 1,
};

enum class WebViewPermissionState : int32_t
{
    Unknown = 0,
    Defer = 1,
    Allow = 2,
    Deny = 3,
};

enum class WebViewPermissionType : int32_t
{
    Geolocation = 0,
    UnlimitedIndexedDBQuota = 1,
    Media = 2,
    PointerLock = 3,
    WebNotifications = 4,
};

enum class ZoomMode : int32_t
{
    Disabled = 0,
    Enabled = 1,
};

struct IAppBar;
struct IAppBar2;
struct IAppBar3;
struct IAppBar4;
struct IAppBarButton;
struct IAppBarButton3;
struct IAppBarButtonFactory;
struct IAppBarButtonStatics;
struct IAppBarButtonStatics3;
struct IAppBarFactory;
struct IAppBarOverrides;
struct IAppBarOverrides3;
struct IAppBarSeparator;
struct IAppBarSeparatorFactory;
struct IAppBarSeparatorStatics;
struct IAppBarSeparatorStatics3;
struct IAppBarStatics;
struct IAppBarStatics2;
struct IAppBarStatics4;
struct IAppBarToggleButton;
struct IAppBarToggleButton3;
struct IAppBarToggleButtonFactory;
struct IAppBarToggleButtonStatics;
struct IAppBarToggleButtonStatics3;
struct IAutoSuggestBox;
struct IAutoSuggestBox2;
struct IAutoSuggestBox3;
struct IAutoSuggestBoxQuerySubmittedEventArgs;
struct IAutoSuggestBoxStatics;
struct IAutoSuggestBoxStatics2;
struct IAutoSuggestBoxStatics3;
struct IAutoSuggestBoxSuggestionChosenEventArgs;
struct IAutoSuggestBoxTextChangedEventArgs;
struct IAutoSuggestBoxTextChangedEventArgsStatics;
struct IBackClickEventArgs;
struct IBitmapIcon;
struct IBitmapIcon2;
struct IBitmapIconFactory;
struct IBitmapIconSource;
struct IBitmapIconSourceFactory;
struct IBitmapIconSourceStatics;
struct IBitmapIconStatics;
struct IBitmapIconStatics2;
struct IBorder;
struct IBorderStatics;
struct IButton;
struct IButtonFactory;
struct IButtonStaticsWithFlyout;
struct IButtonWithFlyout;
struct ICalendarDatePicker;
struct ICalendarDatePicker2;
struct ICalendarDatePickerDateChangedEventArgs;
struct ICalendarDatePickerFactory;
struct ICalendarDatePickerStatics;
struct ICalendarDatePickerStatics2;
struct ICalendarView;
struct ICalendarViewDayItem;
struct ICalendarViewDayItemChangingEventArgs;
struct ICalendarViewDayItemFactory;
struct ICalendarViewDayItemStatics;
struct ICalendarViewFactory;
struct ICalendarViewSelectedDatesChangedEventArgs;
struct ICalendarViewStatics;
struct ICandidateWindowBoundsChangedEventArgs;
struct ICanvas;
struct ICanvasFactory;
struct ICanvasStatics;
struct ICaptureElement;
struct ICaptureElementStatics;
struct ICheckBox;
struct ICheckBoxFactory;
struct IChoosingGroupHeaderContainerEventArgs;
struct IChoosingItemContainerEventArgs;
struct ICleanUpVirtualizedItemEventArgs;
struct IColorChangedEventArgs;
struct IColorPicker;
struct IColorPickerFactory;
struct IColorPickerStatics;
struct IColumnDefinition;
struct IColumnDefinitionStatics;
struct IComboBox;
struct IComboBox2;
struct IComboBox3;
struct IComboBox4;
struct IComboBox5;
struct IComboBoxFactory;
struct IComboBoxItem;
struct IComboBoxItemFactory;
struct IComboBoxOverrides;
struct IComboBoxStatics;
struct IComboBoxStatics2;
struct IComboBoxStatics3;
struct IComboBoxStatics4;
struct IComboBoxStatics5;
struct ICommandBar;
struct ICommandBar2;
struct ICommandBar3;
struct ICommandBarElement;
struct ICommandBarElement2;
struct ICommandBarFactory;
struct ICommandBarOverflowPresenter;
struct ICommandBarOverflowPresenterFactory;
struct ICommandBarStatics;
struct ICommandBarStatics2;
struct ICommandBarStatics3;
struct IContainerContentChangingEventArgs;
struct IContentControl;
struct IContentControl2;
struct IContentControlFactory;
struct IContentControlOverrides;
struct IContentControlStatics;
struct IContentDialog;
struct IContentDialog2;
struct IContentDialog3;
struct IContentDialogButtonClickDeferral;
struct IContentDialogButtonClickEventArgs;
struct IContentDialogClosedEventArgs;
struct IContentDialogClosingDeferral;
struct IContentDialogClosingEventArgs;
struct IContentDialogFactory;
struct IContentDialogOpenedEventArgs;
struct IContentDialogStatics;
struct IContentDialogStatics2;
struct IContentPresenter;
struct IContentPresenter2;
struct IContentPresenter3;
struct IContentPresenter4;
struct IContentPresenterFactory;
struct IContentPresenterOverrides;
struct IContentPresenterStatics;
struct IContentPresenterStatics2;
struct IContentPresenterStatics3;
struct IContentPresenterStatics4;
struct IContextMenuEventArgs;
struct IControl;
struct IControl2;
struct IControl3;
struct IControl4;
struct IControl5;
struct IControlFactory;
struct IControlOverrides;
struct IControlOverrides6;
struct IControlProtected;
struct IControlStatics;
struct IControlStatics2;
struct IControlStatics3;
struct IControlStatics4;
struct IControlStatics5;
struct IControlTemplate;
struct IDataTemplateSelector;
struct IDataTemplateSelector2;
struct IDataTemplateSelectorFactory;
struct IDataTemplateSelectorOverrides;
struct IDataTemplateSelectorOverrides2;
struct IDatePickedEventArgs;
struct IDatePicker;
struct IDatePicker2;
struct IDatePickerFactory;
struct IDatePickerFlyout;
struct IDatePickerFlyout2;
struct IDatePickerFlyoutItem;
struct IDatePickerFlyoutItemStatics;
struct IDatePickerFlyoutPresenter;
struct IDatePickerFlyoutStatics;
struct IDatePickerFlyoutStatics2;
struct IDatePickerStatics;
struct IDatePickerStatics2;
struct IDatePickerValueChangedEventArgs;
struct IDragItemsCompletedEventArgs;
struct IDragItemsStartingEventArgs;
struct IDynamicOverflowItemsChangingEventArgs;
struct IFlipView;
struct IFlipView2;
struct IFlipViewFactory;
struct IFlipViewItem;
struct IFlipViewItemFactory;
struct IFlipViewStatics2;
struct IFlyout;
struct IFlyoutFactory;
struct IFlyoutPresenter;
struct IFlyoutPresenterFactory;
struct IFlyoutStatics;
struct IFocusDisengagedEventArgs;
struct IFocusEngagedEventArgs;
struct IFocusEngagedEventArgs2;
struct IFontIcon;
struct IFontIcon2;
struct IFontIcon3;
struct IFontIconFactory;
struct IFontIconSource;
struct IFontIconSourceFactory;
struct IFontIconSourceStatics;
struct IFontIconStatics;
struct IFontIconStatics2;
struct IFontIconStatics3;
struct IFrame;
struct IFrame2;
struct IFrame3;
struct IFrame4;
struct IFrameFactory;
struct IFrameStatics;
struct IFrameStatics2;
struct IGrid;
struct IGrid2;
struct IGrid3;
struct IGridFactory;
struct IGridStatics;
struct IGridStatics2;
struct IGridStatics3;
struct IGridView;
struct IGridViewFactory;
struct IGridViewHeaderItem;
struct IGridViewHeaderItemFactory;
struct IGridViewItem;
struct IGridViewItemFactory;
struct IGroupItem;
struct IGroupItemFactory;
struct IGroupStyle;
struct IGroupStyle2;
struct IGroupStyleFactory;
struct IGroupStyleSelector;
struct IGroupStyleSelectorFactory;
struct IGroupStyleSelectorOverrides;
struct IHub;
struct IHubFactory;
struct IHubSection;
struct IHubSectionFactory;
struct IHubSectionHeaderClickEventArgs;
struct IHubSectionStatics;
struct IHubStatics;
struct IHyperlinkButton;
struct IHyperlinkButtonFactory;
struct IHyperlinkButtonStatics;
struct IIconElement;
struct IIconElementFactory;
struct IIconElementStatics;
struct IIconSource;
struct IIconSourceFactory;
struct IIconSourceStatics;
struct IImage;
struct IImage2;
struct IImage3;
struct IImageStatics;
struct IInkCanvas;
struct IInkCanvasFactory;
struct IInkToolbar;
struct IInkToolbar2;
struct IInkToolbarBallpointPenButton;
struct IInkToolbarBallpointPenButtonFactory;
struct IInkToolbarCustomPen;
struct IInkToolbarCustomPenButton;
struct IInkToolbarCustomPenButtonFactory;
struct IInkToolbarCustomPenButtonStatics;
struct IInkToolbarCustomPenFactory;
struct IInkToolbarCustomPenOverrides;
struct IInkToolbarCustomToggleButton;
struct IInkToolbarCustomToggleButtonFactory;
struct IInkToolbarCustomToolButton;
struct IInkToolbarCustomToolButtonFactory;
struct IInkToolbarCustomToolButtonStatics;
struct IInkToolbarEraserButton;
struct IInkToolbarEraserButton2;
struct IInkToolbarEraserButtonFactory;
struct IInkToolbarEraserButtonStatics2;
struct IInkToolbarFactory;
struct IInkToolbarFlyoutItem;
struct IInkToolbarFlyoutItemFactory;
struct IInkToolbarFlyoutItemStatics;
struct IInkToolbarHighlighterButton;
struct IInkToolbarHighlighterButtonFactory;
struct IInkToolbarIsStencilButtonCheckedChangedEventArgs;
struct IInkToolbarMenuButton;
struct IInkToolbarMenuButtonFactory;
struct IInkToolbarMenuButtonStatics;
struct IInkToolbarPenButton;
struct IInkToolbarPenButtonFactory;
struct IInkToolbarPenButtonStatics;
struct IInkToolbarPenConfigurationControl;
struct IInkToolbarPenConfigurationControlFactory;
struct IInkToolbarPenConfigurationControlStatics;
struct IInkToolbarPencilButton;
struct IInkToolbarPencilButtonFactory;
struct IInkToolbarRulerButton;
struct IInkToolbarRulerButtonFactory;
struct IInkToolbarRulerButtonStatics;
struct IInkToolbarStatics;
struct IInkToolbarStatics2;
struct IInkToolbarStencilButton;
struct IInkToolbarStencilButtonFactory;
struct IInkToolbarStencilButtonStatics;
struct IInkToolbarToggleButton;
struct IInkToolbarToggleButtonFactory;
struct IInkToolbarToolButton;
struct IInkToolbarToolButtonFactory;
struct IInkToolbarToolButtonStatics;
struct IInsertionPanel;
struct IIsTextTrimmedChangedEventArgs;
struct IItemClickEventArgs;
struct IItemContainerGenerator;
struct IItemContainerMapping;
struct IItemsControl;
struct IItemsControl2;
struct IItemsControl3;
struct IItemsControlFactory;
struct IItemsControlOverrides;
struct IItemsControlStatics;
struct IItemsPanelTemplate;
struct IItemsPickedEventArgs;
struct IItemsPresenter;
struct IItemsPresenter2;
struct IItemsPresenterStatics;
struct IItemsPresenterStatics2;
struct IItemsStackPanel;
struct IItemsStackPanel2;
struct IItemsStackPanelStatics;
struct IItemsStackPanelStatics2;
struct IItemsWrapGrid;
struct IItemsWrapGrid2;
struct IItemsWrapGridStatics;
struct IItemsWrapGridStatics2;
struct IListBox;
struct IListBox2;
struct IListBoxFactory;
struct IListBoxItem;
struct IListBoxItemFactory;
struct IListBoxStatics;
struct IListBoxStatics2;
struct IListPickerFlyout;
struct IListPickerFlyoutPresenter;
struct IListPickerFlyoutStatics;
struct IListView;
struct IListViewBase;
struct IListViewBase2;
struct IListViewBase3;
struct IListViewBase4;
struct IListViewBase5;
struct IListViewBase6;
struct IListViewBaseFactory;
struct IListViewBaseHeaderItem;
struct IListViewBaseHeaderItemFactory;
struct IListViewBaseStatics;
struct IListViewBaseStatics2;
struct IListViewBaseStatics3;
struct IListViewBaseStatics4;
struct IListViewBaseStatics5;
struct IListViewFactory;
struct IListViewHeaderItem;
struct IListViewHeaderItemFactory;
struct IListViewItem;
struct IListViewItemFactory;
struct IListViewPersistenceHelper;
struct IListViewPersistenceHelperStatics;
struct IMediaElement;
struct IMediaElement2;
struct IMediaElement3;
struct IMediaElementStatics;
struct IMediaElementStatics2;
struct IMediaPlayerElement;
struct IMediaPlayerElementFactory;
struct IMediaPlayerElementStatics;
struct IMediaPlayerPresenter;
struct IMediaPlayerPresenterFactory;
struct IMediaPlayerPresenterStatics;
struct IMediaTransportControls;
struct IMediaTransportControls2;
struct IMediaTransportControls3;
struct IMediaTransportControlsFactory;
struct IMediaTransportControlsHelper;
struct IMediaTransportControlsHelperStatics;
struct IMediaTransportControlsStatics;
struct IMediaTransportControlsStatics2;
struct IMediaTransportControlsStatics3;
struct IMenuFlyout;
struct IMenuFlyout2;
struct IMenuFlyoutFactory;
struct IMenuFlyoutItem;
struct IMenuFlyoutItem2;
struct IMenuFlyoutItemBase;
struct IMenuFlyoutItemBaseFactory;
struct IMenuFlyoutItemFactory;
struct IMenuFlyoutItemStatics;
struct IMenuFlyoutItemStatics2;
struct IMenuFlyoutPresenter;
struct IMenuFlyoutPresenter2;
struct IMenuFlyoutPresenterFactory;
struct IMenuFlyoutSeparator;
struct IMenuFlyoutSeparatorFactory;
struct IMenuFlyoutStatics;
struct IMenuFlyoutSubItem;
struct IMenuFlyoutSubItem2;
struct IMenuFlyoutSubItemStatics;
struct IMenuFlyoutSubItemStatics2;
struct INavigate;
struct INavigationView;
struct INavigationViewDisplayModeChangedEventArgs;
struct INavigationViewFactory;
struct INavigationViewItem;
struct INavigationViewItemBase;
struct INavigationViewItemBaseFactory;
struct INavigationViewItemFactory;
struct INavigationViewItemHeader;
struct INavigationViewItemHeaderFactory;
struct INavigationViewItemInvokedEventArgs;
struct INavigationViewItemSeparator;
struct INavigationViewItemSeparatorFactory;
struct INavigationViewItemStatics;
struct INavigationViewList;
struct INavigationViewListFactory;
struct INavigationViewSelectionChangedEventArgs;
struct INavigationViewStatics;
struct INotifyEventArgs;
struct INotifyEventArgs2;
struct IPage;
struct IPageFactory;
struct IPageOverrides;
struct IPageStatics;
struct IPanel;
struct IPanelFactory;
struct IPanelStatics;
struct IParallaxView;
struct IParallaxViewFactory;
struct IParallaxViewStatics;
struct IPasswordBox;
struct IPasswordBox2;
struct IPasswordBox3;
struct IPasswordBox4;
struct IPasswordBoxPasswordChangingEventArgs;
struct IPasswordBoxStatics;
struct IPasswordBoxStatics2;
struct IPasswordBoxStatics3;
struct IPathIcon;
struct IPathIconFactory;
struct IPathIconSource;
struct IPathIconSourceFactory;
struct IPathIconSourceStatics;
struct IPathIconStatics;
struct IPersonPicture;
struct IPersonPictureFactory;
struct IPersonPictureStatics;
struct IPickerConfirmedEventArgs;
struct IPickerFlyout;
struct IPickerFlyoutPresenter;
struct IPickerFlyoutStatics;
struct IPivot;
struct IPivot2;
struct IPivot3;
struct IPivotFactory;
struct IPivotItem;
struct IPivotItemEventArgs;
struct IPivotItemFactory;
struct IPivotItemStatics;
struct IPivotStatics;
struct IPivotStatics2;
struct IPivotStatics3;
struct IProgressBar;
struct IProgressBarFactory;
struct IProgressBarStatics;
struct IProgressRing;
struct IProgressRingStatics;
struct IRadioButton;
struct IRadioButtonFactory;
struct IRadioButtonStatics;
struct IRatingControl;
struct IRatingControlFactory;
struct IRatingControlStatics;
struct IRatingItemFontInfo;
struct IRatingItemFontInfoFactory;
struct IRatingItemFontInfoStatics;
struct IRatingItemImageInfo;
struct IRatingItemImageInfoFactory;
struct IRatingItemImageInfoStatics;
struct IRatingItemInfo;
struct IRatingItemInfoFactory;
struct IRelativePanel;
struct IRelativePanelFactory;
struct IRelativePanelStatics;
struct IRichEditBox;
struct IRichEditBox2;
struct IRichEditBox3;
struct IRichEditBox4;
struct IRichEditBox5;
struct IRichEditBox6;
struct IRichEditBoxFactory;
struct IRichEditBoxStatics;
struct IRichEditBoxStatics2;
struct IRichEditBoxStatics3;
struct IRichEditBoxStatics4;
struct IRichEditBoxStatics5;
struct IRichEditBoxStatics6;
struct IRichEditBoxTextChangingEventArgs;
struct IRichEditBoxTextChangingEventArgs2;
struct IRichTextBlock;
struct IRichTextBlock2;
struct IRichTextBlock3;
struct IRichTextBlock4;
struct IRichTextBlock5;
struct IRichTextBlockOverflow;
struct IRichTextBlockOverflow2;
struct IRichTextBlockOverflow3;
struct IRichTextBlockOverflowStatics;
struct IRichTextBlockOverflowStatics2;
struct IRichTextBlockOverflowStatics3;
struct IRichTextBlockStatics;
struct IRichTextBlockStatics2;
struct IRichTextBlockStatics3;
struct IRichTextBlockStatics4;
struct IRichTextBlockStatics5;
struct IRowDefinition;
struct IRowDefinitionStatics;
struct IScrollContentPresenter;
struct IScrollViewer;
struct IScrollViewer2;
struct IScrollViewer3;
struct IScrollViewerStatics;
struct IScrollViewerStatics2;
struct IScrollViewerView;
struct IScrollViewerViewChangedEventArgs;
struct IScrollViewerViewChangingEventArgs;
struct ISearchBox;
struct ISearchBoxFactory;
struct ISearchBoxQueryChangedEventArgs;
struct ISearchBoxQuerySubmittedEventArgs;
struct ISearchBoxResultSuggestionChosenEventArgs;
struct ISearchBoxStatics;
struct ISearchBoxSuggestionsRequestedEventArgs;
struct ISectionsInViewChangedEventArgs;
struct ISectionsInViewChangedEventArgsFactory;
struct ISelectionChangedEventArgs;
struct ISelectionChangedEventArgsFactory;
struct ISemanticZoom;
struct ISemanticZoomInformation;
struct ISemanticZoomLocation;
struct ISemanticZoomStatics;
struct ISemanticZoomViewChangedEventArgs;
struct ISettingsFlyout;
struct ISettingsFlyoutFactory;
struct ISettingsFlyoutStatics;
struct ISlider;
struct ISlider2;
struct ISliderFactory;
struct ISliderStatics;
struct ISliderStatics2;
struct ISplitView;
struct ISplitView2;
struct ISplitView3;
struct ISplitViewFactory;
struct ISplitViewPaneClosingEventArgs;
struct ISplitViewStatics;
struct ISplitViewStatics2;
struct IStackPanel;
struct IStackPanel2;
struct IStackPanel4;
struct IStackPanelFactory;
struct IStackPanelStatics;
struct IStackPanelStatics2;
struct IStackPanelStatics4;
struct IStyleSelector;
struct IStyleSelectorFactory;
struct IStyleSelectorOverrides;
struct ISwapChainBackgroundPanel;
struct ISwapChainBackgroundPanel2;
struct ISwapChainBackgroundPanelFactory;
struct ISwapChainPanel;
struct ISwapChainPanelFactory;
struct ISwapChainPanelStatics;
struct ISwipeControl;
struct ISwipeControlFactory;
struct ISwipeControlStatics;
struct ISwipeItem;
struct ISwipeItemFactory;
struct ISwipeItemInvokedEventArgs;
struct ISwipeItemStatics;
struct ISwipeItems;
struct ISwipeItemsFactory;
struct ISwipeItemsStatics;
struct ISymbolIcon;
struct ISymbolIconFactory;
struct ISymbolIconSource;
struct ISymbolIconSourceFactory;
struct ISymbolIconSourceStatics;
struct ISymbolIconStatics;
struct ITextBlock;
struct ITextBlock2;
struct ITextBlock3;
struct ITextBlock4;
struct ITextBlock5;
struct ITextBlock6;
struct ITextBlockStatics;
struct ITextBlockStatics2;
struct ITextBlockStatics3;
struct ITextBlockStatics5;
struct ITextBlockStatics6;
struct ITextBox;
struct ITextBox2;
struct ITextBox3;
struct ITextBox4;
struct ITextBox5;
struct ITextBox6;
struct ITextBoxBeforeTextChangingEventArgs;
struct ITextBoxFactory;
struct ITextBoxStatics;
struct ITextBoxStatics2;
struct ITextBoxStatics3;
struct ITextBoxStatics5;
struct ITextBoxStatics6;
struct ITextBoxTextChangingEventArgs;
struct ITextBoxTextChangingEventArgs2;
struct ITextChangedEventArgs;
struct ITextCompositionChangedEventArgs;
struct ITextCompositionEndedEventArgs;
struct ITextCompositionStartedEventArgs;
struct ITextControlCopyingToClipboardEventArgs;
struct ITextControlCuttingToClipboardEventArgs;
struct ITextControlPasteEventArgs;
struct ITimePickedEventArgs;
struct ITimePicker;
struct ITimePicker2;
struct ITimePickerFactory;
struct ITimePickerFlyout;
struct ITimePickerFlyoutPresenter;
struct ITimePickerFlyoutStatics;
struct ITimePickerStatics;
struct ITimePickerStatics2;
struct ITimePickerValueChangedEventArgs;
struct IToggleMenuFlyoutItem;
struct IToggleMenuFlyoutItemFactory;
struct IToggleMenuFlyoutItemStatics;
struct IToggleSwitch;
struct IToggleSwitchOverrides;
struct IToggleSwitchStatics;
struct IToolTip;
struct IToolTipFactory;
struct IToolTipService;
struct IToolTipServiceStatics;
struct IToolTipStatics;
struct IUIElementCollection;
struct IUserControl;
struct IUserControlFactory;
struct IUserControlStatics;
struct IVariableSizedWrapGrid;
struct IVariableSizedWrapGridStatics;
struct IViewbox;
struct IViewboxStatics;
struct IVirtualizingPanel;
struct IVirtualizingPanelFactory;
struct IVirtualizingPanelOverrides;
struct IVirtualizingPanelProtected;
struct IVirtualizingStackPanel;
struct IVirtualizingStackPanelOverrides;
struct IVirtualizingStackPanelStatics;
struct IWebView;
struct IWebView2;
struct IWebView3;
struct IWebView4;
struct IWebView5;
struct IWebViewBrush;
struct IWebViewBrushStatics;
struct IWebViewContentLoadingEventArgs;
struct IWebViewDOMContentLoadedEventArgs;
struct IWebViewDeferredPermissionRequest;
struct IWebViewFactory4;
struct IWebViewLongRunningScriptDetectedEventArgs;
struct IWebViewNavigationCompletedEventArgs;
struct IWebViewNavigationFailedEventArgs;
struct IWebViewNavigationStartingEventArgs;
struct IWebViewNewWindowRequestedEventArgs;
struct IWebViewPermissionRequest;
struct IWebViewPermissionRequestedEventArgs;
struct IWebViewSettings;
struct IWebViewStatics;
struct IWebViewStatics2;
struct IWebViewStatics3;
struct IWebViewStatics4;
struct IWebViewStatics5;
struct IWebViewUnsupportedUriSchemeIdentifiedEventArgs;
struct IWebViewUnviewableContentIdentifiedEventArgs;
struct IWebViewUnviewableContentIdentifiedEventArgs2;
struct IWrapGrid;
struct IWrapGridStatics;
struct AppBar;
struct AppBarButton;
struct AppBarSeparator;
struct AppBarToggleButton;
struct AutoSuggestBox;
struct AutoSuggestBoxQuerySubmittedEventArgs;
struct AutoSuggestBoxSuggestionChosenEventArgs;
struct AutoSuggestBoxTextChangedEventArgs;
struct BackClickEventArgs;
struct BitmapIcon;
struct BitmapIconSource;
struct Border;
struct Button;
struct CalendarDatePicker;
struct CalendarDatePickerDateChangedEventArgs;
struct CalendarView;
struct CalendarViewDayItem;
struct CalendarViewDayItemChangingEventArgs;
struct CalendarViewSelectedDatesChangedEventArgs;
struct CandidateWindowBoundsChangedEventArgs;
struct Canvas;
struct CaptureElement;
struct CheckBox;
struct ChoosingGroupHeaderContainerEventArgs;
struct ChoosingItemContainerEventArgs;
struct CleanUpVirtualizedItemEventArgs;
struct ColorChangedEventArgs;
struct ColorPicker;
struct ColumnDefinition;
struct ColumnDefinitionCollection;
struct ComboBox;
struct ComboBoxItem;
struct CommandBar;
struct CommandBarOverflowPresenter;
struct ContainerContentChangingEventArgs;
struct ContentControl;
struct ContentDialog;
struct ContentDialogButtonClickDeferral;
struct ContentDialogButtonClickEventArgs;
struct ContentDialogClosedEventArgs;
struct ContentDialogClosingDeferral;
struct ContentDialogClosingEventArgs;
struct ContentDialogOpenedEventArgs;
struct ContentPresenter;
struct ContextMenuEventArgs;
struct Control;
struct ControlTemplate;
struct DataTemplateSelector;
struct DatePickedEventArgs;
struct DatePicker;
struct DatePickerFlyout;
struct DatePickerFlyoutItem;
struct DatePickerFlyoutPresenter;
struct DatePickerValueChangedEventArgs;
struct DragItemsCompletedEventArgs;
struct DragItemsStartingEventArgs;
struct DynamicOverflowItemsChangingEventArgs;
struct FlipView;
struct FlipViewItem;
struct Flyout;
struct FlyoutPresenter;
struct FocusDisengagedEventArgs;
struct FocusEngagedEventArgs;
struct FontIcon;
struct FontIconSource;
struct Frame;
struct Grid;
struct GridView;
struct GridViewHeaderItem;
struct GridViewItem;
struct GroupItem;
struct GroupStyle;
struct GroupStyleSelector;
struct Hub;
struct HubSection;
struct HubSectionCollection;
struct HubSectionHeaderClickEventArgs;
struct HyperlinkButton;
struct IconElement;
struct IconSource;
struct Image;
struct InkCanvas;
struct InkToolbar;
struct InkToolbarBallpointPenButton;
struct InkToolbarCustomPen;
struct InkToolbarCustomPenButton;
struct InkToolbarCustomToggleButton;
struct InkToolbarCustomToolButton;
struct InkToolbarEraserButton;
struct InkToolbarFlyoutItem;
struct InkToolbarHighlighterButton;
struct InkToolbarIsStencilButtonCheckedChangedEventArgs;
struct InkToolbarMenuButton;
struct InkToolbarPenButton;
struct InkToolbarPenConfigurationControl;
struct InkToolbarPencilButton;
struct InkToolbarRulerButton;
struct InkToolbarStencilButton;
struct InkToolbarToggleButton;
struct InkToolbarToolButton;
struct IsTextTrimmedChangedEventArgs;
struct ItemClickEventArgs;
struct ItemCollection;
struct ItemContainerGenerator;
struct ItemsControl;
struct ItemsPanelTemplate;
struct ItemsPickedEventArgs;
struct ItemsPresenter;
struct ItemsStackPanel;
struct ItemsWrapGrid;
struct ListBox;
struct ListBoxItem;
struct ListPickerFlyout;
struct ListPickerFlyoutPresenter;
struct ListView;
struct ListViewBase;
struct ListViewBaseHeaderItem;
struct ListViewHeaderItem;
struct ListViewItem;
struct ListViewPersistenceHelper;
struct MediaElement;
struct MediaPlayerElement;
struct MediaPlayerPresenter;
struct MediaTransportControls;
struct MediaTransportControlsHelper;
struct MenuFlyout;
struct MenuFlyoutItem;
struct MenuFlyoutItemBase;
struct MenuFlyoutPresenter;
struct MenuFlyoutSeparator;
struct MenuFlyoutSubItem;
struct NavigationView;
struct NavigationViewDisplayModeChangedEventArgs;
struct NavigationViewItem;
struct NavigationViewItemBase;
struct NavigationViewItemHeader;
struct NavigationViewItemInvokedEventArgs;
struct NavigationViewItemSeparator;
struct NavigationViewList;
struct NavigationViewSelectionChangedEventArgs;
struct NotifyEventArgs;
struct Page;
struct Panel;
struct ParallaxView;
struct PasswordBox;
struct PasswordBoxPasswordChangingEventArgs;
struct PathIcon;
struct PathIconSource;
struct PersonPicture;
struct PickerConfirmedEventArgs;
struct PickerFlyout;
struct PickerFlyoutPresenter;
struct Pivot;
struct PivotItem;
struct PivotItemEventArgs;
struct ProgressBar;
struct ProgressRing;
struct RadioButton;
struct RatingControl;
struct RatingItemFontInfo;
struct RatingItemImageInfo;
struct RatingItemInfo;
struct RelativePanel;
struct RichEditBox;
struct RichEditBoxTextChangingEventArgs;
struct RichTextBlock;
struct RichTextBlockOverflow;
struct RowDefinition;
struct RowDefinitionCollection;
struct ScrollContentPresenter;
struct ScrollViewer;
struct ScrollViewerView;
struct ScrollViewerViewChangedEventArgs;
struct ScrollViewerViewChangingEventArgs;
struct SearchBox;
struct SearchBoxQueryChangedEventArgs;
struct SearchBoxQuerySubmittedEventArgs;
struct SearchBoxResultSuggestionChosenEventArgs;
struct SearchBoxSuggestionsRequestedEventArgs;
struct SectionsInViewChangedEventArgs;
struct SelectionChangedEventArgs;
struct SemanticZoom;
struct SemanticZoomLocation;
struct SemanticZoomViewChangedEventArgs;
struct SettingsFlyout;
struct Slider;
struct SplitView;
struct SplitViewPaneClosingEventArgs;
struct StackPanel;
struct StyleSelector;
struct SwapChainBackgroundPanel;
struct SwapChainPanel;
struct SwipeControl;
struct SwipeItem;
struct SwipeItemInvokedEventArgs;
struct SwipeItems;
struct SymbolIcon;
struct SymbolIconSource;
struct TextBlock;
struct TextBox;
struct TextBoxBeforeTextChangingEventArgs;
struct TextBoxTextChangingEventArgs;
struct TextChangedEventArgs;
struct TextCompositionChangedEventArgs;
struct TextCompositionEndedEventArgs;
struct TextCompositionStartedEventArgs;
struct TextControlCopyingToClipboardEventArgs;
struct TextControlCuttingToClipboardEventArgs;
struct TextControlPasteEventArgs;
struct TimePickedEventArgs;
struct TimePicker;
struct TimePickerFlyout;
struct TimePickerFlyoutPresenter;
struct TimePickerValueChangedEventArgs;
struct ToggleMenuFlyoutItem;
struct ToggleSwitch;
struct ToolTip;
struct ToolTipService;
struct UIElementCollection;
struct UserControl;
struct VariableSizedWrapGrid;
struct Viewbox;
struct VirtualizingPanel;
struct VirtualizingStackPanel;
struct WebView;
struct WebViewBrush;
struct WebViewContentLoadingEventArgs;
struct WebViewDOMContentLoadedEventArgs;
struct WebViewDeferredPermissionRequest;
struct WebViewLongRunningScriptDetectedEventArgs;
struct WebViewNavigationCompletedEventArgs;
struct WebViewNavigationFailedEventArgs;
struct WebViewNavigationStartingEventArgs;
struct WebViewNewWindowRequestedEventArgs;
struct WebViewPermissionRequest;
struct WebViewPermissionRequestedEventArgs;
struct WebViewSettings;
struct WebViewUnsupportedUriSchemeIdentifiedEventArgs;
struct WebViewUnviewableContentIdentifiedEventArgs;
struct WrapGrid;
struct BackClickEventHandler;
struct CalendarViewDayItemChangingEventHandler;
struct CleanUpVirtualizedItemEventHandler;
struct ContextMenuOpeningEventHandler;
struct DragItemsStartingEventHandler;
struct HubSectionHeaderClickEventHandler;
struct ItemClickEventHandler;
struct ListViewItemToKeyHandler;
struct ListViewKeyToItemHandler;
struct NotifyEventHandler;
struct SectionsInViewChangedEventHandler;
struct SelectionChangedEventHandler;
struct SemanticZoomViewChangedEventHandler;
struct TextChangedEventHandler;
struct TextControlPasteEventHandler;
struct WebViewNavigationFailedEventHandler;

}

namespace winrt::impl {

template<> struct is_enum_flag<Windows::UI::Xaml::Controls::DisabledFormattingAccelerators> : std::true_type {};
template <> struct category<Windows::UI::Xaml::Controls::IAppBar>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBar2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBar3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBar4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarButton3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarButtonStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarOverrides3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarSeparator>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarSeparatorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarToggleButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarToggleButton3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarToggleButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBox3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgsStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBackClickEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIcon>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIcon2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconSource>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconSourceFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconSourceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBitmapIconStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBorder>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IBorderStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IButtonStaticsWithFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IButtonWithFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePicker>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePicker2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePickerFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewDayItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewDayItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewDayItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICalendarViewStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICanvas>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICanvasFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICanvasStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICaptureElement>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICaptureElementStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICheckBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICheckBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColorChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColorPicker>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColorPickerFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColorPickerStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColumnDefinition>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IColumnDefinitionStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBox3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBox4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBox5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IComboBoxStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBar>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBar2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBar3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarElement>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarElement2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenterFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ICommandBarStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentControl2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentControlOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialog>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialog2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialog3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogClosingDeferral>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentDialogStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenter2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenter3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenter4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContentPresenterStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IContextMenuEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControl2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControl3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControl4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControl5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlOverrides6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlProtected>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IControlTemplate>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDataTemplateSelector>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDataTemplateSelector2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDataTemplateSelectorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePicker>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePicker2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyout2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyoutItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyoutItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipView2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipViewItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipViewItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlipViewStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlyoutFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlyoutPresenterFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIcon>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIcon2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIcon3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconSource>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconSourceFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconSourceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFontIconStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrame>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrame2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrame3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrame4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrameFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrameStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IFrameStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGrid>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGrid2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGrid3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridViewHeaderItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridViewHeaderItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridViewItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGridViewItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyle>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyle2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyleFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyleSelector>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyleSelectorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IGroupStyleSelectorOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHub>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubSection>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubSectionFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubSectionStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHubStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHyperlinkButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHyperlinkButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IHyperlinkButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconElement>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconElementFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconElementStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconSource>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconSourceFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIconSourceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IImage>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IImage2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IImage3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IImageStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkCanvas>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkCanvasFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbar>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbar2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPen>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPenFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomPenOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarEraserButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarEraserButton2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarMenuButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPencilButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarPencilButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarRulerButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarStencilButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarToggleButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarToggleButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarToolButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarToolButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInkToolbarToolButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IInsertionPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemClickEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemContainerGenerator>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemContainerMapping>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControl2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControl3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControlOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPanelTemplate>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPickedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPresenter2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPresenterStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsPresenterStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsStackPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsStackPanel2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsStackPanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsStackPanelStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsWrapGrid>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsWrapGrid2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsWrapGridStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IItemsWrapGridStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBoxItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBoxItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListPickerFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListPickerFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBase6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseHeaderItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseHeaderItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewBaseStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewHeaderItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewHeaderItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewPersistenceHelper>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IListViewPersistenceHelperStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaElement>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaElement2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaElement3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaElementStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaElementStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerElement>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerElementFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerElementStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerPresenterFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaPlayerPresenterStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControls>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControls2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControls3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsHelper>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsHelperStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyout2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItem2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItemBase>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItemBaseFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutPresenterFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSeparator>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSeparatorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigate>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemBase>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemBaseFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemHeader>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemHeaderFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemSeparator>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemSeparatorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewList>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewListFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INavigationViewStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INotifyEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::INotifyEventArgs2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPage>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPageFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPageOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPageStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IParallaxView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IParallaxViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IParallaxViewStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBox3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBox4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPasswordBoxStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIcon>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIconFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIconSource>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIconSourceFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIconSourceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPathIconStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPersonPicture>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPersonPictureFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPersonPictureStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPickerFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPickerFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPickerFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivot>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivot2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivot3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotItemEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IPivotStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IProgressBar>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IProgressBarFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IProgressBarStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IProgressRing>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IProgressRingStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRadioButton>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRadioButtonFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRadioButtonStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemFontInfo>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemFontInfoFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemFontInfoStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemImageInfo>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemImageInfoFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemImageInfoStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemInfo>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRatingItemInfoFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRelativePanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRelativePanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRelativePanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBox6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxStatics6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlock>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlock2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlock3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlock4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlock5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflow>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflow2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRichTextBlockStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRowDefinition>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IRowDefinitionStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollContentPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewer>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewer2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewer3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewerStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewerStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewerView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgsFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISelectionChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISelectionChangedEventArgsFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISemanticZoom>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISemanticZoomInformation>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISemanticZoomLocation>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISemanticZoomStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISettingsFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISettingsFlyoutFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISettingsFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISlider>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISlider2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISliderFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISliderStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISliderStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitView2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitView3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitViewFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitViewStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISplitViewStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanel2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanel4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanelStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStackPanelStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStyleSelector>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStyleSelectorFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IStyleSelectorOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainPanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwapChainPanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItems>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItemsFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISwipeItemsStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIcon>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIconFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIconSource>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIconSourceFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIconSourceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ISymbolIconStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlock6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlockStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlockStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlockStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlockStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBlockStatics6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBox6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxStatics6>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITextControlPasteEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePicker>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePicker2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerFlyout>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerFlyoutStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleSwitch>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleSwitchOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToggleSwitchStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToolTip>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToolTipFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToolTipService>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToolTipServiceStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IToolTipStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IUIElementCollection>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IUserControl>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IUserControlFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IUserControlStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVariableSizedWrapGrid>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVariableSizedWrapGridStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IViewbox>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IViewboxStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingPanelFactory>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingPanelOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingPanelProtected>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingStackPanel>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingStackPanelOverrides>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IVirtualizingStackPanelStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebView>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebView2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebView3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebView4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebView5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewBrush>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewBrushStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewFactory4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewPermissionRequest>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewSettings>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewStatics2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewStatics3>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewStatics4>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewStatics5>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs2>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWrapGrid>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::IWrapGridStatics>{ using type = interface_category; };
template <> struct category<Windows::UI::Xaml::Controls::AppBar>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AppBarButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AppBarSeparator>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AppBarToggleButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AutoSuggestBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AutoSuggestBoxQuerySubmittedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AutoSuggestBoxSuggestionChosenEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AutoSuggestBoxTextChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::BackClickEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::BitmapIcon>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::BitmapIconSource>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Border>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Button>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarDatePicker>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarDatePickerDateChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewDayItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewSelectedDatesChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Canvas>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CaptureElement>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CheckBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ChoosingGroupHeaderContainerEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ChoosingItemContainerEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColorChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColorPicker>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColumnDefinition>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColumnDefinitionCollection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ComboBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ComboBoxItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBar>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBarOverflowPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialog>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogButtonClickDeferral>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogClosedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogClosingDeferral>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogClosingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogOpenedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContextMenuEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Control>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ControlTemplate>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DataTemplateSelector>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePickedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePicker>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePickerFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePickerFlyoutItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePickerFlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DatePickerValueChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DragItemsCompletedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DragItemsStartingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::DynamicOverflowItemsChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FlipView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FlipViewItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Flyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FocusDisengagedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FocusEngagedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FontIcon>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::FontIconSource>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Frame>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Grid>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GridView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GridViewHeaderItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GridViewItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GroupItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GroupStyle>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::GroupStyleSelector>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Hub>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::HubSection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::HubSectionCollection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::HyperlinkButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::IconElement>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::IconSource>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Image>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkCanvas>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbar>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarBallpointPenButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarCustomPen>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarCustomPenButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarCustomToggleButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarCustomToolButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarEraserButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarHighlighterButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarIsStencilButtonCheckedChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarMenuButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarPenButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarPenConfigurationControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarPencilButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarRulerButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarStencilButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarToggleButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarToolButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemClickEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemCollection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemContainerGenerator>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsPanelTemplate>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsPickedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsStackPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsWrapGrid>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListBoxItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListPickerFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListPickerFlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewBase>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewBaseHeaderItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewHeaderItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewPersistenceHelper>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MediaElement>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MediaPlayerElement>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MediaPlayerPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MediaTransportControls>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MediaTransportControlsHelper>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyoutItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyoutItemBase>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyoutSeparator>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::MenuFlyoutSubItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewDisplayModeChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewItemBase>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewItemHeader>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewItemInvokedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewItemSeparator>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewList>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewSelectionChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::NotifyEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Page>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Panel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ParallaxView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PasswordBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PasswordBoxPasswordChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PathIcon>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PathIconSource>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PersonPicture>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PickerConfirmedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PickerFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PickerFlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Pivot>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PivotItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::PivotItemEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ProgressBar>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ProgressRing>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RadioButton>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RatingControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RatingItemFontInfo>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RatingItemImageInfo>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RatingItemInfo>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RelativePanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RichEditBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RichEditBoxTextChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RichTextBlock>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RichTextBlockOverflow>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RowDefinition>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::RowDefinitionCollection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollContentPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollViewer>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollViewerView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollViewerViewChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollViewerViewChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SearchBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SearchBoxQueryChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SearchBoxQuerySubmittedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SearchBoxResultSuggestionChosenEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SearchBoxSuggestionsRequestedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SectionsInViewChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SelectionChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SemanticZoom>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SemanticZoomLocation>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SettingsFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Slider>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SplitView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SplitViewPaneClosingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::StackPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::StyleSelector>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwapChainBackgroundPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwapChainPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeItemInvokedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeItems>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SymbolIcon>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::SymbolIconSource>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextBlock>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextBox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextBoxBeforeTextChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextControlPasteEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TimePickedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TimePicker>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TimePickerFlyout>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TimePickerFlyoutPresenter>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::TimePickerValueChangedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ToggleMenuFlyoutItem>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ToggleSwitch>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ToolTip>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::ToolTipService>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::UIElementCollection>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::UserControl>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::VariableSizedWrapGrid>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::Viewbox>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::VirtualizingPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::VirtualizingStackPanel>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebView>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewBrush>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewDeferredPermissionRequest>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewLongRunningScriptDetectedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewNewWindowRequestedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewPermissionRequest>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewPermissionRequestedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewSettings>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewUnsupportedUriSchemeIdentifiedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewUnviewableContentIdentifiedEventArgs>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::WrapGrid>{ using type = class_category; };
template <> struct category<Windows::UI::Xaml::Controls::AppBarClosedDisplayMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewDisplayMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewSelectionMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CandidateWindowAlignment>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CharacterCasing>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ClickMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColorPickerHsvChannel>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColorSpectrumComponents>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ColorSpectrumShape>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBarDynamicOverflowAction>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBarLabelPosition>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogButton>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogPlacement>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContentDialogResult>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::DisabledFormattingAccelerators>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::IncrementalLoadingTrigger>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarInitialControls>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarMenuKind>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarStencilKind>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarToggle>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::InkToolbarTool>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::LightDismissOverlayMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewReorderMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewSelectionMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::NavigationViewDisplayMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::Orientation>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::PanelScrollingDirection>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::PasswordRevealMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::RequiresPointer>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::RichEditClipboardFormat>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollBarVisibility>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollIntoViewAlignment>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ScrollMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SelectionMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SnapPointsType>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SplitViewDisplayMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SplitViewPanePlacement>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::StretchDirection>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::SwipeMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::Symbol>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::VirtualizationMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewExecutionMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewPermissionState>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewPermissionType>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::ZoomMode>{ using type = enum_category; };
template <> struct category<Windows::UI::Xaml::Controls::BackClickEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::DragItemsStartingEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::ItemClickEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewItemToKeyHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::ListViewKeyToItemHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::NotifyEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::SelectionChangedEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextChangedEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::TextControlPasteEventHandler>{ using type = delegate_category; };
template <> struct category<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler>{ using type = delegate_category; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBar2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBar2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBar3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBar3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBar4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBar4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarButton3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarButton3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarButtonStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarButtonStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarOverrides3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarOverrides3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarSeparatorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarSeparatorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarSeparatorStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarSeparatorStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarToggleButton3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarToggleButton3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarToggleButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarToggleButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarToggleButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAppBarToggleButtonStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBox3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBox3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxQuerySubmittedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxSuggestionChosenEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxTextChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgsStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IAutoSuggestBoxTextChangedEventArgsStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBackClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBackClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIcon2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIcon2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconSourceFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconSourceFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconSourceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconSourceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBitmapIconStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBitmapIconStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBorder>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBorder" }; };
template <> struct name<Windows::UI::Xaml::Controls::IBorderStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IBorderStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IButtonStaticsWithFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IButtonStaticsWithFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IButtonWithFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IButtonWithFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePicker2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePicker2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePickerDateChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePickerFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePickerFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePickerStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarDatePickerStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarView" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewDayItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewDayItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewDayItemChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewDayItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewDayItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewDayItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewDayItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewSelectedDatesChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICalendarViewStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICalendarViewStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICandidateWindowBoundsChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICanvas>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICanvas" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICanvasFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICanvasFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICanvasStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICanvasStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICaptureElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICaptureElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICaptureElementStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICaptureElementStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICheckBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICheckBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICheckBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICheckBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IChoosingGroupHeaderContainerEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IChoosingItemContainerEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICleanUpVirtualizedItemEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColorChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColorChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColorPicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColorPicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColorPickerFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColorPickerFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColorPickerStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColorPickerStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColumnDefinition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColumnDefinition" }; };
template <> struct name<Windows::UI::Xaml::Controls::IColumnDefinitionStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IColumnDefinitionStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBox3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBox3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBox4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBox4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBox5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBox5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IComboBoxStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IComboBoxStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBar2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBar2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBar3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBar3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarElement2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarElement2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarOverflowPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenterFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarOverflowPresenterFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ICommandBarStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ICommandBarStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContainerContentChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentControl2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentControl2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentControlOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentControlOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialog>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialog" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialog2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialog2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialog3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialog3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogButtonClickDeferral" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogButtonClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogClosedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogClosingDeferral>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogClosingDeferral" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogClosingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogOpenedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentDialogStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentDialogStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenter2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenter2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenter3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenter3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenter4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenter4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContentPresenterStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContentPresenterStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IContextMenuEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IContextMenuEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControl2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControl2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControl3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControl3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControl4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControl4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControl5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControl5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlOverrides6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlOverrides6" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlProtected>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlProtected" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IControlTemplate>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IControlTemplate" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDataTemplateSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDataTemplateSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDataTemplateSelector2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDataTemplateSelector2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDataTemplateSelectorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDataTemplateSelectorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDataTemplateSelectorOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDataTemplateSelectorOverrides2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePicker2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePicker2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyout2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyout2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyoutItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyoutItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerFlyoutStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDatePickerValueChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDragItemsCompletedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDragItemsStartingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IDynamicOverflowItemsChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipView2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipView2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipViewItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipViewItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlipViewStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlipViewStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlyoutFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlyoutFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlyoutPresenterFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlyoutPresenterFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFocusDisengagedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFocusEngagedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFocusEngagedEventArgs2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIcon2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIcon2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIcon3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIcon3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconSourceFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconSourceFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconSourceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconSourceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFontIconStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFontIconStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrame>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrame" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrame2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrame2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrame3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrame3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrame4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrame4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrameFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrameFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrameStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrameStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IFrameStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IFrameStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGrid2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGrid2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGrid3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGrid3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridViewHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridViewHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridViewHeaderItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridViewHeaderItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGridViewItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGridViewItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyle>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyle" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyle2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyle2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyleFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyleFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyleSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyleSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyleSelectorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyleSelectorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IGroupStyleSelectorOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IGroupStyleSelectorOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHub>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHub" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubSection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubSection" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubSectionFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubSectionFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubSectionHeaderClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubSectionStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubSectionStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHubStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHubStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHyperlinkButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHyperlinkButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHyperlinkButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHyperlinkButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IHyperlinkButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IHyperlinkButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconElementFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconElementFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconElementStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconElementStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconSourceFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconSourceFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIconSourceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIconSourceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IImage>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IImage" }; };
template <> struct name<Windows::UI::Xaml::Controls::IImage2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IImage2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IImage3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IImage3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IImageStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IImageStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkCanvas>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkCanvas" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkCanvasFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkCanvasFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbar" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbar2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbar2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarBallpointPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarBallpointPenButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPen>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPen" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPenButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPenButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPenFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPenFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomPenOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomPenOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomToggleButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomToolButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomToolButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarCustomToolButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarEraserButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarEraserButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarEraserButton2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarEraserButton2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarEraserButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarEraserButtonStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarFlyoutItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarFlyoutItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarHighlighterButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarHighlighterButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarIsStencilButtonCheckedChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarMenuButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarMenuButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarMenuButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarMenuButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenConfigurationControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenConfigurationControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPenConfigurationControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPencilButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPencilButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarPencilButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarPencilButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarRulerButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarRulerButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarRulerButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarRulerButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarStencilButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarStencilButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarStencilButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarStencilButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarToggleButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarToggleButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarToolButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarToolButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarToolButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarToolButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInkToolbarToolButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInkToolbarToolButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IInsertionPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IInsertionPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IIsTextTrimmedChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemContainerGenerator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemContainerGenerator" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemContainerMapping>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemContainerMapping" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControl2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControl2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControl3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControl3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControlOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControlOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPanelTemplate>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPanelTemplate" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPresenter2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPresenter2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPresenterStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPresenterStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsPresenterStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsPresenterStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsStackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsStackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsStackPanel2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsStackPanel2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsStackPanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsStackPanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsStackPanelStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsStackPanelStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsWrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsWrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsWrapGrid2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsWrapGrid2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsWrapGridStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsWrapGridStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IItemsWrapGridStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IItemsWrapGridStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBoxItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBoxItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBoxItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBoxItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListPickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListPickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListPickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListPickerFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListPickerFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBase6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBase6" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseHeaderItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseHeaderItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewBaseStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewBaseStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewHeaderItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewHeaderItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewPersistenceHelper>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewPersistenceHelper" }; };
template <> struct name<Windows::UI::Xaml::Controls::IListViewPersistenceHelperStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IListViewPersistenceHelperStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaElement2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaElement2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaElement3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaElement3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaElementStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaElementStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaElementStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaElementStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerElementFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerElementFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerElementStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerElementStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerPresenterFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerPresenterFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaPlayerPresenterStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaPlayerPresenterStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControls>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControls" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControls2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControls2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControls3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControls3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsHelper>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsHelper" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsHelperStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsHelperStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMediaTransportControlsStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyout2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyout2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItem2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItem2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItemBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItemBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItemBaseFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItemBaseFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutItemStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutPresenter2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutPresenterFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutPresenterFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSeparatorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSeparatorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSubItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSubItem2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSubItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IMenuFlyoutSubItemStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigate>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigate" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationView" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewDisplayModeChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemBaseFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemBaseFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemHeader>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemHeader" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemHeaderFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemHeaderFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemInvokedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemSeparatorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemSeparatorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewList>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewList" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewListFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewListFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewSelectionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::INavigationViewStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INavigationViewStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::INotifyEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INotifyEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::INotifyEventArgs2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.INotifyEventArgs2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPage>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPage" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPageFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPageFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPageOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPageOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPageStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPageStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IParallaxView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IParallaxView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IParallaxViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IParallaxViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IParallaxViewStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IParallaxViewStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBox3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBox3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBox4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBox4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBoxPasswordChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPasswordBoxStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPasswordBoxStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIconFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIconFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIconSourceFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIconSourceFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIconSourceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIconSourceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPathIconStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPathIconStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPersonPicture>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPersonPicture" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPersonPictureFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPersonPictureFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPersonPictureStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPersonPictureStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPickerConfirmedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPickerFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPickerFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivot>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivot" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivot2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivot2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivot3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivot3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotItemEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotItemEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IPivotStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IPivotStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IProgressBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IProgressBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::IProgressBarFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IProgressBarFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IProgressBarStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IProgressBarStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IProgressRing>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IProgressRing" }; };
template <> struct name<Windows::UI::Xaml::Controls::IProgressRingStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IProgressRingStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRadioButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRadioButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRadioButtonFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRadioButtonFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRadioButtonStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRadioButtonStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemFontInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemFontInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemFontInfoFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemFontInfoFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemFontInfoStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemFontInfoStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemImageInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemImageInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemImageInfoFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemImageInfoFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemImageInfoStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemImageInfoStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRatingItemInfoFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRatingItemInfoFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRelativePanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRelativePanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRelativePanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRelativePanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRelativePanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRelativePanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBox6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBox6" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxStatics6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxStatics6" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichEditBoxTextChangingEventArgs2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlock>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlock" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlock2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlock2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlock3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlock3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlock4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlock4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlock5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlock5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflow>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflow" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflow2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflow2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflow3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflowStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflowStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockOverflowStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRichTextBlockStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRichTextBlockStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRowDefinition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRowDefinition" }; };
template <> struct name<Windows::UI::Xaml::Controls::IRowDefinitionStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IRowDefinitionStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollContentPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollContentPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewer>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewer" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewer2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewer2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewer3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewer3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewerStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewerStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewerStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewerStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewerView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewerView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewerViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IScrollViewerViewChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxQueryChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxQuerySubmittedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxResultSuggestionChosenEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISearchBoxSuggestionsRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISectionsInViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgsFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISectionsInViewChangedEventArgsFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISelectionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISelectionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISelectionChangedEventArgsFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISelectionChangedEventArgsFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISemanticZoom>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISemanticZoom" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISemanticZoomInformation>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISemanticZoomInformation" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISemanticZoomLocation>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISemanticZoomLocation" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISemanticZoomStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISemanticZoomStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISemanticZoomViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISettingsFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISettingsFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISettingsFlyoutFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISettingsFlyoutFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISettingsFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISettingsFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISlider>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISlider" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISlider2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISlider2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISliderFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISliderFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISliderStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISliderStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISliderStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISliderStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitView" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitView2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitView2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitView3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitView3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitViewFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitViewFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitViewPaneClosingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitViewStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitViewStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISplitViewStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISplitViewStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanel2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanel2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanel4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanel4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanelStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanelStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStackPanelStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStackPanelStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStyleSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStyleSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStyleSelectorFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStyleSelectorFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IStyleSelectorOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IStyleSelectorOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainBackgroundPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainBackgroundPanel2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainBackgroundPanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainPanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainPanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwapChainPanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwapChainPanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItemInvokedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItems>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItems" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItemsFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItemsFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISwipeItemsStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISwipeItemsStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIconFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIconFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIconSourceFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIconSourceFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIconSourceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIconSourceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ISymbolIconStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ISymbolIconStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock4" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock5" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlock6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlock6" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlockStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlockStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlockStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlockStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlockStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlockStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlockStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlockStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBlockStatics6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBlockStatics6" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox4" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox5" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBox6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBox6" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxBeforeTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxStatics6>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxStatics6" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextBoxTextChangingEventArgs2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextCompositionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextCompositionEndedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextCompositionStartedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextControlCopyingToClipboardEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextControlCuttingToClipboardEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITextControlPasteEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITextControlPasteEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePicker2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePicker2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerFlyoutStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerFlyoutStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ITimePickerValueChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleMenuFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleMenuFlyoutItemFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleMenuFlyoutItemStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleSwitch>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleSwitch" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleSwitchOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleSwitchOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToggleSwitchStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToggleSwitchStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToolTip>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToolTip" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToolTipFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToolTipFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToolTipService>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToolTipService" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToolTipServiceStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToolTipServiceStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IToolTipStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IToolTipStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IUIElementCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IUIElementCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::IUserControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IUserControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::IUserControlFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IUserControlFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IUserControlStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IUserControlStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVariableSizedWrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVariableSizedWrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVariableSizedWrapGridStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVariableSizedWrapGridStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IViewbox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IViewbox" }; };
template <> struct name<Windows::UI::Xaml::Controls::IViewboxStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IViewboxStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingPanelFactory>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingPanelFactory" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingPanelOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingPanelOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingPanelProtected>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingPanelProtected" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingStackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingStackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingStackPanelOverrides>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingStackPanelOverrides" }; };
template <> struct name<Windows::UI::Xaml::Controls::IVirtualizingStackPanelStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IVirtualizingStackPanelStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebView" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebView2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebView2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebView3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebView3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebView4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebView4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebView5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebView5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewBrush>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewBrush" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewBrushStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewBrushStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewContentLoadingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewDOMContentLoadedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewDeferredPermissionRequest" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewFactory4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewFactory4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewLongRunningScriptDetectedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewNavigationCompletedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewNavigationFailedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewNavigationStartingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewNewWindowRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewPermissionRequest>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewPermissionRequest" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewPermissionRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewSettings>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewSettings" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewStatics2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewStatics2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewStatics3>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewStatics3" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewStatics4>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewStatics4" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewStatics5>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewStatics5" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewUnsupportedUriSchemeIdentifiedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewUnviewableContentIdentifiedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs2>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWebViewUnviewableContentIdentifiedEventArgs2" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::IWrapGridStatics>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IWrapGridStatics" }; };
template <> struct name<Windows::UI::Xaml::Controls::AppBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AppBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::AppBarButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AppBarButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::AppBarSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AppBarSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::AppBarToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AppBarToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::AutoSuggestBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AutoSuggestBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::AutoSuggestBoxQuerySubmittedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AutoSuggestBoxQuerySubmittedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::AutoSuggestBoxSuggestionChosenEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AutoSuggestBoxSuggestionChosenEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::AutoSuggestBoxTextChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AutoSuggestBoxTextChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::BackClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.BackClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::BitmapIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.BitmapIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::BitmapIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.BitmapIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::Border>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Border" }; };
template <> struct name<Windows::UI::Xaml::Controls::Button>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Button" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarDatePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarDatePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarDatePickerDateChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarDatePickerDateChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarView" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewDayItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewDayItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewDayItemChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewSelectedDatesChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewSelectedDatesChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CandidateWindowBoundsChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::Canvas>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Canvas" }; };
template <> struct name<Windows::UI::Xaml::Controls::CaptureElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CaptureElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::CheckBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CheckBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ChoosingGroupHeaderContainerEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ChoosingGroupHeaderContainerEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ChoosingItemContainerEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ChoosingItemContainerEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CleanUpVirtualizedItemEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColorChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColorChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColorPicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColorPicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColumnDefinition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColumnDefinition" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColumnDefinitionCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColumnDefinitionCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::ComboBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ComboBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ComboBoxItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ComboBoxItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBarOverflowPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBarOverflowPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContainerContentChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialog>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialog" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogButtonClickDeferral>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogButtonClickDeferral" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogButtonClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogClosedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogClosedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogClosingDeferral>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogClosingDeferral" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogClosingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogClosingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogOpenedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogOpenedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContextMenuEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContextMenuEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::Control>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Control" }; };
template <> struct name<Windows::UI::Xaml::Controls::ControlTemplate>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ControlTemplate" }; };
template <> struct name<Windows::UI::Xaml::Controls::DataTemplateSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DataTemplateSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePickerFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePickerFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::DatePickerValueChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DatePickerValueChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::DragItemsCompletedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DragItemsCompletedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::DragItemsStartingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DragItemsStartingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::DynamicOverflowItemsChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DynamicOverflowItemsChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::FlipView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FlipView" }; };
template <> struct name<Windows::UI::Xaml::Controls::FlipViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FlipViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::Flyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Flyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::FlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::FocusDisengagedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FocusDisengagedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::FocusEngagedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FocusEngagedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::FontIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FontIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::FontIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.FontIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::Frame>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Frame" }; };
template <> struct name<Windows::UI::Xaml::Controls::Grid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Grid" }; };
template <> struct name<Windows::UI::Xaml::Controls::GridView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GridView" }; };
template <> struct name<Windows::UI::Xaml::Controls::GridViewHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GridViewHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::GridViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GridViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::GroupItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GroupItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::GroupStyle>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GroupStyle" }; };
template <> struct name<Windows::UI::Xaml::Controls::GroupStyleSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.GroupStyleSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::Hub>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Hub" }; };
template <> struct name<Windows::UI::Xaml::Controls::HubSection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.HubSection" }; };
template <> struct name<Windows::UI::Xaml::Controls::HubSectionCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.HubSectionCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.HubSectionHeaderClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::HyperlinkButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.HyperlinkButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IconElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IconElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::IconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::Image>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Image" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkCanvas>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkCanvas" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbar" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarBallpointPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarBallpointPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarCustomPen>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarCustomPen" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarCustomPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarCustomPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarCustomToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarCustomToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarCustomToolButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarCustomToolButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarEraserButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarEraserButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarHighlighterButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarHighlighterButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarIsStencilButtonCheckedChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarIsStencilButtonCheckedChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarMenuButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarMenuButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarPenButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarPenButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarPenConfigurationControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarPenConfigurationControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarPencilButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarPencilButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarRulerButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarRulerButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarStencilButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarStencilButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarToggleButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarToggleButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarToolButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarToolButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IsTextTrimmedChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemClickEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemClickEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemContainerGenerator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemContainerGenerator" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsPanelTemplate>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsPanelTemplate" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsPickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsPickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsStackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsStackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsWrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsWrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListBoxItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListBoxItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListPickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListPickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListPickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListPickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListView" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewBaseHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewBaseHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewHeaderItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewHeaderItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewPersistenceHelper>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewPersistenceHelper" }; };
template <> struct name<Windows::UI::Xaml::Controls::MediaElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MediaElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::MediaPlayerElement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MediaPlayerElement" }; };
template <> struct name<Windows::UI::Xaml::Controls::MediaPlayerPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MediaPlayerPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::MediaTransportControls>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MediaTransportControls" }; };
template <> struct name<Windows::UI::Xaml::Controls::MediaTransportControlsHelper>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MediaTransportControlsHelper" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyoutItemBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyoutItemBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyoutSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyoutSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::MenuFlyoutSubItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.MenuFlyoutSubItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationView" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewDisplayModeChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewDisplayModeChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewItemBase>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewItemBase" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewItemHeader>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewItemHeader" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewItemInvokedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewItemInvokedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewItemSeparator>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewItemSeparator" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewList>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewList" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewSelectionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewSelectionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::NotifyEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NotifyEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::Page>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Page" }; };
template <> struct name<Windows::UI::Xaml::Controls::Panel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Panel" }; };
template <> struct name<Windows::UI::Xaml::Controls::ParallaxView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ParallaxView" }; };
template <> struct name<Windows::UI::Xaml::Controls::PasswordBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PasswordBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::PasswordBoxPasswordChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PasswordBoxPasswordChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::PathIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PathIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::PathIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PathIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::PersonPicture>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PersonPicture" }; };
template <> struct name<Windows::UI::Xaml::Controls::PickerConfirmedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PickerConfirmedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::PickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::PickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::Pivot>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Pivot" }; };
template <> struct name<Windows::UI::Xaml::Controls::PivotItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PivotItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::PivotItemEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PivotItemEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ProgressBar>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ProgressBar" }; };
template <> struct name<Windows::UI::Xaml::Controls::ProgressRing>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ProgressRing" }; };
template <> struct name<Windows::UI::Xaml::Controls::RadioButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RadioButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::RatingControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RatingControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::RatingItemFontInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RatingItemFontInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::RatingItemImageInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RatingItemImageInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::RatingItemInfo>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RatingItemInfo" }; };
template <> struct name<Windows::UI::Xaml::Controls::RelativePanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RelativePanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::RichEditBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RichEditBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::RichEditBoxTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RichEditBoxTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::RichTextBlock>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RichTextBlock" }; };
template <> struct name<Windows::UI::Xaml::Controls::RichTextBlockOverflow>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RichTextBlockOverflow" }; };
template <> struct name<Windows::UI::Xaml::Controls::RowDefinition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RowDefinition" }; };
template <> struct name<Windows::UI::Xaml::Controls::RowDefinitionCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RowDefinitionCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollContentPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollContentPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollViewer>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollViewer" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollViewerView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollViewerView" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollViewerViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollViewerViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollViewerViewChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollViewerViewChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SearchBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SearchBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::SearchBoxQueryChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SearchBoxQueryChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SearchBoxQuerySubmittedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SearchBoxQuerySubmittedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SearchBoxResultSuggestionChosenEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SearchBoxResultSuggestionChosenEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SearchBoxSuggestionsRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SearchBoxSuggestionsRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SectionsInViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SectionsInViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SelectionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SelectionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SemanticZoom>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SemanticZoom" }; };
template <> struct name<Windows::UI::Xaml::Controls::SemanticZoomLocation>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SemanticZoomLocation" }; };
template <> struct name<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SemanticZoomViewChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SettingsFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SettingsFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::Slider>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Slider" }; };
template <> struct name<Windows::UI::Xaml::Controls::SplitView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SplitView" }; };
template <> struct name<Windows::UI::Xaml::Controls::SplitViewPaneClosingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SplitViewPaneClosingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::StackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.StackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::StyleSelector>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.StyleSelector" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwapChainBackgroundPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwapChainBackgroundPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwapChainPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwapChainPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeItemInvokedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeItemInvokedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeItems>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeItems" }; };
template <> struct name<Windows::UI::Xaml::Controls::SymbolIcon>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SymbolIcon" }; };
template <> struct name<Windows::UI::Xaml::Controls::SymbolIconSource>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SymbolIconSource" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextBlock>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextBlock" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextBox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextBox" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextBoxBeforeTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextBoxBeforeTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextBoxTextChangingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextCompositionChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextCompositionEndedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextCompositionStartedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextControlCopyingToClipboardEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextControlCuttingToClipboardEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextControlPasteEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextControlPasteEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TimePickedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TimePickedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::TimePicker>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TimePicker" }; };
template <> struct name<Windows::UI::Xaml::Controls::TimePickerFlyout>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TimePickerFlyout" }; };
template <> struct name<Windows::UI::Xaml::Controls::TimePickerFlyoutPresenter>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TimePickerFlyoutPresenter" }; };
template <> struct name<Windows::UI::Xaml::Controls::TimePickerValueChangedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TimePickerValueChangedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::ToggleMenuFlyoutItem>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ToggleMenuFlyoutItem" }; };
template <> struct name<Windows::UI::Xaml::Controls::ToggleSwitch>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ToggleSwitch" }; };
template <> struct name<Windows::UI::Xaml::Controls::ToolTip>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ToolTip" }; };
template <> struct name<Windows::UI::Xaml::Controls::ToolTipService>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ToolTipService" }; };
template <> struct name<Windows::UI::Xaml::Controls::UIElementCollection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.UIElementCollection" }; };
template <> struct name<Windows::UI::Xaml::Controls::UserControl>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.UserControl" }; };
template <> struct name<Windows::UI::Xaml::Controls::VariableSizedWrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.VariableSizedWrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::Viewbox>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Viewbox" }; };
template <> struct name<Windows::UI::Xaml::Controls::VirtualizingPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.VirtualizingPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::VirtualizingStackPanel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.VirtualizingStackPanel" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebView>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebView" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewBrush>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewBrush" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewContentLoadingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewDOMContentLoadedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewDeferredPermissionRequest>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewDeferredPermissionRequest" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewLongRunningScriptDetectedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewLongRunningScriptDetectedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewNavigationCompletedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewNavigationFailedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewNavigationStartingEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewNewWindowRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewNewWindowRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewPermissionRequest>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewPermissionRequest" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewPermissionRequestedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewPermissionRequestedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewSettings>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewSettings" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewUnsupportedUriSchemeIdentifiedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewUnsupportedUriSchemeIdentifiedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewUnviewableContentIdentifiedEventArgs>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewUnviewableContentIdentifiedEventArgs" }; };
template <> struct name<Windows::UI::Xaml::Controls::WrapGrid>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WrapGrid" }; };
template <> struct name<Windows::UI::Xaml::Controls::AppBarClosedDisplayMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AppBarClosedDisplayMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.AutoSuggestionBoxTextChangeReason" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewDisplayMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewDisplayMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewSelectionMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewSelectionMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::CandidateWindowAlignment>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CandidateWindowAlignment" }; };
template <> struct name<Windows::UI::Xaml::Controls::CharacterCasing>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CharacterCasing" }; };
template <> struct name<Windows::UI::Xaml::Controls::ClickMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ClickMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColorPickerHsvChannel>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColorPickerHsvChannel" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColorSpectrumComponents>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColorSpectrumComponents" }; };
template <> struct name<Windows::UI::Xaml::Controls::ColorSpectrumShape>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ColorSpectrumShape" }; };
template <> struct name<Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ComboBoxSelectionChangedTrigger" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBarDefaultLabelPosition" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBarDynamicOverflowAction>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBarDynamicOverflowAction" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBarLabelPosition>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBarLabelPosition" }; };
template <> struct name<Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CommandBarOverflowButtonVisibility" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogButton>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogButton" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogPlacement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogPlacement" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContentDialogResult>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContentDialogResult" }; };
template <> struct name<Windows::UI::Xaml::Controls::DisabledFormattingAccelerators>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DisabledFormattingAccelerators" }; };
template <> struct name<Windows::UI::Xaml::Controls::IncrementalLoadingTrigger>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.IncrementalLoadingTrigger" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarButtonFlyoutPlacement" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarFlyoutItemKind" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarInitialControls>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarInitialControls" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarMenuKind>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarMenuKind" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarStencilKind>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarStencilKind" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarToggle>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarToggle" }; };
template <> struct name<Windows::UI::Xaml::Controls::InkToolbarTool>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.InkToolbarTool" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemsUpdatingScrollMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::LightDismissOverlayMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.LightDismissOverlayMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListPickerFlyoutSelectionMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewReorderMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewReorderMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewSelectionMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewSelectionMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::NavigationViewDisplayMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NavigationViewDisplayMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::Orientation>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Orientation" }; };
template <> struct name<Windows::UI::Xaml::Controls::PanelScrollingDirection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PanelScrollingDirection" }; };
template <> struct name<Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ParallaxSourceOffsetKind" }; };
template <> struct name<Windows::UI::Xaml::Controls::PasswordRevealMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PasswordRevealMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PivotHeaderFocusVisualPlacement" }; };
template <> struct name<Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.PivotSlideInAnimationGroup" }; };
template <> struct name<Windows::UI::Xaml::Controls::RequiresPointer>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RequiresPointer" }; };
template <> struct name<Windows::UI::Xaml::Controls::RichEditClipboardFormat>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.RichEditClipboardFormat" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollBarVisibility>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollBarVisibility" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollIntoViewAlignment>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollIntoViewAlignment" }; };
template <> struct name<Windows::UI::Xaml::Controls::ScrollMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ScrollMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::SelectionMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SelectionMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::SnapPointsType>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SnapPointsType" }; };
template <> struct name<Windows::UI::Xaml::Controls::SplitViewDisplayMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SplitViewDisplayMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::SplitViewPanePlacement>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SplitViewPanePlacement" }; };
template <> struct name<Windows::UI::Xaml::Controls::StretchDirection>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.StretchDirection" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeBehaviorOnInvoked" }; };
template <> struct name<Windows::UI::Xaml::Controls::SwipeMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SwipeMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::Symbol>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.Symbol" }; };
template <> struct name<Windows::UI::Xaml::Controls::VirtualizationMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.VirtualizationMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewExecutionMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewExecutionMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewPermissionState>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewPermissionState" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewPermissionType>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewPermissionType" }; };
template <> struct name<Windows::UI::Xaml::Controls::ZoomMode>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ZoomMode" }; };
template <> struct name<Windows::UI::Xaml::Controls::BackClickEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.BackClickEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CalendarViewDayItemChangingEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.CleanUpVirtualizedItemEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ContextMenuOpeningEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::DragItemsStartingEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.DragItemsStartingEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.HubSectionHeaderClickEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::ItemClickEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ItemClickEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewItemToKeyHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewItemToKeyHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::ListViewKeyToItemHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.ListViewKeyToItemHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::NotifyEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.NotifyEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SectionsInViewChangedEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::SelectionChangedEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SelectionChangedEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.SemanticZoomViewChangedEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextChangedEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextChangedEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::TextControlPasteEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.TextControlPasteEventHandler" }; };
template <> struct name<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler>{ static constexpr auto & value{ L"Windows.UI.Xaml.Controls.WebViewNavigationFailedEventHandler" }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBar>{ static constexpr GUID value{ 0x7B0FC253,0x86A5,0x4B43,{ 0x98,0x72,0x0B,0x8A,0x62,0x34,0xB7,0x4B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBar2>{ static constexpr GUID value{ 0xC3AB17B3,0x7AD7,0x4676,{ 0x99,0x10,0x7F,0xE3,0xF0,0xE8,0xE9,0x93 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBar3>{ static constexpr GUID value{ 0x982B001F,0x752E,0x4E7A,{ 0xB0,0x55,0x54,0x80,0x2C,0x9E,0xA7,0x49 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBar4>{ static constexpr GUID value{ 0x94EBC8CD,0x0A64,0x4DA3,{ 0xBF,0x43,0xF1,0x31,0x00,0xA4,0x66,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarButton>{ static constexpr GUID value{ 0x4459A451,0x69E8,0x440C,{ 0x98,0x96,0x4B,0xB4,0xF5,0xF6,0x42,0xD1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarButton3>{ static constexpr GUID value{ 0x0B282150,0x198B,0x4E84,{ 0x8F,0x1C,0x9F,0x6A,0x8B,0xA2,0x67,0xA7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarButtonFactory>{ static constexpr GUID value{ 0xBDBB1BB6,0xCB2E,0x4276,{ 0xAB,0xD6,0x79,0x35,0x13,0x05,0x10,0xE0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarButtonStatics>{ static constexpr GUID value{ 0x7CCD13E6,0x5301,0x407F,{ 0x87,0x4E,0xDC,0x91,0x60,0xAA,0x07,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarButtonStatics3>{ static constexpr GUID value{ 0x4D7BF314,0x2EDE,0x4328,{ 0x89,0x06,0x75,0x2A,0x1F,0x27,0xCD,0xFA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarFactory>{ static constexpr GUID value{ 0x614708D1,0x8E65,0x43CB,{ 0x92,0xD7,0x8E,0xEE,0x17,0x51,0x5F,0x8D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarOverrides>{ static constexpr GUID value{ 0xF003E4E2,0x7B0F,0x4F4A,{ 0x97,0x0D,0xAE,0x8A,0x0E,0xAA,0x9B,0x70 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarOverrides3>{ static constexpr GUID value{ 0x412BBBC8,0x51D0,0x4B49,{ 0xAB,0x62,0xA3,0xDD,0x6B,0xDC,0xB2,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarSeparator>{ static constexpr GUID value{ 0x1B0795A1,0x1BC1,0x4D53,{ 0x95,0xEA,0xFB,0x0A,0x2C,0xCC,0xC9,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarSeparatorFactory>{ static constexpr GUID value{ 0x05DA25CD,0xF407,0x48DE,{ 0x8B,0x50,0xFF,0x87,0xD1,0xE2,0x81,0x8F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics>{ static constexpr GUID value{ 0x37F23484,0x5B35,0x4663,{ 0xA7,0x5D,0xF2,0xD5,0x0C,0xB9,0xC6,0x19 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics3>{ static constexpr GUID value{ 0x36C753F9,0x7373,0x4E5E,{ 0x9B,0xA4,0xC3,0x62,0x2A,0x00,0x3C,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarStatics>{ static constexpr GUID value{ 0x79BB7E8D,0xDCA9,0x4B5F,{ 0xA4,0x48,0x37,0xB1,0x32,0x38,0xED,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarStatics2>{ static constexpr GUID value{ 0x222355E9,0x0384,0x49DE,{ 0x87,0x38,0xDF,0xC9,0xD4,0x09,0xAC,0x5D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarStatics4>{ static constexpr GUID value{ 0xBA02082E,0x1165,0x4451,{ 0x94,0xB3,0xEB,0x3A,0xC7,0x3E,0x41,0x96 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarToggleButton>{ static constexpr GUID value{ 0x2E914438,0xFD53,0x4B8D,{ 0x85,0x8B,0x36,0x44,0x26,0x9F,0x8E,0x4D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarToggleButton3>{ static constexpr GUID value{ 0xEF9A85E5,0x16FF,0x4D72,{ 0xB9,0xE8,0x9B,0x86,0x1E,0xAF,0x84,0xA8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarToggleButtonFactory>{ static constexpr GUID value{ 0x028AA7D4,0x8F54,0x45A6,{ 0x9F,0x90,0x13,0x60,0x56,0x56,0xD7,0x93 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics>{ static constexpr GUID value{ 0xFE5AAF96,0x7929,0x4DA1,{ 0xAA,0x67,0xCD,0xDF,0x73,0xA3,0xE4,0xB5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics3>{ static constexpr GUID value{ 0xBD4C65BF,0x2EDD,0x44D1,{ 0xAC,0xD5,0x35,0xC0,0x0E,0x2F,0x21,0xBC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBox>{ static constexpr GUID value{ 0x103E9B13,0x3400,0x4A16,{ 0x90,0xB9,0x69,0x12,0xBF,0x06,0x97,0x4F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBox2>{ static constexpr GUID value{ 0xAA87DDDE,0xE679,0x45B2,{ 0xA7,0xC9,0x9A,0xED,0xC3,0x9D,0xB8,0x86 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBox3>{ static constexpr GUID value{ 0x9BBBFCEF,0xF32D,0x402E,{ 0x90,0x09,0x05,0xBD,0xBA,0xF6,0x33,0x6E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs>{ static constexpr GUID value{ 0x78DCB116,0x818A,0x4CB5,{ 0xBC,0xA7,0x38,0x2C,0xE6,0xDD,0xC9,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics>{ static constexpr GUID value{ 0xEE22C7F4,0xC15D,0x4FF3,{ 0x8A,0x94,0xF5,0x0D,0xFD,0xFB,0xE8,0x9A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics2>{ static constexpr GUID value{ 0x1CD297A8,0x8E6A,0x41EF,{ 0xA9,0x5D,0x71,0x57,0xDC,0x0C,0x71,0x06 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics3>{ static constexpr GUID value{ 0x2CEAD2DD,0xC4D5,0x4AB2,{ 0x8A,0x13,0xAF,0xDD,0xCF,0x06,0x7C,0x86 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs>{ static constexpr GUID value{ 0x396F7254,0x1ED5,0x4BC5,{ 0xA0,0x60,0x65,0x55,0x30,0xBC,0xA6,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs>{ static constexpr GUID value{ 0x3A6F7254,0x1ED5,0x4BC5,{ 0xA0,0x60,0x65,0x55,0x30,0xBC,0xA6,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgsStatics>{ static constexpr GUID value{ 0xFEF7772B,0x9F45,0x44DB,{ 0x8C,0x27,0xBD,0xA3,0xF9,0x33,0xE7,0xB5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBackClickEventArgs>{ static constexpr GUID value{ 0x2AE6146C,0x477E,0x48C9,{ 0x88,0x30,0x2C,0x46,0x4B,0x7C,0x71,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIcon>{ static constexpr GUID value{ 0xE8FE17CB,0x35F7,0x40F3,{ 0xA1,0x85,0x48,0xB3,0x97,0xB7,0x3E,0x68 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIcon2>{ static constexpr GUID value{ 0x0624A20A,0x9DD1,0x4201,{ 0xBB,0x20,0x42,0x86,0x3D,0xA1,0x56,0x58 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconFactory>{ static constexpr GUID value{ 0x46D64B1D,0x7A49,0x4F66,{ 0x97,0x29,0x28,0x48,0xC7,0x88,0xE4,0x02 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconSource>{ static constexpr GUID value{ 0xC8E33DC7,0xD4AE,0x4A87,{ 0x94,0x7F,0xAC,0x4D,0x0B,0xCF,0x5A,0xF4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconSourceFactory>{ static constexpr GUID value{ 0x6509E5C6,0x44B6,0x4CD1,{ 0x86,0xCD,0xC3,0x18,0x9B,0x12,0xC4,0x3C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconSourceStatics>{ static constexpr GUID value{ 0x5A105887,0xE494,0x4D2B,{ 0x85,0x28,0x39,0x47,0x22,0x96,0x13,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconStatics>{ static constexpr GUID value{ 0xE072D117,0xE4E7,0x4E0C,{ 0x94,0x70,0x53,0xFF,0x1C,0xE8,0x4F,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBitmapIconStatics2>{ static constexpr GUID value{ 0x9745026B,0xB742,0x4A89,{ 0xA5,0xD7,0xA0,0xE5,0xFB,0x80,0x9A,0xF1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBorder>{ static constexpr GUID value{ 0x797C4539,0x45BD,0x4633,{ 0xA0,0x44,0xBF,0xB0,0x2E,0xF5,0x17,0x0F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IBorderStatics>{ static constexpr GUID value{ 0xB81D1639,0xE911,0x4FD7,{ 0xA4,0xC4,0xB9,0xC7,0xF0,0x08,0xB7,0xFC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IButton>{ static constexpr GUID value{ 0x280335AE,0x5570,0x46C7,{ 0x8E,0x0B,0x60,0x2B,0xE7,0x12,0x29,0xA2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IButtonFactory>{ static constexpr GUID value{ 0x80A13C19,0x843A,0x451C,{ 0x8C,0xF5,0x44,0xC7,0x01,0xB0,0xE2,0x16 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IButtonStaticsWithFlyout>{ static constexpr GUID value{ 0x90143898,0xA16C,0x4759,{ 0xB2,0xF0,0xA5,0xF7,0xE6,0x25,0x16,0x9E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IButtonWithFlyout>{ static constexpr GUID value{ 0x09108F87,0xDF6C,0x4180,{ 0x9B,0x3A,0xE6,0x08,0x45,0x82,0x58,0x11 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePicker>{ static constexpr GUID value{ 0x63C9C16F,0x668C,0x4491,{ 0x94,0x44,0xD4,0x5D,0x8B,0xF4,0xFA,0x29 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePicker2>{ static constexpr GUID value{ 0xB216C159,0x2411,0x4A60,{ 0xA7,0xAA,0x27,0x41,0x6B,0x49,0x48,0x1E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs>{ static constexpr GUID value{ 0x60D90DB2,0x5010,0x46BA,{ 0x84,0x2D,0xA4,0x15,0x2C,0x65,0x04,0xE7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePickerFactory>{ static constexpr GUID value{ 0x107AAD5D,0x38BE,0x42AF,{ 0xA9,0x57,0xFC,0x86,0xA5,0xCF,0x1E,0x9A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics>{ static constexpr GUID value{ 0x39A3D291,0xAFAB,0x4B94,{ 0x83,0x95,0xBA,0x7B,0x87,0x4E,0x3C,0x8C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics2>{ static constexpr GUID value{ 0x30206B58,0xA2F6,0x4A00,{ 0x8D,0x13,0x33,0xC4,0x6B,0x6B,0x8E,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarView>{ static constexpr GUID value{ 0xCD639203,0xDFB5,0x4312,{ 0xAC,0x07,0xC0,0x39,0x18,0x24,0x60,0x7B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewDayItem>{ static constexpr GUID value{ 0x0FDB2DC5,0x32C1,0x4B8F,{ 0xBE,0xFC,0x01,0x7B,0x55,0x5B,0x32,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs>{ static constexpr GUID value{ 0x73146666,0x1FB1,0x44F9,{ 0xB7,0xAD,0x4D,0xE8,0x59,0xEC,0xC5,0x65 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewDayItemFactory>{ static constexpr GUID value{ 0x62112BDC,0x1D2F,0x4E44,{ 0x9B,0xAF,0x16,0x65,0x74,0x95,0x21,0xF2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewDayItemStatics>{ static constexpr GUID value{ 0xC3A1DBBF,0xBD88,0x488B,{ 0xB9,0x16,0xD0,0x0D,0x69,0xB1,0x73,0x5A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewFactory>{ static constexpr GUID value{ 0x3D8F82E3,0x6CC6,0x423E,{ 0x8D,0x7C,0x70,0x14,0xD9,0x54,0xDD,0xEF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs>{ static constexpr GUID value{ 0xEE6069F6,0x13EF,0x4896,{ 0x8F,0xFC,0x53,0x02,0xB1,0xB1,0x75,0x39 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICalendarViewStatics>{ static constexpr GUID value{ 0x7260F1C4,0x2F5D,0x41BD,{ 0x99,0xBB,0x45,0x71,0xB2,0x0B,0x79,0xA8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs>{ static constexpr GUID value{ 0x8A946458,0x83B0,0x4C32,{ 0x94,0x50,0x51,0x69,0xA5,0x83,0x8B,0x55 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICanvas>{ static constexpr GUID value{ 0x79190E19,0xCD38,0x4823,{ 0xAE,0xAE,0x64,0xA7,0x71,0x32,0xF5,0x19 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICanvasFactory>{ static constexpr GUID value{ 0x1B328BD1,0xB400,0x4A8E,{ 0x94,0x3B,0x5A,0xD2,0xC4,0x5B,0xE0,0xDF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICanvasStatics>{ static constexpr GUID value{ 0x40CE5C46,0x2962,0x446F,{ 0xAA,0xFB,0x4C,0xDC,0x48,0x69,0x39,0xC9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICaptureElement>{ static constexpr GUID value{ 0x31A5C0E7,0xF307,0x4D4A,{ 0xB6,0x26,0xE9,0x78,0x86,0x3F,0x5B,0x74 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICaptureElementStatics>{ static constexpr GUID value{ 0x1E438DED,0x7DA6,0x409E,{ 0x80,0x6E,0x30,0x5A,0xE4,0xAD,0x9B,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICheckBox>{ static constexpr GUID value{ 0x2294C894,0x7E2A,0x4B70,{ 0xB0,0x88,0x8F,0x5D,0x81,0x48,0x75,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICheckBoxFactory>{ static constexpr GUID value{ 0x4FA6AABB,0x3F4B,0x4301,{ 0xBE,0x07,0x11,0x72,0xEA,0x61,0xEE,0xFB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs>{ static constexpr GUID value{ 0x67DB44D6,0xD201,0x4D72,{ 0xBE,0xAC,0x5E,0x8E,0x58,0xAF,0xD8,0xC7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs>{ static constexpr GUID value{ 0x9BB43BCE,0xAE67,0x4A80,{ 0x83,0x63,0xE3,0xFE,0x1B,0x24,0x4F,0x2C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs>{ static constexpr GUID value{ 0xEA05CCE9,0x937C,0x4120,{ 0x84,0x06,0x79,0x21,0x85,0x78,0x43,0x38 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColorChangedEventArgs>{ static constexpr GUID value{ 0x34F7201F,0xAAD0,0x4C3A,{ 0xB9,0x7B,0x2A,0xBF,0x36,0x45,0x55,0x39 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColorPicker>{ static constexpr GUID value{ 0x6232E371,0x5C64,0x43CB,{ 0x8B,0x35,0x7F,0x82,0xDD,0xE3,0x67,0x40 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColorPickerFactory>{ static constexpr GUID value{ 0xABAE07FF,0xAECF,0x481D,{ 0x92,0x04,0x20,0x1C,0x38,0x94,0xCD,0x1B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColorPickerStatics>{ static constexpr GUID value{ 0x67CA9BE7,0x1574,0x451A,{ 0xB6,0xDF,0xFE,0x57,0xD9,0xD0,0x7B,0x46 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColumnDefinition>{ static constexpr GUID value{ 0xF7F1B229,0xF024,0x467F,{ 0x97,0x0A,0x7E,0x70,0x56,0x15,0xDB,0x7B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IColumnDefinitionStatics>{ static constexpr GUID value{ 0x06B0D728,0xD044,0x40C6,{ 0x94,0x2E,0xAE,0x60,0xEA,0xC7,0x48,0x51 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBox>{ static constexpr GUID value{ 0xB9A8D05C,0xAC97,0x47F1,{ 0xA5,0xF4,0x3F,0x9F,0x4D,0x4B,0x11,0x6C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBox2>{ static constexpr GUID value{ 0xEA0CBF91,0xCA36,0x4FAD,{ 0x97,0x2A,0x2E,0x53,0xA6,0x71,0x8B,0x9F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBox3>{ static constexpr GUID value{ 0x52400A63,0x476C,0x4BB6,{ 0xB7,0x81,0x01,0x93,0x24,0xD3,0xFE,0xD9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBox4>{ static constexpr GUID value{ 0xB7974F49,0xB05C,0x47F9,{ 0x9A,0xAF,0xD6,0xF9,0x18,0x7B,0xE5,0xFD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBox5>{ static constexpr GUID value{ 0xAB79D646,0x800A,0x4A28,{ 0x96,0x9B,0x34,0xBB,0x8F,0xB4,0x58,0xCF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxFactory>{ static constexpr GUID value{ 0xAC0D0444,0xA65B,0x4ABD,{ 0x86,0xDF,0x30,0x16,0x04,0x9E,0xFE,0xDC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxItem>{ static constexpr GUID value{ 0x993FD6D2,0x2AAE,0x4F3B,{ 0xB4,0x4D,0x56,0x48,0xF4,0xD0,0x61,0x14 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxItemFactory>{ static constexpr GUID value{ 0x8FFFE867,0xD94C,0x4E87,{ 0x8F,0xC4,0x6E,0xBC,0xD6,0x3C,0x5A,0xC2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxOverrides>{ static constexpr GUID value{ 0x4F016541,0xBCFE,0x4A22,{ 0x89,0x32,0xC9,0x14,0x98,0x1C,0x22,0x40 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxStatics>{ static constexpr GUID value{ 0x3E14C9B1,0xD15B,0x4DC9,{ 0x81,0x10,0xCF,0x3A,0x11,0x7B,0x96,0xE7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxStatics2>{ static constexpr GUID value{ 0x93988A11,0x402C,0x4B13,{ 0x96,0xD1,0x72,0x20,0x26,0x6B,0x92,0x20 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxStatics3>{ static constexpr GUID value{ 0x949E140F,0xCE7F,0x4E41,{ 0xBD,0xC5,0xD1,0xD3,0x38,0x8A,0xD0,0xA6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxStatics4>{ static constexpr GUID value{ 0xD9F58358,0xF7B0,0x46CE,{ 0x80,0x61,0xAD,0x83,0xEC,0x2F,0x2D,0xD4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IComboBoxStatics5>{ static constexpr GUID value{ 0xB802CEF1,0xA264,0x444A,{ 0x9A,0x61,0xAA,0x88,0x67,0xB7,0xA6,0x3C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBar>{ static constexpr GUID value{ 0x98BC4280,0x4A3D,0x4CEE,{ 0xBD,0x07,0x22,0xCE,0x94,0xC5,0xAF,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBar2>{ static constexpr GUID value{ 0x57662F58,0x5B32,0x475D,{ 0xBE,0x64,0x4C,0xA3,0x6E,0x7B,0x97,0xD4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBar3>{ static constexpr GUID value{ 0x40EBBC23,0x2A79,0x48B3,{ 0x9A,0x67,0x64,0x9B,0x85,0x2D,0x85,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarElement>{ static constexpr GUID value{ 0x67918E1B,0xF2D5,0x44D1,{ 0x8B,0x84,0x92,0xB8,0x7F,0x80,0xA3,0x50 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarElement2>{ static constexpr GUID value{ 0xA9BF1236,0x4402,0x4688,{ 0xB9,0x87,0x9D,0x2B,0x9B,0x7B,0xF2,0xBD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarFactory>{ static constexpr GUID value{ 0x67BDEB44,0x20E1,0x4177,{ 0xAD,0x44,0xF6,0x17,0xB3,0x74,0xE8,0xE8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter>{ static constexpr GUID value{ 0x6E7A9427,0x58EF,0x4366,{ 0xA0,0x17,0x18,0xC1,0x93,0xD5,0x6B,0x14 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenterFactory>{ static constexpr GUID value{ 0x8323F774,0x5AAA,0x4049,{ 0xB7,0x8F,0x21,0x8C,0x6A,0x19,0xC3,0x7E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarStatics>{ static constexpr GUID value{ 0x5BD981EA,0xE278,0x409C,{ 0xB5,0x22,0xF9,0x46,0xCA,0x25,0x3B,0x44 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarStatics2>{ static constexpr GUID value{ 0x3D9EC8E3,0x51A9,0x4E34,{ 0x95,0x6C,0x70,0x81,0xD0,0x6F,0x26,0xF8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ICommandBarStatics3>{ static constexpr GUID value{ 0xB45A24A4,0x8AF1,0x4843,{ 0xB3,0x19,0xE0,0x3F,0xC4,0x5A,0xB7,0x26 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs>{ static constexpr GUID value{ 0x07DEEAA7,0x018F,0x4DDA,{ 0xB3,0x99,0xFD,0x4E,0x13,0xA3,0x1B,0xEA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentControl>{ static constexpr GUID value{ 0xA26DD1DC,0xCD44,0x435C,{ 0xBE,0x94,0x01,0xD6,0x24,0x1C,0x23,0x1C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentControl2>{ static constexpr GUID value{ 0x652C208C,0x8CCF,0x4399,{ 0xBD,0x3E,0x5A,0x01,0x5A,0xA1,0xBC,0x03 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentControlFactory>{ static constexpr GUID value{ 0xAB017B19,0x196E,0x4ED5,{ 0xA2,0x7F,0x55,0xC5,0x8F,0xB1,0x67,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentControlOverrides>{ static constexpr GUID value{ 0x5F4C0B10,0xE38E,0x4B5D,{ 0xBE,0x1A,0x5E,0xD0,0x42,0x46,0xA6,0x35 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentControlStatics>{ static constexpr GUID value{ 0x116982A4,0x5CF5,0x4C05,{ 0xA5,0x3F,0x15,0xE4,0x87,0x6C,0x85,0xEC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialog>{ static constexpr GUID value{ 0x38DC4404,0xD24E,0x40D8,{ 0x94,0x15,0x34,0x94,0x64,0xC1,0xAF,0xDC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialog2>{ static constexpr GUID value{ 0x2F93EB45,0xEE43,0x4303,{ 0x9B,0x38,0x3F,0xE1,0xA1,0x11,0xEC,0xBF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialog3>{ static constexpr GUID value{ 0x9D9A089E,0xF954,0x4EDE,{ 0xB0,0x7F,0x6B,0x06,0x9A,0x9C,0x01,0x80 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral>{ static constexpr GUID value{ 0xBD0D3637,0x19CE,0x4946,{ 0x8E,0x77,0xBD,0x03,0xFE,0x8E,0xBE,0x03 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs>{ static constexpr GUID value{ 0x5F34C205,0x8AFA,0x4CF2,{ 0x8C,0xA0,0x26,0x4D,0x73,0xBE,0xD6,0x3D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs>{ static constexpr GUID value{ 0x905522EF,0x2CBA,0x4AF8,{ 0xB6,0x66,0xCC,0x36,0xC2,0x27,0x32,0xFB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogClosingDeferral>{ static constexpr GUID value{ 0x215D4D11,0x7E30,0x4CB9,{ 0xA7,0x10,0x5A,0x4F,0x9C,0xCA,0x8B,0x42 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs>{ static constexpr GUID value{ 0xDB3C1C34,0x3BBF,0x47D4,{ 0xBE,0x4F,0xC9,0xEC,0x11,0x59,0x18,0xB9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogFactory>{ static constexpr GUID value{ 0x05557178,0x9D8E,0x4315,{ 0xB3,0x7D,0x68,0x0C,0x14,0x01,0x2C,0x35 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs>{ static constexpr GUID value{ 0x0966B315,0x5F59,0x4999,{ 0x9E,0x3E,0x37,0x4C,0x0F,0x17,0x4B,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogStatics>{ static constexpr GUID value{ 0x23AB47A6,0x508A,0x4F33,{ 0xB7,0x86,0xF2,0xFA,0x96,0xD8,0x69,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentDialogStatics2>{ static constexpr GUID value{ 0x329825B2,0x8FB0,0x4125,{ 0xBB,0x07,0xE7,0x9A,0x5A,0x03,0x81,0x9F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenter>{ static constexpr GUID value{ 0x79FDE5B4,0xCD37,0x491C,{ 0x88,0x45,0xDA,0xF4,0x72,0xDE,0xFF,0xF6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenter2>{ static constexpr GUID value{ 0x5138E958,0x335D,0x4210,{ 0x8B,0xBB,0x0A,0xA2,0xB4,0xB5,0xC2,0x9E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenter3>{ static constexpr GUID value{ 0xB038876A,0x9C4D,0x4402,{ 0xAC,0x56,0xA2,0x23,0x48,0x7D,0xC6,0xC8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenter4>{ static constexpr GUID value{ 0x997B1B17,0x3BF8,0x432B,{ 0x8F,0xD9,0x68,0xC7,0xBA,0xB2,0x1F,0x9D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterFactory>{ static constexpr GUID value{ 0x3339D4F7,0x4815,0x44C4,{ 0x9F,0x76,0x68,0xC8,0x38,0x80,0xEF,0x10 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterOverrides>{ static constexpr GUID value{ 0xA76339ED,0x32FF,0x438B,{ 0xAA,0xD5,0x1D,0x68,0xFA,0xE9,0x34,0x26 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterStatics>{ static constexpr GUID value{ 0x18C2893B,0xDA2E,0x4426,{ 0xB8,0x5A,0x2C,0x7E,0x21,0x71,0xBE,0xDF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterStatics2>{ static constexpr GUID value{ 0xC7D89DD9,0x06E6,0x46BE,{ 0xA8,0xA0,0x9C,0x11,0x7D,0x30,0x24,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterStatics3>{ static constexpr GUID value{ 0xCBE6CF5B,0x38B1,0x4D5D,{ 0xB0,0x98,0xBC,0x94,0xB3,0x5C,0x8D,0xDF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContentPresenterStatics4>{ static constexpr GUID value{ 0xFF8BE292,0xAF28,0x47EB,{ 0xA5,0xC3,0xDC,0x44,0xCE,0xD4,0x0F,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IContextMenuEventArgs>{ static constexpr GUID value{ 0x1F7DF263,0xC14B,0x4528,{ 0xB6,0xF0,0x63,0x79,0x99,0xD8,0x3C,0xC6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControl>{ static constexpr GUID value{ 0xA8912263,0x2951,0x4F58,{ 0xA9,0xC5,0x5A,0x13,0x4E,0xAA,0x7F,0x07 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControl2>{ static constexpr GUID value{ 0x43E0FE10,0x14EC,0x427E,{ 0x8C,0x57,0xDE,0xE6,0x0D,0xF6,0x0A,0xA8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControl3>{ static constexpr GUID value{ 0x077B29E4,0xDADE,0x4F55,{ 0x9B,0x96,0x09,0xE2,0x1B,0x28,0xEB,0x1C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControl4>{ static constexpr GUID value{ 0x0E18AEEE,0x5F2E,0x44EA,{ 0x85,0x13,0xD3,0x87,0x5C,0x0A,0x75,0x13 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControl5>{ static constexpr GUID value{ 0x5EBB51D5,0x9E58,0x49B7,{ 0xBC,0x2D,0x01,0x55,0xFF,0x11,0x86,0x64 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlFactory>{ static constexpr GUID value{ 0xB12B1D5A,0x6419,0x4E16,{ 0xB2,0x12,0xA4,0x53,0x36,0xB7,0x57,0x78 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlOverrides>{ static constexpr GUID value{ 0xA09691DF,0x9824,0x41FE,{ 0xB5,0x30,0xB0,0xD8,0x99,0x0E,0x64,0xC1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlOverrides6>{ static constexpr GUID value{ 0xE194C96A,0xD8CC,0x4339,{ 0xA0,0xE1,0x2E,0x9C,0x42,0x08,0x79,0xEC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlProtected>{ static constexpr GUID value{ 0x1791587A,0x2A7C,0x4981,{ 0xA2,0xD8,0xAB,0x99,0xFF,0xFC,0x65,0xB9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlStatics>{ static constexpr GUID value{ 0x473B305B,0x877D,0x4C35,{ 0x8F,0xCA,0x46,0xA0,0x5F,0x96,0x60,0x7A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlStatics2>{ static constexpr GUID value{ 0x32233E36,0xAB74,0x4A25,{ 0xA5,0x56,0x45,0x29,0x31,0x35,0xB2,0xC5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlStatics3>{ static constexpr GUID value{ 0xAAD15E61,0xE4B9,0x4D72,{ 0xB6,0x53,0x93,0x41,0x49,0xAA,0x50,0x03 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlStatics4>{ static constexpr GUID value{ 0x59FDA728,0xC05A,0x4EC2,{ 0x8A,0x4B,0x06,0xAD,0x69,0xB6,0x6E,0x15 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlStatics5>{ static constexpr GUID value{ 0xF635B5A3,0xEF8E,0x404F,{ 0x87,0x7B,0x55,0x80,0x47,0x37,0x10,0xA6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IControlTemplate>{ static constexpr GUID value{ 0xEFD2418E,0x41E0,0x48BB,{ 0x8B,0x82,0x91,0xED,0xA1,0xBA,0x3F,0xE2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDataTemplateSelector>{ static constexpr GUID value{ 0xA907D496,0x46A0,0x4CD7,{ 0x8D,0xBE,0xF9,0xA5,0x81,0xDF,0x60,0xB1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDataTemplateSelector2>{ static constexpr GUID value{ 0x3792BC47,0x8C4B,0x4257,{ 0xA5,0xAE,0xCC,0x3F,0x8E,0xD7,0x86,0xEB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDataTemplateSelectorFactory>{ static constexpr GUID value{ 0x511BAAD0,0x210A,0x457D,{ 0x95,0x21,0x43,0x3D,0x2B,0x11,0xB7,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides>{ static constexpr GUID value{ 0x2D162925,0x5966,0x4BFA,{ 0x86,0x38,0x4D,0x34,0x56,0x89,0xF6,0xCF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides2>{ static constexpr GUID value{ 0x6C3FB5FC,0x8E84,0x4C91,{ 0xAC,0x15,0x04,0xA1,0xD8,0x85,0x50,0x0F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickedEventArgs>{ static constexpr GUID value{ 0xA1527B12,0x59C1,0x4521,{ 0xB2,0x8C,0xB1,0x76,0x67,0x5E,0x7C,0x5A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePicker>{ static constexpr GUID value{ 0x06DA3946,0x08B8,0x4103,{ 0x8B,0x8A,0x09,0x3E,0xFD,0x6A,0x76,0x57 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePicker2>{ static constexpr GUID value{ 0xBB28B475,0x2C1F,0x4340,{ 0x9E,0x30,0x94,0x8F,0x99,0xC9,0xE5,0x7A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFactory>{ static constexpr GUID value{ 0xEEC3CA84,0x9896,0x4A7D,{ 0xBB,0x35,0x6F,0xB2,0x1E,0xAE,0xCA,0x11 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyout>{ static constexpr GUID value{ 0xFBF33B1A,0xA3A4,0x4DF8,{ 0x92,0x28,0x23,0xA5,0xAC,0x27,0xDF,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyout2>{ static constexpr GUID value{ 0xCFB18DBB,0x9931,0x4119,{ 0x8B,0xDA,0x54,0xA8,0x6F,0xDF,0xAC,0x84 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyoutItem>{ static constexpr GUID value{ 0x9D9BC289,0x00D2,0x4AAC,{ 0x9C,0x85,0xD7,0x4F,0x06,0x36,0x78,0x87 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyoutItemStatics>{ static constexpr GUID value{ 0xAA9C91DA,0x07F6,0x4CDF,{ 0x89,0xB4,0xDD,0xA3,0xBD,0xB0,0xEA,0x6B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter>{ static constexpr GUID value{ 0x7C62F70E,0x2DDC,0x4381,{ 0x83,0x2F,0x54,0xCB,0xDF,0xAA,0x84,0x9A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics>{ static constexpr GUID value{ 0xCD570377,0x5845,0x4C12,{ 0x8C,0x10,0x59,0x2D,0x9F,0xCC,0x7C,0xD9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics2>{ static constexpr GUID value{ 0xAFD3E569,0x81E6,0x4B54,{ 0x84,0xA9,0x68,0x07,0x9B,0x73,0xE3,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerStatics>{ static constexpr GUID value{ 0x182E7C69,0x2116,0x4C67,{ 0xB5,0x13,0x71,0x33,0x64,0x83,0x1D,0x79 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerStatics2>{ static constexpr GUID value{ 0xF1076DF6,0xFBA6,0x4550,{ 0x8B,0x88,0xA6,0x42,0x08,0x47,0xF6,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs>{ static constexpr GUID value{ 0x1AE661B2,0xB1B4,0x4273,{ 0x96,0xE0,0x19,0xDA,0xFF,0x18,0x74,0x46 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs>{ static constexpr GUID value{ 0xAF05F22F,0x9E78,0x4B21,{ 0x9A,0x8E,0x41,0xC2,0xD1,0x36,0x7A,0x2A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs>{ static constexpr GUID value{ 0x71CF215C,0xDAED,0x4783,{ 0xAA,0x11,0xDC,0x57,0x4D,0x27,0x13,0xE9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs>{ static constexpr GUID value{ 0xC93C736F,0x6F6E,0x4E43,{ 0x90,0xD9,0x9B,0x46,0xA0,0xD8,0x8B,0x9F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipView>{ static constexpr GUID value{ 0xA1582F68,0x3D7D,0x4D3B,{ 0xB7,0x1D,0x48,0x8E,0xED,0x1E,0x34,0x93 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipView2>{ static constexpr GUID value{ 0xC4FEA4FD,0x7AF3,0x4952,{ 0x9F,0xD9,0x9E,0x09,0x87,0xFC,0x4F,0x29 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipViewFactory>{ static constexpr GUID value{ 0xF1DEA9BE,0x9AE8,0x4D4B,{ 0xAB,0x43,0x16,0xD3,0x1E,0x05,0xF4,0xF3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipViewItem>{ static constexpr GUID value{ 0x56196565,0xCE2B,0x4BDA,{ 0xA3,0x6B,0x82,0xA2,0xB8,0xB0,0xD4,0xC0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipViewItemFactory>{ static constexpr GUID value{ 0xF21D91FE,0x22A0,0x4412,{ 0xA8,0x53,0x9D,0x6A,0x6E,0x8F,0x2A,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlipViewStatics2>{ static constexpr GUID value{ 0x70E3D93F,0x4308,0x4BA2,{ 0xBB,0xCE,0xE2,0xCB,0x0E,0xD3,0x44,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlyout>{ static constexpr GUID value{ 0x6584EBDF,0xCBC7,0x4E19,{ 0x84,0x3A,0xA1,0x4F,0x24,0xA7,0x93,0xEA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlyoutFactory>{ static constexpr GUID value{ 0x4BED4933,0x008E,0x4B03,{ 0xA3,0x85,0x79,0xFE,0x52,0x66,0xDD,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlyoutPresenter>{ static constexpr GUID value{ 0x827D5B79,0xE37B,0x46A5,{ 0x8D,0x44,0x63,0xA1,0x1A,0x58,0x0E,0x83 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlyoutPresenterFactory>{ static constexpr GUID value{ 0xEE4D668F,0xDA76,0x469A,{ 0xAC,0xD7,0x30,0x60,0xE6,0x13,0xAD,0xE7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFlyoutStatics>{ static constexpr GUID value{ 0x61364E0B,0xDB75,0x47E1,{ 0xB2,0xC3,0x5B,0x90,0x1C,0x3D,0x74,0xB6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs>{ static constexpr GUID value{ 0x5E14280F,0x953E,0x4CF8,{ 0xB9,0xEA,0xC5,0x30,0xA1,0xCE,0x02,0xAD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs>{ static constexpr GUID value{ 0xA69FC352,0xDA66,0x404C,{ 0x82,0x3F,0x53,0x58,0x59,0x4E,0x70,0xBB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs2>{ static constexpr GUID value{ 0x4A59E0F4,0x87C0,0x4CCD,{ 0x93,0xC4,0xA3,0xA0,0x1C,0xE3,0x92,0x65 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIcon>{ static constexpr GUID value{ 0xD4D61391,0x39AC,0x4950,{ 0x91,0x66,0x36,0x06,0xC2,0x64,0x41,0x8B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIcon2>{ static constexpr GUID value{ 0xF6EBD84D,0x37E8,0x46EE,{ 0xA5,0x74,0x41,0xAD,0x55,0x04,0x82,0xE0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIcon3>{ static constexpr GUID value{ 0x6155D919,0x1C6C,0x4950,{ 0x87,0x94,0x23,0x1E,0xF0,0x91,0x4D,0x94 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconFactory>{ static constexpr GUID value{ 0x1C781B6B,0x37BF,0x4DDC,{ 0xA1,0xA8,0x1B,0x77,0xDB,0x3C,0xF0,0xEA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconSource>{ static constexpr GUID value{ 0x2211AC9A,0x74E3,0x43ED,{ 0xB6,0x1C,0x21,0xAF,0xC7,0xDF,0x4D,0x10 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconSourceFactory>{ static constexpr GUID value{ 0x8BDCF6BD,0xFC06,0x42B8,{ 0xB3,0x0B,0x75,0x05,0x08,0x2A,0xC3,0x8F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconSourceStatics>{ static constexpr GUID value{ 0x8C0E422F,0x8269,0x43B1,{ 0xB9,0x5A,0xEF,0x07,0x0E,0x86,0x77,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconStatics>{ static constexpr GUID value{ 0xB3BE7BF6,0x1467,0x4086,{ 0xBB,0xCB,0x4E,0x21,0xD9,0x7A,0x7B,0x4D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconStatics2>{ static constexpr GUID value{ 0xE6080672,0x08F8,0x43D3,{ 0x87,0x90,0x46,0x04,0x29,0x0C,0xBE,0xBD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFontIconStatics3>{ static constexpr GUID value{ 0xA4528B17,0xB084,0x4BD5,{ 0xAA,0xB4,0xFE,0xAE,0x9D,0x3B,0x5D,0x26 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrame>{ static constexpr GUID value{ 0x68EA500B,0x3FE9,0x4735,{ 0xB6,0xA0,0xE7,0x60,0x19,0x33,0xB0,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrame2>{ static constexpr GUID value{ 0x3F367F87,0x9F5A,0x4B04,{ 0xB8,0x18,0xB5,0x54,0xC0,0x69,0x59,0x7A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrame3>{ static constexpr GUID value{ 0x648A2B4D,0x53CA,0x4B5A,{ 0xAA,0x8E,0x3C,0xC7,0x44,0x0F,0x4A,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrame4>{ static constexpr GUID value{ 0x9B17C21A,0xBD2B,0x4A00,{ 0x99,0xEB,0x94,0x6B,0xE9,0x61,0x80,0x84 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrameFactory>{ static constexpr GUID value{ 0x02EE93D4,0x448E,0x469E,{ 0x97,0x99,0x0A,0x8A,0x1F,0x70,0xF1,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrameStatics>{ static constexpr GUID value{ 0xD5ACF0E9,0xD967,0x471B,{ 0x84,0x59,0xC8,0xAF,0x43,0x41,0x51,0x1B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IFrameStatics2>{ static constexpr GUID value{ 0xE4B5CDFE,0x42F0,0x4462,{ 0xA1,0xC1,0x5D,0x25,0x9D,0xD8,0x2A,0x03 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGrid>{ static constexpr GUID value{ 0xFD104460,0x2E15,0x4BA3,{ 0x8B,0x8F,0xFA,0x69,0x3A,0x41,0x61,0xE9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGrid2>{ static constexpr GUID value{ 0xF76EFA41,0x380E,0x45DB,{ 0xBE,0x87,0x9E,0x13,0x26,0xBA,0x4B,0x57 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGrid3>{ static constexpr GUID value{ 0x12DFC5FC,0x2342,0x4DD2,{ 0x9E,0x7D,0x20,0x90,0xA1,0x71,0xD1,0xEF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridFactory>{ static constexpr GUID value{ 0xAE814041,0xC531,0x43B4,{ 0xBF,0x99,0x12,0xF5,0x06,0xF7,0xB0,0x1C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridStatics>{ static constexpr GUID value{ 0x64FE2E9F,0xF951,0x42B6,{ 0xA9,0xCE,0xBB,0x17,0x9A,0xF1,0x15,0x95 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridStatics2>{ static constexpr GUID value{ 0x2D666658,0x58B6,0x4A1B,{ 0x84,0x1B,0x87,0x5B,0xA9,0x3B,0x5D,0x6A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridStatics3>{ static constexpr GUID value{ 0xC3FBA437,0x5A0C,0x407A,{ 0x96,0x21,0x79,0x54,0x53,0x86,0xD8,0x11 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridView>{ static constexpr GUID value{ 0x026AE934,0xB67E,0x4D80,{ 0x8F,0x72,0x8A,0xA6,0x4B,0x4D,0x82,0x7B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridViewFactory>{ static constexpr GUID value{ 0xD9BCCA89,0x09F9,0x4C6E,{ 0xA8,0x3E,0xF1,0x99,0x14,0x6F,0x0E,0x7D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridViewHeaderItem>{ static constexpr GUID value{ 0x72D75D7E,0x5DC3,0x4FFC,{ 0x9B,0x1C,0x93,0x9B,0x5C,0x37,0x16,0x1C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridViewHeaderItemFactory>{ static constexpr GUID value{ 0x36E0C96E,0xB56A,0x4B3B,{ 0x8B,0xAC,0x7A,0xEF,0x5E,0x6F,0x99,0x45 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridViewItem>{ static constexpr GUID value{ 0x7D9901F1,0xE7C1,0x4E83,{ 0xB4,0x70,0xC9,0xD6,0xD7,0xBD,0xA9,0xF5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGridViewItemFactory>{ static constexpr GUID value{ 0x229B00AF,0x3FA6,0x43E9,{ 0x97,0x9D,0x07,0xEA,0x0D,0x62,0x80,0xDC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupItem>{ static constexpr GUID value{ 0x4AE8D5D1,0x7228,0x4A16,{ 0xA6,0x1F,0x88,0xC0,0xE8,0xF4,0x5C,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupItemFactory>{ static constexpr GUID value{ 0xD9A1D53E,0xB1E0,0x4319,{ 0x98,0x08,0x7A,0x9E,0x88,0x7E,0x13,0xB0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyle>{ static constexpr GUID value{ 0x71CA300B,0xB89E,0x4184,{ 0xB0,0xDF,0xA9,0xE9,0x54,0x47,0xDE,0x8D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyle2>{ static constexpr GUID value{ 0x69F90679,0x3A11,0x4FE7,{ 0xB4,0xDF,0x2A,0x01,0x39,0xD4,0x01,0x8B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyleFactory>{ static constexpr GUID value{ 0x56FF664F,0xE2D7,0x4F49,{ 0x80,0x3D,0xC7,0x27,0xCD,0xF9,0x37,0x2D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyleSelector>{ static constexpr GUID value{ 0x6DDA119E,0x9A74,0x478F,{ 0xA3,0x39,0x5B,0xB5,0x2D,0xE6,0xC5,0x1E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyleSelectorFactory>{ static constexpr GUID value{ 0xBF570D33,0xB2F6,0x481F,{ 0xA4,0x50,0xC8,0x0C,0x29,0x1F,0xB2,0x2D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IGroupStyleSelectorOverrides>{ static constexpr GUID value{ 0xF691CAB2,0x77AD,0x4D3D,{ 0xA5,0x1C,0x8E,0xF9,0xC3,0x83,0x64,0x56 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHub>{ static constexpr GUID value{ 0xAE692E82,0x7314,0x4F51,{ 0xAB,0x11,0x2A,0xF1,0xED,0x4A,0x19,0xF8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubFactory>{ static constexpr GUID value{ 0xDCA6B2BA,0xC6F5,0x4961,{ 0x99,0x53,0xC5,0x18,0x73,0xDB,0x54,0x24 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubSection>{ static constexpr GUID value{ 0xA4E66CB7,0x7FDD,0x4FE0,{ 0xAB,0x49,0xC2,0x46,0x63,0x9D,0xCC,0xF9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubSectionFactory>{ static constexpr GUID value{ 0xFFF55FA2,0xECE4,0x4BBA,{ 0xAA,0x3B,0x98,0x04,0xAE,0xF4,0x78,0x83 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs>{ static constexpr GUID value{ 0xE1C5EF04,0x1EDD,0x4112,{ 0xAE,0xEB,0x99,0x6C,0x96,0x40,0x06,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubSectionStatics>{ static constexpr GUID value{ 0x12D2D85A,0xEA27,0x42D1,{ 0x99,0x8B,0x61,0xE5,0x2A,0xED,0x84,0x2B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHubStatics>{ static constexpr GUID value{ 0x0E6FA034,0xAD3C,0x4F32,{ 0xB7,0x01,0xE2,0x4F,0xAB,0x56,0x20,0x28 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHyperlinkButton>{ static constexpr GUID value{ 0xCCEBACA3,0x3B5C,0x4F4C,{ 0x9B,0xFD,0x86,0x88,0x7B,0xC7,0x97,0x72 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHyperlinkButtonFactory>{ static constexpr GUID value{ 0x43521BAD,0x4E97,0x4DA9,{ 0xA6,0x4D,0x93,0x5D,0xFD,0x8C,0xED,0xF2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IHyperlinkButtonStatics>{ static constexpr GUID value{ 0xFBAEB5C7,0xCDB7,0x4263,{ 0xB7,0xD6,0x3C,0x0D,0x29,0x04,0xED,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconElement>{ static constexpr GUID value{ 0x9AF0803B,0xD04C,0x467A,{ 0xBB,0xD5,0x9B,0x81,0xF0,0x2D,0x9A,0x56 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconElementFactory>{ static constexpr GUID value{ 0xCF37A562,0x0424,0x43C7,{ 0x8B,0xEA,0x72,0x0F,0xBA,0x97,0x3E,0xF1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconElementStatics>{ static constexpr GUID value{ 0xBE19A623,0x77CF,0x472F,{ 0x82,0xEA,0x04,0x78,0x01,0xD1,0x20,0x12 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconSource>{ static constexpr GUID value{ 0x92EC8D55,0x45EB,0x47A4,{ 0x86,0x3C,0x91,0xB2,0x24,0x04,0x4F,0x9B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconSourceFactory>{ static constexpr GUID value{ 0x4D117CF1,0x1FD6,0x49D7,{ 0xB4,0x83,0x02,0xEC,0x3D,0xE9,0x97,0xD6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIconSourceStatics>{ static constexpr GUID value{ 0x1D389DBE,0x1CD3,0x4F4F,{ 0x83,0xB0,0x55,0xDC,0x63,0x87,0x68,0x5B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IImage>{ static constexpr GUID value{ 0x495B7402,0x9AF3,0x4E50,{ 0xAA,0x90,0x03,0x38,0x8F,0x30,0x86,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IImage2>{ static constexpr GUID value{ 0xF445119E,0x881F,0x48BB,{ 0x87,0x3A,0x64,0x41,0x7C,0xA4,0xF0,0x02 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IImage3>{ static constexpr GUID value{ 0x06EBE792,0x47C2,0x4D92,{ 0xA4,0x88,0x8C,0xD6,0x85,0xD0,0x6A,0xCA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IImageStatics>{ static constexpr GUID value{ 0x89903772,0xC336,0x43D1,{ 0x9D,0x51,0xC3,0xBB,0xD5,0xD5,0xD6,0x91 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkCanvas>{ static constexpr GUID value{ 0x29443C28,0x8E48,0x4FC8,{ 0xA4,0x73,0x35,0xB0,0xBA,0x12,0xAC,0xEA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkCanvasFactory>{ static constexpr GUID value{ 0x924AC2DE,0xAB04,0x48F0,{ 0x96,0x53,0xE0,0xF2,0xDA,0x4D,0xBF,0x1A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbar>{ static constexpr GUID value{ 0x3DDD0CCA,0x51F0,0x486F,{ 0xA0,0x3E,0x4E,0xE1,0x3D,0xC1,0x2B,0xCB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbar2>{ static constexpr GUID value{ 0x86F0C111,0xB484,0x454A,{ 0xAE,0x78,0x1D,0x25,0xA3,0x3D,0x1C,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton>{ static constexpr GUID value{ 0x158329F8,0x1E99,0x3ACC,{ 0x91,0x0F,0x9D,0xA2,0xD8,0x72,0xAE,0x12 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButtonFactory>{ static constexpr GUID value{ 0x2F0BD3E4,0xD754,0x4255,{ 0x8E,0xC4,0x00,0xCD,0x10,0x12,0x96,0xAB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPen>{ static constexpr GUID value{ 0x4082207B,0x2F3D,0x4E6A,{ 0x8C,0x27,0xFE,0x61,0xEF,0x7E,0x70,0xEB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton>{ static constexpr GUID value{ 0x46024401,0x2B2A,0x4F3C,{ 0xA5,0x3C,0x1A,0x04,0x5A,0x40,0x8E,0xFA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonFactory>{ static constexpr GUID value{ 0x0F2EF0BA,0xC8B9,0x4C36,{ 0x89,0x87,0x94,0xD3,0xDA,0xFE,0xDE,0x18 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonStatics>{ static constexpr GUID value{ 0x373C25F4,0xE555,0x4E85,{ 0xA8,0x0D,0xDA,0x6B,0x84,0x33,0xDB,0xDE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPenFactory>{ static constexpr GUID value{ 0xD214D636,0xF1AA,0x4F48,{ 0xBF,0x2C,0xA9,0x26,0xCA,0xAE,0x4C,0x60 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomPenOverrides>{ static constexpr GUID value{ 0x9D22EB6C,0x1255,0x4256,{ 0xB6,0xBD,0x82,0xC2,0xFD,0x27,0x34,0x88 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton>{ static constexpr GUID value{ 0x550C4D84,0x4F54,0x4FBE,{ 0xB1,0x2B,0xE0,0xA5,0x0A,0xAB,0x0D,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButtonFactory>{ static constexpr GUID value{ 0x4A00374D,0x4CD2,0x4ED9,{ 0x86,0x3E,0x83,0xB8,0xCF,0x3F,0xD2,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton>{ static constexpr GUID value{ 0x9F98ACD7,0xC605,0x4105,{ 0xBE,0x10,0x39,0x43,0xA7,0xC0,0xDA,0x3C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonFactory>{ static constexpr GUID value{ 0xC295FE4E,0x30EB,0x4130,{ 0xA6,0xB6,0x8C,0x85,0xD8,0xE2,0x6E,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonStatics>{ static constexpr GUID value{ 0x11FE4CB9,0xBBAC,0x4314,{ 0x93,0x44,0x92,0xC6,0x69,0x3D,0xDE,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarEraserButton>{ static constexpr GUID value{ 0x4CBDB92E,0x5F5E,0x4B35,{ 0xA4,0x1C,0x16,0xFF,0xB0,0x28,0x3B,0xC0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarEraserButton2>{ static constexpr GUID value{ 0xE7A59257,0x5AE8,0x436D,{ 0xB2,0xE2,0x93,0xC2,0x00,0x90,0x0C,0xA0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonFactory>{ static constexpr GUID value{ 0xFD40611D,0xD1BA,0x4D67,{ 0xAF,0x00,0x14,0x80,0x36,0xAD,0x49,0x2C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonStatics2>{ static constexpr GUID value{ 0x038A1736,0xC5CD,0x4311,{ 0x83,0xF4,0x38,0xCB,0xF0,0x7C,0x20,0x66 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarFactory>{ static constexpr GUID value{ 0x3947AA99,0x36B1,0x4374,{ 0xAB,0x5C,0x98,0xBF,0x07,0xA4,0x32,0x0B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>{ static constexpr GUID value{ 0x92B68786,0x37EE,0x4915,{ 0x9E,0x89,0xE1,0x87,0x56,0x4A,0x88,0x9A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemFactory>{ static constexpr GUID value{ 0x352E7B93,0x803B,0x4F0E,{ 0x8C,0x72,0x9D,0xFC,0x03,0x29,0x32,0x9F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemStatics>{ static constexpr GUID value{ 0x1FE54B64,0x4063,0x4A5F,{ 0xB8,0x9C,0x9F,0x58,0x93,0x5E,0xE3,0x79 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton>{ static constexpr GUID value{ 0x0B3CC15B,0x7ABF,0x487E,{ 0xAC,0xC1,0x5B,0x50,0x48,0xFE,0xE6,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButtonFactory>{ static constexpr GUID value{ 0x7C334ADD,0x42CA,0x4943,{ 0x94,0xA4,0x23,0xB5,0xA6,0xE5,0x5C,0xF1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs>{ static constexpr GUID value{ 0x026EDD26,0xD32B,0x4E28,{ 0xA0,0x33,0xD5,0x09,0x76,0x62,0xB2,0x92 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarMenuButton>{ static constexpr GUID value{ 0x860ECAE5,0x7633,0x4EA1,{ 0xA2,0x09,0x50,0x39,0x2D,0x1A,0xEB,0xD1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonFactory>{ static constexpr GUID value{ 0x7A463A9D,0x5DC7,0x44A7,{ 0xAF,0xD0,0x2B,0x68,0x5C,0xB9,0xA9,0x6C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonStatics>{ static constexpr GUID value{ 0xF03B17A6,0xB8B0,0x4A87,{ 0xA9,0x61,0x37,0xCD,0x05,0xD8,0x31,0x37 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenButton>{ static constexpr GUID value{ 0xE0B80C21,0xB032,0x40EE,{ 0xA2,0xB9,0x50,0x7F,0x6C,0xCB,0x82,0x7B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenButtonFactory>{ static constexpr GUID value{ 0xB1463D21,0x59CB,0x4A83,{ 0x92,0xE1,0x69,0x28,0x42,0x79,0x7B,0x2E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenButtonStatics>{ static constexpr GUID value{ 0xB922CE42,0x09F0,0x453D,{ 0x80,0x26,0x44,0xDA,0xF2,0x75,0x3F,0x65 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl>{ static constexpr GUID value{ 0x601AE5F6,0x28A5,0x44CC,{ 0x89,0xA6,0x38,0x0E,0x91,0xA5,0x72,0xDD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlFactory>{ static constexpr GUID value{ 0x67F065EE,0xF5E7,0x46EB,{ 0x91,0x87,0x8D,0x3C,0xA3,0xAF,0x89,0x1B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlStatics>{ static constexpr GUID value{ 0x48A61BEF,0x19CE,0x41BB,{ 0xAB,0xE0,0x7C,0x87,0x26,0xFA,0xE7,0x5E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPencilButton>{ static constexpr GUID value{ 0x5B112832,0x1984,0x4148,{ 0x9F,0x25,0x38,0x2B,0x35,0xDB,0x08,0x7F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarPencilButtonFactory>{ static constexpr GUID value{ 0xDB66D85F,0xCFD6,0x495F,{ 0x93,0xAB,0xB8,0x56,0x6A,0xF9,0xF8,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarRulerButton>{ static constexpr GUID value{ 0x4A992832,0x1984,0x4148,{ 0x9F,0x25,0x38,0x2B,0x35,0xDB,0x08,0x7F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonFactory>{ static constexpr GUID value{ 0xBB26D85F,0xCFD6,0x495F,{ 0x93,0xAB,0xB8,0x56,0x6A,0xF9,0xF8,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonStatics>{ static constexpr GUID value{ 0xBAE75F65,0xBE30,0x4BEE,{ 0x96,0x4B,0xFF,0x9E,0x49,0x8F,0xEE,0x37 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarStatics>{ static constexpr GUID value{ 0xA3B493BB,0xCB4F,0x4E6B,{ 0xA3,0x3D,0xF1,0x1E,0x7A,0x29,0x5E,0xFA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarStatics2>{ static constexpr GUID value{ 0xAAC1F8F2,0x2C1F,0x4E9C,{ 0xB3,0xF3,0x31,0xFF,0x22,0xB5,0x1C,0x7A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarStencilButton>{ static constexpr GUID value{ 0x306A2616,0x5B40,0x4BF3,{ 0x92,0xB7,0xF1,0xDF,0x93,0x6A,0xEF,0xF5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonFactory>{ static constexpr GUID value{ 0xA20701D1,0x8A70,0x4D77,{ 0x89,0xD4,0x17,0x30,0xA3,0xA5,0x8E,0xDF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonStatics>{ static constexpr GUID value{ 0x4748C07F,0x63E4,0x420D,{ 0x93,0x9A,0x6B,0x72,0x43,0xE9,0xD1,0x24 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarToggleButton>{ static constexpr GUID value{ 0xB4A278FA,0xF5F0,0x4B1F,{ 0xBE,0xB0,0x0B,0x8A,0x29,0x90,0x5A,0x4A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarToggleButtonFactory>{ static constexpr GUID value{ 0xB2F90710,0xE5A1,0x4365,{ 0x9D,0x1A,0xE5,0xB7,0xAD,0x8B,0x96,0x68 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarToolButton>{ static constexpr GUID value{ 0x5C5AF41E,0xCCB7,0x4458,{ 0x80,0x64,0xA9,0x84,0x9D,0x31,0x56,0x1B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarToolButtonFactory>{ static constexpr GUID value{ 0x6293BF4B,0x89FE,0x4ED0,{ 0xA1,0xA6,0x88,0xD3,0xEB,0xA9,0x17,0xB2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInkToolbarToolButtonStatics>{ static constexpr GUID value{ 0x9E097D18,0xD136,0x4EF6,{ 0xB0,0xFD,0x1A,0x78,0xC2,0x88,0x4A,0x01 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IInsertionPanel>{ static constexpr GUID value{ 0x6B8DE08F,0x6527,0x4D39,{ 0xBC,0xBF,0x58,0xB0,0x1D,0xA9,0x23,0xD7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs>{ static constexpr GUID value{ 0x16F597CD,0xEBFF,0x4FB4,{ 0x87,0x14,0x26,0x14,0x74,0x18,0xB9,0x45 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemClickEventArgs>{ static constexpr GUID value{ 0x9C314242,0xF29A,0x494D,{ 0xA3,0xA5,0xD4,0xC7,0xB2,0xA4,0x68,0x52 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemContainerGenerator>{ static constexpr GUID value{ 0x40765F00,0x83F0,0x4D7F,{ 0xB1,0xB8,0xF1,0x9D,0xE4,0xF1,0xD5,0xDA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemContainerMapping>{ static constexpr GUID value{ 0x53C9F23A,0xF25D,0x446A,{ 0x99,0xB8,0xC7,0xAE,0xB8,0x39,0x05,0x0F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControl>{ static constexpr GUID value{ 0xF4A91DD8,0xD979,0x4381,{ 0x86,0x52,0xBD,0xA0,0x34,0x2A,0x76,0x5E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControl2>{ static constexpr GUID value{ 0x754C3266,0x0529,0x45E3,{ 0x87,0x48,0xBF,0x74,0x7D,0x15,0x83,0x57 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControl3>{ static constexpr GUID value{ 0x502B7489,0xAEE4,0x4DE3,{ 0xA2,0xAB,0x19,0x5A,0xC2,0x0C,0x42,0x12 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControlFactory>{ static constexpr GUID value{ 0xF7BBC359,0xF8FD,0x471C,{ 0xBC,0xB2,0x2C,0x74,0xBE,0x8E,0xBF,0x8C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControlOverrides>{ static constexpr GUID value{ 0xC79BB41B,0xA084,0x4301,{ 0xA4,0x96,0x72,0x97,0x1F,0x36,0x4E,0xD1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsControlStatics>{ static constexpr GUID value{ 0x37DABD89,0xDCFB,0x45B8,{ 0x9A,0xFE,0x87,0x4D,0xF0,0x97,0x90,0x5E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPanelTemplate>{ static constexpr GUID value{ 0x14EAD768,0x34B2,0x4B97,{ 0xBF,0x3C,0xE8,0xD7,0x32,0x30,0xA2,0xAA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPickedEventArgs>{ static constexpr GUID value{ 0xF95B9AAC,0xA621,0x488E,{ 0x91,0x56,0x8E,0xE3,0x11,0x65,0xBE,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPresenter>{ static constexpr GUID value{ 0xC271569B,0x6DCA,0x4E2B,{ 0x8E,0x14,0xC5,0x51,0x36,0xB0,0x2A,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPresenter2>{ static constexpr GUID value{ 0x5C04AA33,0x1DF3,0x4731,{ 0xA4,0xC9,0xDA,0x81,0x83,0x78,0xD6,0x3D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPresenterStatics>{ static constexpr GUID value{ 0x18DE66CD,0x4A6C,0x4B2E,{ 0xAA,0x86,0xCB,0x12,0x6C,0x9A,0x29,0x20 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsPresenterStatics2>{ static constexpr GUID value{ 0x8971632E,0x7867,0x4D66,{ 0x96,0x30,0x29,0xF1,0xC5,0xF7,0x40,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsStackPanel>{ static constexpr GUID value{ 0xDF7AB79D,0x7AD5,0x4B58,{ 0x93,0x63,0x91,0x9A,0xF9,0x02,0x26,0xE6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsStackPanel2>{ static constexpr GUID value{ 0xEEEECDB0,0x00B4,0x4534,{ 0x93,0x7B,0x56,0x31,0x8B,0x29,0x3E,0x92 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsStackPanelStatics>{ static constexpr GUID value{ 0xCA25D63F,0x044F,0x4B6B,{ 0xB3,0x15,0x0B,0x60,0xE0,0xB4,0xF8,0x7D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsStackPanelStatics2>{ static constexpr GUID value{ 0x3972EB2C,0x384A,0x48BF,{ 0xAD,0xFD,0x77,0x2E,0x25,0x72,0xC5,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsWrapGrid>{ static constexpr GUID value{ 0xDDFE6B5F,0xBA88,0x4A7D,{ 0x8A,0x5B,0xE5,0x8C,0xAF,0x0F,0x4E,0x2D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsWrapGrid2>{ static constexpr GUID value{ 0x80C21C0F,0x63EC,0x4258,{ 0xBD,0x61,0xD4,0xA6,0x95,0x6C,0x86,0x4A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsWrapGridStatics>{ static constexpr GUID value{ 0x4EC5427D,0x24A0,0x449A,{ 0xB7,0x63,0x30,0x77,0xBA,0x0F,0x2D,0xD5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IItemsWrapGridStatics2>{ static constexpr GUID value{ 0x2E27D3F7,0xFEAA,0x478D,{ 0xBF,0xD1,0x29,0x33,0x8A,0xDC,0x5A,0x03 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBox>{ static constexpr GUID value{ 0xE9F3B9FF,0x8E91,0x4ECF,{ 0xA7,0x07,0xC9,0x27,0xF6,0x94,0xF8,0x81 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBox2>{ static constexpr GUID value{ 0x70572ABA,0x8AD1,0x4085,{ 0x93,0x50,0xDE,0xEE,0x35,0x92,0x94,0xE3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBoxFactory>{ static constexpr GUID value{ 0x60CDFDA2,0x2F44,0x444B,{ 0x9C,0x94,0xB8,0xC9,0xFD,0xA4,0x6F,0x59 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBoxItem>{ static constexpr GUID value{ 0x43C13323,0x6EDF,0x4E4B,{ 0xB6,0xB2,0x3A,0x93,0xEE,0xC4,0x1D,0x95 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBoxItemFactory>{ static constexpr GUID value{ 0x4398B8D4,0xA3DE,0x402C,{ 0xB2,0x3D,0x19,0x03,0x84,0xB2,0x7C,0xA8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBoxStatics>{ static constexpr GUID value{ 0x6D3F7F73,0x706A,0x4E53,{ 0xA9,0xAA,0xC9,0xA5,0x3C,0x9C,0xDD,0x70 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListBoxStatics2>{ static constexpr GUID value{ 0x0089ADEB,0xB709,0x4C8D,{ 0xB1,0xED,0x4A,0x7D,0x97,0xEE,0x77,0x16 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListPickerFlyout>{ static constexpr GUID value{ 0x0F0CB9D7,0xE5F3,0x45E6,{ 0x90,0x63,0xFF,0x7B,0xBB,0x19,0x3C,0x47 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter>{ static constexpr GUID value{ 0x68155FB3,0x883E,0x417A,{ 0x80,0xD0,0xE2,0xFD,0x88,0x41,0x00,0x84 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListPickerFlyoutStatics>{ static constexpr GUID value{ 0xFEE25B97,0x8B96,0x4602,{ 0x81,0xD2,0x82,0xFD,0x8E,0x0F,0x7E,0xA8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListView>{ static constexpr GUID value{ 0xF6CE8C6D,0xFE96,0x41AD,{ 0xA6,0x4A,0xC2,0xB8,0x1C,0x4A,0xF7,0xF8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase>{ static constexpr GUID value{ 0x3D0813BA,0x6890,0x4537,{ 0xBF,0xE5,0x79,0x6D,0x94,0x58,0xED,0xD6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase2>{ static constexpr GUID value{ 0xD1C2A4F7,0x78A3,0x4491,{ 0x86,0xE0,0x2D,0xDE,0xBC,0x00,0x7A,0xC5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase3>{ static constexpr GUID value{ 0xB364C035,0x0A13,0x406F,{ 0xA3,0xFB,0xF3,0x0E,0x7D,0xDC,0xA9,0x4C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase4>{ static constexpr GUID value{ 0x18B7792B,0x11DC,0x4EB6,{ 0xA7,0xBC,0x74,0x1A,0xDB,0x3E,0xEB,0x79 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase5>{ static constexpr GUID value{ 0x1A9C6E99,0x1719,0x4B80,{ 0xB3,0x35,0x62,0x83,0x31,0xA0,0x70,0x19 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBase6>{ static constexpr GUID value{ 0xF8A42637,0x965B,0x483B,{ 0x94,0xE5,0xE5,0xC9,0xFE,0xF0,0xE3,0x52 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseFactory>{ static constexpr GUID value{ 0xE67E6C7F,0x150F,0x46D0,{ 0xA6,0xAC,0xC5,0x00,0x2B,0xD9,0xCA,0x53 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseHeaderItem>{ static constexpr GUID value{ 0x6D0DED27,0x0D19,0x4091,{ 0x89,0x17,0xCE,0x7C,0x85,0xC1,0xE6,0x30 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseHeaderItemFactory>{ static constexpr GUID value{ 0x3872A6A1,0xEA19,0x455F,{ 0x9D,0xF7,0x14,0x7C,0xC4,0x1D,0x32,0x9C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseStatics>{ static constexpr GUID value{ 0x8532B8F7,0x3E16,0x455B,{ 0x89,0xA8,0xC1,0x34,0x62,0x23,0xF6,0xD3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseStatics2>{ static constexpr GUID value{ 0x821C00C8,0x78CC,0x411F,{ 0x9F,0x2E,0xA5,0x57,0x58,0x22,0x7F,0x3E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseStatics3>{ static constexpr GUID value{ 0x3B539091,0x31C6,0x4D0C,{ 0x90,0xAF,0x5D,0xC1,0xD6,0xAE,0x9C,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseStatics4>{ static constexpr GUID value{ 0xAD13258B,0xFBD0,0x4F18,{ 0x8B,0xF8,0x9B,0x86,0x13,0x95,0x1C,0x22 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewBaseStatics5>{ static constexpr GUID value{ 0x40346FCF,0x0476,0x4259,{ 0x89,0x5F,0xA6,0x56,0x97,0x38,0x62,0x0F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewFactory>{ static constexpr GUID value{ 0xBDFF696D,0x3F22,0x41F9,{ 0x97,0xA6,0x88,0x31,0x34,0xA7,0x61,0x13 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewHeaderItem>{ static constexpr GUID value{ 0x1B61BAEB,0xE196,0x4B3B,{ 0xA5,0xF9,0x1E,0xD6,0x36,0xF3,0xF7,0x9B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewHeaderItemFactory>{ static constexpr GUID value{ 0x68D2C96A,0x96B0,0x4F08,{ 0xA7,0xA5,0xF1,0x08,0x67,0x20,0xA0,0xFA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewItem>{ static constexpr GUID value{ 0xB7BB4305,0x3DD9,0x43DE,{ 0xA8,0xC0,0xC4,0x72,0xF0,0x85,0xBC,0x11 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewItemFactory>{ static constexpr GUID value{ 0xF431073D,0x9CAC,0x42A2,{ 0x82,0xDF,0x0F,0x44,0x90,0xBC,0x4E,0x2E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewPersistenceHelper>{ static constexpr GUID value{ 0x05BDE8A6,0x2191,0x4B4B,{ 0x8C,0x22,0x9B,0x25,0x67,0x6E,0x80,0x6E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IListViewPersistenceHelperStatics>{ static constexpr GUID value{ 0x6D0C2B08,0xBB9B,0x44F9,{ 0x80,0x63,0x5C,0x3F,0x9C,0x21,0x88,0x4B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaElement>{ static constexpr GUID value{ 0xA38ED2CF,0x13DE,0x4299,{ 0xAD,0xE2,0xAE,0x18,0xF7,0x4E,0xD3,0x53 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaElement2>{ static constexpr GUID value{ 0xFD53DA65,0xB186,0x4654,{ 0xBF,0xDB,0x18,0x0E,0xD2,0x6C,0xAD,0x07 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaElement3>{ static constexpr GUID value{ 0x479F6F13,0x0FDB,0x4ED8,{ 0x92,0x8A,0x4D,0x39,0x16,0x9C,0x3C,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaElementStatics>{ static constexpr GUID value{ 0xDCCD2CB9,0x7568,0x4682,{ 0xA7,0x2A,0x8D,0xDF,0x2A,0x26,0x65,0xCA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaElementStatics2>{ static constexpr GUID value{ 0x9EE7F826,0xF154,0x4DC6,{ 0x80,0x14,0xA6,0xEB,0xA9,0x87,0xF8,0x47 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerElement>{ static constexpr GUID value{ 0x3B4CA526,0x2E25,0x4598,{ 0xBC,0x71,0xD4,0x91,0xF8,0xE8,0xDE,0x39 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerElementFactory>{ static constexpr GUID value{ 0x77E525C3,0xEB17,0x4B8D,{ 0x88,0x9D,0x1E,0xA8,0xAB,0xDB,0xD4,0xEF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerElementStatics>{ static constexpr GUID value{ 0x1E7C4020,0xAC57,0x42DD,{ 0xAD,0x1C,0x3E,0xBC,0x2D,0x7F,0x08,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerPresenter>{ static constexpr GUID value{ 0x77A92326,0x0C5B,0x41FC,{ 0xBF,0x49,0x15,0xF6,0xC3,0x52,0x4B,0x6B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerPresenterFactory>{ static constexpr GUID value{ 0xE6766FB7,0xD96F,0x4B95,{ 0xB3,0x3C,0x59,0xE8,0x1C,0xB1,0xE9,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaPlayerPresenterStatics>{ static constexpr GUID value{ 0x84D774FE,0xEAD4,0x4957,{ 0xB4,0x2B,0x22,0x31,0x58,0xCA,0x0D,0xE7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControls>{ static constexpr GUID value{ 0xD6F69E7D,0x0825,0x49A9,{ 0x9F,0xCE,0x55,0x86,0xD8,0x69,0x4F,0x0C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControls2>{ static constexpr GUID value{ 0x2B89EFEC,0x1BEA,0x451E,{ 0x8B,0xCD,0xCF,0xE2,0xD9,0x42,0x32,0x62 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControls3>{ static constexpr GUID value{ 0x5086430E,0x0940,0x11E7,{ 0x93,0xAE,0x92,0x36,0x1F,0x00,0x26,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsFactory>{ static constexpr GUID value{ 0x1DA2015A,0xA8E4,0x4C1B,{ 0x88,0xC9,0x0B,0x18,0x3E,0xCC,0x62,0xE3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsHelper>{ static constexpr GUID value{ 0x3D41D509,0xFF44,0x4420,{ 0x80,0x7E,0x8F,0x7A,0x2E,0x2C,0x42,0x51 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsHelperStatics>{ static constexpr GUID value{ 0x5A772047,0xA9A1,0x4625,{ 0x92,0x70,0x7F,0x49,0x87,0x5D,0x43,0x94 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics>{ static constexpr GUID value{ 0x590EA907,0xD2EF,0x4C1A,{ 0x94,0x29,0xB4,0xB1,0x5D,0x64,0xFD,0x56 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics2>{ static constexpr GUID value{ 0x1728CFDC,0x561F,0x4386,{ 0xA7,0xF8,0x09,0x0D,0x95,0xF6,0x8D,0x96 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics3>{ static constexpr GUID value{ 0x5FE05542,0x0940,0x11E7,{ 0x93,0xAE,0x92,0x36,0x1F,0x00,0x26,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyout>{ static constexpr GUID value{ 0xAD3210F1,0x985B,0x4171,{ 0xBB,0xBA,0x67,0xBC,0xC7,0x29,0x64,0x9B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyout2>{ static constexpr GUID value{ 0x507C7BAD,0xD9D1,0x4C05,{ 0x9D,0x4B,0xCD,0xA8,0xDE,0x9A,0xB2,0x42 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutFactory>{ static constexpr GUID value{ 0x644533AB,0xBBB9,0x499B,{ 0x9F,0xF3,0x30,0xD4,0x0E,0x2C,0x56,0xD8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItem>{ static constexpr GUID value{ 0x160775CF,0xB598,0x44AF,{ 0xA4,0x88,0xC3,0xCE,0x2A,0xF6,0xD3,0xF0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItem2>{ static constexpr GUID value{ 0x0AE266EB,0x028C,0x4423,{ 0xA8,0xE3,0x98,0x9F,0xD9,0xDD,0x71,0x26 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItemBase>{ static constexpr GUID value{ 0xF9B56047,0x8DA6,0x4730,{ 0x92,0x08,0x14,0x41,0x25,0xC6,0xB3,0x96 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItemBaseFactory>{ static constexpr GUID value{ 0x83E6DBAD,0xFC67,0x41D5,{ 0x87,0x97,0x60,0xAC,0xD1,0xCE,0xB1,0xD9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItemFactory>{ static constexpr GUID value{ 0xC5AA39E2,0x44F3,0x455E,{ 0x9C,0x5B,0x62,0xBB,0x6A,0xFC,0xE3,0xAD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics>{ static constexpr GUID value{ 0x4950B424,0xA43A,0x41F7,{ 0xAA,0x3A,0x9C,0xE9,0x61,0x97,0x47,0xD5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics2>{ static constexpr GUID value{ 0xACA4F564,0x1790,0x4601,{ 0x91,0x6E,0x5A,0xE1,0xF0,0x1F,0x4B,0xD6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter>{ static constexpr GUID value{ 0x906E0304,0x254E,0x413F,{ 0xB2,0x19,0xC7,0xB9,0x7F,0x00,0x37,0x52 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter2>{ static constexpr GUID value{ 0x895894DF,0x5A9F,0x4A1F,{ 0x85,0xEC,0x6F,0x3C,0x1B,0x6D,0xCB,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutPresenterFactory>{ static constexpr GUID value{ 0xB88B5091,0x101C,0x41F8,{ 0xAA,0xC1,0x1B,0x10,0x5C,0x14,0xFB,0x99 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSeparator>{ static constexpr GUID value{ 0x71FA2B7D,0x0B51,0x4950,{ 0xA1,0xA4,0xBB,0xC4,0x2E,0xAC,0x4C,0x12 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSeparatorFactory>{ static constexpr GUID value{ 0xC159DCC8,0xB437,0x44E0,{ 0xB2,0x4B,0x57,0x20,0xAE,0xA1,0xDB,0xAC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutStatics>{ static constexpr GUID value{ 0x3DBEFBA1,0x9522,0x4045,{ 0x9E,0x58,0xC9,0x9B,0x13,0xAA,0xB9,0xB9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem>{ static constexpr GUID value{ 0xE5386550,0xFE2C,0x43E2,{ 0xA7,0x3F,0x62,0x16,0x8F,0x61,0x99,0x73 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem2>{ static constexpr GUID value{ 0xAC935626,0x190A,0x4DE2,{ 0x8D,0x71,0x7C,0xC4,0x74,0x7D,0xA5,0x80 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics>{ static constexpr GUID value{ 0xDDB27A36,0x1874,0x4AEF,{ 0x83,0x7D,0x6F,0xEC,0x9D,0xA4,0xE6,0x81 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics2>{ static constexpr GUID value{ 0xAC14D09B,0x3E93,0x4785,{ 0x94,0xEF,0xFD,0xB2,0x3B,0xAB,0xA9,0x65 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigate>{ static constexpr GUID value{ 0xBF2195A9,0xF4EA,0x4336,{ 0x97,0x7C,0xF8,0xFC,0xF7,0x8B,0x0D,0x9E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationView>{ static constexpr GUID value{ 0xF209CE15,0x391A,0x42CA,{ 0x9F,0xC6,0xF7,0x9D,0xA6,0x5A,0xCA,0x32 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs>{ static constexpr GUID value{ 0xB7C1AD35,0x5544,0x40C1,{ 0x9B,0x33,0xAC,0xFE,0x1D,0x6C,0x80,0x94 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewFactory>{ static constexpr GUID value{ 0xE50687C1,0xB7C2,0x4975,{ 0xAD,0x7A,0x5F,0x4F,0xE6,0xA5,0x14,0xC9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItem>{ static constexpr GUID value{ 0x8614BE0F,0xB7B6,0x4851,{ 0x96,0x0A,0xF5,0xE3,0xF6,0x9F,0x62,0x4A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemBase>{ static constexpr GUID value{ 0xEDF04EB1,0x37D1,0x471F,{ 0x85,0x70,0x38,0x29,0xEE,0x5B,0x2B,0xC6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemBaseFactory>{ static constexpr GUID value{ 0xEB014CEF,0x7890,0x4EBB,{ 0x82,0x45,0x02,0xE8,0x51,0x0F,0x32,0x1D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemFactory>{ static constexpr GUID value{ 0x973BDB4A,0x7E08,0x4F76,{ 0x92,0x3C,0xF1,0x2B,0xD6,0x85,0xE8,0x6E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemHeader>{ static constexpr GUID value{ 0xE21DF22C,0xDA4A,0x4E74,{ 0x9F,0xFC,0xB1,0x63,0xBD,0x7A,0xDA,0xCD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemHeaderFactory>{ static constexpr GUID value{ 0xF3105988,0x7768,0x45D3,{ 0x8B,0xB0,0x6D,0xED,0x9E,0x43,0xA9,0x8B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs>{ static constexpr GUID value{ 0x29496822,0x55D2,0x49FA,{ 0x96,0x4B,0xF1,0xDB,0xAF,0xEF,0x85,0xC4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemSeparator>{ static constexpr GUID value{ 0xDE62C951,0xBB9B,0x471E,{ 0x83,0xE3,0xAF,0x47,0x91,0xE7,0x09,0x6A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemSeparatorFactory>{ static constexpr GUID value{ 0x71CF3A66,0xDB86,0x49E0,{ 0x81,0x54,0x5F,0xD3,0x56,0xAE,0xDE,0xC0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewItemStatics>{ static constexpr GUID value{ 0x803C0081,0xFDA5,0x4B90,{ 0xAA,0xCE,0x3F,0x23,0x06,0xDB,0xE5,0xC4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewList>{ static constexpr GUID value{ 0x4F726F85,0x5CE0,0x48CD,{ 0x8E,0xF2,0x1A,0x29,0x45,0x8A,0x34,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewListFactory>{ static constexpr GUID value{ 0xFAEE9541,0xC3BF,0x47BF,{ 0xB9,0x04,0x61,0x55,0xF4,0xDF,0x6B,0x4F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs>{ static constexpr GUID value{ 0x5AA509A0,0x3A5E,0x4F54,{ 0x89,0x6C,0x98,0xB8,0x5F,0x81,0x95,0x08 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INavigationViewStatics>{ static constexpr GUID value{ 0x363A86C7,0x72DA,0x4420,{ 0xB8,0x71,0x15,0xD9,0xD0,0xD4,0x57,0x56 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INotifyEventArgs>{ static constexpr GUID value{ 0xAF0E05F7,0xC4B7,0x44C5,{ 0xB0,0x9D,0x5C,0xB7,0x05,0x2B,0x3A,0x97 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::INotifyEventArgs2>{ static constexpr GUID value{ 0x0D140F56,0x1DCE,0x4FCD,{ 0x85,0xBC,0x5A,0x55,0x72,0x27,0x3B,0x9C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPage>{ static constexpr GUID value{ 0xC4B27075,0xE641,0x453E,{ 0x82,0x4D,0x01,0x2F,0xC7,0xCF,0x95,0xCF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPageFactory>{ static constexpr GUID value{ 0xDFA149AC,0x1849,0x445E,{ 0x93,0x7C,0x40,0xA9,0x59,0x0C,0xC0,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPageOverrides>{ static constexpr GUID value{ 0x230B9CB8,0x3419,0x4306,{ 0xAA,0xBE,0x4A,0x8E,0x68,0x0D,0x36,0x27 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPageStatics>{ static constexpr GUID value{ 0x376DDE71,0xF725,0x46DD,{ 0x8D,0x80,0xEE,0xEA,0xF7,0xDA,0x74,0xE5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPanel>{ static constexpr GUID value{ 0xA50A4BBD,0x8361,0x469C,{ 0x90,0xDA,0xE9,0xA4,0x0C,0x74,0x74,0xDF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPanelFactory>{ static constexpr GUID value{ 0xEEE68111,0xC7CC,0x433F,{ 0x95,0xCD,0xD6,0x30,0xC3,0x43,0x02,0xDD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPanelStatics>{ static constexpr GUID value{ 0xF23D6B5D,0x8330,0x47A6,{ 0xA0,0x46,0x25,0xF5,0x09,0xB2,0x52,0x32 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IParallaxView>{ static constexpr GUID value{ 0x6B84FCD4,0x4083,0x5B4B,{ 0xBC,0x40,0xD9,0x20,0x4E,0x19,0xB4,0x1A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IParallaxViewFactory>{ static constexpr GUID value{ 0xE4EB9642,0x3E8E,0x5A26,{ 0x94,0xF2,0x91,0x21,0xD1,0x21,0xB9,0x16 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IParallaxViewStatics>{ static constexpr GUID value{ 0x8836E49C,0x0E0E,0x57D8,{ 0x93,0x95,0xF0,0xA9,0xA0,0xD1,0xBB,0x28 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBox>{ static constexpr GUID value{ 0x02B9AA11,0x0B47,0x4E7D,{ 0xAD,0x91,0x3A,0x41,0x68,0xED,0x23,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBox2>{ static constexpr GUID value{ 0x5ED738DF,0x212F,0x4AEB,{ 0xB5,0xB8,0x2C,0x21,0x9A,0xEC,0x3C,0x0C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBox3>{ static constexpr GUID value{ 0x6024D9D1,0x56B7,0x41F0,{ 0x95,0x58,0x39,0x34,0xC1,0x42,0x44,0xD6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBox4>{ static constexpr GUID value{ 0x569F4343,0x8E6C,0x44BF,{ 0x80,0x8D,0x0E,0x03,0x96,0x4E,0xD3,0x2F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs>{ static constexpr GUID value{ 0x142EDA22,0x3552,0x4AB8,{ 0x81,0xA6,0xA4,0x86,0x20,0xEE,0x9C,0x53 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBoxStatics>{ static constexpr GUID value{ 0x5EE67563,0x2D74,0x4ACE,{ 0xBD,0x79,0xFC,0xAB,0x61,0xA7,0xD7,0x7B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBoxStatics2>{ static constexpr GUID value{ 0xFC57935F,0x98FA,0x4066,{ 0xB7,0x85,0xFA,0x72,0x5E,0xCD,0xE2,0x32 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPasswordBoxStatics3>{ static constexpr GUID value{ 0xA2CDD319,0xAD6A,0x4352,{ 0xB5,0x90,0xF6,0x96,0xFF,0xCB,0x8E,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIcon>{ static constexpr GUID value{ 0x214C62DB,0xC366,0x4A0E,{ 0xB9,0xAD,0xDC,0xF1,0x68,0xD7,0xEC,0x0C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIconFactory>{ static constexpr GUID value{ 0xAF9D9652,0x9C5D,0x4A37,{ 0x9E,0x1A,0x04,0x4A,0xBE,0xEF,0x79,0x2B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIconSource>{ static constexpr GUID value{ 0x1F47010E,0xB305,0x4863,{ 0x8B,0x7A,0x15,0xD0,0x8D,0x63,0x3C,0x7A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIconSourceFactory>{ static constexpr GUID value{ 0x8F7F85B9,0x5247,0x4F3B,{ 0x83,0x3F,0xE3,0x84,0xBF,0x7E,0x9C,0x84 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIconSourceStatics>{ static constexpr GUID value{ 0xDF7027D5,0x3682,0x43FF,{ 0x80,0xF0,0xAF,0xA2,0x56,0xB2,0xFD,0xC3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPathIconStatics>{ static constexpr GUID value{ 0x77B75DB8,0xFB15,0x491A,{ 0xB6,0xE3,0x7D,0xBB,0xA9,0x11,0xBA,0xFE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPersonPicture>{ static constexpr GUID value{ 0x6C230B6D,0x0D75,0x4059,{ 0x91,0xBC,0x7B,0x17,0x4D,0x1D,0x73,0x15 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPersonPictureFactory>{ static constexpr GUID value{ 0x4F18330D,0x0416,0x4B92,{ 0xBF,0xD3,0xBF,0x57,0x80,0xB4,0x6A,0xB2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPersonPictureStatics>{ static constexpr GUID value{ 0xDBEC0982,0x3C10,0x4639,{ 0x96,0x14,0xAA,0x5B,0x7C,0xDC,0x32,0xCA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs>{ static constexpr GUID value{ 0x447A9B51,0x1E23,0x4779,{ 0x99,0x2B,0x98,0x68,0x49,0x71,0x39,0x41 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPickerFlyout>{ static constexpr GUID value{ 0xA336FFDB,0x08D9,0x43E6,{ 0x94,0x4E,0xF2,0xE5,0xC7,0xCE,0xE6,0x30 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPickerFlyoutPresenter>{ static constexpr GUID value{ 0x5884C978,0x6B27,0x4B38,{ 0xA9,0xAE,0x67,0x7C,0x29,0x94,0x65,0x2E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPickerFlyoutStatics>{ static constexpr GUID value{ 0xAF18A436,0xF38A,0x4ABD,{ 0xB9,0x33,0x62,0x86,0xC1,0x15,0xB0,0x7F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivot>{ static constexpr GUID value{ 0x103E9B13,0x3400,0x4A16,{ 0x90,0xB9,0x69,0x12,0xBF,0x06,0x97,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivot2>{ static constexpr GUID value{ 0x8B8A8660,0x1A55,0x411C,{ 0xA8,0x2D,0x18,0x99,0x1C,0x3F,0x0D,0x6F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivot3>{ static constexpr GUID value{ 0x95BCBF96,0xF0DA,0x4089,{ 0x8C,0x65,0xE8,0xB8,0x13,0x54,0xC7,0x66 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotFactory>{ static constexpr GUID value{ 0x1B0A818E,0x2529,0x4762,{ 0xBA,0x44,0x9A,0xBC,0x68,0xC3,0xCE,0xCA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotItem>{ static constexpr GUID value{ 0xA4764371,0xA502,0x47A3,{ 0x91,0x5E,0x4A,0xA0,0x96,0xDA,0xF8,0x7F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotItemEventArgs>{ static constexpr GUID value{ 0x1A6F7254,0x1ED5,0x4BC5,{ 0xA0,0x60,0x65,0x55,0x30,0xBC,0xA6,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotItemFactory>{ static constexpr GUID value{ 0x0DCED981,0x636E,0x4A34,{ 0x8A,0x3F,0x8E,0xE0,0x18,0x63,0x92,0x85 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotItemStatics>{ static constexpr GUID value{ 0xE147AD0C,0x488B,0x4A6E,{ 0xBE,0xCD,0xA5,0xDB,0xD9,0x94,0x17,0x54 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotStatics>{ static constexpr GUID value{ 0xEE22C7F4,0xC15D,0x4FF3,{ 0x8A,0x94,0xF5,0x0D,0xFD,0xFB,0xE8,0x99 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotStatics2>{ static constexpr GUID value{ 0xD7518ADD,0xBE75,0x4023,{ 0x8D,0xEB,0xC6,0x51,0x3C,0x31,0x92,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IPivotStatics3>{ static constexpr GUID value{ 0x78B6274E,0x6616,0x4600,{ 0xA0,0x39,0x92,0x2A,0x5D,0x09,0x33,0x0B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IProgressBar>{ static constexpr GUID value{ 0xAE752C89,0x0067,0x4963,{ 0xBF,0x4C,0x29,0xDB,0x0C,0x4A,0x50,0x7E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IProgressBarFactory>{ static constexpr GUID value{ 0xDA9A8C11,0x1591,0x400B,{ 0xA9,0x93,0x0F,0x1C,0x5C,0xC1,0x2F,0x3B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IProgressBarStatics>{ static constexpr GUID value{ 0x7A129FDA,0x5837,0x4E26,{ 0xB3,0xB4,0xE1,0xC0,0x92,0xCE,0xBB,0xEC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IProgressRing>{ static constexpr GUID value{ 0x6DA5E49E,0x6E9D,0x425C,{ 0xBD,0x7C,0x02,0x17,0x3E,0x39,0x76,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IProgressRingStatics>{ static constexpr GUID value{ 0xE8B62507,0x4E2C,0x47D5,{ 0xA5,0x4A,0xC6,0xC4,0x8A,0x5E,0x69,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRadioButton>{ static constexpr GUID value{ 0x325C44E0,0x9A03,0x4BF3,{ 0xAB,0xD6,0x6F,0xBB,0x46,0xC9,0xA4,0x86 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRadioButtonFactory>{ static constexpr GUID value{ 0xF1D04933,0x34E1,0x4A5C,{ 0xB2,0xAE,0xCA,0x3B,0x1C,0x0B,0x20,0xDE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRadioButtonStatics>{ static constexpr GUID value{ 0x6B149293,0xF50F,0x4BD8,{ 0xB0,0xAC,0x5C,0x16,0x2F,0x33,0xA2,0x08 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingControl>{ static constexpr GUID value{ 0xA7D91CA7,0xE5CF,0x4963,{ 0xA2,0x4E,0x96,0x73,0xFE,0x5F,0xFD,0xD5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingControlFactory>{ static constexpr GUID value{ 0x18D81716,0xC542,0x4CCB,{ 0xB3,0x47,0x5E,0x62,0xC5,0xDB,0x78,0x2E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingControlStatics>{ static constexpr GUID value{ 0xD062D399,0xAD85,0x4C1C,{ 0xB2,0xC4,0x35,0xDD,0x44,0x32,0x27,0x5E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemFontInfo>{ static constexpr GUID value{ 0x054723E9,0x7989,0x4D5C,{ 0x9D,0x01,0xA7,0xEB,0x87,0x6F,0x10,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemFontInfoFactory>{ static constexpr GUID value{ 0x9603FE56,0x9E9F,0x40B5,{ 0xBA,0xE1,0x44,0x81,0xBB,0x73,0xBC,0xD3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemFontInfoStatics>{ static constexpr GUID value{ 0xFB214F01,0x6434,0x4EEB,{ 0x82,0xFF,0x7C,0xE5,0xD4,0x0B,0xF5,0x10 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemImageInfo>{ static constexpr GUID value{ 0x25240E8C,0xE0D2,0x490E,{ 0xB8,0xF8,0x96,0xC8,0xEE,0x05,0x12,0xB9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemImageInfoFactory>{ static constexpr GUID value{ 0x269E03F2,0xDA79,0x4787,{ 0x9F,0x4A,0x24,0xA6,0xFA,0x56,0xCD,0xE2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemImageInfoStatics>{ static constexpr GUID value{ 0x8438486B,0x4B1C,0x4123,{ 0xBA,0x0B,0x73,0x48,0x4D,0x68,0xC3,0x38 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemInfo>{ static constexpr GUID value{ 0x9CCBE6A2,0x591E,0x47A0,{ 0xA3,0x18,0x6A,0x1F,0x79,0x47,0xDA,0x2D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRatingItemInfoFactory>{ static constexpr GUID value{ 0xB0FD43D6,0xCFEC,0x43C8,{ 0x9A,0xC5,0x0B,0x0D,0x5E,0x25,0xD8,0x62 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRelativePanel>{ static constexpr GUID value{ 0x2EABFAEB,0xB35A,0x4035,{ 0xAC,0xEA,0x3C,0x4A,0x37,0x30,0x68,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRelativePanelFactory>{ static constexpr GUID value{ 0x8460193C,0x361B,0x44BA,{ 0xA1,0x7E,0xB8,0x4C,0x9D,0xCD,0xC7,0x72 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRelativePanelStatics>{ static constexpr GUID value{ 0x15903C27,0xF18C,0x4C35,{ 0x8E,0x19,0x6A,0x74,0x59,0xD9,0x07,0xB6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox>{ static constexpr GUID value{ 0x90A57A40,0x80B6,0x4FCE,{ 0xB1,0xEC,0xE3,0xC6,0x16,0x28,0x4B,0x6A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox2>{ static constexpr GUID value{ 0xBBEA6EAD,0xE805,0x47A4,{ 0xBB,0xE7,0x47,0xE5,0x9B,0x8F,0x74,0xA7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox3>{ static constexpr GUID value{ 0x6B17A462,0xFBB6,0x4FFF,{ 0x99,0x91,0x93,0x99,0xCB,0x9C,0x0B,0x90 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox4>{ static constexpr GUID value{ 0x5CAA8D35,0xC838,0x4BAD,{ 0xA0,0x7C,0x20,0x41,0x83,0xBB,0x75,0x1F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox5>{ static constexpr GUID value{ 0xA66D9CEA,0x6391,0x4F3B,{ 0x9F,0xD3,0x1F,0xD0,0x1F,0x49,0xF3,0x27 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBox6>{ static constexpr GUID value{ 0x0C89D500,0xE8D8,0x4EAE,{ 0x88,0x04,0x33,0x64,0x92,0x05,0xD7,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxFactory>{ static constexpr GUID value{ 0x61A1DF62,0x2806,0x41ED,{ 0x88,0xED,0xAE,0x21,0xF4,0x7A,0xB4,0x22 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics>{ static constexpr GUID value{ 0xF5E03A74,0x88EA,0x479B,{ 0x9A,0x05,0x37,0x08,0x9F,0xF3,0x0E,0xDE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics2>{ static constexpr GUID value{ 0xE3EB26DE,0x2748,0x420B,{ 0xB1,0xFC,0xCE,0x95,0xB6,0xE8,0x5E,0xEC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics3>{ static constexpr GUID value{ 0x6D17EEC5,0x1FB3,0x4C8B,{ 0xAA,0x23,0xF5,0xE1,0x5D,0x6A,0xB6,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics4>{ static constexpr GUID value{ 0xF5D54FD7,0x7796,0x42A5,{ 0xA5,0xE5,0x2C,0xD2,0x11,0xEE,0x81,0x76 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics5>{ static constexpr GUID value{ 0x4B5C4568,0x43D5,0x43E6,{ 0xBB,0xB9,0xCB,0x4E,0x62,0x50,0xF4,0x5A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxStatics6>{ static constexpr GUID value{ 0xFE40E287,0x82ED,0x4F7E,{ 0x92,0xBA,0x66,0xF6,0x7B,0xC1,0xFF,0x44 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs>{ static constexpr GUID value{ 0x54065018,0x2813,0x4922,{ 0x9F,0x8E,0xB6,0xBB,0xAF,0xD9,0x95,0xD8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs2>{ static constexpr GUID value{ 0x395B0DB5,0x636E,0x413E,{ 0x9E,0xB4,0xFC,0x22,0xEB,0xFA,0x36,0x28 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlock>{ static constexpr GUID value{ 0xE5FFF9E2,0xB968,0x49E7,{ 0x97,0xD4,0x8C,0xCA,0x2A,0xC3,0xAE,0x7C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlock2>{ static constexpr GUID value{ 0x3F209013,0x03E7,0x4508,{ 0x96,0x4A,0x91,0xAE,0xDA,0xB3,0xD1,0x1E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlock3>{ static constexpr GUID value{ 0x7D39AE83,0x8918,0x4613,{ 0xB0,0x07,0x7C,0x89,0x8B,0xA2,0x95,0x0E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlock4>{ static constexpr GUID value{ 0x3577C1EA,0x24FD,0x4F50,{ 0xBB,0xE4,0x3F,0xB6,0x54,0xEA,0x58,0xC5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlock5>{ static constexpr GUID value{ 0x9C7DC0C6,0x7A9F,0x45B6,{ 0x88,0x18,0x82,0x2C,0x54,0x9B,0xA0,0x94 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflow>{ static constexpr GUID value{ 0x4F93749B,0xDAC3,0x4A42,{ 0x9C,0xBB,0x99,0xF0,0xDE,0x37,0xC0,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflow2>{ static constexpr GUID value{ 0x8742624E,0xA882,0x4826,{ 0xB9,0x29,0x4D,0x5C,0x39,0x05,0xB9,0xA1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3>{ static constexpr GUID value{ 0x7F69587B,0x5C7F,0x4B5F,{ 0xBD,0xBC,0xFB,0x95,0xC9,0x0E,0x10,0xDE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics>{ static constexpr GUID value{ 0x041AC2F7,0x4F2B,0x43C3,{ 0xA1,0x22,0x3F,0xEA,0x9C,0xA9,0xDC,0x87 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics2>{ static constexpr GUID value{ 0xB5EBED4C,0xF8C4,0x4A3A,{ 0x90,0x7F,0xE5,0x3E,0x78,0x27,0x9F,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics3>{ static constexpr GUID value{ 0xD1D4A705,0xEB0B,0x4ECB,{ 0xB9,0xB7,0xE6,0x5D,0x03,0x08,0x7C,0x8E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockStatics>{ static constexpr GUID value{ 0x492D883C,0xADEA,0x433C,{ 0xBE,0x1C,0x20,0x8A,0x16,0x42,0x62,0xBE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockStatics2>{ static constexpr GUID value{ 0x0D6131E1,0xAF29,0x48CE,{ 0x8A,0xAF,0x74,0xEC,0xC2,0x8B,0xFB,0xB0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockStatics3>{ static constexpr GUID value{ 0x073F7EF4,0xCA2B,0x4B49,{ 0xA5,0x9A,0x31,0xD8,0xFA,0x74,0x33,0x32 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockStatics4>{ static constexpr GUID value{ 0x80155BC4,0x6D96,0x4B08,{ 0xAD,0x57,0x13,0xDB,0x0F,0x04,0x64,0x12 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRichTextBlockStatics5>{ static constexpr GUID value{ 0xAC9283A1,0x4F25,0x4280,{ 0x88,0x68,0x3E,0xEE,0xE8,0x28,0x21,0xE8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRowDefinition>{ static constexpr GUID value{ 0x4ABAE829,0xD80C,0x4A5E,{ 0xA4,0x8C,0xF8,0xB3,0xD3,0xB6,0x53,0x3D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IRowDefinitionStatics>{ static constexpr GUID value{ 0x5ADF3FE5,0x2056,0x4724,{ 0x94,0xD6,0xE4,0x81,0x2B,0x02,0x2E,0xC8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollContentPresenter>{ static constexpr GUID value{ 0x5712EE2B,0x0EEB,0x46D3,{ 0xAA,0x31,0x5F,0x68,0x01,0xB8,0xDE,0x20 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewer>{ static constexpr GUID value{ 0x64E9BE00,0x4DC1,0x493D,{ 0xAB,0xE7,0xCB,0xD3,0xC5,0x77,0x49,0x0D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewer2>{ static constexpr GUID value{ 0x64E9BE10,0x4DD1,0x494D,{ 0xAB,0xF7,0xCB,0xD3,0xC5,0x77,0x49,0x1D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewer3>{ static constexpr GUID value{ 0x74E9BE21,0x5DE2,0x595E,{ 0xBC,0x08,0xDB,0xD3,0xC5,0x77,0x49,0x2C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewerStatics>{ static constexpr GUID value{ 0x33D1299D,0x8D6E,0x4290,{ 0xBF,0x22,0x90,0x5C,0xCC,0xD0,0x4D,0x31 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewerStatics2>{ static constexpr GUID value{ 0x33D129AD,0x8D7E,0x42A0,{ 0xBF,0x32,0x90,0x5C,0xCC,0xD0,0x4D,0x41 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewerView>{ static constexpr GUID value{ 0x64E9BE01,0x4DC2,0x493E,{ 0xAB,0xE8,0xCB,0xD3,0xC5,0x77,0x49,0x0E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs>{ static constexpr GUID value{ 0x4DD04F7E,0x7A11,0x4B2E,{ 0x99,0x33,0x57,0x7D,0xF3,0x92,0x52,0xB6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs>{ static constexpr GUID value{ 0x4DD04F7F,0x7A11,0x4B2E,{ 0x99,0x33,0x57,0x7D,0xF3,0x92,0x52,0xB6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBox>{ static constexpr GUID value{ 0xF89ECC5A,0x99BA,0x4BD4,{ 0x96,0x6C,0xF1,0x1F,0xA4,0x43,0xD1,0x3C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxFactory>{ static constexpr GUID value{ 0xCD743F6D,0x8685,0x46B4,{ 0x9D,0xDD,0x20,0x2F,0x69,0x41,0xB7,0x01 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs>{ static constexpr GUID value{ 0xA9A70F8F,0x0CB0,0x4BD2,{ 0x99,0x98,0x2F,0xB5,0x7A,0xD5,0xE7,0x31 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs>{ static constexpr GUID value{ 0x126E90FD,0x3C4E,0x4CCB,{ 0x9A,0xEF,0x47,0x05,0xD1,0x9F,0xE5,0x48 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs>{ static constexpr GUID value{ 0x18918C23,0xE4C3,0x4662,{ 0xA0,0x3B,0xD0,0x54,0xFF,0xD0,0xF9,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxStatics>{ static constexpr GUID value{ 0xB123634F,0x6871,0x48CD,{ 0x92,0xDF,0x4C,0xFF,0x22,0x45,0x90,0x82 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs>{ static constexpr GUID value{ 0xDA15170E,0xE566,0x48CB,{ 0xBD,0x11,0xFE,0x4B,0x0F,0x30,0xA4,0x4D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs>{ static constexpr GUID value{ 0xDD49EE6B,0xD165,0x430F,{ 0xA3,0x7D,0xB8,0x07,0x06,0x4F,0x85,0xE1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgsFactory>{ static constexpr GUID value{ 0x557F5244,0x92F8,0x4150,{ 0xB7,0x30,0xE6,0x34,0x6E,0x8F,0x50,0xD1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISelectionChangedEventArgs>{ static constexpr GUID value{ 0xC972D2DC,0xB609,0x4758,{ 0x85,0x1E,0xA7,0x99,0xC2,0x1D,0xE9,0x7D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISelectionChangedEventArgsFactory>{ static constexpr GUID value{ 0x11A8B6B5,0x2830,0x4517,{ 0x84,0xCD,0x55,0x24,0xC8,0xB8,0x8B,0x45 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISemanticZoom>{ static constexpr GUID value{ 0x019FFF21,0xECE6,0x4FBC,{ 0xBF,0x40,0x89,0x38,0xD4,0x81,0x3E,0x27 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISemanticZoomInformation>{ static constexpr GUID value{ 0xA76A3B63,0x229B,0x4DC5,{ 0xAA,0x11,0x9D,0x92,0x2F,0xBF,0x8A,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISemanticZoomLocation>{ static constexpr GUID value{ 0x42011736,0xE3C2,0x496B,{ 0xBC,0x4E,0xD7,0x50,0xD4,0x37,0x5B,0x9A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISemanticZoomStatics>{ static constexpr GUID value{ 0x8EF17EF2,0x9898,0x4666,{ 0xB2,0x85,0x3E,0xD3,0x8A,0x07,0x91,0x0E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs>{ static constexpr GUID value{ 0x47DFC068,0xB569,0x4B19,{ 0x84,0x2D,0x8E,0x6C,0xF9,0x09,0x89,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISettingsFlyout>{ static constexpr GUID value{ 0x830BA82B,0xC55B,0x4E32,{ 0xA5,0x1C,0x57,0x91,0xE0,0x24,0xC8,0xAF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISettingsFlyoutFactory>{ static constexpr GUID value{ 0x480C7011,0x57AA,0x4DB6,{ 0xB6,0xFD,0xEC,0x67,0x6F,0x6D,0x41,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISettingsFlyoutStatics>{ static constexpr GUID value{ 0xD0E3B535,0x9157,0x4BE4,{ 0xA4,0x2A,0xF5,0x91,0x69,0x88,0x46,0xAC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISlider>{ static constexpr GUID value{ 0x89572027,0x4C48,0x4700,{ 0x80,0x76,0x49,0x7B,0xA7,0x3D,0x9C,0x18 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISlider2>{ static constexpr GUID value{ 0x40A3C50E,0x87D6,0x4D2F,{ 0xB1,0xCF,0xB2,0x79,0xCC,0x99,0x6F,0x26 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISliderFactory>{ static constexpr GUID value{ 0x03A67B37,0xC7BF,0x437C,{ 0x84,0x8F,0x8C,0xB5,0xB7,0x53,0xEA,0xB4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISliderStatics>{ static constexpr GUID value{ 0x8A4363D7,0x7FDF,0x4D30,{ 0x98,0xFE,0xCE,0x78,0xC0,0x5B,0x31,0xCF } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISliderStatics2>{ static constexpr GUID value{ 0x00E7935D,0x79A5,0x4759,{ 0x96,0xA6,0x29,0xE0,0xA9,0x4A,0xDD,0x33 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitView>{ static constexpr GUID value{ 0x97222F31,0x3844,0x429E,{ 0x93,0x9C,0x16,0x73,0x15,0x53,0x22,0xA1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitView2>{ static constexpr GUID value{ 0x5EA7DC10,0xCC83,0x409A,{ 0x82,0xF9,0x3E,0x91,0xD6,0xD7,0x08,0x4F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitView3>{ static constexpr GUID value{ 0x0EA12D8D,0x1171,0x407B,{ 0x96,0xD3,0x5E,0x1B,0x47,0x0C,0x3E,0xC5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitViewFactory>{ static constexpr GUID value{ 0xF101773A,0x084E,0x4FB9,{ 0x84,0x42,0x63,0x22,0x1B,0x44,0x53,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs>{ static constexpr GUID value{ 0x93CF494E,0x7A95,0x44D8,{ 0x95,0x62,0x1B,0x34,0x82,0x48,0xDA,0x9F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitViewStatics>{ static constexpr GUID value{ 0x859B4F6F,0x44AB,0x4E4B,{ 0x91,0xC1,0x17,0xB7,0x05,0x6D,0x9B,0x5F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISplitViewStatics2>{ static constexpr GUID value{ 0x14B7CD7A,0xDFBC,0x422C,{ 0x80,0xA9,0x58,0x58,0x71,0x29,0x71,0x13 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanel>{ static constexpr GUID value{ 0xB8AE8FE2,0xD641,0x4FD7,{ 0x80,0xB4,0x74,0x39,0x20,0x7D,0x27,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanel2>{ static constexpr GUID value{ 0x36F23359,0x040E,0x48F7,{ 0x9A,0x98,0xF2,0x66,0x45,0x91,0x95,0x9C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanel4>{ static constexpr GUID value{ 0x43EBF7F6,0x3196,0x412E,{ 0x8A,0x95,0xAD,0xD0,0x02,0xFF,0x43,0xF0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanelFactory>{ static constexpr GUID value{ 0x63D8248A,0x8B34,0x445A,{ 0x80,0x8F,0xB6,0xEC,0xD6,0x2A,0x27,0xD9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanelStatics>{ static constexpr GUID value{ 0xF0D0CD93,0x4DBC,0x48A7,{ 0x99,0x14,0x95,0x49,0x24,0x65,0x77,0x71 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanelStatics2>{ static constexpr GUID value{ 0xD97E6257,0x080D,0x412E,{ 0xA9,0x1A,0xCE,0x6E,0x5D,0x02,0xAA,0xD3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStackPanelStatics4>{ static constexpr GUID value{ 0x279CDD71,0x067B,0x459F,{ 0x81,0x5F,0xEC,0xD8,0x5C,0x5E,0x48,0x43 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStyleSelector>{ static constexpr GUID value{ 0xD1113F67,0xD8C1,0x4AE4,{ 0x98,0xF0,0xD8,0x50,0x45,0x02,0xF0,0x8B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStyleSelectorFactory>{ static constexpr GUID value{ 0x9E942AE7,0x3761,0x447F,{ 0x8F,0x97,0x29,0xE3,0x9D,0x5E,0xB3,0x10 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IStyleSelectorOverrides>{ static constexpr GUID value{ 0x08ADD66D,0x0E2E,0x43A0,{ 0xAE,0xCA,0x8F,0xAA,0x94,0xB9,0xD0,0x17 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel>{ static constexpr GUID value{ 0x1C59DB48,0x8233,0x4C0C,{ 0xBC,0xF5,0x02,0xA5,0xFB,0x35,0xAE,0x00 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel2>{ static constexpr GUID value{ 0x21E672F2,0x2592,0x4C38,{ 0x87,0x0F,0x28,0xFB,0xCF,0x52,0xC0,0x95 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanelFactory>{ static constexpr GUID value{ 0x198289D4,0xC89B,0x49B2,{ 0x89,0x6C,0x59,0x17,0xBF,0x8A,0xDC,0xAE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainPanel>{ static constexpr GUID value{ 0xC589644F,0xEBA8,0x427A,{ 0xB7,0x5A,0x9F,0x1F,0x93,0xA1,0x1A,0xE9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainPanelFactory>{ static constexpr GUID value{ 0xF38F8D7F,0x1A48,0x49CB,{ 0x86,0xD2,0x10,0xEA,0xAA,0xF6,0xFD,0x70 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwapChainPanelStatics>{ static constexpr GUID value{ 0xF89C0297,0xEEA8,0x498C,{ 0x99,0xC4,0x25,0x7E,0x36,0x60,0xDF,0x7E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeControl>{ static constexpr GUID value{ 0x9EE3D96F,0x6704,0x4823,{ 0xAA,0x15,0x1C,0x14,0x3B,0xC5,0x3C,0xF7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeControlFactory>{ static constexpr GUID value{ 0xC0AAA3AE,0xD141,0x4E12,{ 0xA7,0x28,0x5F,0x95,0xB5,0x07,0xE7,0xAB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeControlStatics>{ static constexpr GUID value{ 0xE57AE83C,0x2216,0x4717,{ 0x9E,0xF6,0x46,0x62,0x33,0x4C,0x65,0x01 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItem>{ static constexpr GUID value{ 0x836EDADC,0x45C8,0x4A00,{ 0x90,0xA0,0x71,0x07,0xFA,0x89,0x4A,0x1B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItemFactory>{ static constexpr GUID value{ 0x844BD61A,0x1716,0x4097,{ 0xBB,0xA2,0x75,0x26,0xDA,0x22,0xDE,0x39 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs>{ static constexpr GUID value{ 0xC5B025F5,0xCB32,0x4733,{ 0x80,0x11,0x5D,0x0D,0x37,0xF4,0x55,0x0A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItemStatics>{ static constexpr GUID value{ 0xD0B44E96,0x2766,0x4D93,{ 0xB5,0xDB,0xF5,0xE1,0xBE,0x83,0x2C,0x2D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItems>{ static constexpr GUID value{ 0xB01726FF,0x969A,0x40D0,{ 0x9F,0x04,0x76,0x08,0x4C,0xE6,0xD7,0xB7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItemsFactory>{ static constexpr GUID value{ 0x47C460EE,0xD5AA,0x445F,{ 0xB3,0x1E,0x50,0xC0,0x76,0xC0,0x11,0xB9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISwipeItemsStatics>{ static constexpr GUID value{ 0x376250DF,0x48DB,0x43E3,{ 0xB0,0xE9,0x08,0x9E,0x5D,0xA9,0xA1,0x14 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIcon>{ static constexpr GUID value{ 0x7A4774C9,0xA6A3,0x4B30,{ 0x8F,0xF1,0x90,0x81,0xD7,0x0E,0x9A,0x5C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIconFactory>{ static constexpr GUID value{ 0xC7252B88,0xE76C,0x4B44,{ 0x8A,0x05,0x04,0x6B,0x9D,0xC7,0x72,0xB8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIconSource>{ static constexpr GUID value{ 0x625D95A2,0xB6B1,0x408A,{ 0xB2,0x89,0xEA,0xB2,0xEC,0xBA,0x62,0xD8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIconSourceFactory>{ static constexpr GUID value{ 0xA526AAB0,0x4130,0x4907,{ 0xB0,0x49,0x21,0xF9,0x24,0x0C,0x7A,0x40 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIconSourceStatics>{ static constexpr GUID value{ 0x8BC49738,0xD94E,0x4148,{ 0x8D,0x64,0x1A,0xDF,0x0F,0x23,0xF2,0x5F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ISymbolIconStatics>{ static constexpr GUID value{ 0x8624FBDF,0x952C,0x4F76,{ 0xB0,0x3F,0x30,0x83,0x3B,0xE9,0x95,0x72 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock>{ static constexpr GUID value{ 0xAE2D9271,0x3B4A,0x45FC,{ 0x84,0x68,0xF7,0x94,0x95,0x48,0xF4,0xD5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock2>{ static constexpr GUID value{ 0x45206A4C,0x0A4E,0x4FBF,{ 0xAE,0xE9,0x33,0x5D,0x5A,0x20,0x5F,0x6E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock3>{ static constexpr GUID value{ 0xB651DD5A,0x424B,0x48C3,{ 0x9B,0x67,0x48,0x6F,0x4E,0x13,0x98,0x99 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock4>{ static constexpr GUID value{ 0xB014F270,0x9808,0x4ADC,{ 0xB4,0x52,0x60,0xCD,0xA5,0x41,0x00,0xC1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock5>{ static constexpr GUID value{ 0x624A2D38,0xEDBD,0x4A5A,{ 0xB6,0x78,0xE4,0x9F,0x1E,0x07,0xAF,0xBD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlock6>{ static constexpr GUID value{ 0x31816CD9,0x0404,0x410F,{ 0x91,0xEC,0x33,0xB0,0xA0,0xBB,0x92,0xB2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlockStatics>{ static constexpr GUID value{ 0x193EC042,0xA847,0x4552,{ 0xB4,0xE8,0xDB,0x36,0x65,0x5B,0x84,0x0A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlockStatics2>{ static constexpr GUID value{ 0x88100B1B,0xFF24,0x4B93,{ 0xA0,0xE6,0xF0,0x29,0xC9,0x48,0x71,0xF1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlockStatics3>{ static constexpr GUID value{ 0x8D16B9EB,0x20A1,0x4EAB,{ 0xBB,0xF2,0x1D,0x6B,0xDC,0xBC,0xD7,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlockStatics5>{ static constexpr GUID value{ 0x8E4D9C70,0x0D4E,0x48DF,{ 0xAE,0x7F,0xBB,0x7A,0x9A,0xF6,0x85,0x2E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBlockStatics6>{ static constexpr GUID value{ 0x3D1013A9,0xF9A6,0x43A2,{ 0x99,0xD3,0x57,0x3B,0x89,0xA8,0x3C,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox>{ static constexpr GUID value{ 0xE48F5A8B,0x1DFF,0x4352,{ 0xA1,0xF4,0xE5,0x16,0x51,0x4E,0xC8,0x82 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox2>{ static constexpr GUID value{ 0xF7168C00,0x1432,0x462A,{ 0x94,0x05,0x38,0xF3,0x85,0xBF,0xC3,0x7C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox3>{ static constexpr GUID value{ 0x7DF18C3C,0x2826,0x425E,{ 0x9A,0x94,0x00,0xB7,0xF7,0x3F,0x37,0x56 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox4>{ static constexpr GUID value{ 0xB5F1A675,0xCCE1,0x45AF,{ 0xAE,0xF9,0xC4,0x78,0x7B,0xBB,0x5E,0x30 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox5>{ static constexpr GUID value{ 0x35F9CFC1,0x4176,0x44F4,{ 0xB7,0x56,0xE9,0xCC,0xC4,0x39,0x98,0x05 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBox6>{ static constexpr GUID value{ 0x41FF2D07,0x5085,0x4E52,{ 0xA5,0x1C,0xF9,0x4B,0x06,0xCD,0x55,0x8B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs>{ static constexpr GUID value{ 0xA5541DB3,0x7784,0x4258,{ 0xAA,0x83,0xE4,0xBE,0xDD,0x72,0x74,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxFactory>{ static constexpr GUID value{ 0x710E4278,0x8529,0x47D3,{ 0x8D,0x8E,0x30,0x7E,0x34,0xCF,0xF0,0x81 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxStatics>{ static constexpr GUID value{ 0x7E37F4FB,0xA4BC,0x4625,{ 0x88,0x38,0x8E,0xB2,0xA9,0x09,0x12,0x83 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxStatics2>{ static constexpr GUID value{ 0x7592F37D,0x4E76,0x4EE4,{ 0x8E,0x0F,0x7D,0x6E,0x1A,0x23,0x32,0x6B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxStatics3>{ static constexpr GUID value{ 0x0E1005C0,0x10B5,0x40F6,{ 0x92,0xC2,0xCE,0x13,0x4B,0x0D,0x34,0x57 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxStatics5>{ static constexpr GUID value{ 0x07D04B45,0x1B2F,0x4627,{ 0x82,0xFD,0x68,0x3F,0x19,0x7E,0x5A,0x75 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxStatics6>{ static constexpr GUID value{ 0xDC0D97E7,0x1CB7,0x433E,{ 0xAA,0x4F,0x9C,0x64,0xC9,0x8C,0xDE,0xE5 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs>{ static constexpr GUID value{ 0x4E6A4B75,0x43DD,0x4E33,{ 0xAC,0xBE,0x2D,0x87,0x96,0xA1,0x79,0x27 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs2>{ static constexpr GUID value{ 0xC0723D44,0x53A6,0x415F,{ 0xA9,0x81,0x50,0xDF,0xAF,0x1B,0xEC,0xBE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextChangedEventArgs>{ static constexpr GUID value{ 0x4DD04F7D,0x7A11,0x4B2E,{ 0x99,0x33,0x57,0x7D,0xF3,0x92,0x52,0xB6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs>{ static constexpr GUID value{ 0xB9C7E0F2,0x50B7,0x441D,{ 0x99,0x0C,0x68,0x55,0x3E,0x2E,0x05,0x6B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs>{ static constexpr GUID value{ 0x46E34DB2,0x77C0,0x4015,{ 0x8E,0xB4,0x92,0xEE,0xFD,0xFC,0x59,0x14 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs>{ static constexpr GUID value{ 0xDF22ABB2,0x10CF,0x491E,{ 0x91,0xE8,0xD3,0xCD,0x72,0xD8,0xA0,0xD3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs>{ static constexpr GUID value{ 0xE405EF19,0xD0DF,0x43DA,{ 0xAC,0xE6,0x16,0xF9,0x11,0x38,0x68,0xC3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs>{ static constexpr GUID value{ 0x5F894995,0xA58D,0x4CF3,{ 0xB5,0x89,0xB5,0xE5,0x00,0xE0,0x64,0x75 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITextControlPasteEventArgs>{ static constexpr GUID value{ 0x4BD1D625,0x221A,0x477E,{ 0xBB,0x2C,0xAD,0x0C,0x1E,0xD1,0x25,0xE7 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickedEventArgs>{ static constexpr GUID value{ 0x8AD3FF21,0x5F66,0x4785,{ 0xB9,0x99,0x24,0xFE,0xF3,0x9F,0xB6,0xDB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePicker>{ static constexpr GUID value{ 0xE39099F2,0x3AFF,0x4792,{ 0x90,0x9E,0x2D,0x99,0x41,0xEC,0x03,0x57 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePicker2>{ static constexpr GUID value{ 0x0FF0798C,0xF922,0x419F,{ 0x8B,0x3D,0x23,0xEE,0x75,0x86,0xD4,0x8E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerFactory>{ static constexpr GUID value{ 0x553FE413,0x6CD7,0x46A9,{ 0xA9,0x7B,0xA1,0x8B,0xDC,0x4B,0x4C,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerFlyout>{ static constexpr GUID value{ 0xBB739D75,0xE836,0x439E,{ 0x86,0xD5,0x50,0x6D,0x2D,0x18,0xE4,0x04 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter>{ static constexpr GUID value{ 0xC5320638,0x7A18,0x40ED,{ 0x9F,0xD0,0x4C,0x85,0x2C,0x09,0xB2,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerFlyoutStatics>{ static constexpr GUID value{ 0x3F6728CE,0x2169,0x4003,{ 0xB4,0xA8,0x8D,0xE7,0x03,0x5A,0x0A,0xD6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerStatics>{ static constexpr GUID value{ 0xFA71DFB1,0x233E,0x4F31,{ 0xB8,0xBE,0xA6,0xEA,0x67,0x0C,0x25,0xCD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerStatics2>{ static constexpr GUID value{ 0x36D8ABCD,0x4E10,0x451A,{ 0xB9,0x3B,0x1A,0x73,0x1E,0xA7,0xEE,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs>{ static constexpr GUID value{ 0x2F4EDB8D,0xB995,0x4E31,{ 0x8B,0xA9,0xC4,0xDC,0xDE,0xB2,0x1C,0xA3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem>{ static constexpr GUID value{ 0x49841EDD,0x88E9,0x4663,{ 0xA7,0x01,0xCD,0x4F,0xD2,0x5E,0x39,0x8F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemFactory>{ static constexpr GUID value{ 0xA151966F,0x3BF7,0x46B6,{ 0xB6,0x1C,0x9B,0x2C,0x1B,0xA6,0x88,0x43 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemStatics>{ static constexpr GUID value{ 0x16C724FB,0x6C1A,0x4852,{ 0x92,0x58,0x08,0xC0,0x38,0x36,0x79,0x07 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleSwitch>{ static constexpr GUID value{ 0x331D8F00,0xC5F9,0x46A5,{ 0xB6,0xC8,0xED,0xE5,0x39,0x30,0x45,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleSwitchOverrides>{ static constexpr GUID value{ 0xBFD07F53,0xF8CA,0x4E47,{ 0x94,0x9E,0x9E,0x80,0x42,0x9B,0x3D,0x16 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToggleSwitchStatics>{ static constexpr GUID value{ 0x1D37147F,0x97DF,0x4226,{ 0x92,0xCA,0xDD,0xF4,0x53,0xD7,0xFD,0x5A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToolTip>{ static constexpr GUID value{ 0x7DE5D75F,0x4415,0x429F,{ 0xB5,0x23,0x69,0x9B,0xDB,0x8C,0x30,0xDB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToolTipFactory>{ static constexpr GUID value{ 0x89839403,0xB538,0x49E3,{ 0xA4,0x30,0x3A,0xC0,0x37,0xDC,0x6F,0xE0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToolTipService>{ static constexpr GUID value{ 0x03A55F87,0xBFCC,0x4A1E,{ 0x8F,0xEA,0x98,0xF6,0x10,0x83,0x2C,0xEA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToolTipServiceStatics>{ static constexpr GUID value{ 0x86E649F8,0xE245,0x48AA,{ 0xA8,0xC8,0xD1,0x07,0x3E,0xD7,0x63,0x19 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IToolTipStatics>{ static constexpr GUID value{ 0xF00285B8,0x4BA9,0x4F4F,{ 0x86,0xA7,0x86,0x00,0x38,0x13,0xCE,0xB3 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IUIElementCollection>{ static constexpr GUID value{ 0xD6602D54,0x88F6,0x43F6,{ 0x85,0xD8,0xA9,0xD9,0x14,0xA6,0xDD,0x3B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IUserControl>{ static constexpr GUID value{ 0xA7A69EC9,0xEA35,0x4679,{ 0xBF,0x29,0xF4,0xF0,0x92,0x86,0xD3,0x14 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IUserControlFactory>{ static constexpr GUID value{ 0x38B1ED92,0xA28A,0x4972,{ 0x93,0xDF,0xF4,0xF7,0x59,0xB8,0xAF,0xD2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IUserControlStatics>{ static constexpr GUID value{ 0xE8887976,0x2C5C,0x41CF,{ 0xBE,0x6A,0x9E,0x44,0xBE,0xFD,0xF6,0x55 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVariableSizedWrapGrid>{ static constexpr GUID value{ 0x9CA507C7,0x23C9,0x4F01,{ 0xB8,0x0F,0xBE,0x5C,0x21,0xEE,0xF4,0x74 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVariableSizedWrapGridStatics>{ static constexpr GUID value{ 0xFE9DB859,0x8127,0x4AEF,{ 0xB7,0xA2,0x94,0x98,0x47,0x48,0x6E,0x96 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IViewbox>{ static constexpr GUID value{ 0x05252C58,0xBA9D,0x4809,{ 0x9E,0xC3,0xFA,0x0D,0x16,0x71,0x0B,0xA1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IViewboxStatics>{ static constexpr GUID value{ 0x5CD1E72D,0xE8D3,0x4865,{ 0x8F,0x08,0xB6,0xB2,0xD6,0x89,0xAD,0xF1 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingPanel>{ static constexpr GUID value{ 0x38AAD50C,0x12CF,0x4D1E,{ 0xA8,0x84,0xC9,0xDF,0x85,0xF0,0x7C,0xD9 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingPanelFactory>{ static constexpr GUID value{ 0xBE19F839,0xCBD0,0x43E9,{ 0xA5,0xD0,0x0B,0xDB,0xA0,0xFF,0xBD,0x38 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingPanelOverrides>{ static constexpr GUID value{ 0x5EF6BD7D,0x677F,0x408D,{ 0xA9,0x6C,0xB1,0x95,0x07,0x75,0x04,0x66 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingPanelProtected>{ static constexpr GUID value{ 0xC9C9AB42,0xC232,0x479D,{ 0xA7,0xC9,0x5E,0x76,0x11,0x19,0x6A,0x45 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingStackPanel>{ static constexpr GUID value{ 0x7567CD9A,0xA3B4,0x4DEA,{ 0xBB,0x11,0x54,0x9E,0x2C,0x2F,0x91,0x9D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingStackPanelOverrides>{ static constexpr GUID value{ 0xCBE6F72C,0x2892,0x46D1,{ 0x98,0x7F,0x58,0xCA,0x10,0x81,0xF0,0x40 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IVirtualizingStackPanelStatics>{ static constexpr GUID value{ 0x8314E778,0x91D3,0x4D56,{ 0xAC,0x09,0x22,0x3A,0xDC,0xD2,0xBD,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebView>{ static constexpr GUID value{ 0x5862CC46,0x1F7D,0x479B,{ 0x92,0xA6,0xDE,0x78,0x58,0xFE,0x8D,0x54 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebView2>{ static constexpr GUID value{ 0xD481759E,0x3EFF,0x4462,{ 0x82,0x3D,0xFD,0x52,0xF9,0xBA,0x4C,0xC8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebView3>{ static constexpr GUID value{ 0xC497789B,0xB499,0x4D69,{ 0xB5,0xC2,0xAE,0x9D,0x5D,0x6D,0x59,0x4E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebView4>{ static constexpr GUID value{ 0xE28243BC,0x67F3,0x462A,{ 0xB4,0xE0,0x3B,0xBF,0x6C,0x3D,0xAB,0x0B } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebView5>{ static constexpr GUID value{ 0x8C9884A6,0x2F3B,0x4A55,{ 0xA4,0x63,0x84,0x44,0xC2,0x09,0x5D,0x00 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewBrush>{ static constexpr GUID value{ 0x40E86F75,0x0CF4,0x4B72,{ 0xA4,0xD6,0xCF,0x5D,0x15,0x78,0x01,0x16 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewBrushStatics>{ static constexpr GUID value{ 0xD74DAA24,0x1D05,0x463E,{ 0xB0,0x28,0x6B,0xAA,0x44,0x20,0xE7,0x62 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs>{ static constexpr GUID value{ 0x6E2980BB,0x98B8,0x413E,{ 0x81,0x29,0x97,0x1C,0x6F,0x7E,0x4C,0x8A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs>{ static constexpr GUID value{ 0xC47EBA15,0xDC6B,0x4B36,{ 0x9D,0x80,0x82,0xFB,0x88,0x17,0xB9,0x88 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest>{ static constexpr GUID value{ 0xA3DCC461,0x7350,0x4D3A,{ 0x8F,0xB9,0x40,0xEE,0xEC,0x27,0x46,0xC2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewFactory4>{ static constexpr GUID value{ 0x82EDAC58,0xEE6A,0x4C9B,{ 0xA3,0xA0,0x93,0x47,0xA7,0xD0,0xEF,0x4C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs>{ static constexpr GUID value{ 0xF3F020AB,0xA46C,0x42B0,{ 0x9E,0xFE,0x69,0x76,0x4D,0x5C,0xFF,0xA6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs>{ static constexpr GUID value{ 0x11E6F20B,0xEBA7,0x44C0,{ 0x88,0x9B,0xED,0xEB,0x6A,0x06,0x4D,0xDD } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs>{ static constexpr GUID value{ 0xAF09609A,0x129C,0x4170,{ 0x9E,0x9C,0xE2,0xCD,0xF0,0x25,0xDC,0xA4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs>{ static constexpr GUID value{ 0x94CB8668,0x8367,0x43D5,{ 0x91,0xBB,0x96,0xEB,0xA3,0x7E,0xC7,0x84 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs>{ static constexpr GUID value{ 0x470FA818,0x6862,0x44D9,{ 0xB3,0xD1,0xC0,0x69,0x63,0x73,0xDE,0x35 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewPermissionRequest>{ static constexpr GUID value{ 0x17B76332,0x66C4,0x4131,{ 0x99,0x9E,0xDF,0x7D,0xE2,0x0A,0x8C,0x9C } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs>{ static constexpr GUID value{ 0xDADECFD0,0x6E1E,0x473F,{ 0xB0,0xBE,0xB0,0x24,0x04,0xD6,0xA8,0x6D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewSettings>{ static constexpr GUID value{ 0x1D50AD4D,0xABF6,0x4785,{ 0x8D,0xF3,0xFD,0xEB,0xC1,0x27,0x03,0x01 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewStatics>{ static constexpr GUID value{ 0xA0B561DE,0x5FDB,0x443B,{ 0xB9,0xF0,0x5C,0x30,0xF6,0xB7,0xA1,0xF4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewStatics2>{ static constexpr GUID value{ 0x322F8780,0xE812,0x466B,{ 0x9E,0x50,0x8E,0x9F,0xEC,0x24,0x01,0x8A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewStatics3>{ static constexpr GUID value{ 0x129BEF8A,0x4509,0x4374,{ 0xB0,0xD1,0xA7,0x10,0x4D,0x0C,0x3A,0x2F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewStatics4>{ static constexpr GUID value{ 0x44B197B0,0xB746,0x40F3,{ 0x99,0x36,0x4E,0xBB,0xFF,0x6B,0x47,0xB8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewStatics5>{ static constexpr GUID value{ 0x08A0B8D1,0x508A,0x4DB8,{ 0x97,0xEF,0x0F,0xA5,0x05,0xE1,0x9E,0xC2 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs>{ static constexpr GUID value{ 0xB9C9E1A7,0x620F,0x4895,{ 0x93,0x5D,0x10,0xFB,0xAC,0x6F,0xD2,0x9E } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs>{ static constexpr GUID value{ 0x37BC16E1,0x6062,0x4678,{ 0xB2,0x0B,0x6C,0x36,0xAC,0x9C,0x59,0xAC } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs2>{ static constexpr GUID value{ 0x9ABE1154,0x36F0,0x4268,{ 0x8D,0x88,0x12,0x1E,0xED,0xF4,0x5E,0x6A } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWrapGrid>{ static constexpr GUID value{ 0x0552178B,0x7567,0x47C2,{ 0xBD,0x5C,0xAD,0x83,0x94,0xC8,0x28,0xBA } }; };
template <> struct guid<Windows::UI::Xaml::Controls::IWrapGridStatics>{ static constexpr GUID value{ 0xD04A6B97,0x13CB,0x479C,{ 0xA2,0x85,0xE4,0xE5,0x68,0x46,0xC4,0xCB } }; };
template <> struct guid<Windows::UI::Xaml::Controls::BackClickEventHandler>{ static constexpr GUID value{ 0xFA9BC21F,0x9892,0x482E,{ 0xAB,0xF6,0xEB,0x2D,0x60,0x7D,0x32,0xDE } }; };
template <> struct guid<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler>{ static constexpr GUID value{ 0x8D745891,0x4DE3,0x49CB,{ 0x97,0x4B,0x08,0x38,0x71,0xA3,0xAF,0xE6 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler>{ static constexpr GUID value{ 0xCACAD0D6,0x0F0D,0x4870,{ 0x88,0x4D,0xF2,0xDE,0xDF,0x67,0x42,0x88 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler>{ static constexpr GUID value{ 0xDF945151,0x745C,0x4446,{ 0xB2,0xFC,0x21,0x6D,0x76,0x58,0x47,0xA0 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::DragItemsStartingEventHandler>{ static constexpr GUID value{ 0x3AAEAB4C,0x14CB,0x4434,{ 0xBE,0xCC,0x88,0xA8,0x58,0x5C,0x2F,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler>{ static constexpr GUID value{ 0xAFE17B9B,0x9C63,0x4583,{ 0x88,0xE4,0xC5,0x90,0x19,0xB7,0xF4,0x9D } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ItemClickEventHandler>{ static constexpr GUID value{ 0x3DF6D14E,0xE18A,0x4A75,{ 0x93,0x95,0x62,0x7C,0x5F,0x3C,0xD4,0x89 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ListViewItemToKeyHandler>{ static constexpr GUID value{ 0x6AF5DA76,0x7E8B,0x4A91,{ 0x9A,0x56,0x46,0x0C,0xB4,0x7D,0x52,0x3F } }; };
template <> struct guid<Windows::UI::Xaml::Controls::ListViewKeyToItemHandler>{ static constexpr GUID value{ 0x26FD5855,0xB530,0x4688,{ 0xB9,0xF0,0x42,0x82,0x49,0x17,0x8E,0xF8 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::NotifyEventHandler>{ static constexpr GUID value{ 0xC2FDD1F8,0x7105,0x4A74,{ 0xA1,0x09,0xDE,0x29,0xDF,0xF5,0x6B,0x98 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler>{ static constexpr GUID value{ 0x6BECAA6A,0x63F8,0x47FF,{ 0xB6,0xAC,0x76,0xE7,0xDA,0x24,0x7D,0x67 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::SelectionChangedEventHandler>{ static constexpr GUID value{ 0xE1A05352,0x5AA0,0x42CA,{ 0x9C,0xD9,0x06,0x8A,0x14,0xDB,0x6E,0x68 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler>{ static constexpr GUID value{ 0x1FA9161D,0x5D73,0x44FB,{ 0x81,0xAC,0xD1,0xC9,0x38,0x49,0x19,0xD4 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::TextChangedEventHandler>{ static constexpr GUID value{ 0x8EB35B97,0xAD87,0x40E8,{ 0x81,0x8B,0x77,0xDB,0x24,0x75,0x95,0x66 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::TextControlPasteEventHandler>{ static constexpr GUID value{ 0xD56DB359,0x6F77,0x4296,{ 0xAB,0x9C,0x79,0x49,0x39,0x44,0x43,0x65 } }; };
template <> struct guid<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler>{ static constexpr GUID value{ 0xA31EAFE1,0x41DC,0x47F8,{ 0xAE,0x22,0x97,0x06,0xC8,0xF1,0x43,0xD4 } }; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AppBar>{ using type = Windows::UI::Xaml::Controls::IAppBar; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AppBarButton>{ using type = Windows::UI::Xaml::Controls::IAppBarButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AppBarSeparator>{ using type = Windows::UI::Xaml::Controls::IAppBarSeparator; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AppBarToggleButton>{ using type = Windows::UI::Xaml::Controls::IAppBarToggleButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AutoSuggestBox>{ using type = Windows::UI::Xaml::Controls::IAutoSuggestBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AutoSuggestBoxQuerySubmittedEventArgs>{ using type = Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AutoSuggestBoxSuggestionChosenEventArgs>{ using type = Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::AutoSuggestBoxTextChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::BackClickEventArgs>{ using type = Windows::UI::Xaml::Controls::IBackClickEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::BitmapIcon>{ using type = Windows::UI::Xaml::Controls::IBitmapIcon; };
template <> struct default_interface<Windows::UI::Xaml::Controls::BitmapIconSource>{ using type = Windows::UI::Xaml::Controls::IBitmapIconSource; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Border>{ using type = Windows::UI::Xaml::Controls::IBorder; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Button>{ using type = Windows::UI::Xaml::Controls::IButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarDatePicker>{ using type = Windows::UI::Xaml::Controls::ICalendarDatePicker; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarDatePickerDateChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarView>{ using type = Windows::UI::Xaml::Controls::ICalendarView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarViewDayItem>{ using type = Windows::UI::Xaml::Controls::ICalendarViewDayItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CalendarViewSelectedDatesChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Canvas>{ using type = Windows::UI::Xaml::Controls::ICanvas; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CaptureElement>{ using type = Windows::UI::Xaml::Controls::ICaptureElement; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CheckBox>{ using type = Windows::UI::Xaml::Controls::ICheckBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ChoosingGroupHeaderContainerEventArgs>{ using type = Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ChoosingItemContainerEventArgs>{ using type = Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventArgs>{ using type = Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ColorChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IColorChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ColorPicker>{ using type = Windows::UI::Xaml::Controls::IColorPicker; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ColumnDefinition>{ using type = Windows::UI::Xaml::Controls::IColumnDefinition; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ColumnDefinitionCollection>{ using type = Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::ColumnDefinition>; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ComboBox>{ using type = Windows::UI::Xaml::Controls::IComboBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ComboBoxItem>{ using type = Windows::UI::Xaml::Controls::IComboBoxItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CommandBar>{ using type = Windows::UI::Xaml::Controls::ICommandBar; };
template <> struct default_interface<Windows::UI::Xaml::Controls::CommandBarOverflowPresenter>{ using type = Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentControl>{ using type = Windows::UI::Xaml::Controls::IContentControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialog>{ using type = Windows::UI::Xaml::Controls::IContentDialog; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogButtonClickDeferral>{ using type = Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs>{ using type = Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogClosedEventArgs>{ using type = Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogClosingDeferral>{ using type = Windows::UI::Xaml::Controls::IContentDialogClosingDeferral; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogClosingEventArgs>{ using type = Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentDialogOpenedEventArgs>{ using type = Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContentPresenter>{ using type = Windows::UI::Xaml::Controls::IContentPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ContextMenuEventArgs>{ using type = Windows::UI::Xaml::Controls::IContextMenuEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Control>{ using type = Windows::UI::Xaml::Controls::IControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ControlTemplate>{ using type = Windows::UI::Xaml::Controls::IControlTemplate; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DataTemplateSelector>{ using type = Windows::UI::Xaml::Controls::IDataTemplateSelector; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePickedEventArgs>{ using type = Windows::UI::Xaml::Controls::IDatePickedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePicker>{ using type = Windows::UI::Xaml::Controls::IDatePicker; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePickerFlyout>{ using type = Windows::UI::Xaml::Controls::IDatePickerFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePickerFlyoutItem>{ using type = Windows::UI::Xaml::Controls::IDatePickerFlyoutItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePickerFlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DatePickerValueChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DragItemsCompletedEventArgs>{ using type = Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DragItemsStartingEventArgs>{ using type = Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::DynamicOverflowItemsChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FlipView>{ using type = Windows::UI::Xaml::Controls::IFlipView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FlipViewItem>{ using type = Windows::UI::Xaml::Controls::IFlipViewItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Flyout>{ using type = Windows::UI::Xaml::Controls::IFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::IFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FocusDisengagedEventArgs>{ using type = Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FocusEngagedEventArgs>{ using type = Windows::UI::Xaml::Controls::IFocusEngagedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FontIcon>{ using type = Windows::UI::Xaml::Controls::IFontIcon; };
template <> struct default_interface<Windows::UI::Xaml::Controls::FontIconSource>{ using type = Windows::UI::Xaml::Controls::IFontIconSource; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Frame>{ using type = Windows::UI::Xaml::Controls::IFrame; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Grid>{ using type = Windows::UI::Xaml::Controls::IGrid; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GridView>{ using type = Windows::UI::Xaml::Controls::IGridView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GridViewHeaderItem>{ using type = Windows::UI::Xaml::Controls::IGridViewHeaderItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GridViewItem>{ using type = Windows::UI::Xaml::Controls::IGridViewItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GroupItem>{ using type = Windows::UI::Xaml::Controls::IGroupItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GroupStyle>{ using type = Windows::UI::Xaml::Controls::IGroupStyle; };
template <> struct default_interface<Windows::UI::Xaml::Controls::GroupStyleSelector>{ using type = Windows::UI::Xaml::Controls::IGroupStyleSelector; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Hub>{ using type = Windows::UI::Xaml::Controls::IHub; };
template <> struct default_interface<Windows::UI::Xaml::Controls::HubSection>{ using type = Windows::UI::Xaml::Controls::IHubSection; };
template <> struct default_interface<Windows::UI::Xaml::Controls::HubSectionCollection>{ using type = Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::HubSection>; };
template <> struct default_interface<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventArgs>{ using type = Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::HyperlinkButton>{ using type = Windows::UI::Xaml::Controls::IHyperlinkButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::IconElement>{ using type = Windows::UI::Xaml::Controls::IIconElement; };
template <> struct default_interface<Windows::UI::Xaml::Controls::IconSource>{ using type = Windows::UI::Xaml::Controls::IIconSource; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Image>{ using type = Windows::UI::Xaml::Controls::IImage; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkCanvas>{ using type = Windows::UI::Xaml::Controls::IInkCanvas; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbar>{ using type = Windows::UI::Xaml::Controls::IInkToolbar; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarBallpointPenButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarCustomPen>{ using type = Windows::UI::Xaml::Controls::IInkToolbarCustomPen; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarCustomPenButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarCustomToggleButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarCustomToolButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarEraserButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarEraserButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem>{ using type = Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarHighlighterButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarIsStencilButtonCheckedChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarMenuButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarMenuButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarPenButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarPenButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarPenConfigurationControl>{ using type = Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarPencilButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarPencilButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarRulerButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarRulerButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarStencilButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarStencilButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarToggleButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarToggleButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::InkToolbarToolButton>{ using type = Windows::UI::Xaml::Controls::IInkToolbarToolButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemClickEventArgs>{ using type = Windows::UI::Xaml::Controls::IItemClickEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemCollection>{ using type = Windows::Foundation::Collections::IObservableVector<Windows::Foundation::IInspectable>; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemContainerGenerator>{ using type = Windows::UI::Xaml::Controls::IItemContainerGenerator; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsControl>{ using type = Windows::UI::Xaml::Controls::IItemsControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsPanelTemplate>{ using type = Windows::UI::Xaml::Controls::IItemsPanelTemplate; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsPickedEventArgs>{ using type = Windows::UI::Xaml::Controls::IItemsPickedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsPresenter>{ using type = Windows::UI::Xaml::Controls::IItemsPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsStackPanel>{ using type = Windows::UI::Xaml::Controls::IItemsStackPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ItemsWrapGrid>{ using type = Windows::UI::Xaml::Controls::IItemsWrapGrid; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListBox>{ using type = Windows::UI::Xaml::Controls::IListBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListBoxItem>{ using type = Windows::UI::Xaml::Controls::IListBoxItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListPickerFlyout>{ using type = Windows::UI::Xaml::Controls::IListPickerFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListPickerFlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListView>{ using type = Windows::UI::Xaml::Controls::IListView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListViewBase>{ using type = Windows::UI::Xaml::Controls::IListViewBase; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListViewBaseHeaderItem>{ using type = Windows::UI::Xaml::Controls::IListViewBaseHeaderItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListViewHeaderItem>{ using type = Windows::UI::Xaml::Controls::IListViewHeaderItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListViewItem>{ using type = Windows::UI::Xaml::Controls::IListViewItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ListViewPersistenceHelper>{ using type = Windows::UI::Xaml::Controls::IListViewPersistenceHelper; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MediaElement>{ using type = Windows::UI::Xaml::Controls::IMediaElement; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MediaPlayerElement>{ using type = Windows::UI::Xaml::Controls::IMediaPlayerElement; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MediaPlayerPresenter>{ using type = Windows::UI::Xaml::Controls::IMediaPlayerPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MediaTransportControls>{ using type = Windows::UI::Xaml::Controls::IMediaTransportControls; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MediaTransportControlsHelper>{ using type = Windows::UI::Xaml::Controls::IMediaTransportControlsHelper; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyout>{ using type = Windows::UI::Xaml::Controls::IMenuFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyoutItem>{ using type = Windows::UI::Xaml::Controls::IMenuFlyoutItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyoutItemBase>{ using type = Windows::UI::Xaml::Controls::IMenuFlyoutItemBase; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::IMenuFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyoutSeparator>{ using type = Windows::UI::Xaml::Controls::IMenuFlyoutSeparator; };
template <> struct default_interface<Windows::UI::Xaml::Controls::MenuFlyoutSubItem>{ using type = Windows::UI::Xaml::Controls::IMenuFlyoutSubItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationView>{ using type = Windows::UI::Xaml::Controls::INavigationView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewDisplayModeChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewItem>{ using type = Windows::UI::Xaml::Controls::INavigationViewItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewItemBase>{ using type = Windows::UI::Xaml::Controls::INavigationViewItemBase; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewItemHeader>{ using type = Windows::UI::Xaml::Controls::INavigationViewItemHeader; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewItemInvokedEventArgs>{ using type = Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewItemSeparator>{ using type = Windows::UI::Xaml::Controls::INavigationViewItemSeparator; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewList>{ using type = Windows::UI::Xaml::Controls::INavigationViewList; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NavigationViewSelectionChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::NotifyEventArgs>{ using type = Windows::UI::Xaml::Controls::INotifyEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Page>{ using type = Windows::UI::Xaml::Controls::IPage; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Panel>{ using type = Windows::UI::Xaml::Controls::IPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ParallaxView>{ using type = Windows::UI::Xaml::Controls::IParallaxView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PasswordBox>{ using type = Windows::UI::Xaml::Controls::IPasswordBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PasswordBoxPasswordChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PathIcon>{ using type = Windows::UI::Xaml::Controls::IPathIcon; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PathIconSource>{ using type = Windows::UI::Xaml::Controls::IPathIconSource; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PersonPicture>{ using type = Windows::UI::Xaml::Controls::IPersonPicture; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PickerConfirmedEventArgs>{ using type = Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PickerFlyout>{ using type = Windows::UI::Xaml::Controls::IPickerFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PickerFlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::IPickerFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Pivot>{ using type = Windows::UI::Xaml::Controls::IPivot; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PivotItem>{ using type = Windows::UI::Xaml::Controls::IPivotItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::PivotItemEventArgs>{ using type = Windows::UI::Xaml::Controls::IPivotItemEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ProgressBar>{ using type = Windows::UI::Xaml::Controls::IProgressBar; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ProgressRing>{ using type = Windows::UI::Xaml::Controls::IProgressRing; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RadioButton>{ using type = Windows::UI::Xaml::Controls::IRadioButton; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RatingControl>{ using type = Windows::UI::Xaml::Controls::IRatingControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RatingItemFontInfo>{ using type = Windows::UI::Xaml::Controls::IRatingItemFontInfo; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RatingItemImageInfo>{ using type = Windows::UI::Xaml::Controls::IRatingItemImageInfo; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RatingItemInfo>{ using type = Windows::UI::Xaml::Controls::IRatingItemInfo; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RelativePanel>{ using type = Windows::UI::Xaml::Controls::IRelativePanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RichEditBox>{ using type = Windows::UI::Xaml::Controls::IRichEditBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RichEditBoxTextChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RichTextBlock>{ using type = Windows::UI::Xaml::Controls::IRichTextBlock; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RichTextBlockOverflow>{ using type = Windows::UI::Xaml::Controls::IRichTextBlockOverflow; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RowDefinition>{ using type = Windows::UI::Xaml::Controls::IRowDefinition; };
template <> struct default_interface<Windows::UI::Xaml::Controls::RowDefinitionCollection>{ using type = Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::RowDefinition>; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ScrollContentPresenter>{ using type = Windows::UI::Xaml::Controls::IScrollContentPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ScrollViewer>{ using type = Windows::UI::Xaml::Controls::IScrollViewer; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ScrollViewerView>{ using type = Windows::UI::Xaml::Controls::IScrollViewerView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ScrollViewerViewChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ScrollViewerViewChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SearchBox>{ using type = Windows::UI::Xaml::Controls::ISearchBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SearchBoxQueryChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SearchBoxQuerySubmittedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SearchBoxResultSuggestionChosenEventArgs>{ using type = Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SearchBoxSuggestionsRequestedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SectionsInViewChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SelectionChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISelectionChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SemanticZoom>{ using type = Windows::UI::Xaml::Controls::ISemanticZoom; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SemanticZoomLocation>{ using type = Windows::UI::Xaml::Controls::ISemanticZoomLocation; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SettingsFlyout>{ using type = Windows::UI::Xaml::Controls::ISettingsFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Slider>{ using type = Windows::UI::Xaml::Controls::ISlider; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SplitView>{ using type = Windows::UI::Xaml::Controls::ISplitView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SplitViewPaneClosingEventArgs>{ using type = Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::StackPanel>{ using type = Windows::UI::Xaml::Controls::IStackPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::StyleSelector>{ using type = Windows::UI::Xaml::Controls::IStyleSelector; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwapChainBackgroundPanel>{ using type = Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwapChainPanel>{ using type = Windows::UI::Xaml::Controls::ISwapChainPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwipeControl>{ using type = Windows::UI::Xaml::Controls::ISwipeControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwipeItem>{ using type = Windows::UI::Xaml::Controls::ISwipeItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwipeItemInvokedEventArgs>{ using type = Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SwipeItems>{ using type = Windows::UI::Xaml::Controls::ISwipeItems; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SymbolIcon>{ using type = Windows::UI::Xaml::Controls::ISymbolIcon; };
template <> struct default_interface<Windows::UI::Xaml::Controls::SymbolIconSource>{ using type = Windows::UI::Xaml::Controls::ISymbolIconSource; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextBlock>{ using type = Windows::UI::Xaml::Controls::ITextBlock; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextBox>{ using type = Windows::UI::Xaml::Controls::ITextBox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextBoxBeforeTextChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TextControlPasteEventArgs>{ using type = Windows::UI::Xaml::Controls::ITextControlPasteEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TimePickedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITimePickedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TimePicker>{ using type = Windows::UI::Xaml::Controls::ITimePicker; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TimePickerFlyout>{ using type = Windows::UI::Xaml::Controls::ITimePickerFlyout; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TimePickerFlyoutPresenter>{ using type = Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter; };
template <> struct default_interface<Windows::UI::Xaml::Controls::TimePickerValueChangedEventArgs>{ using type = Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ToggleMenuFlyoutItem>{ using type = Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ToggleSwitch>{ using type = Windows::UI::Xaml::Controls::IToggleSwitch; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ToolTip>{ using type = Windows::UI::Xaml::Controls::IToolTip; };
template <> struct default_interface<Windows::UI::Xaml::Controls::ToolTipService>{ using type = Windows::UI::Xaml::Controls::IToolTipService; };
template <> struct default_interface<Windows::UI::Xaml::Controls::UIElementCollection>{ using type = Windows::Foundation::Collections::IVector<Windows::UI::Xaml::UIElement>; };
template <> struct default_interface<Windows::UI::Xaml::Controls::UserControl>{ using type = Windows::UI::Xaml::Controls::IUserControl; };
template <> struct default_interface<Windows::UI::Xaml::Controls::VariableSizedWrapGrid>{ using type = Windows::UI::Xaml::Controls::IVariableSizedWrapGrid; };
template <> struct default_interface<Windows::UI::Xaml::Controls::Viewbox>{ using type = Windows::UI::Xaml::Controls::IViewbox; };
template <> struct default_interface<Windows::UI::Xaml::Controls::VirtualizingPanel>{ using type = Windows::UI::Xaml::Controls::IVirtualizingPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::VirtualizingStackPanel>{ using type = Windows::UI::Xaml::Controls::IVirtualizingStackPanel; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebView>{ using type = Windows::UI::Xaml::Controls::IWebView; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewBrush>{ using type = Windows::UI::Xaml::Controls::IWebViewBrush; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewDeferredPermissionRequest>{ using type = Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewLongRunningScriptDetectedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewNewWindowRequestedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewPermissionRequest>{ using type = Windows::UI::Xaml::Controls::IWebViewPermissionRequest; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewPermissionRequestedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewSettings>{ using type = Windows::UI::Xaml::Controls::IWebViewSettings; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewUnsupportedUriSchemeIdentifiedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WebViewUnviewableContentIdentifiedEventArgs>{ using type = Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs; };
template <> struct default_interface<Windows::UI::Xaml::Controls::WrapGrid>{ using type = Windows::UI::Xaml::Controls::IWrapGrid; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBar
{
    bool IsOpen() const noexcept;
    void IsOpen(bool value) const noexcept;
    bool IsSticky() const noexcept;
    void IsSticky(bool value) const noexcept;
    event_token Opened(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Opened_revoker = event_revoker<Windows::UI::Xaml::Controls::IAppBar>;
    Opened_revoker Opened(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Opened(event_token const& token) const;
    event_token Closed(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Closed_revoker = event_revoker<Windows::UI::Xaml::Controls::IAppBar>;
    Closed_revoker Closed(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Closed(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBar> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBar<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBar2
{
    Windows::UI::Xaml::Controls::AppBarClosedDisplayMode ClosedDisplayMode() const noexcept;
    void ClosedDisplayMode(Windows::UI::Xaml::Controls::AppBarClosedDisplayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBar2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBar2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBar3
{
    Windows::UI::Xaml::Controls::Primitives::AppBarTemplateSettings TemplateSettings() const noexcept;
    event_token Opening(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Opening_revoker = event_revoker<Windows::UI::Xaml::Controls::IAppBar3>;
    Opening_revoker Opening(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Opening(event_token const& token) const;
    event_token Closing(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Closing_revoker = event_revoker<Windows::UI::Xaml::Controls::IAppBar3>;
    Closing_revoker Closing(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Closing(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBar3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBar3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBar4
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBar4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBar4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarButton
{
    hstring Label() const noexcept;
    void Label(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Controls::IconElement Icon() const noexcept;
    void Icon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarButton3
{
    Windows::UI::Xaml::Controls::CommandBarLabelPosition LabelPosition() const noexcept;
    void LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarButton3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarButton3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarButtonFactory
{
    Windows::UI::Xaml::Controls::AppBarButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarButtonStatics
{
    Windows::UI::Xaml::DependencyProperty LabelProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IconProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsCompactProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarButtonStatics3
{
    Windows::UI::Xaml::DependencyProperty LabelPositionProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsInOverflowProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DynamicOverflowOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarButtonStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarButtonStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarFactory
{
    Windows::UI::Xaml::Controls::AppBar CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarOverrides
{
    void OnClosed(Windows::Foundation::IInspectable const& e) const;
    void OnOpened(Windows::Foundation::IInspectable const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarOverrides3
{
    void OnClosing(Windows::Foundation::IInspectable const& e) const;
    void OnOpening(Windows::Foundation::IInspectable const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarOverrides3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarOverrides3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarSeparator
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarSeparator> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarSeparator<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarSeparatorFactory
{
    Windows::UI::Xaml::Controls::AppBarSeparator CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarSeparatorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarSeparatorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarSeparatorStatics
{
    Windows::UI::Xaml::DependencyProperty IsCompactProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarSeparatorStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarSeparatorStatics3
{
    Windows::UI::Xaml::DependencyProperty IsInOverflowProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DynamicOverflowOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarSeparatorStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarStatics
{
    Windows::UI::Xaml::DependencyProperty IsOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsStickyProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarStatics2
{
    Windows::UI::Xaml::DependencyProperty ClosedDisplayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarStatics4
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarToggleButton
{
    hstring Label() const noexcept;
    void Label(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Controls::IconElement Icon() const noexcept;
    void Icon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarToggleButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarToggleButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarToggleButton3
{
    Windows::UI::Xaml::Controls::CommandBarLabelPosition LabelPosition() const noexcept;
    void LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarToggleButton3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarToggleButton3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonFactory
{
    Windows::UI::Xaml::Controls::AppBarToggleButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarToggleButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonStatics
{
    Windows::UI::Xaml::DependencyProperty LabelProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IconProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsCompactProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonStatics3
{
    Windows::UI::Xaml::DependencyProperty LabelPositionProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsInOverflowProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DynamicOverflowOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAppBarToggleButtonStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBox
{
    double MaxSuggestionListHeight() const noexcept;
    void MaxSuggestionListHeight(double value) const noexcept;
    bool IsSuggestionListOpen() const noexcept;
    void IsSuggestionListOpen(bool value) const noexcept;
    hstring TextMemberPath() const noexcept;
    void TextMemberPath(param::hstring const& value) const noexcept;
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
    bool UpdateTextOnSelect() const noexcept;
    void UpdateTextOnSelect(bool value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    bool AutoMaximizeSuggestionArea() const noexcept;
    void AutoMaximizeSuggestionArea(bool value) const noexcept;
    Windows::UI::Xaml::Style TextBoxStyle() const noexcept;
    void TextBoxStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    event_token SuggestionChosen(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxSuggestionChosenEventArgs> const& value) const;
    using SuggestionChosen_revoker = event_revoker<Windows::UI::Xaml::Controls::IAutoSuggestBox>;
    SuggestionChosen_revoker SuggestionChosen(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxSuggestionChosenEventArgs> const& value) const;
    void SuggestionChosen(event_token const& token) const;
    event_token TextChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxTextChangedEventArgs> const& value) const;
    using TextChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IAutoSuggestBox>;
    TextChanged_revoker TextChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxTextChangedEventArgs> const& value) const;
    void TextChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBox2
{
    Windows::UI::Xaml::Controls::IconElement QueryIcon() const noexcept;
    void QueryIcon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
    event_token QuerySubmitted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxQuerySubmittedEventArgs> const& value) const;
    using QuerySubmitted_revoker = event_revoker<Windows::UI::Xaml::Controls::IAutoSuggestBox2>;
    QuerySubmitted_revoker QuerySubmitted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::AutoSuggestBox, Windows::UI::Xaml::Controls::AutoSuggestBoxQuerySubmittedEventArgs> const& value) const;
    void QuerySubmitted(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBox3
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBox3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBox3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxQuerySubmittedEventArgs
{
    hstring QueryText() const noexcept;
    Windows::Foundation::IInspectable ChosenSuggestion() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxQuerySubmittedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics
{
    Windows::UI::Xaml::DependencyProperty MaxSuggestionListHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSuggestionListOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextMemberPathProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty UpdateTextOnSelectProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AutoMaximizeSuggestionAreaProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextBoxStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty QueryIconProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics3
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxSuggestionChosenEventArgs
{
    Windows::Foundation::IInspectable SelectedItem() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxSuggestionChosenEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxTextChangedEventArgs
{
    Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason Reason() const noexcept;
    void Reason(Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason const& value) const noexcept;
    bool CheckCurrent() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxTextChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxTextChangedEventArgsStatics
{
    Windows::UI::Xaml::DependencyProperty ReasonProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgsStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IAutoSuggestBoxTextChangedEventArgsStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBackClickEventArgs
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBackClickEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBackClickEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIcon
{
    Windows::Foundation::Uri UriSource() const noexcept;
    void UriSource(Windows::Foundation::Uri const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIcon> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIcon<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIcon2
{
    bool ShowAsMonochrome() const noexcept;
    void ShowAsMonochrome(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIcon2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIcon2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconFactory
{
    Windows::UI::Xaml::Controls::BitmapIcon CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconSource
{
    Windows::Foundation::Uri UriSource() const noexcept;
    void UriSource(Windows::Foundation::Uri const& value) const noexcept;
    bool ShowAsMonochrome() const noexcept;
    void ShowAsMonochrome(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconSource> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconSource<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconSourceFactory
{
    Windows::UI::Xaml::Controls::BitmapIconSource CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconSourceFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconSourceFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconSourceStatics
{
    Windows::UI::Xaml::DependencyProperty UriSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ShowAsMonochromeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconSourceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconSourceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconStatics
{
    Windows::UI::Xaml::DependencyProperty UriSourceProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBitmapIconStatics2
{
    Windows::UI::Xaml::DependencyProperty ShowAsMonochromeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBitmapIconStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBitmapIconStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBorder
{
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Background() const noexcept;
    void Background(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::CornerRadius CornerRadius() const noexcept;
    void CornerRadius(Windows::UI::Xaml::CornerRadius const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::UIElement Child() const noexcept;
    void Child(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection ChildTransitions() const noexcept;
    void ChildTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBorder> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBorder<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IBorderStatics
{
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CornerRadiusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ChildTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IBorderStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IBorderStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IButtonFactory
{
    Windows::UI::Xaml::Controls::Button CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IButtonStaticsWithFlyout
{
    Windows::UI::Xaml::DependencyProperty FlyoutProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IButtonStaticsWithFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IButtonStaticsWithFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IButtonWithFlyout
{
    Windows::UI::Xaml::Controls::Primitives::FlyoutBase Flyout() const noexcept;
    void Flyout(Windows::UI::Xaml::Controls::Primitives::FlyoutBase const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IButtonWithFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IButtonWithFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePicker
{
    Windows::Foundation::IReference<Windows::Foundation::DateTime> Date() const noexcept;
    void Date(optional<Windows::Foundation::DateTime> const& value) const noexcept;
    bool IsCalendarOpen() const noexcept;
    void IsCalendarOpen(bool value) const noexcept;
    hstring DateFormat() const noexcept;
    void DateFormat(param::hstring const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Style CalendarViewStyle() const noexcept;
    void CalendarViewStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::Foundation::DateTime MinDate() const noexcept;
    void MinDate(Windows::Foundation::DateTime const& value) const noexcept;
    Windows::Foundation::DateTime MaxDate() const noexcept;
    void MaxDate(Windows::Foundation::DateTime const& value) const noexcept;
    bool IsTodayHighlighted() const noexcept;
    void IsTodayHighlighted(bool value) const noexcept;
    Windows::UI::Xaml::Controls::CalendarViewDisplayMode DisplayMode() const noexcept;
    void DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode const& value) const noexcept;
    Windows::Globalization::DayOfWeek FirstDayOfWeek() const noexcept;
    void FirstDayOfWeek(Windows::Globalization::DayOfWeek const& value) const noexcept;
    hstring DayOfWeekFormat() const noexcept;
    void DayOfWeekFormat(param::hstring const& value) const noexcept;
    hstring CalendarIdentifier() const noexcept;
    void CalendarIdentifier(param::hstring const& value) const noexcept;
    bool IsOutOfScopeEnabled() const noexcept;
    void IsOutOfScopeEnabled(bool value) const noexcept;
    bool IsGroupLabelVisible() const noexcept;
    void IsGroupLabelVisible(bool value) const noexcept;
    event_token CalendarViewDayItemChanging(Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler const& value) const;
    using CalendarViewDayItemChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarDatePicker>;
    CalendarViewDayItemChanging_revoker CalendarViewDayItemChanging(auto_revoke_t, Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler const& value) const;
    void CalendarViewDayItemChanging(event_token const& token) const;
    event_token DateChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarDatePicker, Windows::UI::Xaml::Controls::CalendarDatePickerDateChangedEventArgs> const& value) const;
    using DateChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarDatePicker>;
    DateChanged_revoker DateChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarDatePicker, Windows::UI::Xaml::Controls::CalendarDatePickerDateChangedEventArgs> const& value) const;
    void DateChanged(event_token const& token) const;
    event_token Opened(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Opened_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarDatePicker>;
    Opened_revoker Opened(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Opened(event_token const& token) const;
    event_token Closed(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using Closed_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarDatePicker>;
    Closed_revoker Closed(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void Closed(event_token const& token) const;
    void SetDisplayDate(Windows::Foundation::DateTime const& date) const;
    void SetYearDecadeDisplayDimensions(int32_t columns, int32_t rows) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePicker> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePicker<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePicker2
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePicker2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePicker2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePickerDateChangedEventArgs
{
    Windows::Foundation::IReference<Windows::Foundation::DateTime> NewDate() const noexcept;
    Windows::Foundation::IReference<Windows::Foundation::DateTime> OldDate() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePickerDateChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePickerFactory
{
    Windows::UI::Xaml::Controls::CalendarDatePicker CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePickerFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePickerFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePickerStatics
{
    Windows::UI::Xaml::DependencyProperty DateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsCalendarOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DateFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarViewStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinDateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxDateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTodayHighlightedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstDayOfWeekProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayOfWeekFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsOutOfScopeEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsGroupLabelVisibleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePickerStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarDatePickerStatics2
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarDatePickerStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarView
{
    hstring CalendarIdentifier() const noexcept;
    void CalendarIdentifier(param::hstring const& value) const noexcept;
    hstring DayOfWeekFormat() const noexcept;
    void DayOfWeekFormat(param::hstring const& value) const noexcept;
    bool IsGroupLabelVisible() const noexcept;
    void IsGroupLabelVisible(bool value) const noexcept;
    Windows::UI::Xaml::Controls::CalendarViewDisplayMode DisplayMode() const noexcept;
    void DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode const& value) const noexcept;
    Windows::Globalization::DayOfWeek FirstDayOfWeek() const noexcept;
    void FirstDayOfWeek(Windows::Globalization::DayOfWeek const& value) const noexcept;
    bool IsOutOfScopeEnabled() const noexcept;
    void IsOutOfScopeEnabled(bool value) const noexcept;
    bool IsTodayHighlighted() const noexcept;
    void IsTodayHighlighted(bool value) const noexcept;
    Windows::Foundation::DateTime MaxDate() const noexcept;
    void MaxDate(Windows::Foundation::DateTime const& value) const noexcept;
    Windows::Foundation::DateTime MinDate() const noexcept;
    void MinDate(Windows::Foundation::DateTime const& value) const noexcept;
    int32_t NumberOfWeeksInView() const noexcept;
    void NumberOfWeeksInView(int32_t value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::DateTime> SelectedDates() const noexcept;
    Windows::UI::Xaml::Controls::CalendarViewSelectionMode SelectionMode() const noexcept;
    void SelectionMode(Windows::UI::Xaml::Controls::CalendarViewSelectionMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::CalendarViewTemplateSettings TemplateSettings() const noexcept;
    Windows::UI::Xaml::Media::Brush FocusBorderBrush() const noexcept;
    void FocusBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush SelectedHoverBorderBrush() const noexcept;
    void SelectedHoverBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush SelectedPressedBorderBrush() const noexcept;
    void SelectedPressedBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush SelectedBorderBrush() const noexcept;
    void SelectedBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush HoverBorderBrush() const noexcept;
    void HoverBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush PressedBorderBrush() const noexcept;
    void PressedBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush CalendarItemBorderBrush() const noexcept;
    void CalendarItemBorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush OutOfScopeBackground() const noexcept;
    void OutOfScopeBackground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush CalendarItemBackground() const noexcept;
    void CalendarItemBackground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush PressedForeground() const noexcept;
    void PressedForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush TodayForeground() const noexcept;
    void TodayForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush BlackoutForeground() const noexcept;
    void BlackoutForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush SelectedForeground() const noexcept;
    void SelectedForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush OutOfScopeForeground() const noexcept;
    void OutOfScopeForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush CalendarItemForeground() const noexcept;
    void CalendarItemForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily DayItemFontFamily() const noexcept;
    void DayItemFontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    double DayItemFontSize() const noexcept;
    void DayItemFontSize(double value) const noexcept;
    Windows::UI::Text::FontStyle DayItemFontStyle() const noexcept;
    void DayItemFontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontWeight DayItemFontWeight() const noexcept;
    void DayItemFontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontWeight TodayFontWeight() const noexcept;
    void TodayFontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FirstOfMonthLabelFontFamily() const noexcept;
    void FirstOfMonthLabelFontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    double FirstOfMonthLabelFontSize() const noexcept;
    void FirstOfMonthLabelFontSize(double value) const noexcept;
    Windows::UI::Text::FontStyle FirstOfMonthLabelFontStyle() const noexcept;
    void FirstOfMonthLabelFontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontWeight FirstOfMonthLabelFontWeight() const noexcept;
    void FirstOfMonthLabelFontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily MonthYearItemFontFamily() const noexcept;
    void MonthYearItemFontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    double MonthYearItemFontSize() const noexcept;
    void MonthYearItemFontSize(double value) const noexcept;
    Windows::UI::Text::FontStyle MonthYearItemFontStyle() const noexcept;
    void MonthYearItemFontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontWeight MonthYearItemFontWeight() const noexcept;
    void MonthYearItemFontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FirstOfYearDecadeLabelFontFamily() const noexcept;
    void FirstOfYearDecadeLabelFontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    double FirstOfYearDecadeLabelFontSize() const noexcept;
    void FirstOfYearDecadeLabelFontSize(double value) const noexcept;
    Windows::UI::Text::FontStyle FirstOfYearDecadeLabelFontStyle() const noexcept;
    void FirstOfYearDecadeLabelFontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontWeight FirstOfYearDecadeLabelFontWeight() const noexcept;
    void FirstOfYearDecadeLabelFontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalDayItemAlignment() const noexcept;
    void HorizontalDayItemAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalDayItemAlignment() const noexcept;
    void VerticalDayItemAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalFirstOfMonthLabelAlignment() const noexcept;
    void HorizontalFirstOfMonthLabelAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalFirstOfMonthLabelAlignment() const noexcept;
    void VerticalFirstOfMonthLabelAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
    Windows::UI::Xaml::Thickness CalendarItemBorderThickness() const noexcept;
    void CalendarItemBorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Style CalendarViewDayItemStyle() const noexcept;
    void CalendarViewDayItemStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    event_token CalendarViewDayItemChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs> const& value) const;
    using CalendarViewDayItemChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarView>;
    CalendarViewDayItemChanging_revoker CalendarViewDayItemChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs> const& value) const;
    void CalendarViewDayItemChanging(event_token const& token) const;
    event_token SelectedDatesChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewSelectedDatesChangedEventArgs> const& value) const;
    using SelectedDatesChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ICalendarView>;
    SelectedDatesChanged_revoker SelectedDatesChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewSelectedDatesChangedEventArgs> const& value) const;
    void SelectedDatesChanged(event_token const& token) const;
    void SetDisplayDate(Windows::Foundation::DateTime const& date) const;
    void SetYearDecadeDisplayDimensions(int32_t columns, int32_t rows) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewDayItem
{
    bool IsBlackout() const noexcept;
    void IsBlackout(bool value) const noexcept;
    Windows::Foundation::DateTime Date() const noexcept;
    void SetDensityColors(param::iterable<Windows::UI::Color> const& colors) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewDayItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewDayItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemChangingEventArgs
{
    bool InRecycleQueue() const noexcept;
    Windows::UI::Xaml::Controls::CalendarViewDayItem Item() const noexcept;
    uint32_t Phase() const noexcept;
    void RegisterUpdateCallback(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs> const& callback) const;
    void RegisterUpdateCallback(uint32_t callbackPhase, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CalendarView, Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventArgs> const& callback) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemFactory
{
    Windows::UI::Xaml::Controls::CalendarViewDayItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewDayItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemStatics
{
    Windows::UI::Xaml::DependencyProperty IsBlackoutProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DateProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewDayItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewDayItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewFactory
{
    Windows::UI::Xaml::Controls::CalendarView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewSelectedDatesChangedEventArgs
{
    Windows::Foundation::Collections::IVectorView<Windows::Foundation::DateTime> AddedDates() const noexcept;
    Windows::Foundation::Collections::IVectorView<Windows::Foundation::DateTime> RemovedDates() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewSelectedDatesChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICalendarViewStatics
{
    Windows::UI::Xaml::DependencyProperty CalendarIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayOfWeekFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsGroupLabelVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstDayOfWeekProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsOutOfScopeEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTodayHighlightedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxDateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinDateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty NumberOfWeeksInViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedDatesProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TemplateSettingsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FocusBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedHoverBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedPressedBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HoverBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PressedBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarItemBorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OutOfScopeBackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarItemBackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PressedForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TodayForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BlackoutForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OutOfScopeForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarItemForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayItemFontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayItemFontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayItemFontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayItemFontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TodayFontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfMonthLabelFontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfMonthLabelFontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfMonthLabelFontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfMonthLabelFontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthYearItemFontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthYearItemFontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthYearItemFontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthYearItemFontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfYearDecadeLabelFontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfYearDecadeLabelFontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfYearDecadeLabelFontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FirstOfYearDecadeLabelFontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalDayItemAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalDayItemAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalFirstOfMonthLabelAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalFirstOfMonthLabelAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarItemBorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarViewDayItemStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICalendarViewStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICalendarViewStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICandidateWindowBoundsChangedEventArgs
{
    Windows::Foundation::Rect Bounds() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICandidateWindowBoundsChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICanvas
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ICanvas> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICanvas<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICanvasFactory
{
    Windows::UI::Xaml::Controls::Canvas CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICanvasFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICanvasFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICanvasStatics
{
    Windows::UI::Xaml::DependencyProperty LeftProperty() const noexcept;
    double GetLeft(Windows::UI::Xaml::UIElement const& element) const;
    void SetLeft(Windows::UI::Xaml::UIElement const& element, double length) const;
    Windows::UI::Xaml::DependencyProperty TopProperty() const noexcept;
    double GetTop(Windows::UI::Xaml::UIElement const& element) const;
    void SetTop(Windows::UI::Xaml::UIElement const& element, double length) const;
    Windows::UI::Xaml::DependencyProperty ZIndexProperty() const noexcept;
    int32_t GetZIndex(Windows::UI::Xaml::UIElement const& element) const;
    void SetZIndex(Windows::UI::Xaml::UIElement const& element, int32_t value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICanvasStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICanvasStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICaptureElement
{
    Windows::Media::Capture::MediaCapture Source() const noexcept;
    void Source(Windows::Media::Capture::MediaCapture const& value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICaptureElement> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICaptureElement<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICaptureElementStatics
{
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICaptureElementStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICaptureElementStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICheckBox
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ICheckBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICheckBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICheckBoxFactory
{
    Windows::UI::Xaml::Controls::CheckBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICheckBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICheckBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IChoosingGroupHeaderContainerEventArgs
{
    Windows::UI::Xaml::Controls::ListViewBaseHeaderItem GroupHeaderContainer() const noexcept;
    void GroupHeaderContainer(Windows::UI::Xaml::Controls::ListViewBaseHeaderItem const& value) const noexcept;
    int32_t GroupIndex() const noexcept;
    Windows::Foundation::IInspectable Group() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IChoosingGroupHeaderContainerEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IChoosingItemContainerEventArgs
{
    int32_t ItemIndex() const noexcept;
    Windows::Foundation::IInspectable Item() const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SelectorItem ItemContainer() const noexcept;
    void ItemContainer(Windows::UI::Xaml::Controls::Primitives::SelectorItem const& value) const noexcept;
    bool IsContainerPrepared() const noexcept;
    void IsContainerPrepared(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IChoosingItemContainerEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICleanUpVirtualizedItemEventArgs
{
    Windows::Foundation::IInspectable Value() const noexcept;
    Windows::UI::Xaml::UIElement UIElement() const noexcept;
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICleanUpVirtualizedItemEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColorChangedEventArgs
{
    Windows::UI::Color OldColor() const noexcept;
    Windows::UI::Color NewColor() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColorChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColorChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColorPicker
{
    Windows::UI::Color Color() const noexcept;
    void Color(Windows::UI::Color const& value) const noexcept;
    Windows::Foundation::IReference<Windows::UI::Color> PreviousColor() const noexcept;
    void PreviousColor(optional<Windows::UI::Color> const& value) const noexcept;
    bool IsAlphaEnabled() const noexcept;
    void IsAlphaEnabled(bool value) const noexcept;
    bool IsColorSpectrumVisible() const noexcept;
    void IsColorSpectrumVisible(bool value) const noexcept;
    bool IsColorPreviewVisible() const noexcept;
    void IsColorPreviewVisible(bool value) const noexcept;
    bool IsColorSliderVisible() const noexcept;
    void IsColorSliderVisible(bool value) const noexcept;
    bool IsAlphaSliderVisible() const noexcept;
    void IsAlphaSliderVisible(bool value) const noexcept;
    bool IsMoreButtonVisible() const noexcept;
    void IsMoreButtonVisible(bool value) const noexcept;
    bool IsColorChannelTextInputVisible() const noexcept;
    void IsColorChannelTextInputVisible(bool value) const noexcept;
    bool IsAlphaTextInputVisible() const noexcept;
    void IsAlphaTextInputVisible(bool value) const noexcept;
    bool IsHexInputVisible() const noexcept;
    void IsHexInputVisible(bool value) const noexcept;
    int32_t MinHue() const noexcept;
    void MinHue(int32_t value) const noexcept;
    int32_t MaxHue() const noexcept;
    void MaxHue(int32_t value) const noexcept;
    int32_t MinSaturation() const noexcept;
    void MinSaturation(int32_t value) const noexcept;
    int32_t MaxSaturation() const noexcept;
    void MaxSaturation(int32_t value) const noexcept;
    int32_t MinValue() const noexcept;
    void MinValue(int32_t value) const noexcept;
    int32_t MaxValue() const noexcept;
    void MaxValue(int32_t value) const noexcept;
    Windows::UI::Xaml::Controls::ColorSpectrumShape ColorSpectrumShape() const noexcept;
    void ColorSpectrumShape(Windows::UI::Xaml::Controls::ColorSpectrumShape const& value) const noexcept;
    Windows::UI::Xaml::Controls::ColorSpectrumComponents ColorSpectrumComponents() const noexcept;
    void ColorSpectrumComponents(Windows::UI::Xaml::Controls::ColorSpectrumComponents const& value) const noexcept;
    event_token ColorChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ColorPicker, Windows::UI::Xaml::Controls::ColorChangedEventArgs> const& value) const;
    using ColorChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IColorPicker>;
    ColorChanged_revoker ColorChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ColorPicker, Windows::UI::Xaml::Controls::ColorChangedEventArgs> const& value) const;
    void ColorChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColorPicker> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColorPicker<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColorPickerFactory
{
    Windows::UI::Xaml::Controls::ColorPicker CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColorPickerFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColorPickerFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColorPickerStatics
{
    Windows::UI::Xaml::DependencyProperty ColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PreviousColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsAlphaEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorSpectrumVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorPreviewVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorSliderVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsAlphaSliderVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsMoreButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorChannelTextInputVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsAlphaTextInputVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsHexInputVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinHueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxHueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinSaturationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxSaturationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ColorSpectrumShapeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ColorSpectrumComponentsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColorPickerStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColorPickerStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColumnDefinition
{
    Windows::UI::Xaml::GridLength Width() const noexcept;
    void Width(Windows::UI::Xaml::GridLength const& value) const noexcept;
    double MaxWidth() const noexcept;
    void MaxWidth(double value) const noexcept;
    double MinWidth() const noexcept;
    void MinWidth(double value) const noexcept;
    double ActualWidth() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColumnDefinition> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColumnDefinition<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IColumnDefinitionStatics
{
    Windows::UI::Xaml::DependencyProperty WidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinWidthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IColumnDefinitionStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IColumnDefinitionStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBox
{
    bool IsDropDownOpen() const noexcept;
    void IsDropDownOpen(bool value) const noexcept;
    bool IsEditable() const noexcept;
    bool IsSelectionBoxHighlighted() const noexcept;
    double MaxDropDownHeight() const noexcept;
    void MaxDropDownHeight(double value) const noexcept;
    Windows::Foundation::IInspectable SelectionBoxItem() const noexcept;
    Windows::UI::Xaml::DataTemplate SelectionBoxItemTemplate() const noexcept;
    Windows::UI::Xaml::Controls::Primitives::ComboBoxTemplateSettings TemplateSettings() const noexcept;
    event_token DropDownClosed(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using DropDownClosed_revoker = event_revoker<Windows::UI::Xaml::Controls::IComboBox>;
    DropDownClosed_revoker DropDownClosed(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void DropDownClosed(event_token const& token) const;
    event_token DropDownOpened(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using DropDownOpened_revoker = event_revoker<Windows::UI::Xaml::Controls::IComboBox>;
    DropDownOpened_revoker DropDownOpened(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void DropDownOpened(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBox2
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBox3
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
    bool IsTextSearchEnabled() const noexcept;
    void IsTextSearchEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBox3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBox3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBox4
{
    Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger SelectionChangedTrigger() const noexcept;
    void SelectionChangedTrigger(Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBox4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBox4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBox5
{
    Windows::UI::Xaml::Media::Brush PlaceholderForeground() const noexcept;
    void PlaceholderForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBox5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBox5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxFactory
{
    Windows::UI::Xaml::Controls::ComboBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxItemFactory
{
    Windows::UI::Xaml::Controls::ComboBoxItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxOverrides
{
    void OnDropDownClosed(Windows::Foundation::IInspectable const& e) const;
    void OnDropDownOpened(Windows::Foundation::IInspectable const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxStatics
{
    Windows::UI::Xaml::DependencyProperty IsDropDownOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxDropDownHeightProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxStatics3
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextSearchEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxStatics4
{
    Windows::UI::Xaml::DependencyProperty SelectionChangedTriggerProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IComboBoxStatics5
{
    Windows::UI::Xaml::DependencyProperty PlaceholderForegroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IComboBoxStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IComboBoxStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBar
{
    Windows::Foundation::Collections::IObservableVector<Windows::UI::Xaml::Controls::ICommandBarElement> PrimaryCommands() const noexcept;
    Windows::Foundation::Collections::IObservableVector<Windows::UI::Xaml::Controls::ICommandBarElement> SecondaryCommands() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBar> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBar<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBar2
{
    Windows::UI::Xaml::Style CommandBarOverflowPresenterStyle() const noexcept;
    void CommandBarOverflowPresenterStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::CommandBarTemplateSettings CommandBarTemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBar2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBar2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBar3
{
    Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition DefaultLabelPosition() const noexcept;
    void DefaultLabelPosition(Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition const& value) const noexcept;
    Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility OverflowButtonVisibility() const noexcept;
    void OverflowButtonVisibility(Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility const& value) const noexcept;
    bool IsDynamicOverflowEnabled() const noexcept;
    void IsDynamicOverflowEnabled(bool value) const noexcept;
    event_token DynamicOverflowItemsChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CommandBar, Windows::UI::Xaml::Controls::DynamicOverflowItemsChangingEventArgs> const& value) const;
    using DynamicOverflowItemsChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::ICommandBar3>;
    DynamicOverflowItemsChanging_revoker DynamicOverflowItemsChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::CommandBar, Windows::UI::Xaml::Controls::DynamicOverflowItemsChangingEventArgs> const& value) const;
    void DynamicOverflowItemsChanging(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBar3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBar3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarElement
{
    bool IsCompact() const noexcept;
    void IsCompact(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarElement> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarElement<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarElement2
{
    bool IsInOverflow() const noexcept;
    int32_t DynamicOverflowOrder() const noexcept;
    void DynamicOverflowOrder(int32_t value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarElement2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarElement2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarFactory
{
    Windows::UI::Xaml::Controls::CommandBar CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarOverflowPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarOverflowPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarOverflowPresenterFactory
{
    Windows::UI::Xaml::Controls::CommandBarOverflowPresenter CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenterFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarOverflowPresenterFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarStatics
{
    Windows::UI::Xaml::DependencyProperty PrimaryCommandsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryCommandsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarStatics2
{
    Windows::UI::Xaml::DependencyProperty CommandBarOverflowPresenterStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ICommandBarStatics3
{
    Windows::UI::Xaml::DependencyProperty DefaultLabelPositionProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OverflowButtonVisibilityProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsDynamicOverflowEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ICommandBarStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ICommandBarStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContainerContentChangingEventArgs
{
    Windows::UI::Xaml::Controls::Primitives::SelectorItem ItemContainer() const noexcept;
    bool InRecycleQueue() const noexcept;
    int32_t ItemIndex() const noexcept;
    Windows::Foundation::IInspectable Item() const noexcept;
    uint32_t Phase() const noexcept;
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
    void RegisterUpdateCallback(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs> const& callback) const;
    void RegisterUpdateCallback(uint32_t callbackPhase, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs> const& callback) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContainerContentChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentControl
{
    Windows::Foundation::IInspectable Content() const noexcept;
    void Content(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate ContentTemplate() const noexcept;
    void ContentTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::DataTemplateSelector ContentTemplateSelector() const noexcept;
    void ContentTemplateSelector(Windows::UI::Xaml::Controls::DataTemplateSelector const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection ContentTransitions() const noexcept;
    void ContentTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentControl2
{
    Windows::UI::Xaml::UIElement ContentTemplateRoot() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentControl2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentControl2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentControlFactory
{
    Windows::UI::Xaml::Controls::ContentControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentControlOverrides
{
    void OnContentChanged(Windows::Foundation::IInspectable const& oldContent, Windows::Foundation::IInspectable const& newContent) const;
    void OnContentTemplateChanged(Windows::UI::Xaml::DataTemplate const& oldContentTemplate, Windows::UI::Xaml::DataTemplate const& newContentTemplate) const;
    void OnContentTemplateSelectorChanged(Windows::UI::Xaml::Controls::DataTemplateSelector const& oldContentTemplateSelector, Windows::UI::Xaml::Controls::DataTemplateSelector const& newContentTemplateSelector) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentControlOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentControlOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentControlStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTemplateSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialog
{
    Windows::Foundation::IInspectable Title() const noexcept;
    void Title(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate TitleTemplate() const noexcept;
    void TitleTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    bool FullSizeDesired() const noexcept;
    void FullSizeDesired(bool value) const noexcept;
    hstring PrimaryButtonText() const noexcept;
    void PrimaryButtonText(param::hstring const& value) const noexcept;
    hstring SecondaryButtonText() const noexcept;
    void SecondaryButtonText(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Input::ICommand PrimaryButtonCommand() const noexcept;
    void PrimaryButtonCommand(Windows::UI::Xaml::Input::ICommand const& value) const noexcept;
    Windows::UI::Xaml::Input::ICommand SecondaryButtonCommand() const noexcept;
    void SecondaryButtonCommand(Windows::UI::Xaml::Input::ICommand const& value) const noexcept;
    Windows::Foundation::IInspectable PrimaryButtonCommandParameter() const noexcept;
    void PrimaryButtonCommandParameter(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::Foundation::IInspectable SecondaryButtonCommandParameter() const noexcept;
    void SecondaryButtonCommandParameter(Windows::Foundation::IInspectable const& value) const noexcept;
    bool IsPrimaryButtonEnabled() const noexcept;
    void IsPrimaryButtonEnabled(bool value) const noexcept;
    bool IsSecondaryButtonEnabled() const noexcept;
    void IsSecondaryButtonEnabled(bool value) const noexcept;
    event_token Closing(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogClosingEventArgs> const& value) const;
    using Closing_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog>;
    Closing_revoker Closing(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogClosingEventArgs> const& value) const;
    void Closing(event_token const& token) const;
    event_token Closed(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogClosedEventArgs> const& value) const;
    using Closed_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog>;
    Closed_revoker Closed(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogClosedEventArgs> const& value) const;
    void Closed(event_token const& token) const;
    event_token Opened(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogOpenedEventArgs> const& value) const;
    using Opened_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog>;
    Opened_revoker Opened(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogOpenedEventArgs> const& value) const;
    void Opened(event_token const& token) const;
    event_token PrimaryButtonClick(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    using PrimaryButtonClick_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog>;
    PrimaryButtonClick_revoker PrimaryButtonClick(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    void PrimaryButtonClick(event_token const& token) const;
    event_token SecondaryButtonClick(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    using SecondaryButtonClick_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog>;
    SecondaryButtonClick_revoker SecondaryButtonClick(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    void SecondaryButtonClick(event_token const& token) const;
    void Hide() const;
    Windows::Foundation::IAsyncOperation<Windows::UI::Xaml::Controls::ContentDialogResult> ShowAsync() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialog> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialog<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialog2
{
    hstring CloseButtonText() const noexcept;
    void CloseButtonText(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Input::ICommand CloseButtonCommand() const noexcept;
    void CloseButtonCommand(Windows::UI::Xaml::Input::ICommand const& value) const noexcept;
    Windows::Foundation::IInspectable CloseButtonCommandParameter() const noexcept;
    void CloseButtonCommandParameter(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::Style PrimaryButtonStyle() const noexcept;
    void PrimaryButtonStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Style SecondaryButtonStyle() const noexcept;
    void SecondaryButtonStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Style CloseButtonStyle() const noexcept;
    void CloseButtonStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Controls::ContentDialogButton DefaultButton() const noexcept;
    void DefaultButton(Windows::UI::Xaml::Controls::ContentDialogButton const& value) const noexcept;
    event_token CloseButtonClick(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    using CloseButtonClick_revoker = event_revoker<Windows::UI::Xaml::Controls::IContentDialog2>;
    CloseButtonClick_revoker CloseButtonClick(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ContentDialog, Windows::UI::Xaml::Controls::ContentDialogButtonClickEventArgs> const& value) const;
    void CloseButtonClick(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialog2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialog2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialog3
{
    Windows::Foundation::IAsyncOperation<Windows::UI::Xaml::Controls::ContentDialogResult> ShowAsync(Windows::UI::Xaml::Controls::ContentDialogPlacement const& placement) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialog3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialog3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogButtonClickDeferral
{
    void Complete() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogButtonClickDeferral<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogButtonClickEventArgs
{
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
    Windows::UI::Xaml::Controls::ContentDialogButtonClickDeferral GetDeferral() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogButtonClickEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogClosedEventArgs
{
    Windows::UI::Xaml::Controls::ContentDialogResult Result() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogClosedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogClosingDeferral
{
    void Complete() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogClosingDeferral> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogClosingDeferral<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogClosingEventArgs
{
    Windows::UI::Xaml::Controls::ContentDialogResult Result() const noexcept;
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
    Windows::UI::Xaml::Controls::ContentDialogClosingDeferral GetDeferral() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogClosingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogFactory
{
    Windows::UI::Xaml::Controls::ContentDialog CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogOpenedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogOpenedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogStatics
{
    Windows::UI::Xaml::DependencyProperty TitleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TitleTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FullSizeDesiredProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PrimaryButtonTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryButtonTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PrimaryButtonCommandProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryButtonCommandProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PrimaryButtonCommandParameterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryButtonCommandParameterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPrimaryButtonEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSecondaryButtonEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentDialogStatics2
{
    Windows::UI::Xaml::DependencyProperty CloseButtonTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CloseButtonCommandProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CloseButtonCommandParameterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PrimaryButtonStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryButtonStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CloseButtonStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DefaultButtonProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentDialogStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentDialogStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenter
{
    Windows::Foundation::IInspectable Content() const noexcept;
    void Content(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate ContentTemplate() const noexcept;
    void ContentTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::DataTemplateSelector ContentTemplateSelector() const noexcept;
    void ContentTemplateSelector(Windows::UI::Xaml::Controls::DataTemplateSelector const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection ContentTransitions() const noexcept;
    void ContentTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontStretch FontStretch() const noexcept;
    void FontStretch(Windows::UI::Text::FontStretch const& value) const noexcept;
    int32_t CharacterSpacing() const noexcept;
    void CharacterSpacing(int32_t value) const noexcept;
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenter2
{
    Windows::UI::Xaml::OpticalMarginAlignment OpticalMarginAlignment() const noexcept;
    void OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment const& value) const noexcept;
    Windows::UI::Xaml::TextLineBounds TextLineBounds() const noexcept;
    void TextLineBounds(Windows::UI::Xaml::TextLineBounds const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenter2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenter2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenter3
{
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenter3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenter3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenter4
{
    Windows::UI::Xaml::TextWrapping TextWrapping() const noexcept;
    void TextWrapping(Windows::UI::Xaml::TextWrapping const& value) const noexcept;
    int32_t MaxLines() const noexcept;
    void MaxLines(int32_t value) const noexcept;
    Windows::UI::Xaml::LineStackingStrategy LineStackingStrategy() const noexcept;
    void LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy const& value) const noexcept;
    double LineHeight() const noexcept;
    void LineHeight(double value) const noexcept;
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::CornerRadius CornerRadius() const noexcept;
    void CornerRadius(Windows::UI::Xaml::CornerRadius const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Background() const noexcept;
    void Background(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalContentAlignment() const noexcept;
    void HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalContentAlignment() const noexcept;
    void VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenter4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenter4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterFactory
{
    Windows::UI::Xaml::Controls::ContentPresenter CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterOverrides
{
    void OnContentTemplateChanged(Windows::UI::Xaml::DataTemplate const& oldContentTemplate, Windows::UI::Xaml::DataTemplate const& newContentTemplate) const;
    void OnContentTemplateSelectorChanged(Windows::UI::Xaml::Controls::DataTemplateSelector const& oldContentTemplateSelector, Windows::UI::Xaml::Controls::DataTemplateSelector const& newContentTemplateSelector) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTemplateSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTransitionsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterSpacingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterStatics2
{
    Windows::UI::Xaml::DependencyProperty OpticalMarginAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextLineBoundsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterStatics3
{
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContentPresenterStatics4
{
    Windows::UI::Xaml::DependencyProperty TextWrappingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxLinesProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineStackingStrategyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CornerRadiusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalContentAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalContentAlignmentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContentPresenterStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContentPresenterStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IContextMenuEventArgs
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
    double CursorLeft() const noexcept;
    double CursorTop() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IContextMenuEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IContextMenuEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControl
{
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontStretch FontStretch() const noexcept;
    void FontStretch(Windows::UI::Text::FontStretch const& value) const noexcept;
    int32_t CharacterSpacing() const noexcept;
    void CharacterSpacing(int32_t value) const noexcept;
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    bool IsTabStop() const noexcept;
    void IsTabStop(bool value) const noexcept;
    bool IsEnabled() const noexcept;
    void IsEnabled(bool value) const noexcept;
    int32_t TabIndex() const noexcept;
    void TabIndex(int32_t value) const noexcept;
    Windows::UI::Xaml::Input::KeyboardNavigationMode TabNavigation() const noexcept;
    void TabNavigation(Windows::UI::Xaml::Input::KeyboardNavigationMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::ControlTemplate Template() const noexcept;
    void Template(Windows::UI::Xaml::Controls::ControlTemplate const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalContentAlignment() const noexcept;
    void HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalContentAlignment() const noexcept;
    void VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Background() const noexcept;
    void Background(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::FocusState FocusState() const noexcept;
    event_token IsEnabledChanged(Windows::UI::Xaml::DependencyPropertyChangedEventHandler const& value) const;
    using IsEnabledChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IControl>;
    IsEnabledChanged_revoker IsEnabledChanged(auto_revoke_t, Windows::UI::Xaml::DependencyPropertyChangedEventHandler const& value) const;
    void IsEnabledChanged(event_token const& token) const;
    bool ApplyTemplate() const;
    bool Focus(Windows::UI::Xaml::FocusState const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControl2
{
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControl2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControl2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControl3
{
    bool UseSystemFocusVisuals() const noexcept;
    void UseSystemFocusVisuals(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControl3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControl3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControl4
{
    bool IsFocusEngagementEnabled() const noexcept;
    void IsFocusEngagementEnabled(bool value) const noexcept;
    bool IsFocusEngaged() const noexcept;
    void IsFocusEngaged(bool value) const noexcept;
    Windows::UI::Xaml::Controls::RequiresPointer RequiresPointer() const noexcept;
    void RequiresPointer(Windows::UI::Xaml::Controls::RequiresPointer const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusLeft() const noexcept;
    void XYFocusLeft(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusRight() const noexcept;
    void XYFocusRight(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusUp() const noexcept;
    void XYFocusUp(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusDown() const noexcept;
    void XYFocusDown(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::ElementSoundMode ElementSoundMode() const noexcept;
    void ElementSoundMode(Windows::UI::Xaml::ElementSoundMode const& value) const noexcept;
    event_token FocusEngaged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Control, Windows::UI::Xaml::Controls::FocusEngagedEventArgs> const& value) const;
    using FocusEngaged_revoker = event_revoker<Windows::UI::Xaml::Controls::IControl4>;
    FocusEngaged_revoker FocusEngaged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Control, Windows::UI::Xaml::Controls::FocusEngagedEventArgs> const& value) const;
    void FocusEngaged(event_token const& token) const;
    event_token FocusDisengaged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Control, Windows::UI::Xaml::Controls::FocusDisengagedEventArgs> const& value) const;
    using FocusDisengaged_revoker = event_revoker<Windows::UI::Xaml::Controls::IControl4>;
    FocusDisengaged_revoker FocusDisengaged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Control, Windows::UI::Xaml::Controls::FocusDisengagedEventArgs> const& value) const;
    void FocusDisengaged(event_token const& token) const;
    void RemoveFocusEngagement() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControl4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControl4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControl5
{
    Windows::Foundation::Uri DefaultStyleResourceUri() const noexcept;
    void DefaultStyleResourceUri(Windows::Foundation::Uri const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControl5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControl5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlFactory
{
    Windows::UI::Xaml::Controls::Control CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlOverrides
{
    void OnPointerEntered(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerPressed(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerMoved(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerReleased(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerExited(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerCaptureLost(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerCanceled(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnPointerWheelChanged(Windows::UI::Xaml::Input::PointerRoutedEventArgs const& e) const;
    void OnTapped(Windows::UI::Xaml::Input::TappedRoutedEventArgs const& e) const;
    void OnDoubleTapped(Windows::UI::Xaml::Input::DoubleTappedRoutedEventArgs const& e) const;
    void OnHolding(Windows::UI::Xaml::Input::HoldingRoutedEventArgs const& e) const;
    void OnRightTapped(Windows::UI::Xaml::Input::RightTappedRoutedEventArgs const& e) const;
    void OnManipulationStarting(Windows::UI::Xaml::Input::ManipulationStartingRoutedEventArgs const& e) const;
    void OnManipulationInertiaStarting(Windows::UI::Xaml::Input::ManipulationInertiaStartingRoutedEventArgs const& e) const;
    void OnManipulationStarted(Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs const& e) const;
    void OnManipulationDelta(Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs const& e) const;
    void OnManipulationCompleted(Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs const& e) const;
    void OnKeyUp(Windows::UI::Xaml::Input::KeyRoutedEventArgs const& e) const;
    void OnKeyDown(Windows::UI::Xaml::Input::KeyRoutedEventArgs const& e) const;
    void OnGotFocus(Windows::UI::Xaml::RoutedEventArgs const& e) const;
    void OnLostFocus(Windows::UI::Xaml::RoutedEventArgs const& e) const;
    void OnDragEnter(Windows::UI::Xaml::DragEventArgs const& e) const;
    void OnDragLeave(Windows::UI::Xaml::DragEventArgs const& e) const;
    void OnDragOver(Windows::UI::Xaml::DragEventArgs const& e) const;
    void OnDrop(Windows::UI::Xaml::DragEventArgs const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlOverrides6
{
    void OnPreviewKeyDown(Windows::UI::Xaml::Input::KeyRoutedEventArgs const& e) const;
    void OnPreviewKeyUp(Windows::UI::Xaml::Input::KeyRoutedEventArgs const& e) const;
    void OnCharacterReceived(Windows::UI::Xaml::Input::CharacterReceivedRoutedEventArgs const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlOverrides6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlOverrides6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlProtected
{
    Windows::Foundation::IInspectable DefaultStyleKey() const noexcept;
    void DefaultStyleKey(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject GetTemplateChild(param::hstring const& childName) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlProtected> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlProtected<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlStatics
{
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterSpacingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTabStopProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TabIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TabNavigationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalContentAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalContentAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DefaultStyleKeyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FocusStateProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlStatics2
{
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlStatics3
{
    Windows::UI::Xaml::DependencyProperty UseSystemFocusVisualsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTemplateFocusTargetProperty() const noexcept;
    bool GetIsTemplateFocusTarget(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetIsTemplateFocusTarget(Windows::UI::Xaml::FrameworkElement const& element, bool value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlStatics4
{
    Windows::UI::Xaml::DependencyProperty IsFocusEngagementEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFocusEngagedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RequiresPointerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusLeftProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusRightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusUpProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusDownProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ElementSoundModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlStatics5
{
    Windows::UI::Xaml::DependencyProperty DefaultStyleResourceUriProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTemplateKeyTipTargetProperty() const noexcept;
    bool GetIsTemplateKeyTipTarget(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsTemplateKeyTipTarget(Windows::UI::Xaml::DependencyObject const& element, bool value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IControlTemplate
{
    Windows::UI::Xaml::Interop::TypeName TargetType() const noexcept;
    void TargetType(Windows::UI::Xaml::Interop::TypeName const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IControlTemplate> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IControlTemplate<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDataTemplateSelector
{
    Windows::UI::Xaml::DataTemplate SelectTemplate(Windows::Foundation::IInspectable const& item, Windows::UI::Xaml::DependencyObject const& container) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDataTemplateSelector> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDataTemplateSelector<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDataTemplateSelector2
{
    Windows::UI::Xaml::DataTemplate SelectTemplate(Windows::Foundation::IInspectable const& item) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDataTemplateSelector2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDataTemplateSelector2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorFactory
{
    Windows::UI::Xaml::Controls::DataTemplateSelector CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDataTemplateSelectorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorOverrides
{
    Windows::UI::Xaml::DataTemplate SelectTemplateCore(Windows::Foundation::IInspectable const& item, Windows::UI::Xaml::DependencyObject const& container) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorOverrides2
{
    Windows::UI::Xaml::DataTemplate SelectTemplateCore(Windows::Foundation::IInspectable const& item) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDataTemplateSelectorOverrides2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickedEventArgs
{
    Windows::Foundation::DateTime OldDate() const noexcept;
    Windows::Foundation::DateTime NewDate() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePicker
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring CalendarIdentifier() const noexcept;
    void CalendarIdentifier(param::hstring const& value) const noexcept;
    Windows::Foundation::DateTime Date() const noexcept;
    void Date(Windows::Foundation::DateTime const& value) const noexcept;
    bool DayVisible() const noexcept;
    void DayVisible(bool value) const noexcept;
    bool MonthVisible() const noexcept;
    void MonthVisible(bool value) const noexcept;
    bool YearVisible() const noexcept;
    void YearVisible(bool value) const noexcept;
    hstring DayFormat() const noexcept;
    void DayFormat(param::hstring const& value) const noexcept;
    hstring MonthFormat() const noexcept;
    void MonthFormat(param::hstring const& value) const noexcept;
    hstring YearFormat() const noexcept;
    void YearFormat(param::hstring const& value) const noexcept;
    Windows::Foundation::DateTime MinYear() const noexcept;
    void MinYear(Windows::Foundation::DateTime const& value) const noexcept;
    Windows::Foundation::DateTime MaxYear() const noexcept;
    void MaxYear(Windows::Foundation::DateTime const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    event_token DateChanged(Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::DatePickerValueChangedEventArgs> const& value) const;
    using DateChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IDatePicker>;
    DateChanged_revoker DateChanged(auto_revoke_t, Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::DatePickerValueChangedEventArgs> const& value) const;
    void DateChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePicker> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePicker<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePicker2
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePicker2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePicker2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFactory
{
    Windows::UI::Xaml::Controls::DatePicker CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyout
{
    hstring CalendarIdentifier() const noexcept;
    void CalendarIdentifier(param::hstring const& value) const noexcept;
    Windows::Foundation::DateTime Date() const noexcept;
    void Date(Windows::Foundation::DateTime const& value) const noexcept;
    bool DayVisible() const noexcept;
    void DayVisible(bool value) const noexcept;
    bool MonthVisible() const noexcept;
    void MonthVisible(bool value) const noexcept;
    bool YearVisible() const noexcept;
    void YearVisible(bool value) const noexcept;
    Windows::Foundation::DateTime MinYear() const noexcept;
    void MinYear(Windows::Foundation::DateTime const& value) const noexcept;
    Windows::Foundation::DateTime MaxYear() const noexcept;
    void MaxYear(Windows::Foundation::DateTime const& value) const noexcept;
    event_token DatePicked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::DatePickerFlyout, Windows::UI::Xaml::Controls::DatePickedEventArgs> const& value) const;
    using DatePicked_revoker = event_revoker<Windows::UI::Xaml::Controls::IDatePickerFlyout>;
    DatePicked_revoker DatePicked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::DatePickerFlyout, Windows::UI::Xaml::Controls::DatePickedEventArgs> const& value) const;
    void DatePicked(event_token const& token) const;
    Windows::Foundation::IAsyncOperation<Windows::Foundation::IReference<Windows::Foundation::DateTime>> ShowAtAsync(Windows::UI::Xaml::FrameworkElement const& target) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyout2
{
    hstring DayFormat() const noexcept;
    void DayFormat(param::hstring const& value) const noexcept;
    hstring MonthFormat() const noexcept;
    void MonthFormat(param::hstring const& value) const noexcept;
    hstring YearFormat() const noexcept;
    void YearFormat(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyout2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyout2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutItem
{
    hstring PrimaryText() const noexcept;
    void PrimaryText(param::hstring const& value) const noexcept;
    hstring SecondaryText() const noexcept;
    void SecondaryText(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyoutItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutItemStatics
{
    Windows::UI::Xaml::DependencyProperty PrimaryTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SecondaryTextProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyoutItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty CalendarIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty YearVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinYearProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxYearProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutStatics2
{
    Windows::UI::Xaml::DependencyProperty DayFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty YearFormatProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerFlyoutStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CalendarIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty YearVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DayFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MonthFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty YearFormatProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinYearProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxYearProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerStatics2
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDatePickerValueChangedEventArgs
{
    Windows::Foundation::DateTime OldDate() const noexcept;
    Windows::Foundation::DateTime NewDate() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDatePickerValueChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDragItemsCompletedEventArgs
{
    Windows::Foundation::Collections::IVectorView<Windows::Foundation::IInspectable> Items() const noexcept;
    Windows::ApplicationModel::DataTransfer::DataPackageOperation DropResult() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDragItemsCompletedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDragItemsStartingEventArgs
{
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> Items() const noexcept;
    Windows::ApplicationModel::DataTransfer::DataPackage Data() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDragItemsStartingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IDynamicOverflowItemsChangingEventArgs
{
    Windows::UI::Xaml::Controls::CommandBarDynamicOverflowAction Action() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IDynamicOverflowItemsChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipView
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipView2
{
    bool UseTouchAnimationsForAllNavigation() const noexcept;
    void UseTouchAnimationsForAllNavigation(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipView2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipView2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipViewFactory
{
    Windows::UI::Xaml::Controls::FlipView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipViewItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipViewItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipViewItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipViewItemFactory
{
    Windows::UI::Xaml::Controls::FlipViewItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipViewItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipViewItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlipViewStatics2
{
    Windows::UI::Xaml::DependencyProperty UseTouchAnimationsForAllNavigationProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlipViewStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlipViewStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlyout
{
    Windows::UI::Xaml::UIElement Content() const noexcept;
    void Content(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::Style FlyoutPresenterStyle() const noexcept;
    void FlyoutPresenterStyle(Windows::UI::Xaml::Style const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlyoutFactory
{
    Windows::UI::Xaml::Controls::Flyout CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlyoutFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlyoutFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlyoutPresenterFactory
{
    Windows::UI::Xaml::Controls::FlyoutPresenter CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlyoutPresenterFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlyoutPresenterFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FlyoutPresenterStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFocusDisengagedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFocusDisengagedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFocusEngagedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFocusEngagedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFocusEngagedEventArgs2
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFocusEngagedEventArgs2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIcon
{
    hstring Glyph() const noexcept;
    void Glyph(param::hstring const& value) const noexcept;
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIcon> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIcon<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIcon2
{
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIcon2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIcon2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIcon3
{
    bool MirroredWhenRightToLeft() const noexcept;
    void MirroredWhenRightToLeft(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIcon3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIcon3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconFactory
{
    Windows::UI::Xaml::Controls::FontIcon CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconSource
{
    hstring Glyph() const noexcept;
    void Glyph(param::hstring const& value) const noexcept;
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
    bool MirroredWhenRightToLeft() const noexcept;
    void MirroredWhenRightToLeft(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconSource> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconSource<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconSourceFactory
{
    Windows::UI::Xaml::Controls::FontIconSource CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconSourceFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconSourceFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconSourceStatics
{
    Windows::UI::Xaml::DependencyProperty GlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MirroredWhenRightToLeftProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconSourceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconSourceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconStatics
{
    Windows::UI::Xaml::DependencyProperty GlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconStatics2
{
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFontIconStatics3
{
    Windows::UI::Xaml::DependencyProperty MirroredWhenRightToLeftProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFontIconStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFontIconStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrame
{
    int32_t CacheSize() const noexcept;
    void CacheSize(int32_t value) const noexcept;
    bool CanGoBack() const noexcept;
    bool CanGoForward() const noexcept;
    Windows::UI::Xaml::Interop::TypeName CurrentSourcePageType() const noexcept;
    Windows::UI::Xaml::Interop::TypeName SourcePageType() const noexcept;
    void SourcePageType(Windows::UI::Xaml::Interop::TypeName const& value) const noexcept;
    int32_t BackStackDepth() const noexcept;
    event_token Navigated(Windows::UI::Xaml::Navigation::NavigatedEventHandler const& value) const;
    using Navigated_revoker = event_revoker<Windows::UI::Xaml::Controls::IFrame>;
    Navigated_revoker Navigated(auto_revoke_t, Windows::UI::Xaml::Navigation::NavigatedEventHandler const& value) const;
    void Navigated(event_token const& token) const;
    event_token Navigating(Windows::UI::Xaml::Navigation::NavigatingCancelEventHandler const& value) const;
    using Navigating_revoker = event_revoker<Windows::UI::Xaml::Controls::IFrame>;
    Navigating_revoker Navigating(auto_revoke_t, Windows::UI::Xaml::Navigation::NavigatingCancelEventHandler const& value) const;
    void Navigating(event_token const& token) const;
    event_token NavigationFailed(Windows::UI::Xaml::Navigation::NavigationFailedEventHandler const& value) const;
    using NavigationFailed_revoker = event_revoker<Windows::UI::Xaml::Controls::IFrame>;
    NavigationFailed_revoker NavigationFailed(auto_revoke_t, Windows::UI::Xaml::Navigation::NavigationFailedEventHandler const& value) const;
    void NavigationFailed(event_token const& token) const;
    event_token NavigationStopped(Windows::UI::Xaml::Navigation::NavigationStoppedEventHandler const& value) const;
    using NavigationStopped_revoker = event_revoker<Windows::UI::Xaml::Controls::IFrame>;
    NavigationStopped_revoker NavigationStopped(auto_revoke_t, Windows::UI::Xaml::Navigation::NavigationStoppedEventHandler const& value) const;
    void NavigationStopped(event_token const& token) const;
    void GoBack() const;
    void GoForward() const;
    bool Navigate(Windows::UI::Xaml::Interop::TypeName const& sourcePageType, Windows::Foundation::IInspectable const& parameter) const;
    hstring GetNavigationState() const;
    void SetNavigationState(param::hstring const& navigationState) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrame> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrame<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrame2
{
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Navigation::PageStackEntry> BackStack() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Navigation::PageStackEntry> ForwardStack() const noexcept;
    bool Navigate(Windows::UI::Xaml::Interop::TypeName const& sourcePageType, Windows::Foundation::IInspectable const& parameter, Windows::UI::Xaml::Media::Animation::NavigationTransitionInfo const& infoOverride) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrame2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrame2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrame3
{
    void GoBack(Windows::UI::Xaml::Media::Animation::NavigationTransitionInfo const& transitionInfoOverride) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrame3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrame3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrame4
{
    void SetNavigationState(param::hstring const& navigationState, bool suppressNavigate) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrame4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrame4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrameFactory
{
    Windows::UI::Xaml::Controls::Frame CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrameFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrameFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrameStatics
{
    Windows::UI::Xaml::DependencyProperty CacheSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanGoBackProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanGoForwardProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CurrentSourcePageTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SourcePageTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BackStackDepthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrameStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrameStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IFrameStatics2
{
    Windows::UI::Xaml::DependencyProperty BackStackProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForwardStackProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IFrameStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IFrameStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGrid
{
    Windows::UI::Xaml::Controls::RowDefinitionCollection RowDefinitions() const noexcept;
    Windows::UI::Xaml::Controls::ColumnDefinitionCollection ColumnDefinitions() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGrid> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGrid<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGrid2
{
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::CornerRadius CornerRadius() const noexcept;
    void CornerRadius(Windows::UI::Xaml::CornerRadius const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGrid2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGrid2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGrid3
{
    double RowSpacing() const noexcept;
    void RowSpacing(double value) const noexcept;
    double ColumnSpacing() const noexcept;
    void ColumnSpacing(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGrid3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGrid3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridFactory
{
    Windows::UI::Xaml::Controls::Grid CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridStatics
{
    Windows::UI::Xaml::DependencyProperty RowProperty() const noexcept;
    int32_t GetRow(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetRow(Windows::UI::Xaml::FrameworkElement const& element, int32_t value) const;
    Windows::UI::Xaml::DependencyProperty ColumnProperty() const noexcept;
    int32_t GetColumn(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetColumn(Windows::UI::Xaml::FrameworkElement const& element, int32_t value) const;
    Windows::UI::Xaml::DependencyProperty RowSpanProperty() const noexcept;
    int32_t GetRowSpan(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetRowSpan(Windows::UI::Xaml::FrameworkElement const& element, int32_t value) const;
    Windows::UI::Xaml::DependencyProperty ColumnSpanProperty() const noexcept;
    int32_t GetColumnSpan(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetColumnSpan(Windows::UI::Xaml::FrameworkElement const& element, int32_t value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridStatics2
{
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CornerRadiusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridStatics3
{
    Windows::UI::Xaml::DependencyProperty RowSpacingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ColumnSpacingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridView
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridViewFactory
{
    Windows::UI::Xaml::Controls::GridView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridViewHeaderItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridViewHeaderItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridViewHeaderItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridViewHeaderItemFactory
{
    Windows::UI::Xaml::Controls::GridViewHeaderItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridViewHeaderItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridViewHeaderItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridViewItem
{
    Windows::UI::Xaml::Controls::Primitives::GridViewItemTemplateSettings TemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridViewItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridViewItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGridViewItemFactory
{
    Windows::UI::Xaml::Controls::GridViewItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGridViewItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGridViewItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupItemFactory
{
    Windows::UI::Xaml::Controls::GroupItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyle
{
    Windows::UI::Xaml::Controls::ItemsPanelTemplate Panel() const noexcept;
    void Panel(Windows::UI::Xaml::Controls::ItemsPanelTemplate const& value) const noexcept;
    [[deprecated("ContainerStyle may be altered or unavailable for releases after Windows 8.1, and is not supported for ItemsControl.GroupStyle.")]] Windows::UI::Xaml::Style ContainerStyle() const noexcept;
    [[deprecated("ContainerStyle may be altered or unavailable for releases after Windows 8.1, and is not supported for ItemsControl.GroupStyle.")]] void ContainerStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    [[deprecated("ContainerStyleSelector may be altered or unavailable for releases after Windows 8.1, and is not supported for ItemsControl.GroupStyle.")]] Windows::UI::Xaml::Controls::StyleSelector ContainerStyleSelector() const noexcept;
    [[deprecated("ContainerStyleSelector may be altered or unavailable for releases after Windows 8.1, and is not supported for ItemsControl.GroupStyle.")]] void ContainerStyleSelector(Windows::UI::Xaml::Controls::StyleSelector const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::DataTemplateSelector HeaderTemplateSelector() const noexcept;
    void HeaderTemplateSelector(Windows::UI::Xaml::Controls::DataTemplateSelector const& value) const noexcept;
    bool HidesIfEmpty() const noexcept;
    void HidesIfEmpty(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyle> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyle<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyle2
{
    Windows::UI::Xaml::Style HeaderContainerStyle() const noexcept;
    void HeaderContainerStyle(Windows::UI::Xaml::Style const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyle2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyle2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyleFactory
{
    Windows::UI::Xaml::Controls::GroupStyle CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyleFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyleFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyleSelector
{
    Windows::UI::Xaml::Controls::GroupStyle SelectGroupStyle(Windows::Foundation::IInspectable const& group, uint32_t level) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyleSelector> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyleSelector<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyleSelectorFactory
{
    Windows::UI::Xaml::Controls::GroupStyleSelector CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyleSelectorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyleSelectorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IGroupStyleSelectorOverrides
{
    Windows::UI::Xaml::Controls::GroupStyle SelectGroupStyleCore(Windows::Foundation::IInspectable const& group, uint32_t level) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IGroupStyleSelectorOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IGroupStyleSelectorOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHub
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    int32_t DefaultSectionIndex() const noexcept;
    void DefaultSectionIndex(int32_t value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::HubSection> Sections() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::HubSection> SectionsInView() const noexcept;
    Windows::Foundation::Collections::IObservableVector<Windows::Foundation::IInspectable> SectionHeaders() const noexcept;
    event_token SectionHeaderClick(Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler const& value) const;
    using SectionHeaderClick_revoker = event_revoker<Windows::UI::Xaml::Controls::IHub>;
    SectionHeaderClick_revoker SectionHeaderClick(auto_revoke_t, Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler const& value) const;
    void SectionHeaderClick(event_token const& token) const;
    event_token SectionsInViewChanged(Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler const& value) const;
    using SectionsInViewChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IHub>;
    SectionsInViewChanged_revoker SectionsInViewChanged(auto_revoke_t, Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler const& value) const;
    void SectionsInViewChanged(event_token const& token) const;
    void ScrollToSection(Windows::UI::Xaml::Controls::HubSection const& section) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHub> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHub<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubFactory
{
    Windows::UI::Xaml::Controls::Hub CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubSection
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate ContentTemplate() const noexcept;
    void ContentTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    bool IsHeaderInteractive() const noexcept;
    void IsHeaderInteractive(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubSection> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubSection<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubSectionFactory
{
    Windows::UI::Xaml::Controls::HubSection CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubSectionFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubSectionFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubSectionHeaderClickEventArgs
{
    Windows::UI::Xaml::Controls::HubSection Section() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubSectionHeaderClickEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubSectionStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContentTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsHeaderInteractiveProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubSectionStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubSectionStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHubStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DefaultSectionIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SemanticZoomOwnerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsActiveViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomedInViewProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHubStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHubStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHyperlinkButton
{
    Windows::Foundation::Uri NavigateUri() const noexcept;
    void NavigateUri(Windows::Foundation::Uri const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHyperlinkButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHyperlinkButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHyperlinkButtonFactory
{
    Windows::UI::Xaml::Controls::HyperlinkButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHyperlinkButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHyperlinkButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IHyperlinkButtonStatics
{
    Windows::UI::Xaml::DependencyProperty NavigateUriProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IHyperlinkButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IHyperlinkButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconElement
{
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconElement> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconElement<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconElementFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconElementFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconElementFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconElementStatics
{
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconElementStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconElementStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconSource
{
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconSource> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconSource<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconSourceFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconSourceFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconSourceFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIconSourceStatics
{
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IIconSourceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIconSourceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IImage
{
    Windows::UI::Xaml::Media::ImageSource Source() const noexcept;
    void Source(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
    Windows::UI::Xaml::Thickness NineGrid() const noexcept;
    void NineGrid(Windows::UI::Xaml::Thickness const& value) const noexcept;
    [[deprecated("PlayToSource may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource.")]] Windows::Media::PlayTo::PlayToSource PlayToSource() const noexcept;
    event_token ImageFailed(Windows::UI::Xaml::ExceptionRoutedEventHandler const& value) const;
    using ImageFailed_revoker = event_revoker<Windows::UI::Xaml::Controls::IImage>;
    ImageFailed_revoker ImageFailed(auto_revoke_t, Windows::UI::Xaml::ExceptionRoutedEventHandler const& value) const;
    void ImageFailed(event_token const& token) const;
    event_token ImageOpened(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using ImageOpened_revoker = event_revoker<Windows::UI::Xaml::Controls::IImage>;
    ImageOpened_revoker ImageOpened(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void ImageOpened(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IImage> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IImage<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IImage2
{
    Windows::Media::Casting::CastingSource GetAsCastingSource() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IImage2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IImage2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IImage3
{
    Windows::UI::Composition::CompositionBrush GetAlphaMask() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IImage3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IImage3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IImageStatics
{
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty NineGridProperty() const noexcept;
    [[deprecated("PlayToSource may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource.")]] Windows::UI::Xaml::DependencyProperty PlayToSourceProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IImageStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IImageStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkCanvas
{
    Windows::UI::Input::Inking::InkPresenter InkPresenter() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkCanvas> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkCanvas<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkCanvasFactory
{
    Windows::UI::Xaml::Controls::InkCanvas CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkCanvasFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkCanvasFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbar
{
    Windows::UI::Xaml::Controls::InkToolbarInitialControls InitialControls() const noexcept;
    void InitialControls(Windows::UI::Xaml::Controls::InkToolbarInitialControls const& value) const noexcept;
    Windows::UI::Xaml::DependencyObjectCollection Children() const noexcept;
    Windows::UI::Xaml::Controls::InkToolbarToolButton ActiveTool() const noexcept;
    void ActiveTool(Windows::UI::Xaml::Controls::InkToolbarToolButton const& value) const noexcept;
    Windows::UI::Input::Inking::InkDrawingAttributes InkDrawingAttributes() const noexcept;
    bool IsRulerButtonChecked() const noexcept;
    void IsRulerButtonChecked(bool value) const noexcept;
    Windows::UI::Xaml::Controls::InkCanvas TargetInkCanvas() const noexcept;
    void TargetInkCanvas(Windows::UI::Xaml::Controls::InkCanvas const& value) const noexcept;
    event_token ActiveToolChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    using ActiveToolChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbar>;
    ActiveToolChanged_revoker ActiveToolChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    void ActiveToolChanged(event_token const& token) const;
    event_token InkDrawingAttributesChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    using InkDrawingAttributesChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbar>;
    InkDrawingAttributesChanged_revoker InkDrawingAttributesChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    void InkDrawingAttributesChanged(event_token const& token) const;
    event_token EraseAllClicked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    using EraseAllClicked_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbar>;
    EraseAllClicked_revoker EraseAllClicked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    void EraseAllClicked(event_token const& token) const;
    [[deprecated("InkToolbarRulerButton is replaced by InkToolbarStencilButton starting from Windows 10 Creators Update. For more info, see MSDN.")]] event_token IsRulerButtonCheckedChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    using IsRulerButtonCheckedChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbar>;
    [[deprecated("InkToolbarRulerButton is replaced by InkToolbarStencilButton starting from Windows 10 Creators Update. For more info, see MSDN.")]] IsRulerButtonCheckedChanged_revoker IsRulerButtonCheckedChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::Foundation::IInspectable> const& value) const;
    [[deprecated("InkToolbarRulerButton is replaced by InkToolbarStencilButton starting from Windows 10 Creators Update. For more info, see MSDN.")]] void IsRulerButtonCheckedChanged(event_token const& token) const;
    Windows::UI::Xaml::Controls::InkToolbarToolButton GetToolButton(Windows::UI::Xaml::Controls::InkToolbarTool const& tool) const;
    Windows::UI::Xaml::Controls::InkToolbarToggleButton GetToggleButton(Windows::UI::Xaml::Controls::InkToolbarToggle const& tool) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbar> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbar<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbar2
{
    bool IsStencilButtonChecked() const noexcept;
    void IsStencilButtonChecked(bool value) const noexcept;
    Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement ButtonFlyoutPlacement() const noexcept;
    void ButtonFlyoutPlacement(Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    event_token IsStencilButtonCheckedChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::UI::Xaml::Controls::InkToolbarIsStencilButtonCheckedChangedEventArgs> const& value) const;
    using IsStencilButtonCheckedChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbar2>;
    IsStencilButtonCheckedChanged_revoker IsStencilButtonCheckedChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbar, Windows::UI::Xaml::Controls::InkToolbarIsStencilButtonCheckedChangedEventArgs> const& value) const;
    void IsStencilButtonCheckedChanged(event_token const& token) const;
    Windows::UI::Xaml::Controls::InkToolbarMenuButton GetMenuButton(Windows::UI::Xaml::Controls::InkToolbarMenuKind const& menu) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbar2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbar2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarBallpointPenButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarBallpointPenButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarBallpointPenButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarBallpointPenButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarBallpointPenButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPen
{
    Windows::UI::Input::Inking::InkDrawingAttributes CreateInkDrawingAttributes(Windows::UI::Xaml::Media::Brush const& brush, double strokeWidth) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPen> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPen<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButton
{
    Windows::UI::Xaml::Controls::InkToolbarCustomPen CustomPen() const noexcept;
    void CustomPen(Windows::UI::Xaml::Controls::InkToolbarCustomPen const& value) const noexcept;
    Windows::UI::Xaml::UIElement ConfigurationContent() const noexcept;
    void ConfigurationContent(Windows::UI::Xaml::UIElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarCustomPenButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButtonStatics
{
    Windows::UI::Xaml::DependencyProperty CustomPenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ConfigurationContentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenFactory
{
    Windows::UI::Xaml::Controls::InkToolbarCustomPen CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPenFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenOverrides
{
    Windows::UI::Input::Inking::InkDrawingAttributes CreateInkDrawingAttributesCore(Windows::UI::Xaml::Media::Brush const& brush, double strokeWidth) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomPenOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomPenOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToggleButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToggleButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToggleButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarCustomToggleButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToggleButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButton
{
    Windows::UI::Xaml::UIElement ConfigurationContent() const noexcept;
    void ConfigurationContent(Windows::UI::Xaml::UIElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarCustomToolButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButtonStatics
{
    Windows::UI::Xaml::DependencyProperty ConfigurationContentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarCustomToolButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarEraserButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButton2
{
    bool IsClearAllVisible() const noexcept;
    void IsClearAllVisible(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarEraserButton2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButton2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarEraserButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButtonStatics2
{
    Windows::UI::Xaml::DependencyProperty IsClearAllVisibleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarEraserButtonStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarFactory
{
    Windows::UI::Xaml::Controls::InkToolbar CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItem
{
    Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind Kind() const noexcept;
    void Kind(Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind const& value) const noexcept;
    bool IsChecked() const noexcept;
    void IsChecked(bool value) const noexcept;
    event_token Checked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem, Windows::Foundation::IInspectable> const& value) const;
    using Checked_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>;
    Checked_revoker Checked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem, Windows::Foundation::IInspectable> const& value) const;
    void Checked(event_token const& token) const;
    event_token Unchecked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem, Windows::Foundation::IInspectable> const& value) const;
    using Unchecked_revoker = event_revoker<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>;
    Unchecked_revoker Unchecked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::InkToolbarFlyoutItem, Windows::Foundation::IInspectable> const& value) const;
    void Unchecked(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItemFactory
{
    Windows::UI::Xaml::Controls::InkToolbarFlyoutItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItemStatics
{
    Windows::UI::Xaml::DependencyProperty KindProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsCheckedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarFlyoutItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarHighlighterButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarHighlighterButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarHighlighterButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarHighlighterButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarHighlighterButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarIsStencilButtonCheckedChangedEventArgs
{
    Windows::UI::Xaml::Controls::InkToolbarStencilButton StencilButton() const noexcept;
    Windows::UI::Xaml::Controls::InkToolbarStencilKind StencilKind() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarIsStencilButtonCheckedChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButton
{
    Windows::UI::Xaml::Controls::InkToolbarMenuKind MenuKind() const noexcept;
    bool IsExtensionGlyphShown() const noexcept;
    void IsExtensionGlyphShown(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarMenuButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButtonFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButtonStatics
{
    Windows::UI::Xaml::DependencyProperty IsExtensionGlyphShownProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarMenuButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenButton
{
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Media::Brush> Palette() const noexcept;
    void Palette(param::vector<Windows::UI::Xaml::Media::Brush> const& value) const noexcept;
    double MinStrokeWidth() const noexcept;
    void MinStrokeWidth(double value) const noexcept;
    double MaxStrokeWidth() const noexcept;
    void MaxStrokeWidth(double value) const noexcept;
    Windows::UI::Xaml::Media::Brush SelectedBrush() const noexcept;
    int32_t SelectedBrushIndex() const noexcept;
    void SelectedBrushIndex(int32_t value) const noexcept;
    double SelectedStrokeWidth() const noexcept;
    void SelectedStrokeWidth(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenButtonFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenButtonStatics
{
    Windows::UI::Xaml::DependencyProperty PaletteProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinStrokeWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxStrokeWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedBrushIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedStrokeWidthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControl
{
    Windows::UI::Xaml::Controls::InkToolbarPenButton PenButton() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControlFactory
{
    Windows::UI::Xaml::Controls::InkToolbarPenConfigurationControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControlStatics
{
    Windows::UI::Xaml::DependencyProperty PenButtonProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPenConfigurationControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPencilButton
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPencilButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPencilButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarPencilButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarPencilButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarPencilButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarPencilButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButton
{
    [[deprecated("InkToolbarRulerButton is deprecated starting from Windows 10 Creators Update. Please use InkToolbarStencilButton going forward. For more info, see MSDN.")]] Windows::UI::Input::Inking::InkPresenterRuler Ruler() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarRulerButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButtonFactory
{
    [[deprecated("InkToolbarRulerButton is deprecated starting from Windows 10 Creators Update. Please use InkToolbarStencilButton going forward. For more info, see MSDN.")]] Windows::UI::Xaml::Controls::InkToolbarRulerButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButtonStatics
{
    [[deprecated("InkToolbarRulerButton is deprecated starting from Windows 10 Creators Update. Please use InkToolbarStencilButton going forward. For more info, see MSDN.")]] Windows::UI::Xaml::DependencyProperty RulerProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarRulerButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarStatics
{
    Windows::UI::Xaml::DependencyProperty InitialControlsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ChildrenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ActiveToolProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InkDrawingAttributesProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsRulerButtonCheckedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TargetInkCanvasProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarStatics2
{
    Windows::UI::Xaml::DependencyProperty IsStencilButtonCheckedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ButtonFlyoutPlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButton
{
    Windows::UI::Input::Inking::InkPresenterRuler Ruler() const noexcept;
    Windows::UI::Input::Inking::InkPresenterProtractor Protractor() const noexcept;
    Windows::UI::Xaml::Controls::InkToolbarStencilKind SelectedStencil() const noexcept;
    void SelectedStencil(Windows::UI::Xaml::Controls::InkToolbarStencilKind const& value) const noexcept;
    bool IsRulerItemVisible() const noexcept;
    void IsRulerItemVisible(bool value) const noexcept;
    bool IsProtractorItemVisible() const noexcept;
    void IsProtractorItemVisible(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarStencilButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButtonFactory
{
    Windows::UI::Xaml::Controls::InkToolbarStencilButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButtonStatics
{
    Windows::UI::Xaml::DependencyProperty RulerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ProtractorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedStencilProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsRulerItemVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsProtractorItemVisibleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarStencilButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarToggleButton
{
    Windows::UI::Xaml::Controls::InkToolbarToggle ToggleKind() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarToggleButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarToggleButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarToggleButtonFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarToggleButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarToggleButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarToolButton
{
    Windows::UI::Xaml::Controls::InkToolbarTool ToolKind() const noexcept;
    bool IsExtensionGlyphShown() const noexcept;
    void IsExtensionGlyphShown(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarToolButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarToolButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarToolButtonFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarToolButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarToolButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInkToolbarToolButtonStatics
{
    Windows::UI::Xaml::DependencyProperty IsExtensionGlyphShownProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInkToolbarToolButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInkToolbarToolButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IInsertionPanel
{
    void GetInsertionIndexes(Windows::Foundation::Point const& position, int32_t& first, int32_t& second) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IInsertionPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IInsertionPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IIsTextTrimmedChangedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IIsTextTrimmedChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemClickEventArgs
{
    Windows::Foundation::IInspectable ClickedItem() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemClickEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemClickEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemContainerGenerator
{
    event_token ItemsChanged(Windows::UI::Xaml::Controls::Primitives::ItemsChangedEventHandler const& value) const;
    using ItemsChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IItemContainerGenerator>;
    ItemsChanged_revoker ItemsChanged(auto_revoke_t, Windows::UI::Xaml::Controls::Primitives::ItemsChangedEventHandler const& value) const;
    void ItemsChanged(event_token const& token) const;
    [[deprecated("ItemFromContainer may be altered or unavailable for releases after Windows 8.1. Instead, use ItemsControl.ItemFromContainer.")]] Windows::Foundation::IInspectable ItemFromContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    [[deprecated("ContainerFromItem may be altered or unavailable for releases after Windows 8.1. Instead, use ItemsControl.ContainerFromItem.")]] Windows::UI::Xaml::DependencyObject ContainerFromItem(Windows::Foundation::IInspectable const& item) const;
    [[deprecated("IndexFromContainer may be altered or unavailable for releases after Windows 8.1. Instead, use ItemsControl.IndexFromContainer.")]] int32_t IndexFromContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    [[deprecated("ContainerFromIndex may be altered or unavailable for releases after Windows 8.1. Instead, use ItemsControl.ContainerFromIndex.")]] Windows::UI::Xaml::DependencyObject ContainerFromIndex(int32_t index) const;
    Windows::UI::Xaml::Controls::ItemContainerGenerator GetItemContainerGeneratorForPanel(Windows::UI::Xaml::Controls::Panel const& panel) const;
    void StartAt(Windows::UI::Xaml::Controls::Primitives::GeneratorPosition const& position, Windows::UI::Xaml::Controls::Primitives::GeneratorDirection const& direction, bool allowStartAtRealizedItem) const;
    void Stop() const;
    Windows::UI::Xaml::DependencyObject GenerateNext(bool& isNewlyRealized) const;
    void PrepareItemContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    void RemoveAll() const;
    void Remove(Windows::UI::Xaml::Controls::Primitives::GeneratorPosition const& position, int32_t count) const;
    Windows::UI::Xaml::Controls::Primitives::GeneratorPosition GeneratorPositionFromIndex(int32_t itemIndex) const;
    int32_t IndexFromGeneratorPosition(Windows::UI::Xaml::Controls::Primitives::GeneratorPosition const& position) const;
    void Recycle(Windows::UI::Xaml::Controls::Primitives::GeneratorPosition const& position, int32_t count) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemContainerGenerator> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemContainerGenerator<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemContainerMapping
{
    Windows::Foundation::IInspectable ItemFromContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    Windows::UI::Xaml::DependencyObject ContainerFromItem(Windows::Foundation::IInspectable const& item) const;
    int32_t IndexFromContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    Windows::UI::Xaml::DependencyObject ContainerFromIndex(int32_t index) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemContainerMapping> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemContainerMapping<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControl
{
    Windows::Foundation::IInspectable ItemsSource() const noexcept;
    void ItemsSource(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::Controls::ItemCollection Items() const noexcept;
    Windows::UI::Xaml::DataTemplate ItemTemplate() const noexcept;
    void ItemTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::DataTemplateSelector ItemTemplateSelector() const noexcept;
    void ItemTemplateSelector(Windows::UI::Xaml::Controls::DataTemplateSelector const& value) const noexcept;
    Windows::UI::Xaml::Controls::ItemsPanelTemplate ItemsPanel() const noexcept;
    void ItemsPanel(Windows::UI::Xaml::Controls::ItemsPanelTemplate const& value) const noexcept;
    hstring DisplayMemberPath() const noexcept;
    void DisplayMemberPath(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Style ItemContainerStyle() const noexcept;
    void ItemContainerStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Controls::StyleSelector ItemContainerStyleSelector() const noexcept;
    void ItemContainerStyleSelector(Windows::UI::Xaml::Controls::StyleSelector const& value) const noexcept;
    Windows::UI::Xaml::Controls::ItemContainerGenerator ItemContainerGenerator() const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection ItemContainerTransitions() const noexcept;
    void ItemContainerTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
    Windows::Foundation::Collections::IObservableVector<Windows::UI::Xaml::Controls::GroupStyle> GroupStyle() const noexcept;
    Windows::UI::Xaml::Controls::GroupStyleSelector GroupStyleSelector() const noexcept;
    void GroupStyleSelector(Windows::UI::Xaml::Controls::GroupStyleSelector const& value) const noexcept;
    bool IsGrouping() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControl2
{
    Windows::UI::Xaml::Controls::Panel ItemsPanelRoot() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControl2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControl2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControl3
{
    Windows::UI::Xaml::DependencyObject GroupHeaderContainerFromItemContainer(Windows::UI::Xaml::DependencyObject const& itemContainer) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControl3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControl3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControlFactory
{
    Windows::UI::Xaml::Controls::ItemsControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControlOverrides
{
    bool IsItemItsOwnContainerOverride(Windows::Foundation::IInspectable const& item) const;
    Windows::UI::Xaml::DependencyObject GetContainerForItemOverride() const;
    void ClearContainerForItemOverride(Windows::UI::Xaml::DependencyObject const& element, Windows::Foundation::IInspectable const& item) const;
    void PrepareContainerForItemOverride(Windows::UI::Xaml::DependencyObject const& element, Windows::Foundation::IInspectable const& item) const;
    void OnItemsChanged(Windows::Foundation::IInspectable const& e) const;
    void OnItemContainerStyleChanged(Windows::UI::Xaml::Style const& oldItemContainerStyle, Windows::UI::Xaml::Style const& newItemContainerStyle) const;
    void OnItemContainerStyleSelectorChanged(Windows::UI::Xaml::Controls::StyleSelector const& oldItemContainerStyleSelector, Windows::UI::Xaml::Controls::StyleSelector const& newItemContainerStyleSelector) const;
    void OnItemTemplateChanged(Windows::UI::Xaml::DataTemplate const& oldItemTemplate, Windows::UI::Xaml::DataTemplate const& newItemTemplate) const;
    void OnItemTemplateSelectorChanged(Windows::UI::Xaml::Controls::DataTemplateSelector const& oldItemTemplateSelector, Windows::UI::Xaml::Controls::DataTemplateSelector const& newItemTemplateSelector) const;
    void OnGroupStyleSelectorChanged(Windows::UI::Xaml::Controls::GroupStyleSelector const& oldGroupStyleSelector, Windows::UI::Xaml::Controls::GroupStyleSelector const& newGroupStyleSelector) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControlOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControlOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsControlStatics
{
    Windows::UI::Xaml::DependencyProperty ItemsSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemTemplateSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemsPanelProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayMemberPathProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemContainerStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemContainerStyleSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemContainerTransitionsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty GroupStyleSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsGroupingProperty() const noexcept;
    Windows::UI::Xaml::Controls::ItemsControl GetItemsOwner(Windows::UI::Xaml::DependencyObject const& element) const;
    Windows::UI::Xaml::Controls::ItemsControl ItemsControlFromItemContainer(Windows::UI::Xaml::DependencyObject const& container) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPanelTemplate
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPanelTemplate> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPanelTemplate<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPickedEventArgs
{
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> AddedItems() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> RemovedItems() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPickedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPickedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPresenter
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection HeaderTransitions() const noexcept;
    void HeaderTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPresenter2
{
    Windows::Foundation::IInspectable Footer() const noexcept;
    void Footer(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate FooterTemplate() const noexcept;
    void FooterTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection FooterTransitions() const noexcept;
    void FooterTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPresenter2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPresenter2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPresenterStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTransitionsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPresenterStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPresenterStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsPresenterStatics2
{
    Windows::UI::Xaml::DependencyProperty FooterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FooterTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FooterTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsPresenterStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsPresenterStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsStackPanel
{
    Windows::UI::Xaml::Thickness GroupPadding() const noexcept;
    void GroupPadding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    int32_t FirstCacheIndex() const noexcept;
    int32_t FirstVisibleIndex() const noexcept;
    int32_t LastVisibleIndex() const noexcept;
    int32_t LastCacheIndex() const noexcept;
    Windows::UI::Xaml::Controls::PanelScrollingDirection ScrollingDirection() const noexcept;
    Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement GroupHeaderPlacement() const noexcept;
    void GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement const& value) const noexcept;
    Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode ItemsUpdatingScrollMode() const noexcept;
    void ItemsUpdatingScrollMode(Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode const& value) const noexcept;
    double CacheLength() const noexcept;
    void CacheLength(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsStackPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsStackPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsStackPanel2
{
    bool AreStickyGroupHeadersEnabled() const noexcept;
    void AreStickyGroupHeadersEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsStackPanel2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsStackPanel2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsStackPanelStatics
{
    Windows::UI::Xaml::DependencyProperty GroupPaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty GroupHeaderPlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CacheLengthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsStackPanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsStackPanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsStackPanelStatics2
{
    Windows::UI::Xaml::DependencyProperty AreStickyGroupHeadersEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsStackPanelStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsStackPanelStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsWrapGrid
{
    Windows::UI::Xaml::Thickness GroupPadding() const noexcept;
    void GroupPadding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    int32_t MaximumRowsOrColumns() const noexcept;
    void MaximumRowsOrColumns(int32_t value) const noexcept;
    double ItemWidth() const noexcept;
    void ItemWidth(double value) const noexcept;
    double ItemHeight() const noexcept;
    void ItemHeight(double value) const noexcept;
    int32_t FirstCacheIndex() const noexcept;
    int32_t FirstVisibleIndex() const noexcept;
    int32_t LastVisibleIndex() const noexcept;
    int32_t LastCacheIndex() const noexcept;
    Windows::UI::Xaml::Controls::PanelScrollingDirection ScrollingDirection() const noexcept;
    Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement GroupHeaderPlacement() const noexcept;
    void GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement const& value) const noexcept;
    double CacheLength() const noexcept;
    void CacheLength(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsWrapGrid> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsWrapGrid<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsWrapGrid2
{
    bool AreStickyGroupHeadersEnabled() const noexcept;
    void AreStickyGroupHeadersEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsWrapGrid2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsWrapGrid2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsWrapGridStatics
{
    Windows::UI::Xaml::DependencyProperty GroupPaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaximumRowsOrColumnsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty GroupHeaderPlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CacheLengthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsWrapGridStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsWrapGridStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IItemsWrapGridStatics2
{
    Windows::UI::Xaml::DependencyProperty AreStickyGroupHeadersEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IItemsWrapGridStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IItemsWrapGridStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBox
{
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> SelectedItems() const noexcept;
    Windows::UI::Xaml::Controls::SelectionMode SelectionMode() const noexcept;
    void SelectionMode(Windows::UI::Xaml::Controls::SelectionMode const& value) const noexcept;
    void ScrollIntoView(Windows::Foundation::IInspectable const& item) const;
    void SelectAll() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBox2
{
    bool SingleSelectionFollowsFocus() const noexcept;
    void SingleSelectionFollowsFocus(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBoxFactory
{
    Windows::UI::Xaml::Controls::ListBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBoxItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBoxItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBoxItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBoxItemFactory
{
    Windows::UI::Xaml::Controls::ListBoxItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBoxItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBoxItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBoxStatics
{
    Windows::UI::Xaml::DependencyProperty SelectionModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty SingleSelectionFollowsFocusProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListPickerFlyout
{
    Windows::Foundation::IInspectable ItemsSource() const noexcept;
    void ItemsSource(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate ItemTemplate() const noexcept;
    void ItemTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring DisplayMemberPath() const noexcept;
    void DisplayMemberPath(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode SelectionMode() const noexcept;
    void SelectionMode(Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode const& value) const noexcept;
    int32_t SelectedIndex() const noexcept;
    void SelectedIndex(int32_t value) const noexcept;
    Windows::Foundation::IInspectable SelectedItem() const noexcept;
    void SelectedItem(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::Foundation::IInspectable SelectedValue() const noexcept;
    void SelectedValue(Windows::Foundation::IInspectable const& value) const noexcept;
    hstring SelectedValuePath() const noexcept;
    void SelectedValuePath(param::hstring const& value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> SelectedItems() const noexcept;
    event_token ItemsPicked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListPickerFlyout, Windows::UI::Xaml::Controls::ItemsPickedEventArgs> const& value) const;
    using ItemsPicked_revoker = event_revoker<Windows::UI::Xaml::Controls::IListPickerFlyout>;
    ItemsPicked_revoker ItemsPicked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListPickerFlyout, Windows::UI::Xaml::Controls::ItemsPickedEventArgs> const& value) const;
    void ItemsPicked(event_token const& token) const;
    Windows::Foundation::IAsyncOperation<Windows::Foundation::Collections::IVectorView<Windows::Foundation::IInspectable>> ShowAtAsync(Windows::UI::Xaml::FrameworkElement const& target) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListPickerFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListPickerFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListPickerFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListPickerFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListPickerFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty ItemsSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayMemberPathProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedItemProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedValuePathProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListPickerFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListPickerFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListView
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase
{
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> SelectedItems() const noexcept;
    Windows::UI::Xaml::Controls::ListViewSelectionMode SelectionMode() const noexcept;
    void SelectionMode(Windows::UI::Xaml::Controls::ListViewSelectionMode const& value) const noexcept;
    bool IsSwipeEnabled() const noexcept;
    void IsSwipeEnabled(bool value) const noexcept;
    bool CanDragItems() const noexcept;
    void CanDragItems(bool value) const noexcept;
    bool CanReorderItems() const noexcept;
    void CanReorderItems(bool value) const noexcept;
    bool IsItemClickEnabled() const noexcept;
    void IsItemClickEnabled(bool value) const noexcept;
    double DataFetchSize() const noexcept;
    void DataFetchSize(double value) const noexcept;
    double IncrementalLoadingThreshold() const noexcept;
    void IncrementalLoadingThreshold(double value) const noexcept;
    Windows::UI::Xaml::Controls::IncrementalLoadingTrigger IncrementalLoadingTrigger() const noexcept;
    void IncrementalLoadingTrigger(Windows::UI::Xaml::Controls::IncrementalLoadingTrigger const& value) const noexcept;
    event_token ItemClick(Windows::UI::Xaml::Controls::ItemClickEventHandler const& value) const;
    using ItemClick_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase>;
    ItemClick_revoker ItemClick(auto_revoke_t, Windows::UI::Xaml::Controls::ItemClickEventHandler const& value) const;
    void ItemClick(event_token const& token) const;
    event_token DragItemsStarting(Windows::UI::Xaml::Controls::DragItemsStartingEventHandler const& value) const;
    using DragItemsStarting_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase>;
    DragItemsStarting_revoker DragItemsStarting(auto_revoke_t, Windows::UI::Xaml::Controls::DragItemsStartingEventHandler const& value) const;
    void DragItemsStarting(event_token const& token) const;
    void ScrollIntoView(Windows::Foundation::IInspectable const& item) const;
    void SelectAll() const;
    Windows::Foundation::IAsyncOperation<Windows::UI::Xaml::Data::LoadMoreItemsResult> LoadMoreItemsAsync() const;
    void ScrollIntoView(Windows::Foundation::IInspectable const& item, Windows::UI::Xaml::Controls::ScrollIntoViewAlignment const& alignment) const;
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection HeaderTransitions() const noexcept;
    void HeaderTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase2
{
    bool ShowsScrollingPlaceholders() const noexcept;
    void ShowsScrollingPlaceholders(bool value) const noexcept;
    event_token ContainerContentChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs> const& value) const;
    using ContainerContentChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase2>;
    ContainerContentChanging_revoker ContainerContentChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ContainerContentChangingEventArgs> const& value) const;
    void ContainerContentChanging(event_token const& token) const;
    void SetDesiredContainerUpdateDuration(Windows::Foundation::TimeSpan const& duration) const;
    Windows::Foundation::IInspectable Footer() const noexcept;
    void Footer(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate FooterTemplate() const noexcept;
    void FooterTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection FooterTransitions() const noexcept;
    void FooterTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase3
{
    Windows::UI::Xaml::Controls::ListViewReorderMode ReorderMode() const noexcept;
    void ReorderMode(Windows::UI::Xaml::Controls::ListViewReorderMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase4
{
    Windows::Foundation::Collections::IVectorView<Windows::UI::Xaml::Data::ItemIndexRange> SelectedRanges() const noexcept;
    bool IsMultiSelectCheckBoxEnabled() const noexcept;
    void IsMultiSelectCheckBoxEnabled(bool value) const noexcept;
    event_token DragItemsCompleted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::DragItemsCompletedEventArgs> const& value) const;
    using DragItemsCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase4>;
    DragItemsCompleted_revoker DragItemsCompleted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::DragItemsCompletedEventArgs> const& value) const;
    void DragItemsCompleted(event_token const& token) const;
    event_token ChoosingItemContainer(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ChoosingItemContainerEventArgs> const& value) const;
    using ChoosingItemContainer_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase4>;
    ChoosingItemContainer_revoker ChoosingItemContainer(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ChoosingItemContainerEventArgs> const& value) const;
    void ChoosingItemContainer(event_token const& token) const;
    event_token ChoosingGroupHeaderContainer(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ChoosingGroupHeaderContainerEventArgs> const& value) const;
    using ChoosingGroupHeaderContainer_revoker = event_revoker<Windows::UI::Xaml::Controls::IListViewBase4>;
    ChoosingGroupHeaderContainer_revoker ChoosingGroupHeaderContainer(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::ListViewBase, Windows::UI::Xaml::Controls::ChoosingGroupHeaderContainerEventArgs> const& value) const;
    void ChoosingGroupHeaderContainer(event_token const& token) const;
    void SelectRange(Windows::UI::Xaml::Data::ItemIndexRange const& itemIndexRange) const;
    void DeselectRange(Windows::UI::Xaml::Data::ItemIndexRange const& itemIndexRange) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase5
{
    bool SingleSelectionFollowsFocus() const noexcept;
    void SingleSelectionFollowsFocus(bool value) const noexcept;
    bool IsDragSource() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBase6
{
    Windows::Foundation::IAsyncOperation<bool> TryStartConnectedAnimationAsync(Windows::UI::Xaml::Media::Animation::ConnectedAnimation const& animation, Windows::Foundation::IInspectable const& item, param::hstring const& elementName) const;
    Windows::UI::Xaml::Media::Animation::ConnectedAnimation PrepareConnectedAnimation(param::hstring const& key, Windows::Foundation::IInspectable const& item, param::hstring const& elementName) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBase6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBase6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseFactory
{
    Windows::UI::Xaml::Controls::ListViewBase CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseHeaderItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseHeaderItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseHeaderItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseHeaderItemFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseHeaderItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseHeaderItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseStatics
{
    Windows::UI::Xaml::DependencyProperty SelectionModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSwipeEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanDragItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanReorderItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsItemClickEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DataFetchSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IncrementalLoadingThresholdProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IncrementalLoadingTriggerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SemanticZoomOwnerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsActiveViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomedInViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseStatics2
{
    Windows::UI::Xaml::DependencyProperty ShowsScrollingPlaceholdersProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FooterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FooterTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FooterTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseStatics3
{
    Windows::UI::Xaml::DependencyProperty ReorderModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseStatics4
{
    Windows::UI::Xaml::DependencyProperty IsMultiSelectCheckBoxEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewBaseStatics5
{
    Windows::UI::Xaml::DependencyProperty SingleSelectionFollowsFocusProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewBaseStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewBaseStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewFactory
{
    Windows::UI::Xaml::Controls::ListView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewHeaderItem
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewHeaderItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewHeaderItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewHeaderItemFactory
{
    Windows::UI::Xaml::Controls::ListViewHeaderItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewHeaderItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewHeaderItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewItem
{
    Windows::UI::Xaml::Controls::Primitives::ListViewItemTemplateSettings TemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewItemFactory
{
    Windows::UI::Xaml::Controls::ListViewItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewPersistenceHelper
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewPersistenceHelper> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewPersistenceHelper<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IListViewPersistenceHelperStatics
{
    hstring GetRelativeScrollPosition(Windows::UI::Xaml::Controls::ListViewBase const& listViewBase, Windows::UI::Xaml::Controls::ListViewItemToKeyHandler const& itemToKeyHandler) const;
    Windows::Foundation::IAsyncAction SetRelativeScrollPositionAsync(Windows::UI::Xaml::Controls::ListViewBase const& listViewBase, param::hstring const& relativeScrollPosition, Windows::UI::Xaml::Controls::ListViewKeyToItemHandler const& keyToItemHandler) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IListViewPersistenceHelperStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IListViewPersistenceHelperStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaElement
{
    Windows::UI::Xaml::Media::ImageSource PosterSource() const noexcept;
    void PosterSource(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::Foundation::Uri Source() const noexcept;
    void Source(Windows::Foundation::Uri const& value) const noexcept;
    bool IsMuted() const noexcept;
    void IsMuted(bool value) const noexcept;
    bool IsAudioOnly() const noexcept;
    bool AutoPlay() const noexcept;
    void AutoPlay(bool value) const noexcept;
    double Volume() const noexcept;
    void Volume(double value) const noexcept;
    double Balance() const noexcept;
    void Balance(double value) const noexcept;
    int32_t NaturalVideoHeight() const noexcept;
    int32_t NaturalVideoWidth() const noexcept;
    Windows::UI::Xaml::Duration NaturalDuration() const noexcept;
    Windows::Foundation::TimeSpan Position() const noexcept;
    void Position(Windows::Foundation::TimeSpan const& value) const noexcept;
    double DownloadProgress() const noexcept;
    double BufferingProgress() const noexcept;
    double DownloadProgressOffset() const noexcept;
    Windows::UI::Xaml::Media::MediaElementState CurrentState() const noexcept;
    Windows::UI::Xaml::Media::TimelineMarkerCollection Markers() const noexcept;
    bool CanSeek() const noexcept;
    bool CanPause() const noexcept;
    int32_t AudioStreamCount() const noexcept;
    Windows::Foundation::IReference<int32_t> AudioStreamIndex() const noexcept;
    void AudioStreamIndex(optional<int32_t> const& value) const noexcept;
    double PlaybackRate() const noexcept;
    void PlaybackRate(double value) const noexcept;
    bool IsLooping() const noexcept;
    void IsLooping(bool value) const noexcept;
    [[deprecated("PlayToSource may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource.")]] Windows::Media::PlayTo::PlayToSource PlayToSource() const noexcept;
    double DefaultPlaybackRate() const noexcept;
    void DefaultPlaybackRate(double value) const noexcept;
    int32_t AspectRatioWidth() const noexcept;
    int32_t AspectRatioHeight() const noexcept;
    bool RealTimePlayback() const noexcept;
    void RealTimePlayback(bool value) const noexcept;
    Windows::UI::Xaml::Media::AudioCategory AudioCategory() const noexcept;
    void AudioCategory(Windows::UI::Xaml::Media::AudioCategory const& value) const noexcept;
    Windows::UI::Xaml::Media::AudioDeviceType AudioDeviceType() const noexcept;
    void AudioDeviceType(Windows::UI::Xaml::Media::AudioDeviceType const& value) const noexcept;
    Windows::Media::Protection::MediaProtectionManager ProtectionManager() const noexcept;
    void ProtectionManager(Windows::Media::Protection::MediaProtectionManager const& value) const noexcept;
    Windows::UI::Xaml::Media::Stereo3DVideoPackingMode Stereo3DVideoPackingMode() const noexcept;
    void Stereo3DVideoPackingMode(Windows::UI::Xaml::Media::Stereo3DVideoPackingMode const& value) const noexcept;
    Windows::UI::Xaml::Media::Stereo3DVideoRenderMode Stereo3DVideoRenderMode() const noexcept;
    void Stereo3DVideoRenderMode(Windows::UI::Xaml::Media::Stereo3DVideoRenderMode const& value) const noexcept;
    bool IsStereo3DVideo() const noexcept;
    event_token MediaOpened(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using MediaOpened_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    MediaOpened_revoker MediaOpened(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void MediaOpened(event_token const& token) const;
    event_token MediaEnded(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using MediaEnded_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    MediaEnded_revoker MediaEnded(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void MediaEnded(event_token const& token) const;
    event_token MediaFailed(Windows::UI::Xaml::ExceptionRoutedEventHandler const& value) const;
    using MediaFailed_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    MediaFailed_revoker MediaFailed(auto_revoke_t, Windows::UI::Xaml::ExceptionRoutedEventHandler const& value) const;
    void MediaFailed(event_token const& token) const;
    event_token DownloadProgressChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using DownloadProgressChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    DownloadProgressChanged_revoker DownloadProgressChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void DownloadProgressChanged(event_token const& token) const;
    event_token BufferingProgressChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using BufferingProgressChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    BufferingProgressChanged_revoker BufferingProgressChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void BufferingProgressChanged(event_token const& token) const;
    event_token CurrentStateChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using CurrentStateChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    CurrentStateChanged_revoker CurrentStateChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void CurrentStateChanged(event_token const& token) const;
    event_token MarkerReached(Windows::UI::Xaml::Media::TimelineMarkerRoutedEventHandler const& value) const;
    using MarkerReached_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    MarkerReached_revoker MarkerReached(auto_revoke_t, Windows::UI::Xaml::Media::TimelineMarkerRoutedEventHandler const& value) const;
    void MarkerReached(event_token const& token) const;
    event_token RateChanged(Windows::UI::Xaml::Media::RateChangedRoutedEventHandler const& value) const;
    using RateChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    RateChanged_revoker RateChanged(auto_revoke_t, Windows::UI::Xaml::Media::RateChangedRoutedEventHandler const& value) const;
    void RateChanged(event_token const& token) const;
    event_token VolumeChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using VolumeChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    VolumeChanged_revoker VolumeChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void VolumeChanged(event_token const& token) const;
    event_token SeekCompleted(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using SeekCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement>;
    SeekCompleted_revoker SeekCompleted(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void SeekCompleted(event_token const& token) const;
    void Stop() const;
    void Play() const;
    void Pause() const;
    Windows::UI::Xaml::Media::MediaCanPlayResponse CanPlayType(param::hstring const& type) const;
    void SetSource(Windows::Storage::Streams::IRandomAccessStream const& stream, param::hstring const& mimeType) const;
    hstring GetAudioStreamLanguage(optional<int32_t> const& index) const;
    void AddAudioEffect(param::hstring const& effectID, bool effectOptional, Windows::Foundation::Collections::IPropertySet const& effectConfiguration) const;
    void AddVideoEffect(param::hstring const& effectID, bool effectOptional, Windows::Foundation::Collections::IPropertySet const& effectConfiguration) const;
    void RemoveAllEffects() const;
    Windows::UI::Xaml::Media::Stereo3DVideoPackingMode ActualStereo3DVideoPackingMode() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaElement> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaElement<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaElement2
{
    bool AreTransportControlsEnabled() const noexcept;
    void AreTransportControlsEnabled(bool value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
    bool IsFullWindow() const noexcept;
    void IsFullWindow(bool value) const noexcept;
    void SetMediaStreamSource(Windows::Media::Core::IMediaSource const& source) const;
    [[deprecated("PlayToPreferredSourceUri may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource().PreferredSourceUri.")]] Windows::Foundation::Uri PlayToPreferredSourceUri() const noexcept;
    [[deprecated("PlayToPreferredSourceUri may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource().PreferredSourceUri.")]] void PlayToPreferredSourceUri(Windows::Foundation::Uri const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaElement2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaElement2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaElement3
{
    Windows::UI::Xaml::Controls::MediaTransportControls TransportControls() const noexcept;
    void TransportControls(Windows::UI::Xaml::Controls::MediaTransportControls const& value) const noexcept;
    event_token PartialMediaFailureDetected(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::MediaElement, Windows::UI::Xaml::Media::PartialMediaFailureDetectedEventArgs> const& value) const;
    using PartialMediaFailureDetected_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaElement3>;
    PartialMediaFailureDetected_revoker PartialMediaFailureDetected(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::MediaElement, Windows::UI::Xaml::Media::PartialMediaFailureDetectedEventArgs> const& value) const;
    void PartialMediaFailureDetected(event_token const& token) const;
    void SetPlaybackSource(Windows::Media::Playback::IMediaPlaybackSource const& source) const;
    Windows::Media::Casting::CastingSource GetAsCastingSource() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaElement3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaElement3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaElementStatics
{
    Windows::UI::Xaml::DependencyProperty PosterSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsMutedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsAudioOnlyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AutoPlayProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VolumeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BalanceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty NaturalVideoHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty NaturalVideoWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty NaturalDurationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PositionProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DownloadProgressProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BufferingProgressProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DownloadProgressOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CurrentStateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanSeekProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanPauseProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AudioStreamCountProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AudioStreamIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaybackRateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsLoopingProperty() const noexcept;
    [[deprecated("PlayToSource may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource.")]] Windows::UI::Xaml::DependencyProperty PlayToSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DefaultPlaybackRateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AspectRatioWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AspectRatioHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RealTimePlaybackProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AudioCategoryProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AudioDeviceTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ProtectionManagerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty Stereo3DVideoPackingModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty Stereo3DVideoRenderModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsStereo3DVideoProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ActualStereo3DVideoPackingModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaElementStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaElementStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaElementStatics2
{
    Windows::UI::Xaml::DependencyProperty AreTransportControlsEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFullWindowProperty() const noexcept;
    [[deprecated("PlayToPreferredSourceUri may be altered or unavailable for releases after Windows 10.0. Instead, use GetAsCastingSource().PreferredSourceUri.")]] Windows::UI::Xaml::DependencyProperty PlayToPreferredSourceUriProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaElementStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaElementStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerElement
{
    Windows::Media::Playback::IMediaPlaybackSource Source() const noexcept;
    void Source(Windows::Media::Playback::IMediaPlaybackSource const& value) const noexcept;
    Windows::UI::Xaml::Controls::MediaTransportControls TransportControls() const noexcept;
    void TransportControls(Windows::UI::Xaml::Controls::MediaTransportControls const& value) const noexcept;
    bool AreTransportControlsEnabled() const noexcept;
    void AreTransportControlsEnabled(bool value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource PosterSource() const noexcept;
    void PosterSource(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
    bool AutoPlay() const noexcept;
    void AutoPlay(bool value) const noexcept;
    bool IsFullWindow() const noexcept;
    void IsFullWindow(bool value) const noexcept;
    Windows::Media::Playback::MediaPlayer MediaPlayer() const noexcept;
    void SetMediaPlayer(Windows::Media::Playback::MediaPlayer const& mediaPlayer) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerElement> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerElement<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerElementFactory
{
    Windows::UI::Xaml::Controls::MediaPlayerElement CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerElementFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerElementFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerElementStatics
{
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AreTransportControlsEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PosterSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AutoPlayProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFullWindowProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MediaPlayerProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerElementStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerElementStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenter
{
    Windows::Media::Playback::MediaPlayer MediaPlayer() const noexcept;
    void MediaPlayer(Windows::Media::Playback::MediaPlayer const& value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
    bool IsFullWindow() const noexcept;
    void IsFullWindow(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenterFactory
{
    Windows::UI::Xaml::Controls::MediaPlayerPresenter CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerPresenterFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenterFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenterStatics
{
    Windows::UI::Xaml::DependencyProperty MediaPlayerProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFullWindowProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaPlayerPresenterStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaPlayerPresenterStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControls
{
    bool IsFullWindowButtonVisible() const noexcept;
    void IsFullWindowButtonVisible(bool value) const noexcept;
    bool IsFullWindowEnabled() const noexcept;
    void IsFullWindowEnabled(bool value) const noexcept;
    bool IsZoomButtonVisible() const noexcept;
    void IsZoomButtonVisible(bool value) const noexcept;
    bool IsZoomEnabled() const noexcept;
    void IsZoomEnabled(bool value) const noexcept;
    bool IsFastForwardButtonVisible() const noexcept;
    void IsFastForwardButtonVisible(bool value) const noexcept;
    bool IsFastForwardEnabled() const noexcept;
    void IsFastForwardEnabled(bool value) const noexcept;
    bool IsFastRewindButtonVisible() const noexcept;
    void IsFastRewindButtonVisible(bool value) const noexcept;
    bool IsFastRewindEnabled() const noexcept;
    void IsFastRewindEnabled(bool value) const noexcept;
    bool IsStopButtonVisible() const noexcept;
    void IsStopButtonVisible(bool value) const noexcept;
    bool IsStopEnabled() const noexcept;
    void IsStopEnabled(bool value) const noexcept;
    bool IsVolumeButtonVisible() const noexcept;
    void IsVolumeButtonVisible(bool value) const noexcept;
    bool IsVolumeEnabled() const noexcept;
    void IsVolumeEnabled(bool value) const noexcept;
    bool IsPlaybackRateButtonVisible() const noexcept;
    void IsPlaybackRateButtonVisible(bool value) const noexcept;
    bool IsPlaybackRateEnabled() const noexcept;
    void IsPlaybackRateEnabled(bool value) const noexcept;
    bool IsSeekBarVisible() const noexcept;
    void IsSeekBarVisible(bool value) const noexcept;
    bool IsSeekEnabled() const noexcept;
    void IsSeekEnabled(bool value) const noexcept;
    bool IsCompact() const noexcept;
    void IsCompact(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControls> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControls<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControls2
{
    bool IsSkipForwardButtonVisible() const noexcept;
    void IsSkipForwardButtonVisible(bool value) const noexcept;
    bool IsSkipForwardEnabled() const noexcept;
    void IsSkipForwardEnabled(bool value) const noexcept;
    bool IsSkipBackwardButtonVisible() const noexcept;
    void IsSkipBackwardButtonVisible(bool value) const noexcept;
    bool IsSkipBackwardEnabled() const noexcept;
    void IsSkipBackwardEnabled(bool value) const noexcept;
    bool IsNextTrackButtonVisible() const noexcept;
    void IsNextTrackButtonVisible(bool value) const noexcept;
    bool IsPreviousTrackButtonVisible() const noexcept;
    void IsPreviousTrackButtonVisible(bool value) const noexcept;
    Windows::UI::Xaml::Media::FastPlayFallbackBehaviour FastPlayFallbackBehaviour() const noexcept;
    void FastPlayFallbackBehaviour(Windows::UI::Xaml::Media::FastPlayFallbackBehaviour const& value) const noexcept;
    event_token ThumbnailRequested(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::MediaTransportControls, Windows::UI::Xaml::Media::MediaTransportControlsThumbnailRequestedEventArgs> const& value) const;
    using ThumbnailRequested_revoker = event_revoker<Windows::UI::Xaml::Controls::IMediaTransportControls2>;
    ThumbnailRequested_revoker ThumbnailRequested(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::MediaTransportControls, Windows::UI::Xaml::Media::MediaTransportControlsThumbnailRequestedEventArgs> const& value) const;
    void ThumbnailRequested(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControls2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControls2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControls3
{
    bool ShowAndHideAutomatically() const noexcept;
    void ShowAndHideAutomatically(bool value) const noexcept;
    bool IsRepeatEnabled() const noexcept;
    void IsRepeatEnabled(bool value) const noexcept;
    bool IsRepeatButtonVisible() const noexcept;
    void IsRepeatButtonVisible(bool value) const noexcept;
    void Show() const;
    void Hide() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControls3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControls3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsFactory
{
    Windows::UI::Xaml::Controls::MediaTransportControls CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsHelper
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsHelper> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsHelper<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsHelperStatics
{
    Windows::UI::Xaml::DependencyProperty DropoutOrderProperty() const noexcept;
    Windows::Foundation::IReference<int32_t> GetDropoutOrder(Windows::UI::Xaml::UIElement const& element) const;
    void SetDropoutOrder(Windows::UI::Xaml::UIElement const& element, optional<int32_t> const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsHelperStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsHelperStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics
{
    Windows::UI::Xaml::DependencyProperty IsFullWindowButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFullWindowEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFastForwardButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFastForwardEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFastRewindButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsFastRewindEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsStopButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsStopEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsVolumeButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsVolumeEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPlaybackRateButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPlaybackRateEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSeekBarVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSeekEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsCompactProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics2
{
    Windows::UI::Xaml::DependencyProperty IsSkipForwardButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSkipForwardEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSkipBackwardButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSkipBackwardEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsNextTrackButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPreviousTrackButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FastPlayFallbackBehaviourProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics3
{
    Windows::UI::Xaml::DependencyProperty ShowAndHideAutomaticallyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsRepeatEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsRepeatButtonVisibleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMediaTransportControlsStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyout
{
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::MenuFlyoutItemBase> Items() const noexcept;
    Windows::UI::Xaml::Style MenuFlyoutPresenterStyle() const noexcept;
    void MenuFlyoutPresenterStyle(Windows::UI::Xaml::Style const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyout2
{
    void ShowAt(Windows::UI::Xaml::UIElement const& targetElement, Windows::Foundation::Point const& point) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyout2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyout2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutFactory
{
    Windows::UI::Xaml::Controls::MenuFlyout CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItem
{
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Input::ICommand Command() const noexcept;
    void Command(Windows::UI::Xaml::Input::ICommand const& value) const noexcept;
    Windows::Foundation::IInspectable CommandParameter() const noexcept;
    void CommandParameter(Windows::Foundation::IInspectable const& value) const noexcept;
    event_token Click(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using Click_revoker = event_revoker<Windows::UI::Xaml::Controls::IMenuFlyoutItem>;
    Click_revoker Click(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void Click(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItem2
{
    Windows::UI::Xaml::Controls::IconElement Icon() const noexcept;
    void Icon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItem2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItem2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemBase
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItemBase> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemBase<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemBaseFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItemBaseFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemBaseFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemFactory
{
    Windows::UI::Xaml::Controls::MenuFlyoutItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemStatics
{
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CommandProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CommandParameterProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemStatics2
{
    Windows::UI::Xaml::DependencyProperty IconProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutItemStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenter2
{
    Windows::UI::Xaml::Controls::Primitives::MenuFlyoutPresenterTemplateSettings TemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenter2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenterFactory
{
    Windows::UI::Xaml::Controls::MenuFlyoutPresenter CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutPresenterFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutPresenterFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSeparator
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSeparator> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSeparator<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSeparatorFactory
{
    Windows::UI::Xaml::Controls::MenuFlyoutSeparator CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSeparatorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSeparatorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty MenuFlyoutPresenterStyleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItem
{
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::MenuFlyoutItemBase> Items() const noexcept;
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItem2
{
    Windows::UI::Xaml::Controls::IconElement Icon() const noexcept;
    void Icon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItem2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItemStatics
{
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItemStatics2
{
    Windows::UI::Xaml::DependencyProperty IconProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IMenuFlyoutSubItemStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigate
{
    bool Navigate(Windows::UI::Xaml::Interop::TypeName const& sourcePageType) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigate> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigate<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationView
{
    bool IsPaneOpen() const noexcept;
    void IsPaneOpen(bool value) const noexcept;
    double CompactModeThresholdWidth() const noexcept;
    void CompactModeThresholdWidth(double value) const noexcept;
    double ExpandedModeThresholdWidth() const noexcept;
    void ExpandedModeThresholdWidth(double value) const noexcept;
    Windows::UI::Xaml::UIElement PaneFooter() const noexcept;
    void PaneFooter(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::NavigationViewDisplayMode DisplayMode() const noexcept;
    bool IsSettingsVisible() const noexcept;
    void IsSettingsVisible(bool value) const noexcept;
    bool IsPaneToggleButtonVisible() const noexcept;
    void IsPaneToggleButtonVisible(bool value) const noexcept;
    bool AlwaysShowHeader() const noexcept;
    void AlwaysShowHeader(bool value) const noexcept;
    double CompactPaneLength() const noexcept;
    void CompactPaneLength(double value) const noexcept;
    double OpenPaneLength() const noexcept;
    void OpenPaneLength(double value) const noexcept;
    Windows::UI::Xaml::Style PaneToggleButtonStyle() const noexcept;
    void PaneToggleButtonStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::Foundation::IInspectable SelectedItem() const noexcept;
    void SelectedItem(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> MenuItems() const noexcept;
    Windows::Foundation::IInspectable MenuItemsSource() const noexcept;
    void MenuItemsSource(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::Foundation::IInspectable SettingsItem() const noexcept;
    Windows::UI::Xaml::Controls::AutoSuggestBox AutoSuggestBox() const noexcept;
    void AutoSuggestBox(Windows::UI::Xaml::Controls::AutoSuggestBox const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate MenuItemTemplate() const noexcept;
    void MenuItemTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::DataTemplateSelector MenuItemTemplateSelector() const noexcept;
    void MenuItemTemplateSelector(Windows::UI::Xaml::Controls::DataTemplateSelector const& value) const noexcept;
    Windows::UI::Xaml::Style MenuItemContainerStyle() const noexcept;
    void MenuItemContainerStyle(Windows::UI::Xaml::Style const& value) const noexcept;
    Windows::UI::Xaml::Controls::StyleSelector MenuItemContainerStyleSelector() const noexcept;
    void MenuItemContainerStyleSelector(Windows::UI::Xaml::Controls::StyleSelector const& value) const noexcept;
    Windows::Foundation::IInspectable MenuItemFromContainer(Windows::UI::Xaml::DependencyObject const& container) const;
    Windows::UI::Xaml::DependencyObject ContainerFromMenuItem(Windows::Foundation::IInspectable const& item) const;
    event_token SelectionChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewSelectionChangedEventArgs> const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::INavigationView>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewSelectionChangedEventArgs> const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token ItemInvoked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewItemInvokedEventArgs> const& value) const;
    using ItemInvoked_revoker = event_revoker<Windows::UI::Xaml::Controls::INavigationView>;
    ItemInvoked_revoker ItemInvoked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewItemInvokedEventArgs> const& value) const;
    void ItemInvoked(event_token const& token) const;
    event_token DisplayModeChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewDisplayModeChangedEventArgs> const& value) const;
    using DisplayModeChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::INavigationView>;
    DisplayModeChanged_revoker DisplayModeChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::NavigationView, Windows::UI::Xaml::Controls::NavigationViewDisplayModeChangedEventArgs> const& value) const;
    void DisplayModeChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewDisplayModeChangedEventArgs
{
    Windows::UI::Xaml::Controls::NavigationViewDisplayMode DisplayMode() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewDisplayModeChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewFactory
{
    Windows::UI::Xaml::Controls::NavigationView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItem
{
    Windows::UI::Xaml::Controls::IconElement Icon() const noexcept;
    void Icon(Windows::UI::Xaml::Controls::IconElement const& value) const noexcept;
    double CompactPaneLength() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemBase
{
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemBase> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemBase<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemBaseFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemBaseFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemBaseFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemFactory
{
    Windows::UI::Xaml::Controls::NavigationViewItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemHeader
{
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemHeader> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemHeader<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemHeaderFactory
{
    Windows::UI::Xaml::Controls::NavigationViewItemHeader CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemHeaderFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemHeaderFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemInvokedEventArgs
{
    Windows::Foundation::IInspectable InvokedItem() const noexcept;
    bool IsSettingsInvoked() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemInvokedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemSeparator
{
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemSeparator> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemSeparator<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemSeparatorFactory
{
    Windows::UI::Xaml::Controls::NavigationViewItemSeparator CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemSeparatorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemSeparatorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewItemStatics
{
    Windows::UI::Xaml::DependencyProperty IconProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CompactPaneLengthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewList
{
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewList> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewList<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewListFactory
{
    Windows::UI::Xaml::Controls::NavigationViewList CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewListFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewListFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewSelectionChangedEventArgs
{
    Windows::Foundation::IInspectable SelectedItem() const noexcept;
    bool IsSettingsSelected() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewSelectionChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INavigationViewStatics
{
    Windows::UI::Xaml::DependencyProperty IsPaneOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CompactModeThresholdWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ExpandedModeThresholdWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaneFooterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSettingsVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPaneToggleButtonVisibleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AlwaysShowHeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CompactPaneLengthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OpenPaneLengthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaneToggleButtonStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemsSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedItemProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SettingsItemProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AutoSuggestBoxProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemTemplateSelectorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemContainerStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MenuItemContainerStyleSelectorProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INavigationViewStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INavigationViewStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INotifyEventArgs
{
    hstring Value() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INotifyEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INotifyEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_INotifyEventArgs2
{
    Windows::Foundation::Uri CallingUri() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::INotifyEventArgs2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_INotifyEventArgs2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPage
{
    Windows::UI::Xaml::Controls::Frame Frame() const noexcept;
    Windows::UI::Xaml::Navigation::NavigationCacheMode NavigationCacheMode() const noexcept;
    void NavigationCacheMode(Windows::UI::Xaml::Navigation::NavigationCacheMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::AppBar TopAppBar() const noexcept;
    void TopAppBar(Windows::UI::Xaml::Controls::AppBar const& value) const noexcept;
    Windows::UI::Xaml::Controls::AppBar BottomAppBar() const noexcept;
    void BottomAppBar(Windows::UI::Xaml::Controls::AppBar const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPage> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPage<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPageFactory
{
    Windows::UI::Xaml::Controls::Page CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPageFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPageFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPageOverrides
{
    void OnNavigatedFrom(Windows::UI::Xaml::Navigation::NavigationEventArgs const& e) const;
    void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs const& e) const;
    void OnNavigatingFrom(Windows::UI::Xaml::Navigation::NavigatingCancelEventArgs const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPageOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPageOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPageStatics
{
    Windows::UI::Xaml::DependencyProperty FrameProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TopAppBarProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BottomAppBarProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPageStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPageStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPanel
{
    Windows::UI::Xaml::Controls::UIElementCollection Children() const noexcept;
    Windows::UI::Xaml::Media::Brush Background() const noexcept;
    void Background(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    bool IsItemsHost() const noexcept;
    Windows::UI::Xaml::Media::Animation::TransitionCollection ChildrenTransitions() const noexcept;
    void ChildrenTransitions(Windows::UI::Xaml::Media::Animation::TransitionCollection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPanelFactory
{
    Windows::UI::Xaml::Controls::Panel CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPanelStatics
{
    Windows::UI::Xaml::DependencyProperty BackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsItemsHostProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ChildrenTransitionsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IParallaxView
{
    Windows::UI::Xaml::UIElement Child() const noexcept;
    void Child(Windows::UI::Xaml::UIElement const& value) const noexcept;
    double HorizontalShift() const noexcept;
    void HorizontalShift(double value) const noexcept;
    double HorizontalSourceEndOffset() const noexcept;
    void HorizontalSourceEndOffset(double value) const noexcept;
    Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind HorizontalSourceOffsetKind() const noexcept;
    void HorizontalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind const& value) const noexcept;
    double HorizontalSourceStartOffset() const noexcept;
    void HorizontalSourceStartOffset(double value) const noexcept;
    bool IsHorizontalShiftClamped() const noexcept;
    void IsHorizontalShiftClamped(bool value) const noexcept;
    bool IsVerticalShiftClamped() const noexcept;
    void IsVerticalShiftClamped(bool value) const noexcept;
    double MaxHorizontalShiftRatio() const noexcept;
    void MaxHorizontalShiftRatio(double value) const noexcept;
    double MaxVerticalShiftRatio() const noexcept;
    void MaxVerticalShiftRatio(double value) const noexcept;
    Windows::UI::Xaml::UIElement Source() const noexcept;
    void Source(Windows::UI::Xaml::UIElement const& value) const noexcept;
    double VerticalShift() const noexcept;
    void VerticalShift(double value) const noexcept;
    double VerticalSourceEndOffset() const noexcept;
    void VerticalSourceEndOffset(double value) const noexcept;
    Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind VerticalSourceOffsetKind() const noexcept;
    void VerticalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind const& value) const noexcept;
    double VerticalSourceStartOffset() const noexcept;
    void VerticalSourceStartOffset(double value) const noexcept;
    void RefreshAutomaticHorizontalOffsets() const;
    void RefreshAutomaticVerticalOffsets() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IParallaxView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IParallaxView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IParallaxViewFactory
{
    Windows::UI::Xaml::Controls::ParallaxView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IParallaxViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IParallaxViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IParallaxViewStatics
{
    Windows::UI::Xaml::DependencyProperty ChildProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalSourceEndOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalSourceOffsetKindProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalSourceStartOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxHorizontalShiftRatioProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalShiftProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsHorizontalShiftClampedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsVerticalShiftClampedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalSourceEndOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalSourceOffsetKindProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalSourceStartOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxVerticalShiftRatioProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalShiftProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IParallaxViewStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IParallaxViewStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBox
{
    hstring Password() const noexcept;
    void Password(param::hstring const& value) const noexcept;
    hstring PasswordChar() const noexcept;
    void PasswordChar(param::hstring const& value) const noexcept;
    [[deprecated("IsPasswordRevealButtonEnabledProperty may be altered or unavailable for releases after Windows 10.0. Instead, use PasswordRevealModeProperty.")]] bool IsPasswordRevealButtonEnabled() const noexcept;
    [[deprecated("IsPasswordRevealButtonEnabledProperty may be altered or unavailable for releases after Windows 10.0. Instead, use PasswordRevealModeProperty.")]] void IsPasswordRevealButtonEnabled(bool value) const noexcept;
    int32_t MaxLength() const noexcept;
    void MaxLength(int32_t value) const noexcept;
    event_token PasswordChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using PasswordChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IPasswordBox>;
    PasswordChanged_revoker PasswordChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void PasswordChanged(event_token const& token) const;
    event_token ContextMenuOpening(Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    using ContextMenuOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::IPasswordBox>;
    ContextMenuOpening_revoker ContextMenuOpening(auto_revoke_t, Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    void ContextMenuOpening(event_token const& token) const;
    void SelectAll() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBox2
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColor() const noexcept;
    void SelectionHighlightColor(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    bool PreventKeyboardDisplayOnProgrammaticFocus() const noexcept;
    void PreventKeyboardDisplayOnProgrammaticFocus(bool value) const noexcept;
    event_token Paste(Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    using Paste_revoker = event_revoker<Windows::UI::Xaml::Controls::IPasswordBox2>;
    Paste_revoker Paste(auto_revoke_t, Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    void Paste(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBox3
{
    Windows::UI::Xaml::Controls::PasswordRevealMode PasswordRevealMode() const noexcept;
    void PasswordRevealMode(Windows::UI::Xaml::Controls::PasswordRevealMode const& value) const noexcept;
    Windows::UI::Xaml::TextReadingOrder TextReadingOrder() const noexcept;
    void TextReadingOrder(Windows::UI::Xaml::TextReadingOrder const& value) const noexcept;
    Windows::UI::Xaml::Input::InputScope InputScope() const noexcept;
    void InputScope(Windows::UI::Xaml::Input::InputScope const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBox3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBox3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBox4
{
    event_token PasswordChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::PasswordBox, Windows::UI::Xaml::Controls::PasswordBoxPasswordChangingEventArgs> const& value) const;
    using PasswordChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::IPasswordBox4>;
    PasswordChanging_revoker PasswordChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::PasswordBox, Windows::UI::Xaml::Controls::PasswordBoxPasswordChangingEventArgs> const& value) const;
    void PasswordChanging(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBox4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBox4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBoxPasswordChangingEventArgs
{
    bool IsContentChanging() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBoxPasswordChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics
{
    Windows::UI::Xaml::DependencyProperty PasswordProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PasswordCharProperty() const noexcept;
    [[deprecated("IsPasswordRevealButtonEnabledProperty may be altered or unavailable for releases after Windows 10.0. Instead, use PasswordRevealModeProperty.")]] Windows::UI::Xaml::DependencyProperty IsPasswordRevealButtonEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxLengthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PreventKeyboardDisplayOnProgrammaticFocusProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics3
{
    Windows::UI::Xaml::DependencyProperty PasswordRevealModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextReadingOrderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InputScopeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPasswordBoxStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPasswordBoxStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIcon
{
    Windows::UI::Xaml::Media::Geometry Data() const noexcept;
    void Data(Windows::UI::Xaml::Media::Geometry const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIcon> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIcon<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIconFactory
{
    Windows::UI::Xaml::Controls::PathIcon CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIconFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIconFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIconSource
{
    Windows::UI::Xaml::Media::Geometry Data() const noexcept;
    void Data(Windows::UI::Xaml::Media::Geometry const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIconSource> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIconSource<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIconSourceFactory
{
    Windows::UI::Xaml::Controls::PathIconSource CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIconSourceFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIconSourceFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIconSourceStatics
{
    Windows::UI::Xaml::DependencyProperty DataProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIconSourceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIconSourceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPathIconStatics
{
    Windows::UI::Xaml::DependencyProperty DataProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPathIconStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPathIconStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPersonPicture
{
    int32_t BadgeNumber() const noexcept;
    void BadgeNumber(int32_t value) const noexcept;
    hstring BadgeGlyph() const noexcept;
    void BadgeGlyph(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource BadgeImageSource() const noexcept;
    void BadgeImageSource(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    hstring BadgeText() const noexcept;
    void BadgeText(param::hstring const& value) const noexcept;
    bool IsGroup() const noexcept;
    void IsGroup(bool value) const noexcept;
    Windows::ApplicationModel::Contacts::Contact Contact() const noexcept;
    void Contact(Windows::ApplicationModel::Contacts::Contact const& value) const noexcept;
    hstring DisplayName() const noexcept;
    void DisplayName(param::hstring const& value) const noexcept;
    hstring Initials() const noexcept;
    void Initials(param::hstring const& value) const noexcept;
    bool PreferSmallImage() const noexcept;
    void PreferSmallImage(bool value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource ProfilePicture() const noexcept;
    void ProfilePicture(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPersonPicture> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPersonPicture<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPersonPictureFactory
{
    Windows::UI::Xaml::Controls::PersonPicture CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPersonPictureFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPersonPictureFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPersonPictureStatics
{
    Windows::UI::Xaml::DependencyProperty BadgeNumberProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BadgeGlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BadgeImageSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BadgeTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsGroupProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ContactProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayNameProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InitialsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PreferSmallImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ProfilePictureProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPersonPictureStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPersonPictureStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPickerConfirmedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPickerConfirmedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPickerFlyout
{
    Windows::UI::Xaml::UIElement Content() const noexcept;
    void Content(Windows::UI::Xaml::UIElement const& value) const noexcept;
    bool ConfirmationButtonsVisible() const noexcept;
    void ConfirmationButtonsVisible(bool value) const noexcept;
    event_token Confirmed(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::PickerFlyout, Windows::UI::Xaml::Controls::PickerConfirmedEventArgs> const& value) const;
    using Confirmed_revoker = event_revoker<Windows::UI::Xaml::Controls::IPickerFlyout>;
    Confirmed_revoker Confirmed(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::PickerFlyout, Windows::UI::Xaml::Controls::PickerConfirmedEventArgs> const& value) const;
    void Confirmed(event_token const& token) const;
    Windows::Foundation::IAsyncOperation<bool> ShowAtAsync(Windows::UI::Xaml::FrameworkElement const& target) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPickerFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPickerFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPickerFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IPickerFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPickerFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPickerFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ConfirmationButtonsVisibleProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPickerFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPickerFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivot
{
    Windows::Foundation::IInspectable Title() const noexcept;
    void Title(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate TitleTemplate() const noexcept;
    void TitleTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    int32_t SelectedIndex() const noexcept;
    void SelectedIndex(int32_t value) const noexcept;
    Windows::Foundation::IInspectable SelectedItem() const noexcept;
    void SelectedItem(Windows::Foundation::IInspectable const& value) const noexcept;
    bool IsLocked() const noexcept;
    void IsLocked(bool value) const noexcept;
    event_token SelectionChanged(Windows::UI::Xaml::Controls::SelectionChangedEventHandler const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IPivot>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::UI::Xaml::Controls::SelectionChangedEventHandler const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token PivotItemLoading(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    using PivotItemLoading_revoker = event_revoker<Windows::UI::Xaml::Controls::IPivot>;
    PivotItemLoading_revoker PivotItemLoading(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    void PivotItemLoading(event_token const& token) const;
    event_token PivotItemLoaded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    using PivotItemLoaded_revoker = event_revoker<Windows::UI::Xaml::Controls::IPivot>;
    PivotItemLoaded_revoker PivotItemLoaded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    void PivotItemLoaded(event_token const& token) const;
    event_token PivotItemUnloading(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    using PivotItemUnloading_revoker = event_revoker<Windows::UI::Xaml::Controls::IPivot>;
    PivotItemUnloading_revoker PivotItemUnloading(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    void PivotItemUnloading(event_token const& token) const;
    event_token PivotItemUnloaded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    using PivotItemUnloaded_revoker = event_revoker<Windows::UI::Xaml::Controls::IPivot>;
    PivotItemUnloaded_revoker PivotItemUnloaded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::Pivot, Windows::UI::Xaml::Controls::PivotItemEventArgs> const& value) const;
    void PivotItemUnloaded(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivot> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivot<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivot2
{
    Windows::Foundation::IInspectable LeftHeader() const noexcept;
    void LeftHeader(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate LeftHeaderTemplate() const noexcept;
    void LeftHeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::Foundation::IInspectable RightHeader() const noexcept;
    void RightHeader(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate RightHeaderTemplate() const noexcept;
    void RightHeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivot2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivot2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivot3
{
    Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement HeaderFocusVisualPlacement() const noexcept;
    void HeaderFocusVisualPlacement(Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement const& value) const noexcept;
    bool IsHeaderItemsCarouselEnabled() const noexcept;
    void IsHeaderItemsCarouselEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivot3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivot3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotFactory
{
    Windows::UI::Xaml::Controls::Pivot CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotItem
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotItemEventArgs
{
    Windows::UI::Xaml::Controls::PivotItem Item() const noexcept;
    void Item(Windows::UI::Xaml::Controls::PivotItem const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotItemEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotItemEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotItemFactory
{
    Windows::UI::Xaml::Controls::PivotItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotItemStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotStatics
{
    Windows::UI::Xaml::DependencyProperty TitleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TitleTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedIndexProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedItemProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsLockedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SlideInAnimationGroupProperty() const noexcept;
    Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup GetSlideInAnimationGroup(Windows::UI::Xaml::FrameworkElement const& element) const;
    void SetSlideInAnimationGroup(Windows::UI::Xaml::FrameworkElement const& element, Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotStatics2
{
    Windows::UI::Xaml::DependencyProperty LeftHeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LeftHeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RightHeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RightHeaderTemplateProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IPivotStatics3
{
    Windows::UI::Xaml::DependencyProperty HeaderFocusVisualPlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsHeaderItemsCarouselEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IPivotStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IPivotStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IProgressBar
{
    bool IsIndeterminate() const noexcept;
    void IsIndeterminate(bool value) const noexcept;
    bool ShowError() const noexcept;
    void ShowError(bool value) const noexcept;
    bool ShowPaused() const noexcept;
    void ShowPaused(bool value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::ProgressBarTemplateSettings TemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IProgressBar> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IProgressBar<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IProgressBarFactory
{
    Windows::UI::Xaml::Controls::ProgressBar CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IProgressBarFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IProgressBarFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IProgressBarStatics
{
    Windows::UI::Xaml::DependencyProperty IsIndeterminateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ShowErrorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ShowPausedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IProgressBarStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IProgressBarStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IProgressRing
{
    bool IsActive() const noexcept;
    void IsActive(bool value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::ProgressRingTemplateSettings TemplateSettings() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IProgressRing> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IProgressRing<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IProgressRingStatics
{
    Windows::UI::Xaml::DependencyProperty IsActiveProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IProgressRingStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IProgressRingStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRadioButton
{
    hstring GroupName() const noexcept;
    void GroupName(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRadioButton> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRadioButton<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRadioButtonFactory
{
    Windows::UI::Xaml::Controls::RadioButton CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRadioButtonFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRadioButtonFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRadioButtonStatics
{
    Windows::UI::Xaml::DependencyProperty GroupNameProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRadioButtonStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRadioButtonStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingControl
{
    hstring Caption() const noexcept;
    void Caption(param::hstring const& value) const noexcept;
    int32_t InitialSetValue() const noexcept;
    void InitialSetValue(int32_t value) const noexcept;
    bool IsClearEnabled() const noexcept;
    void IsClearEnabled(bool value) const noexcept;
    bool IsReadOnly() const noexcept;
    void IsReadOnly(bool value) const noexcept;
    int32_t MaxRating() const noexcept;
    void MaxRating(int32_t value) const noexcept;
    double PlaceholderValue() const noexcept;
    void PlaceholderValue(double value) const noexcept;
    Windows::UI::Xaml::Controls::RatingItemInfo ItemInfo() const noexcept;
    void ItemInfo(Windows::UI::Xaml::Controls::RatingItemInfo const& value) const noexcept;
    double Value() const noexcept;
    void Value(double value) const noexcept;
    event_token ValueChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RatingControl, Windows::Foundation::IInspectable> const& value) const;
    using ValueChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRatingControl>;
    ValueChanged_revoker ValueChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RatingControl, Windows::Foundation::IInspectable> const& value) const;
    void ValueChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingControlFactory
{
    Windows::UI::Xaml::Controls::RatingControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingControlStatics
{
    Windows::UI::Xaml::DependencyProperty CaptionProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InitialSetValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsClearEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsReadOnlyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxRatingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemInfoProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ValueProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemFontInfo
{
    hstring DisabledGlyph() const noexcept;
    void DisabledGlyph(param::hstring const& value) const noexcept;
    hstring Glyph() const noexcept;
    void Glyph(param::hstring const& value) const noexcept;
    hstring PointerOverGlyph() const noexcept;
    void PointerOverGlyph(param::hstring const& value) const noexcept;
    hstring PointerOverPlaceholderGlyph() const noexcept;
    void PointerOverPlaceholderGlyph(param::hstring const& value) const noexcept;
    hstring PlaceholderGlyph() const noexcept;
    void PlaceholderGlyph(param::hstring const& value) const noexcept;
    hstring UnsetGlyph() const noexcept;
    void UnsetGlyph(param::hstring const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemFontInfo> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemFontInfo<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemFontInfoFactory
{
    Windows::UI::Xaml::Controls::RatingItemFontInfo CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemFontInfoFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemFontInfoFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemFontInfoStatics
{
    Windows::UI::Xaml::DependencyProperty DisabledGlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty GlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderGlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PointerOverGlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PointerOverPlaceholderGlyphProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty UnsetGlyphProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemFontInfoStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemFontInfoStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemImageInfo
{
    Windows::UI::Xaml::Media::ImageSource DisabledImage() const noexcept;
    void DisabledImage(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource Image() const noexcept;
    void Image(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource PlaceholderImage() const noexcept;
    void PlaceholderImage(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource PointerOverImage() const noexcept;
    void PointerOverImage(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource PointerOverPlaceholderImage() const noexcept;
    void PointerOverPlaceholderImage(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource UnsetImage() const noexcept;
    void UnsetImage(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemImageInfo> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemImageInfo<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemImageInfoFactory
{
    Windows::UI::Xaml::Controls::RatingItemImageInfo CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemImageInfoFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemImageInfoFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemImageInfoStatics
{
    Windows::UI::Xaml::DependencyProperty DisabledImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PointerOverImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PointerOverPlaceholderImageProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty UnsetImageProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemImageInfoStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemImageInfoStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemInfo
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemInfo> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemInfo<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRatingItemInfoFactory
{
    Windows::UI::Xaml::Controls::RatingItemInfo CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRatingItemInfoFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRatingItemInfoFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRelativePanel
{
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::CornerRadius CornerRadius() const noexcept;
    void CornerRadius(Windows::UI::Xaml::CornerRadius const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRelativePanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRelativePanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRelativePanelFactory
{
    Windows::UI::Xaml::Controls::RelativePanel CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRelativePanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRelativePanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRelativePanelStatics
{
    Windows::UI::Xaml::DependencyProperty LeftOfProperty() const noexcept;
    Windows::Foundation::IInspectable GetLeftOf(Windows::UI::Xaml::UIElement const& element) const;
    void SetLeftOf(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AboveProperty() const noexcept;
    Windows::Foundation::IInspectable GetAbove(Windows::UI::Xaml::UIElement const& element) const;
    void SetAbove(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty RightOfProperty() const noexcept;
    Windows::Foundation::IInspectable GetRightOf(Windows::UI::Xaml::UIElement const& element) const;
    void SetRightOf(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty BelowProperty() const noexcept;
    Windows::Foundation::IInspectable GetBelow(Windows::UI::Xaml::UIElement const& element) const;
    void SetBelow(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignHorizontalCenterWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignHorizontalCenterWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignHorizontalCenterWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignVerticalCenterWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignVerticalCenterWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignVerticalCenterWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignLeftWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignLeftWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignLeftWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignTopWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignTopWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignTopWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignRightWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignRightWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignRightWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignBottomWithProperty() const noexcept;
    Windows::Foundation::IInspectable GetAlignBottomWith(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignBottomWith(Windows::UI::Xaml::UIElement const& element, Windows::Foundation::IInspectable const& value) const;
    Windows::UI::Xaml::DependencyProperty AlignLeftWithPanelProperty() const noexcept;
    bool GetAlignLeftWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignLeftWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty AlignTopWithPanelProperty() const noexcept;
    bool GetAlignTopWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignTopWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty AlignRightWithPanelProperty() const noexcept;
    bool GetAlignRightWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignRightWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty AlignBottomWithPanelProperty() const noexcept;
    bool GetAlignBottomWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignBottomWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty AlignHorizontalCenterWithPanelProperty() const noexcept;
    bool GetAlignHorizontalCenterWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignHorizontalCenterWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty AlignVerticalCenterWithPanelProperty() const noexcept;
    bool GetAlignVerticalCenterWithPanel(Windows::UI::Xaml::UIElement const& element) const;
    void SetAlignVerticalCenterWithPanel(Windows::UI::Xaml::UIElement const& element, bool value) const;
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CornerRadiusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRelativePanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRelativePanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox
{
    bool IsReadOnly() const noexcept;
    void IsReadOnly(bool value) const noexcept;
    bool AcceptsReturn() const noexcept;
    void AcceptsReturn(bool value) const noexcept;
    Windows::UI::Xaml::TextAlignment TextAlignment() const noexcept;
    void TextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::UI::Xaml::TextWrapping TextWrapping() const noexcept;
    void TextWrapping(Windows::UI::Xaml::TextWrapping const& value) const noexcept;
    bool IsSpellCheckEnabled() const noexcept;
    void IsSpellCheckEnabled(bool value) const noexcept;
    bool IsTextPredictionEnabled() const noexcept;
    void IsTextPredictionEnabled(bool value) const noexcept;
    Windows::UI::Text::ITextDocument Document() const noexcept;
    Windows::UI::Xaml::Input::InputScope InputScope() const noexcept;
    void InputScope(Windows::UI::Xaml::Input::InputScope const& value) const noexcept;
    event_token TextChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using TextChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox>;
    TextChanged_revoker TextChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void TextChanged(event_token const& token) const;
    event_token SelectionChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token ContextMenuOpening(Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    using ContextMenuOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox>;
    ContextMenuOpening_revoker ContextMenuOpening(auto_revoke_t, Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    void ContextMenuOpening(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox2
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColor() const noexcept;
    void SelectionHighlightColor(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    bool PreventKeyboardDisplayOnProgrammaticFocus() const noexcept;
    void PreventKeyboardDisplayOnProgrammaticFocus(bool value) const noexcept;
    bool IsColorFontEnabled() const noexcept;
    void IsColorFontEnabled(bool value) const noexcept;
    event_token Paste(Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    using Paste_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox2>;
    Paste_revoker Paste(auto_revoke_t, Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    void Paste(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox3
{
    event_token TextCompositionStarted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs> const& value) const;
    using TextCompositionStarted_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox3>;
    TextCompositionStarted_revoker TextCompositionStarted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs> const& value) const;
    void TextCompositionStarted(event_token const& token) const;
    event_token TextCompositionChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs> const& value) const;
    using TextCompositionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox3>;
    TextCompositionChanged_revoker TextCompositionChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs> const& value) const;
    void TextCompositionChanged(event_token const& token) const;
    event_token TextCompositionEnded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs> const& value) const;
    using TextCompositionEnded_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox3>;
    TextCompositionEnded_revoker TextCompositionEnded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs> const& value) const;
    void TextCompositionEnded(event_token const& token) const;
    Windows::UI::Xaml::TextReadingOrder TextReadingOrder() const noexcept;
    void TextReadingOrder(Windows::UI::Xaml::TextReadingOrder const& value) const noexcept;
    Windows::UI::Xaml::Controls::CandidateWindowAlignment DesiredCandidateWindowAlignment() const noexcept;
    void DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment const& value) const noexcept;
    event_token CandidateWindowBoundsChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs> const& value) const;
    using CandidateWindowBoundsChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox3>;
    CandidateWindowBoundsChanged_revoker CandidateWindowBoundsChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs> const& value) const;
    void CandidateWindowBoundsChanged(event_token const& token) const;
    event_token TextChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::RichEditBoxTextChangingEventArgs> const& value) const;
    using TextChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox3>;
    TextChanging_revoker TextChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::RichEditBoxTextChangingEventArgs> const& value) const;
    void TextChanging(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox4
{
    Windows::Foundation::IAsyncOperation<Windows::Foundation::Collections::IVectorView<hstring>> GetLinguisticAlternativesAsync() const;
    Windows::UI::Xaml::Controls::RichEditClipboardFormat ClipboardCopyFormat() const noexcept;
    void ClipboardCopyFormat(Windows::UI::Xaml::Controls::RichEditClipboardFormat const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox5
{
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColorWhenNotFocused() const noexcept;
    void SelectionHighlightColorWhenNotFocused(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    int32_t MaxLength() const noexcept;
    void MaxLength(int32_t value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBox6
{
    Windows::UI::Xaml::TextAlignment HorizontalTextAlignment() const noexcept;
    void HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::UI::Xaml::Controls::CharacterCasing CharacterCasing() const noexcept;
    void CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing const& value) const noexcept;
    Windows::UI::Xaml::Controls::DisabledFormattingAccelerators DisabledFormattingAccelerators() const noexcept;
    void DisabledFormattingAccelerators(Windows::UI::Xaml::Controls::DisabledFormattingAccelerators const& value) const noexcept;
    event_token CopyingToClipboard(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs> const& value) const;
    using CopyingToClipboard_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox6>;
    CopyingToClipboard_revoker CopyingToClipboard(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs> const& value) const;
    void CopyingToClipboard(event_token const& token) const;
    event_token CuttingToClipboard(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs> const& value) const;
    using CuttingToClipboard_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichEditBox6>;
    CuttingToClipboard_revoker CuttingToClipboard(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichEditBox, Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs> const& value) const;
    void CuttingToClipboard(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBox6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBox6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxFactory
{
    Windows::UI::Xaml::Controls::RichEditBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics
{
    Windows::UI::Xaml::DependencyProperty IsReadOnlyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AcceptsReturnProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextWrappingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSpellCheckEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextPredictionEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InputScopeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PreventKeyboardDisplayOnProgrammaticFocusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorFontEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics3
{
    Windows::UI::Xaml::DependencyProperty DesiredCandidateWindowAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextReadingOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics4
{
    Windows::UI::Xaml::DependencyProperty ClipboardCopyFormatProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics5
{
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorWhenNotFocusedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxLengthProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics6
{
    Windows::UI::Xaml::DependencyProperty HorizontalTextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterCasingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisabledFormattingAcceleratorsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxStatics6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxStatics6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxTextChangingEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxTextChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichEditBoxTextChangingEventArgs2
{
    bool IsContentChanging() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichEditBoxTextChangingEventArgs2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlock
{
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontStretch FontStretch() const noexcept;
    void FontStretch(Windows::UI::Text::FontStretch const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::TextWrapping TextWrapping() const noexcept;
    void TextWrapping(Windows::UI::Xaml::TextWrapping const& value) const noexcept;
    Windows::UI::Xaml::TextTrimming TextTrimming() const noexcept;
    void TextTrimming(Windows::UI::Xaml::TextTrimming const& value) const noexcept;
    Windows::UI::Xaml::TextAlignment TextAlignment() const noexcept;
    void TextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::UI::Xaml::Documents::BlockCollection Blocks() const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    double LineHeight() const noexcept;
    void LineHeight(double value) const noexcept;
    Windows::UI::Xaml::LineStackingStrategy LineStackingStrategy() const noexcept;
    void LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy const& value) const noexcept;
    int32_t CharacterSpacing() const noexcept;
    void CharacterSpacing(int32_t value) const noexcept;
    Windows::UI::Xaml::Controls::RichTextBlockOverflow OverflowContentTarget() const noexcept;
    void OverflowContentTarget(Windows::UI::Xaml::Controls::RichTextBlockOverflow const& value) const noexcept;
    bool IsTextSelectionEnabled() const noexcept;
    void IsTextSelectionEnabled(bool value) const noexcept;
    bool HasOverflowContent() const noexcept;
    hstring SelectedText() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentStart() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentEnd() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer SelectionStart() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer SelectionEnd() const noexcept;
    double BaselineOffset() const noexcept;
    event_token SelectionChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichTextBlock>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token ContextMenuOpening(Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    using ContextMenuOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichTextBlock>;
    ContextMenuOpening_revoker ContextMenuOpening(auto_revoke_t, Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    void ContextMenuOpening(event_token const& token) const;
    void SelectAll() const;
    void Select(Windows::UI::Xaml::Documents::TextPointer const& start, Windows::UI::Xaml::Documents::TextPointer const& end) const;
    Windows::UI::Xaml::Documents::TextPointer GetPositionFromPoint(Windows::Foundation::Point const& point) const;
    bool Focus(Windows::UI::Xaml::FocusState const& value) const;
    double TextIndent() const noexcept;
    void TextIndent(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlock> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlock<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlock2
{
    int32_t MaxLines() const noexcept;
    void MaxLines(int32_t value) const noexcept;
    Windows::UI::Xaml::TextLineBounds TextLineBounds() const noexcept;
    void TextLineBounds(Windows::UI::Xaml::TextLineBounds const& value) const noexcept;
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColor() const noexcept;
    void SelectionHighlightColor(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    Windows::UI::Xaml::OpticalMarginAlignment OpticalMarginAlignment() const noexcept;
    void OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment const& value) const noexcept;
    bool IsColorFontEnabled() const noexcept;
    void IsColorFontEnabled(bool value) const noexcept;
    Windows::UI::Xaml::TextReadingOrder TextReadingOrder() const noexcept;
    void TextReadingOrder(Windows::UI::Xaml::TextReadingOrder const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlock2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlock2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlock3
{
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlock3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlock3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlock4
{
    Windows::UI::Text::TextDecorations TextDecorations() const noexcept;
    void TextDecorations(Windows::UI::Text::TextDecorations const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlock4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlock4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlock5
{
    bool IsTextTrimmed() const noexcept;
    Windows::UI::Xaml::TextAlignment HorizontalTextAlignment() const noexcept;
    void HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Documents::TextHighlighter> TextHighlighters() const noexcept;
    event_token IsTextTrimmedChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichTextBlock, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    using IsTextTrimmedChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichTextBlock5>;
    IsTextTrimmedChanged_revoker IsTextTrimmedChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichTextBlock, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    void IsTextTrimmedChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlock5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlock5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow
{
    Windows::UI::Xaml::Controls::RichTextBlockOverflow OverflowContentTarget() const noexcept;
    void OverflowContentTarget(Windows::UI::Xaml::Controls::RichTextBlockOverflow const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::Controls::RichTextBlock ContentSource() const noexcept;
    bool HasOverflowContent() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentStart() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentEnd() const noexcept;
    double BaselineOffset() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer GetPositionFromPoint(Windows::Foundation::Point const& point) const;
    bool Focus(Windows::UI::Xaml::FocusState const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflow> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow2
{
    int32_t MaxLines() const noexcept;
    void MaxLines(int32_t value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflow2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow3
{
    bool IsTextTrimmed() const noexcept;
    event_token IsTextTrimmedChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichTextBlockOverflow, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    using IsTextTrimmedChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3>;
    IsTextTrimmedChanged_revoker IsTextTrimmedChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::RichTextBlockOverflow, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    void IsTextTrimmedChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflow3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics
{
    Windows::UI::Xaml::DependencyProperty OverflowContentTargetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HasOverflowContentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics2
{
    Windows::UI::Xaml::DependencyProperty MaxLinesProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics3
{
    Windows::UI::Xaml::DependencyProperty IsTextTrimmedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockOverflowStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics
{
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextWrappingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextTrimmingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineStackingStrategyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterSpacingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OverflowContentTargetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextSelectionEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HasOverflowContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextIndentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics2
{
    Windows::UI::Xaml::DependencyProperty MaxLinesProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextLineBoundsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OpticalMarginAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorFontEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextReadingOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics3
{
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics4
{
    Windows::UI::Xaml::DependencyProperty TextDecorationsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics5
{
    Windows::UI::Xaml::DependencyProperty IsTextTrimmedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalTextAlignmentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRichTextBlockStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRichTextBlockStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRowDefinition
{
    Windows::UI::Xaml::GridLength Height() const noexcept;
    void Height(Windows::UI::Xaml::GridLength const& value) const noexcept;
    double MaxHeight() const noexcept;
    void MaxHeight(double value) const noexcept;
    double MinHeight() const noexcept;
    void MinHeight(double value) const noexcept;
    double ActualHeight() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRowDefinition> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRowDefinition<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IRowDefinitionStatics
{
    Windows::UI::Xaml::DependencyProperty HeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinHeightProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IRowDefinitionStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IRowDefinitionStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollContentPresenter
{
    bool CanVerticallyScroll() const noexcept;
    void CanVerticallyScroll(bool value) const noexcept;
    bool CanHorizontallyScroll() const noexcept;
    void CanHorizontallyScroll(bool value) const noexcept;
    double ExtentWidth() const noexcept;
    double ExtentHeight() const noexcept;
    double ViewportWidth() const noexcept;
    double ViewportHeight() const noexcept;
    double HorizontalOffset() const noexcept;
    double VerticalOffset() const noexcept;
    Windows::Foundation::IInspectable ScrollOwner() const noexcept;
    void ScrollOwner(Windows::Foundation::IInspectable const& value) const noexcept;
    void LineUp() const;
    void LineDown() const;
    void LineLeft() const;
    void LineRight() const;
    void PageUp() const;
    void PageDown() const;
    void PageLeft() const;
    void PageRight() const;
    void MouseWheelUp() const;
    void MouseWheelDown() const;
    void MouseWheelLeft() const;
    void MouseWheelRight() const;
    void SetHorizontalOffset(double offset) const;
    void SetVerticalOffset(double offset) const;
    Windows::Foundation::Rect MakeVisible(Windows::UI::Xaml::UIElement const& visual, Windows::Foundation::Rect const& rectangle) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollContentPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollContentPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewer
{
    Windows::UI::Xaml::Controls::ScrollBarVisibility HorizontalScrollBarVisibility() const noexcept;
    void HorizontalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility const& value) const noexcept;
    Windows::UI::Xaml::Controls::ScrollBarVisibility VerticalScrollBarVisibility() const noexcept;
    void VerticalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility const& value) const noexcept;
    bool IsHorizontalRailEnabled() const noexcept;
    void IsHorizontalRailEnabled(bool value) const noexcept;
    bool IsVerticalRailEnabled() const noexcept;
    void IsVerticalRailEnabled(bool value) const noexcept;
    bool IsHorizontalScrollChainingEnabled() const noexcept;
    void IsHorizontalScrollChainingEnabled(bool value) const noexcept;
    bool IsVerticalScrollChainingEnabled() const noexcept;
    void IsVerticalScrollChainingEnabled(bool value) const noexcept;
    bool IsZoomChainingEnabled() const noexcept;
    void IsZoomChainingEnabled(bool value) const noexcept;
    bool IsScrollInertiaEnabled() const noexcept;
    void IsScrollInertiaEnabled(bool value) const noexcept;
    bool IsZoomInertiaEnabled() const noexcept;
    void IsZoomInertiaEnabled(bool value) const noexcept;
    Windows::UI::Xaml::Controls::ScrollMode HorizontalScrollMode() const noexcept;
    void HorizontalScrollMode(Windows::UI::Xaml::Controls::ScrollMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::ScrollMode VerticalScrollMode() const noexcept;
    void VerticalScrollMode(Windows::UI::Xaml::Controls::ScrollMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::ZoomMode ZoomMode() const noexcept;
    void ZoomMode(Windows::UI::Xaml::Controls::ZoomMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment HorizontalSnapPointsAlignment() const noexcept;
    void HorizontalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment VerticalSnapPointsAlignment() const noexcept;
    void VerticalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment const& value) const noexcept;
    Windows::UI::Xaml::Controls::SnapPointsType HorizontalSnapPointsType() const noexcept;
    void HorizontalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType const& value) const noexcept;
    Windows::UI::Xaml::Controls::SnapPointsType VerticalSnapPointsType() const noexcept;
    void VerticalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType const& value) const noexcept;
    Windows::UI::Xaml::Controls::SnapPointsType ZoomSnapPointsType() const noexcept;
    void ZoomSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType const& value) const noexcept;
    double HorizontalOffset() const noexcept;
    double ViewportWidth() const noexcept;
    double ScrollableWidth() const noexcept;
    Windows::UI::Xaml::Visibility ComputedHorizontalScrollBarVisibility() const noexcept;
    double ExtentWidth() const noexcept;
    double VerticalOffset() const noexcept;
    double ViewportHeight() const noexcept;
    double ScrollableHeight() const noexcept;
    Windows::UI::Xaml::Visibility ComputedVerticalScrollBarVisibility() const noexcept;
    double ExtentHeight() const noexcept;
    float MinZoomFactor() const noexcept;
    void MinZoomFactor(float value) const noexcept;
    float MaxZoomFactor() const noexcept;
    void MaxZoomFactor(float value) const noexcept;
    float ZoomFactor() const noexcept;
    Windows::Foundation::Collections::IVector<float> ZoomSnapPoints() const noexcept;
    event_token ViewChanged(Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::ScrollViewerViewChangedEventArgs> const& value) const;
    using ViewChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IScrollViewer>;
    ViewChanged_revoker ViewChanged(auto_revoke_t, Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::ScrollViewerViewChangedEventArgs> const& value) const;
    void ViewChanged(event_token const& token) const;
    [[deprecated("ScrollToHorizontalOffset may be altered or unavailable for releases after Windows 8.1. Instead, use ChangeView.")]] void ScrollToHorizontalOffset(double offset) const;
    [[deprecated("ScrollToVerticalOffset may be altered or unavailable for releases after Windows 8.1. Instead, use ChangeView.")]] void ScrollToVerticalOffset(double offset) const;
    [[deprecated("ZoomToFactor may be altered or unavailable for releases after Windows 8.1. Instead, use ChangeView.")]] void ZoomToFactor(float factor) const;
    void InvalidateScrollInfo() const;
    bool IsDeferredScrollingEnabled() const noexcept;
    void IsDeferredScrollingEnabled(bool value) const noexcept;
    bool BringIntoViewOnFocusChange() const noexcept;
    void BringIntoViewOnFocusChange(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewer> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewer<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewer2
{
    Windows::UI::Xaml::UIElement TopLeftHeader() const noexcept;
    void TopLeftHeader(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::UIElement LeftHeader() const noexcept;
    void LeftHeader(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::UIElement TopHeader() const noexcept;
    void TopHeader(Windows::UI::Xaml::UIElement const& value) const noexcept;
    event_token ViewChanging(Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::ScrollViewerViewChangingEventArgs> const& value) const;
    using ViewChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::IScrollViewer2>;
    ViewChanging_revoker ViewChanging(auto_revoke_t, Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::ScrollViewerViewChangingEventArgs> const& value) const;
    void ViewChanging(event_token const& token) const;
    bool ChangeView(optional<double> const& horizontalOffset, optional<double> const& verticalOffset, optional<float> const& zoomFactor) const;
    bool ChangeView(optional<double> const& horizontalOffset, optional<double> const& verticalOffset, optional<float> const& zoomFactor, bool disableAnimation) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewer2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewer2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewer3
{
    event_token DirectManipulationStarted(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using DirectManipulationStarted_revoker = event_revoker<Windows::UI::Xaml::Controls::IScrollViewer3>;
    DirectManipulationStarted_revoker DirectManipulationStarted(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void DirectManipulationStarted(event_token const& token) const;
    event_token DirectManipulationCompleted(Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    using DirectManipulationCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IScrollViewer3>;
    DirectManipulationCompleted_revoker DirectManipulationCompleted(auto_revoke_t, Windows::Foundation::EventHandler<Windows::Foundation::IInspectable> const& value) const;
    void DirectManipulationCompleted(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewer3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewer3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewerStatics
{
    Windows::UI::Xaml::DependencyProperty HorizontalSnapPointsAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalSnapPointsAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalSnapPointsTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalSnapPointsTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ZoomSnapPointsTypeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ViewportWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ScrollableWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ComputedHorizontalScrollBarVisibilityProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ExtentWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ViewportHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ScrollableHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ComputedVerticalScrollBarVisibilityProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ExtentHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinZoomFactorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxZoomFactorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ZoomFactorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ZoomSnapPointsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalScrollBarVisibilityProperty() const noexcept;
    Windows::UI::Xaml::Controls::ScrollBarVisibility GetHorizontalScrollBarVisibility(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetHorizontalScrollBarVisibility(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::ScrollBarVisibility const& horizontalScrollBarVisibility) const;
    Windows::UI::Xaml::DependencyProperty VerticalScrollBarVisibilityProperty() const noexcept;
    Windows::UI::Xaml::Controls::ScrollBarVisibility GetVerticalScrollBarVisibility(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetVerticalScrollBarVisibility(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::ScrollBarVisibility const& verticalScrollBarVisibility) const;
    Windows::UI::Xaml::DependencyProperty IsHorizontalRailEnabledProperty() const noexcept;
    bool GetIsHorizontalRailEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsHorizontalRailEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isHorizontalRailEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsVerticalRailEnabledProperty() const noexcept;
    bool GetIsVerticalRailEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsVerticalRailEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isVerticalRailEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsHorizontalScrollChainingEnabledProperty() const noexcept;
    bool GetIsHorizontalScrollChainingEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsHorizontalScrollChainingEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isHorizontalScrollChainingEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsVerticalScrollChainingEnabledProperty() const noexcept;
    bool GetIsVerticalScrollChainingEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsVerticalScrollChainingEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isVerticalScrollChainingEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsZoomChainingEnabledProperty() const noexcept;
    bool GetIsZoomChainingEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsZoomChainingEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isZoomChainingEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsScrollInertiaEnabledProperty() const noexcept;
    bool GetIsScrollInertiaEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsScrollInertiaEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isScrollInertiaEnabled) const;
    Windows::UI::Xaml::DependencyProperty IsZoomInertiaEnabledProperty() const noexcept;
    bool GetIsZoomInertiaEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsZoomInertiaEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isZoomInertiaEnabled) const;
    Windows::UI::Xaml::DependencyProperty HorizontalScrollModeProperty() const noexcept;
    Windows::UI::Xaml::Controls::ScrollMode GetHorizontalScrollMode(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetHorizontalScrollMode(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::ScrollMode const& horizontalScrollMode) const;
    Windows::UI::Xaml::DependencyProperty VerticalScrollModeProperty() const noexcept;
    Windows::UI::Xaml::Controls::ScrollMode GetVerticalScrollMode(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetVerticalScrollMode(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::ScrollMode const& verticalScrollMode) const;
    Windows::UI::Xaml::DependencyProperty ZoomModeProperty() const noexcept;
    Windows::UI::Xaml::Controls::ZoomMode GetZoomMode(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetZoomMode(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::ZoomMode const& zoomMode) const;
    Windows::UI::Xaml::DependencyProperty IsDeferredScrollingEnabledProperty() const noexcept;
    bool GetIsDeferredScrollingEnabled(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetIsDeferredScrollingEnabled(Windows::UI::Xaml::DependencyObject const& element, bool isDeferredScrollingEnabled) const;
    Windows::UI::Xaml::DependencyProperty BringIntoViewOnFocusChangeProperty() const noexcept;
    bool GetBringIntoViewOnFocusChange(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetBringIntoViewOnFocusChange(Windows::UI::Xaml::DependencyObject const& element, bool bringIntoViewOnFocusChange) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewerStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewerStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewerStatics2
{
    Windows::UI::Xaml::DependencyProperty TopLeftHeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LeftHeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TopHeaderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewerStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewerStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewerView
{
    double HorizontalOffset() const noexcept;
    double VerticalOffset() const noexcept;
    float ZoomFactor() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewerView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewerView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewerViewChangedEventArgs
{
    bool IsIntermediate() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewerViewChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IScrollViewerViewChangingEventArgs
{
    Windows::UI::Xaml::Controls::ScrollViewerView NextView() const noexcept;
    Windows::UI::Xaml::Controls::ScrollViewerView FinalView() const noexcept;
    bool IsInertial() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IScrollViewerViewChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBox
{
    bool SearchHistoryEnabled() const noexcept;
    void SearchHistoryEnabled(bool value) const noexcept;
    hstring SearchHistoryContext() const noexcept;
    void SearchHistoryContext(param::hstring const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    hstring QueryText() const noexcept;
    void QueryText(param::hstring const& value) const noexcept;
    bool FocusOnKeyboardInput() const noexcept;
    void FocusOnKeyboardInput(bool value) const noexcept;
    bool ChooseSuggestionOnEnter() const noexcept;
    void ChooseSuggestionOnEnter(bool value) const noexcept;
    event_token QueryChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxQueryChangedEventArgs> const& value) const;
    using QueryChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ISearchBox>;
    QueryChanged_revoker QueryChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxQueryChangedEventArgs> const& value) const;
    void QueryChanged(event_token const& token) const;
    event_token SuggestionsRequested(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxSuggestionsRequestedEventArgs> const& value) const;
    using SuggestionsRequested_revoker = event_revoker<Windows::UI::Xaml::Controls::ISearchBox>;
    SuggestionsRequested_revoker SuggestionsRequested(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxSuggestionsRequestedEventArgs> const& value) const;
    void SuggestionsRequested(event_token const& token) const;
    event_token QuerySubmitted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxQuerySubmittedEventArgs> const& value) const;
    using QuerySubmitted_revoker = event_revoker<Windows::UI::Xaml::Controls::ISearchBox>;
    QuerySubmitted_revoker QuerySubmitted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxQuerySubmittedEventArgs> const& value) const;
    void QuerySubmitted(event_token const& token) const;
    event_token ResultSuggestionChosen(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxResultSuggestionChosenEventArgs> const& value) const;
    using ResultSuggestionChosen_revoker = event_revoker<Windows::UI::Xaml::Controls::ISearchBox>;
    ResultSuggestionChosen_revoker ResultSuggestionChosen(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::Controls::SearchBoxResultSuggestionChosenEventArgs> const& value) const;
    void ResultSuggestionChosen(event_token const& token) const;
    event_token PrepareForFocusOnKeyboardInput(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::RoutedEventArgs> const& value) const;
    using PrepareForFocusOnKeyboardInput_revoker = event_revoker<Windows::UI::Xaml::Controls::ISearchBox>;
    PrepareForFocusOnKeyboardInput_revoker PrepareForFocusOnKeyboardInput(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SearchBox, Windows::UI::Xaml::RoutedEventArgs> const& value) const;
    void PrepareForFocusOnKeyboardInput(event_token const& token) const;
    void SetLocalContentSuggestionSettings(Windows::ApplicationModel::Search::LocalContentSuggestionSettings const& settings) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxFactory
{
    Windows::UI::Xaml::Controls::SearchBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxQueryChangedEventArgs
{
    hstring QueryText() const noexcept;
    hstring Language() const noexcept;
    Windows::ApplicationModel::Search::SearchQueryLinguisticDetails LinguisticDetails() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxQueryChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxQuerySubmittedEventArgs
{
    hstring QueryText() const noexcept;
    hstring Language() const noexcept;
    Windows::ApplicationModel::Search::SearchQueryLinguisticDetails LinguisticDetails() const noexcept;
    Windows::System::VirtualKeyModifiers KeyModifiers() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxQuerySubmittedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxResultSuggestionChosenEventArgs
{
    hstring Tag() const noexcept;
    Windows::System::VirtualKeyModifiers KeyModifiers() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxResultSuggestionChosenEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxStatics
{
    Windows::UI::Xaml::DependencyProperty SearchHistoryEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SearchHistoryContextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty QueryTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FocusOnKeyboardInputProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ChooseSuggestionOnEnterProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISearchBoxSuggestionsRequestedEventArgs
{
    hstring QueryText() const noexcept;
    hstring Language() const noexcept;
    Windows::ApplicationModel::Search::SearchQueryLinguisticDetails LinguisticDetails() const noexcept;
    Windows::ApplicationModel::Search::SearchSuggestionsRequest Request() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISearchBoxSuggestionsRequestedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISectionsInViewChangedEventArgs
{
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::HubSection> AddedSections() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::HubSection> RemovedSections() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISectionsInViewChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISectionsInViewChangedEventArgsFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgsFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISectionsInViewChangedEventArgsFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISelectionChangedEventArgs
{
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> AddedItems() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::Foundation::IInspectable> RemovedItems() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISelectionChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISelectionChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISelectionChangedEventArgsFactory
{
    Windows::UI::Xaml::Controls::SelectionChangedEventArgs CreateInstanceWithRemovedItemsAndAddedItems(param::vector<Windows::Foundation::IInspectable> const& removedItems, param::vector<Windows::Foundation::IInspectable> const& addedItems, Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISelectionChangedEventArgsFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISelectionChangedEventArgsFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISemanticZoom
{
    Windows::UI::Xaml::Controls::ISemanticZoomInformation ZoomedInView() const noexcept;
    void ZoomedInView(Windows::UI::Xaml::Controls::ISemanticZoomInformation const& value) const noexcept;
    Windows::UI::Xaml::Controls::ISemanticZoomInformation ZoomedOutView() const noexcept;
    void ZoomedOutView(Windows::UI::Xaml::Controls::ISemanticZoomInformation const& value) const noexcept;
    bool IsZoomedInViewActive() const noexcept;
    void IsZoomedInViewActive(bool value) const noexcept;
    bool CanChangeViews() const noexcept;
    void CanChangeViews(bool value) const noexcept;
    event_token ViewChangeStarted(Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler const& value) const;
    using ViewChangeStarted_revoker = event_revoker<Windows::UI::Xaml::Controls::ISemanticZoom>;
    ViewChangeStarted_revoker ViewChangeStarted(auto_revoke_t, Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler const& value) const;
    void ViewChangeStarted(event_token const& token) const;
    event_token ViewChangeCompleted(Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler const& value) const;
    using ViewChangeCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::ISemanticZoom>;
    ViewChangeCompleted_revoker ViewChangeCompleted(auto_revoke_t, Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler const& value) const;
    void ViewChangeCompleted(event_token const& token) const;
    void ToggleActiveView() const;
    bool IsZoomOutButtonEnabled() const noexcept;
    void IsZoomOutButtonEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISemanticZoom> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISemanticZoom<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISemanticZoomInformation
{
    Windows::UI::Xaml::Controls::SemanticZoom SemanticZoomOwner() const noexcept;
    void SemanticZoomOwner(Windows::UI::Xaml::Controls::SemanticZoom const& value) const noexcept;
    bool IsActiveView() const noexcept;
    void IsActiveView(bool value) const noexcept;
    bool IsZoomedInView() const noexcept;
    void IsZoomedInView(bool value) const noexcept;
    void InitializeViewChange() const;
    void CompleteViewChange() const;
    void MakeVisible(Windows::UI::Xaml::Controls::SemanticZoomLocation const& item) const;
    void StartViewChangeFrom(Windows::UI::Xaml::Controls::SemanticZoomLocation const& source, Windows::UI::Xaml::Controls::SemanticZoomLocation const& destination) const;
    void StartViewChangeTo(Windows::UI::Xaml::Controls::SemanticZoomLocation const& source, Windows::UI::Xaml::Controls::SemanticZoomLocation const& destination) const;
    void CompleteViewChangeFrom(Windows::UI::Xaml::Controls::SemanticZoomLocation const& source, Windows::UI::Xaml::Controls::SemanticZoomLocation const& destination) const;
    void CompleteViewChangeTo(Windows::UI::Xaml::Controls::SemanticZoomLocation const& source, Windows::UI::Xaml::Controls::SemanticZoomLocation const& destination) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISemanticZoomInformation> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISemanticZoomInformation<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISemanticZoomLocation
{
    Windows::Foundation::IInspectable Item() const noexcept;
    void Item(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::Foundation::Rect Bounds() const noexcept;
    void Bounds(Windows::Foundation::Rect const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISemanticZoomLocation> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISemanticZoomLocation<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISemanticZoomStatics
{
    Windows::UI::Xaml::DependencyProperty ZoomedInViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ZoomedOutViewProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomedInViewActiveProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanChangeViewsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsZoomOutButtonEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISemanticZoomStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISemanticZoomStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISemanticZoomViewChangedEventArgs
{
    bool IsSourceZoomedInView() const noexcept;
    void IsSourceZoomedInView(bool value) const noexcept;
    Windows::UI::Xaml::Controls::SemanticZoomLocation SourceItem() const noexcept;
    void SourceItem(Windows::UI::Xaml::Controls::SemanticZoomLocation const& value) const noexcept;
    Windows::UI::Xaml::Controls::SemanticZoomLocation DestinationItem() const noexcept;
    void DestinationItem(Windows::UI::Xaml::Controls::SemanticZoomLocation const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISemanticZoomViewChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISettingsFlyout
{
    hstring Title() const noexcept;
    void Title(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush HeaderBackground() const noexcept;
    void HeaderBackground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush HeaderForeground() const noexcept;
    void HeaderForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::ImageSource IconSource() const noexcept;
    void IconSource(Windows::UI::Xaml::Media::ImageSource const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SettingsFlyoutTemplateSettings TemplateSettings() const noexcept;
    event_token BackClick(Windows::UI::Xaml::Controls::BackClickEventHandler const& value) const;
    using BackClick_revoker = event_revoker<Windows::UI::Xaml::Controls::ISettingsFlyout>;
    BackClick_revoker BackClick(auto_revoke_t, Windows::UI::Xaml::Controls::BackClickEventHandler const& value) const;
    void BackClick(event_token const& token) const;
    void Show() const;
    void ShowIndependent() const;
    void Hide() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISettingsFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISettingsFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISettingsFlyoutFactory
{
    Windows::UI::Xaml::Controls::SettingsFlyout CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISettingsFlyoutFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISettingsFlyoutFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISettingsFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty TitleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderBackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IconSourceProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISettingsFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISettingsFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISlider
{
    double IntermediateValue() const noexcept;
    void IntermediateValue(double value) const noexcept;
    double StepFrequency() const noexcept;
    void StepFrequency(double value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SliderSnapsTo SnapsTo() const noexcept;
    void SnapsTo(Windows::UI::Xaml::Controls::Primitives::SliderSnapsTo const& value) const noexcept;
    double TickFrequency() const noexcept;
    void TickFrequency(double value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::TickPlacement TickPlacement() const noexcept;
    void TickPlacement(Windows::UI::Xaml::Controls::Primitives::TickPlacement const& value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    bool IsDirectionReversed() const noexcept;
    void IsDirectionReversed(bool value) const noexcept;
    bool IsThumbToolTipEnabled() const noexcept;
    void IsThumbToolTipEnabled(bool value) const noexcept;
    Windows::UI::Xaml::Data::IValueConverter ThumbToolTipValueConverter() const noexcept;
    void ThumbToolTipValueConverter(Windows::UI::Xaml::Data::IValueConverter const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISlider> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISlider<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISlider2
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISlider2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISlider2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISliderFactory
{
    Windows::UI::Xaml::Controls::Slider CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISliderFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISliderFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISliderStatics
{
    Windows::UI::Xaml::DependencyProperty IntermediateValueProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StepFrequencyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SnapsToProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TickFrequencyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TickPlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsDirectionReversedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsThumbToolTipEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ThumbToolTipValueConverterProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISliderStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISliderStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISliderStatics2
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISliderStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISliderStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitView
{
    Windows::UI::Xaml::UIElement Content() const noexcept;
    void Content(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::UIElement Pane() const noexcept;
    void Pane(Windows::UI::Xaml::UIElement const& value) const noexcept;
    bool IsPaneOpen() const noexcept;
    void IsPaneOpen(bool value) const noexcept;
    double OpenPaneLength() const noexcept;
    void OpenPaneLength(double value) const noexcept;
    double CompactPaneLength() const noexcept;
    void CompactPaneLength(double value) const noexcept;
    Windows::UI::Xaml::Controls::SplitViewPanePlacement PanePlacement() const noexcept;
    void PanePlacement(Windows::UI::Xaml::Controls::SplitViewPanePlacement const& value) const noexcept;
    Windows::UI::Xaml::Controls::SplitViewDisplayMode DisplayMode() const noexcept;
    void DisplayMode(Windows::UI::Xaml::Controls::SplitViewDisplayMode const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::SplitViewTemplateSettings TemplateSettings() const noexcept;
    Windows::UI::Xaml::Media::Brush PaneBackground() const noexcept;
    void PaneBackground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    event_token PaneClosing(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::UI::Xaml::Controls::SplitViewPaneClosingEventArgs> const& value) const;
    using PaneClosing_revoker = event_revoker<Windows::UI::Xaml::Controls::ISplitView>;
    PaneClosing_revoker PaneClosing(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::UI::Xaml::Controls::SplitViewPaneClosingEventArgs> const& value) const;
    void PaneClosing(event_token const& token) const;
    event_token PaneClosed(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    using PaneClosed_revoker = event_revoker<Windows::UI::Xaml::Controls::ISplitView>;
    PaneClosed_revoker PaneClosed(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    void PaneClosed(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitView2
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitView2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitView2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitView3
{
    event_token PaneOpening(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    using PaneOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::ISplitView3>;
    PaneOpening_revoker PaneOpening(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    void PaneOpening(event_token const& token) const;
    event_token PaneOpened(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    using PaneOpened_revoker = event_revoker<Windows::UI::Xaml::Controls::ISplitView3>;
    PaneOpened_revoker PaneOpened(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SplitView, Windows::Foundation::IInspectable> const& value) const;
    void PaneOpened(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitView3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitView3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitViewFactory
{
    Windows::UI::Xaml::Controls::SplitView CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitViewFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitViewFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitViewPaneClosingEventArgs
{
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitViewPaneClosingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitViewStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaneProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsPaneOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OpenPaneLengthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CompactPaneLengthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PanePlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DisplayModeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TemplateSettingsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaneBackgroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitViewStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitViewStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISplitViewStatics2
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISplitViewStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISplitViewStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanel
{
    bool AreScrollSnapPointsRegular() const noexcept;
    void AreScrollSnapPointsRegular(bool value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanel2
{
    Windows::UI::Xaml::Media::Brush BorderBrush() const noexcept;
    void BorderBrush(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Thickness BorderThickness() const noexcept;
    void BorderThickness(Windows::UI::Xaml::Thickness const& value) const noexcept;
    Windows::UI::Xaml::CornerRadius CornerRadius() const noexcept;
    void CornerRadius(Windows::UI::Xaml::CornerRadius const& value) const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanel2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanel2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanel4
{
    double Spacing() const noexcept;
    void Spacing(double value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanel4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanel4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanelFactory
{
    Windows::UI::Xaml::Controls::StackPanel CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanelStatics
{
    Windows::UI::Xaml::DependencyProperty AreScrollSnapPointsRegularProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanelStatics2
{
    Windows::UI::Xaml::DependencyProperty BorderBrushProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BorderThicknessProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CornerRadiusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanelStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanelStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStackPanelStatics4
{
    Windows::UI::Xaml::DependencyProperty SpacingProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStackPanelStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStackPanelStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStyleSelector
{
    Windows::UI::Xaml::Style SelectStyle(Windows::Foundation::IInspectable const& item, Windows::UI::Xaml::DependencyObject const& container) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStyleSelector> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStyleSelector<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStyleSelectorFactory
{
    Windows::UI::Xaml::Controls::StyleSelector CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStyleSelectorFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStyleSelectorFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IStyleSelectorOverrides
{
    Windows::UI::Xaml::Style SelectStyleCore(Windows::Foundation::IInspectable const& item, Windows::UI::Xaml::DependencyObject const& container) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IStyleSelectorOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IStyleSelectorOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanel
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanel2
{
    Windows::UI::Core::CoreIndependentInputSource CreateCoreIndependentInputSource(Windows::UI::Core::CoreInputDeviceTypes const& deviceTypes) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanel2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanelFactory
{
    Windows::UI::Xaml::Controls::SwapChainBackgroundPanel CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainBackgroundPanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainPanel
{
    float CompositionScaleX() const noexcept;
    float CompositionScaleY() const noexcept;
    event_token CompositionScaleChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SwapChainPanel, Windows::Foundation::IInspectable> const& value) const;
    using CompositionScaleChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ISwapChainPanel>;
    CompositionScaleChanged_revoker CompositionScaleChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SwapChainPanel, Windows::Foundation::IInspectable> const& value) const;
    void CompositionScaleChanged(event_token const& token) const;
    Windows::UI::Core::CoreIndependentInputSource CreateCoreIndependentInputSource(Windows::UI::Core::CoreInputDeviceTypes const& deviceTypes) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainPanelFactory
{
    Windows::UI::Xaml::Controls::SwapChainPanel CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainPanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainPanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwapChainPanelStatics
{
    Windows::UI::Xaml::DependencyProperty CompositionScaleXProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CompositionScaleYProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwapChainPanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwapChainPanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeControl
{
    Windows::UI::Xaml::Controls::SwipeItems LeftItems() const noexcept;
    void LeftItems(Windows::UI::Xaml::Controls::SwipeItems const& value) const noexcept;
    Windows::UI::Xaml::Controls::SwipeItems RightItems() const noexcept;
    void RightItems(Windows::UI::Xaml::Controls::SwipeItems const& value) const noexcept;
    Windows::UI::Xaml::Controls::SwipeItems TopItems() const noexcept;
    void TopItems(Windows::UI::Xaml::Controls::SwipeItems const& value) const noexcept;
    Windows::UI::Xaml::Controls::SwipeItems BottomItems() const noexcept;
    void BottomItems(Windows::UI::Xaml::Controls::SwipeItems const& value) const noexcept;
    void Close() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeControlFactory
{
    Windows::UI::Xaml::Controls::SwipeControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeControlStatics
{
    Windows::UI::Xaml::DependencyProperty LeftItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RightItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TopItemsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BottomItemsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItem
{
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Controls::IconSource IconSource() const noexcept;
    void IconSource(Windows::UI::Xaml::Controls::IconSource const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Background() const noexcept;
    void Background(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::Input::ICommand Command() const noexcept;
    void Command(Windows::UI::Xaml::Input::ICommand const& value) const noexcept;
    Windows::Foundation::IInspectable CommandParameter() const noexcept;
    void CommandParameter(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked BehaviorOnInvoked() const noexcept;
    void BehaviorOnInvoked(Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked const& value) const noexcept;
    event_token Invoked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SwipeItem, Windows::UI::Xaml::Controls::SwipeItemInvokedEventArgs> const& value) const;
    using Invoked_revoker = event_revoker<Windows::UI::Xaml::Controls::ISwipeItem>;
    Invoked_revoker Invoked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::SwipeItem, Windows::UI::Xaml::Controls::SwipeItemInvokedEventArgs> const& value) const;
    void Invoked(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItemFactory
{
    Windows::UI::Xaml::Controls::SwipeItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItemInvokedEventArgs
{
    Windows::UI::Xaml::Controls::SwipeControl SwipeControl() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItemInvokedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItemStatics
{
    Windows::UI::Xaml::DependencyProperty IconSourceProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BackgroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CommandProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CommandParameterProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty BehaviorOnInvokedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItems
{
    Windows::UI::Xaml::Controls::SwipeMode Mode() const noexcept;
    void Mode(Windows::UI::Xaml::Controls::SwipeMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItems> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItems<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItemsFactory
{
    Windows::UI::Xaml::Controls::SwipeItems CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItemsFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItemsFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISwipeItemsStatics
{
    Windows::UI::Xaml::DependencyProperty ModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISwipeItemsStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISwipeItemsStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIcon
{
    Windows::UI::Xaml::Controls::Symbol Symbol() const noexcept;
    void Symbol(Windows::UI::Xaml::Controls::Symbol const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIcon> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIcon<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIconFactory
{
    Windows::UI::Xaml::Controls::SymbolIcon CreateInstanceWithSymbol(Windows::UI::Xaml::Controls::Symbol const& symbol) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIconFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIconFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIconSource
{
    Windows::UI::Xaml::Controls::Symbol Symbol() const noexcept;
    void Symbol(Windows::UI::Xaml::Controls::Symbol const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIconSource> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIconSource<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIconSourceFactory
{
    Windows::UI::Xaml::Controls::SymbolIconSource CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIconSourceFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIconSourceFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIconSourceStatics
{
    Windows::UI::Xaml::DependencyProperty SymbolProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIconSourceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIconSourceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ISymbolIconStatics
{
    Windows::UI::Xaml::DependencyProperty SymbolProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ISymbolIconStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ISymbolIconStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock
{
    double FontSize() const noexcept;
    void FontSize(double value) const noexcept;
    Windows::UI::Xaml::Media::FontFamily FontFamily() const noexcept;
    void FontFamily(Windows::UI::Xaml::Media::FontFamily const& value) const noexcept;
    Windows::UI::Text::FontWeight FontWeight() const noexcept;
    void FontWeight(Windows::UI::Text::FontWeight const& value) const noexcept;
    Windows::UI::Text::FontStyle FontStyle() const noexcept;
    void FontStyle(Windows::UI::Text::FontStyle const& value) const noexcept;
    Windows::UI::Text::FontStretch FontStretch() const noexcept;
    void FontStretch(Windows::UI::Text::FontStretch const& value) const noexcept;
    int32_t CharacterSpacing() const noexcept;
    void CharacterSpacing(int32_t value) const noexcept;
    Windows::UI::Xaml::Media::Brush Foreground() const noexcept;
    void Foreground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    Windows::UI::Xaml::TextWrapping TextWrapping() const noexcept;
    void TextWrapping(Windows::UI::Xaml::TextWrapping const& value) const noexcept;
    Windows::UI::Xaml::TextTrimming TextTrimming() const noexcept;
    void TextTrimming(Windows::UI::Xaml::TextTrimming const& value) const noexcept;
    Windows::UI::Xaml::TextAlignment TextAlignment() const noexcept;
    void TextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Documents::InlineCollection Inlines() const noexcept;
    Windows::UI::Xaml::Thickness Padding() const noexcept;
    void Padding(Windows::UI::Xaml::Thickness const& value) const noexcept;
    double LineHeight() const noexcept;
    void LineHeight(double value) const noexcept;
    Windows::UI::Xaml::LineStackingStrategy LineStackingStrategy() const noexcept;
    void LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy const& value) const noexcept;
    bool IsTextSelectionEnabled() const noexcept;
    void IsTextSelectionEnabled(bool value) const noexcept;
    hstring SelectedText() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentStart() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer ContentEnd() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer SelectionStart() const noexcept;
    Windows::UI::Xaml::Documents::TextPointer SelectionEnd() const noexcept;
    double BaselineOffset() const noexcept;
    event_token SelectionChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBlock>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token ContextMenuOpening(Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    using ContextMenuOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBlock>;
    ContextMenuOpening_revoker ContextMenuOpening(auto_revoke_t, Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    void ContextMenuOpening(event_token const& token) const;
    void SelectAll() const;
    void Select(Windows::UI::Xaml::Documents::TextPointer const& start, Windows::UI::Xaml::Documents::TextPointer const& end) const;
    bool Focus(Windows::UI::Xaml::FocusState const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock2
{
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColor() const noexcept;
    void SelectionHighlightColor(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    int32_t MaxLines() const noexcept;
    void MaxLines(int32_t value) const noexcept;
    Windows::UI::Xaml::TextLineBounds TextLineBounds() const noexcept;
    void TextLineBounds(Windows::UI::Xaml::TextLineBounds const& value) const noexcept;
    Windows::UI::Xaml::OpticalMarginAlignment OpticalMarginAlignment() const noexcept;
    void OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment const& value) const noexcept;
    bool IsColorFontEnabled() const noexcept;
    void IsColorFontEnabled(bool value) const noexcept;
    Windows::UI::Xaml::TextReadingOrder TextReadingOrder() const noexcept;
    void TextReadingOrder(Windows::UI::Xaml::TextReadingOrder const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock3
{
    bool IsTextScaleFactorEnabled() const noexcept;
    void IsTextScaleFactorEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock4
{
    Windows::UI::Composition::CompositionBrush GetAlphaMask() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock5
{
    Windows::UI::Text::TextDecorations TextDecorations() const noexcept;
    void TextDecorations(Windows::UI::Text::TextDecorations const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlock6
{
    bool IsTextTrimmed() const noexcept;
    Windows::UI::Xaml::TextAlignment HorizontalTextAlignment() const noexcept;
    void HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Documents::TextHighlighter> TextHighlighters() const noexcept;
    event_token IsTextTrimmedChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBlock, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    using IsTextTrimmedChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBlock6>;
    IsTextTrimmedChanged_revoker IsTextTrimmedChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBlock, Windows::UI::Xaml::Controls::IsTextTrimmedChangedEventArgs> const& value) const;
    void IsTextTrimmedChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlock6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlock6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlockStatics
{
    Windows::UI::Xaml::DependencyProperty FontSizeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontFamilyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontWeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStyleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty FontStretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterSpacingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ForegroundProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextWrappingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextTrimmingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PaddingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty LineStackingStrategyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextSelectionEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectedTextProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlockStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlockStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlockStatics2
{
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxLinesProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextLineBoundsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OpticalMarginAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorFontEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextReadingOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlockStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlockStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlockStatics3
{
    Windows::UI::Xaml::DependencyProperty IsTextScaleFactorEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlockStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlockStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlockStatics5
{
    Windows::UI::Xaml::DependencyProperty TextDecorationsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlockStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlockStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBlockStatics6
{
    Windows::UI::Xaml::DependencyProperty IsTextTrimmedProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalTextAlignmentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBlockStatics6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBlockStatics6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox
{
    hstring Text() const noexcept;
    void Text(param::hstring const& value) const noexcept;
    hstring SelectedText() const noexcept;
    void SelectedText(param::hstring const& value) const noexcept;
    int32_t SelectionLength() const noexcept;
    void SelectionLength(int32_t value) const noexcept;
    int32_t SelectionStart() const noexcept;
    void SelectionStart(int32_t value) const noexcept;
    int32_t MaxLength() const noexcept;
    void MaxLength(int32_t value) const noexcept;
    bool IsReadOnly() const noexcept;
    void IsReadOnly(bool value) const noexcept;
    bool AcceptsReturn() const noexcept;
    void AcceptsReturn(bool value) const noexcept;
    Windows::UI::Xaml::TextAlignment TextAlignment() const noexcept;
    void TextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::UI::Xaml::TextWrapping TextWrapping() const noexcept;
    void TextWrapping(Windows::UI::Xaml::TextWrapping const& value) const noexcept;
    bool IsSpellCheckEnabled() const noexcept;
    void IsSpellCheckEnabled(bool value) const noexcept;
    bool IsTextPredictionEnabled() const noexcept;
    void IsTextPredictionEnabled(bool value) const noexcept;
    Windows::UI::Xaml::Input::InputScope InputScope() const noexcept;
    void InputScope(Windows::UI::Xaml::Input::InputScope const& value) const noexcept;
    event_token TextChanged(Windows::UI::Xaml::Controls::TextChangedEventHandler const& value) const;
    using TextChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox>;
    TextChanged_revoker TextChanged(auto_revoke_t, Windows::UI::Xaml::Controls::TextChangedEventHandler const& value) const;
    void TextChanged(event_token const& token) const;
    event_token SelectionChanged(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using SelectionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox>;
    SelectionChanged_revoker SelectionChanged(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void SelectionChanged(event_token const& token) const;
    event_token ContextMenuOpening(Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    using ContextMenuOpening_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox>;
    ContextMenuOpening_revoker ContextMenuOpening(auto_revoke_t, Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler const& value) const;
    void ContextMenuOpening(event_token const& token) const;
    void Select(int32_t start, int32_t length) const;
    void SelectAll() const;
    Windows::Foundation::Rect GetRectFromCharacterIndex(int32_t charIndex, bool trailingEdge) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox2
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring PlaceholderText() const noexcept;
    void PlaceholderText(param::hstring const& value) const noexcept;
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColor() const noexcept;
    void SelectionHighlightColor(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
    bool PreventKeyboardDisplayOnProgrammaticFocus() const noexcept;
    void PreventKeyboardDisplayOnProgrammaticFocus(bool value) const noexcept;
    bool IsColorFontEnabled() const noexcept;
    void IsColorFontEnabled(bool value) const noexcept;
    event_token Paste(Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    using Paste_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox2>;
    Paste_revoker Paste(auto_revoke_t, Windows::UI::Xaml::Controls::TextControlPasteEventHandler const& value) const;
    void Paste(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox3
{
    event_token TextCompositionStarted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs> const& value) const;
    using TextCompositionStarted_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox3>;
    TextCompositionStarted_revoker TextCompositionStarted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs> const& value) const;
    void TextCompositionStarted(event_token const& token) const;
    event_token TextCompositionChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs> const& value) const;
    using TextCompositionChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox3>;
    TextCompositionChanged_revoker TextCompositionChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs> const& value) const;
    void TextCompositionChanged(event_token const& token) const;
    event_token TextCompositionEnded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs> const& value) const;
    using TextCompositionEnded_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox3>;
    TextCompositionEnded_revoker TextCompositionEnded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs> const& value) const;
    void TextCompositionEnded(event_token const& token) const;
    Windows::UI::Xaml::TextReadingOrder TextReadingOrder() const noexcept;
    void TextReadingOrder(Windows::UI::Xaml::TextReadingOrder const& value) const noexcept;
    Windows::UI::Xaml::Controls::CandidateWindowAlignment DesiredCandidateWindowAlignment() const noexcept;
    void DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment const& value) const noexcept;
    event_token CandidateWindowBoundsChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs> const& value) const;
    using CandidateWindowBoundsChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox3>;
    CandidateWindowBoundsChanged_revoker CandidateWindowBoundsChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::CandidateWindowBoundsChangedEventArgs> const& value) const;
    void CandidateWindowBoundsChanged(event_token const& token) const;
    event_token TextChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs> const& value) const;
    using TextChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox3>;
    TextChanging_revoker TextChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs> const& value) const;
    void TextChanging(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox4
{
    Windows::Foundation::IAsyncOperation<Windows::Foundation::Collections::IVectorView<hstring>> GetLinguisticAlternativesAsync() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox5
{
    Windows::UI::Xaml::Media::SolidColorBrush SelectionHighlightColorWhenNotFocused() const noexcept;
    void SelectionHighlightColorWhenNotFocused(Windows::UI::Xaml::Media::SolidColorBrush const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBox6
{
    Windows::UI::Xaml::TextAlignment HorizontalTextAlignment() const noexcept;
    void HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment const& value) const noexcept;
    Windows::UI::Xaml::Controls::CharacterCasing CharacterCasing() const noexcept;
    void CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing const& value) const noexcept;
    Windows::UI::Xaml::Media::Brush PlaceholderForeground() const noexcept;
    void PlaceholderForeground(Windows::UI::Xaml::Media::Brush const& value) const noexcept;
    event_token CopyingToClipboard(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs> const& value) const;
    using CopyingToClipboard_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox6>;
    CopyingToClipboard_revoker CopyingToClipboard(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextControlCopyingToClipboardEventArgs> const& value) const;
    void CopyingToClipboard(event_token const& token) const;
    event_token CuttingToClipboard(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs> const& value) const;
    using CuttingToClipboard_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox6>;
    CuttingToClipboard_revoker CuttingToClipboard(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextControlCuttingToClipboardEventArgs> const& value) const;
    void CuttingToClipboard(event_token const& token) const;
    event_token BeforeTextChanging(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextBoxBeforeTextChangingEventArgs> const& value) const;
    using BeforeTextChanging_revoker = event_revoker<Windows::UI::Xaml::Controls::ITextBox6>;
    BeforeTextChanging_revoker BeforeTextChanging(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TextBox, Windows::UI::Xaml::Controls::TextBoxBeforeTextChangingEventArgs> const& value) const;
    void BeforeTextChanging(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBox6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBox6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxBeforeTextChangingEventArgs
{
    hstring NewText() const noexcept;
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxBeforeTextChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxFactory
{
    Windows::UI::Xaml::Controls::TextBox CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxStatics
{
    Windows::UI::Xaml::DependencyProperty TextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaxLengthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsReadOnlyProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty AcceptsReturnProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextWrappingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsSpellCheckEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsTextPredictionEnabledProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty InputScopeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxStatics2
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderTextProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PreventKeyboardDisplayOnProgrammaticFocusProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsColorFontEnabledProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxStatics3
{
    Windows::UI::Xaml::DependencyProperty DesiredCandidateWindowAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TextReadingOrderProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxStatics5
{
    Windows::UI::Xaml::DependencyProperty SelectionHighlightColorWhenNotFocusedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxStatics6
{
    Windows::UI::Xaml::DependencyProperty HorizontalTextAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CharacterCasingProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlaceholderForegroundProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxStatics6> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxStatics6<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxTextChangingEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxTextChangingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextBoxTextChangingEventArgs2
{
    bool IsContentChanging() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextBoxTextChangingEventArgs2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextChangedEventArgs
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextCompositionChangedEventArgs
{
    int32_t StartIndex() const noexcept;
    int32_t Length() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextCompositionChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextCompositionEndedEventArgs
{
    int32_t StartIndex() const noexcept;
    int32_t Length() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextCompositionEndedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextCompositionStartedEventArgs
{
    int32_t StartIndex() const noexcept;
    int32_t Length() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextCompositionStartedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextControlCopyingToClipboardEventArgs
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextControlCopyingToClipboardEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextControlCuttingToClipboardEventArgs
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextControlCuttingToClipboardEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITextControlPasteEventArgs
{
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITextControlPasteEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITextControlPasteEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickedEventArgs
{
    Windows::Foundation::TimeSpan OldTime() const noexcept;
    Windows::Foundation::TimeSpan NewTime() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePicker
{
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    hstring ClockIdentifier() const noexcept;
    void ClockIdentifier(param::hstring const& value) const noexcept;
    int32_t MinuteIncrement() const noexcept;
    void MinuteIncrement(int32_t value) const noexcept;
    Windows::Foundation::TimeSpan Time() const noexcept;
    void Time(Windows::Foundation::TimeSpan const& value) const noexcept;
    event_token TimeChanged(Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::TimePickerValueChangedEventArgs> const& value) const;
    using TimeChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::ITimePicker>;
    TimeChanged_revoker TimeChanged(auto_revoke_t, Windows::Foundation::EventHandler<Windows::UI::Xaml::Controls::TimePickerValueChangedEventArgs> const& value) const;
    void TimeChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePicker> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePicker<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePicker2
{
    Windows::UI::Xaml::Controls::LightDismissOverlayMode LightDismissOverlayMode() const noexcept;
    void LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePicker2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePicker2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerFactory
{
    Windows::UI::Xaml::Controls::TimePicker CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerFlyout
{
    hstring ClockIdentifier() const noexcept;
    void ClockIdentifier(param::hstring const& value) const noexcept;
    Windows::Foundation::TimeSpan Time() const noexcept;
    void Time(Windows::Foundation::TimeSpan const& value) const noexcept;
    int32_t MinuteIncrement() const noexcept;
    void MinuteIncrement(int32_t value) const noexcept;
    event_token TimePicked(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TimePickerFlyout, Windows::UI::Xaml::Controls::TimePickedEventArgs> const& value) const;
    using TimePicked_revoker = event_revoker<Windows::UI::Xaml::Controls::ITimePickerFlyout>;
    TimePicked_revoker TimePicked(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::TimePickerFlyout, Windows::UI::Xaml::Controls::TimePickedEventArgs> const& value) const;
    void TimePicked(event_token const& token) const;
    Windows::Foundation::IAsyncOperation<Windows::Foundation::IReference<Windows::Foundation::TimeSpan>> ShowAtAsync(Windows::UI::Xaml::FrameworkElement const& target) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerFlyout> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerFlyout<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerFlyoutPresenter
{
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerFlyoutPresenter<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerFlyoutStatics
{
    Windows::UI::Xaml::DependencyProperty ClockIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TimeProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinuteIncrementProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerFlyoutStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerFlyoutStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerStatics
{
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ClockIdentifierProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MinuteIncrementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty TimeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerStatics2
{
    Windows::UI::Xaml::DependencyProperty LightDismissOverlayModeProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_ITimePickerValueChangedEventArgs
{
    Windows::Foundation::TimeSpan OldTime() const noexcept;
    Windows::Foundation::TimeSpan NewTime() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_ITimePickerValueChangedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItem
{
    bool IsChecked() const noexcept;
    void IsChecked(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItem<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItemFactory
{
    Windows::UI::Xaml::Controls::ToggleMenuFlyoutItem CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItemFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItemStatics
{
    Windows::UI::Xaml::DependencyProperty IsCheckedProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleMenuFlyoutItemStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleSwitch
{
    bool IsOn() const noexcept;
    void IsOn(bool value) const noexcept;
    Windows::Foundation::IInspectable Header() const noexcept;
    void Header(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate HeaderTemplate() const noexcept;
    void HeaderTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::Foundation::IInspectable OnContent() const noexcept;
    void OnContent(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate OnContentTemplate() const noexcept;
    void OnContentTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::Foundation::IInspectable OffContent() const noexcept;
    void OffContent(Windows::Foundation::IInspectable const& value) const noexcept;
    Windows::UI::Xaml::DataTemplate OffContentTemplate() const noexcept;
    void OffContentTemplate(Windows::UI::Xaml::DataTemplate const& value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::ToggleSwitchTemplateSettings TemplateSettings() const noexcept;
    event_token Toggled(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using Toggled_revoker = event_revoker<Windows::UI::Xaml::Controls::IToggleSwitch>;
    Toggled_revoker Toggled(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void Toggled(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleSwitch> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleSwitch<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleSwitchOverrides
{
    void OnToggled() const;
    void OnOnContentChanged(Windows::Foundation::IInspectable const& oldContent, Windows::Foundation::IInspectable const& newContent) const;
    void OnOffContentChanged(Windows::Foundation::IInspectable const& oldContent, Windows::Foundation::IInspectable const& newContent) const;
    void OnHeaderChanged(Windows::Foundation::IInspectable const& oldContent, Windows::Foundation::IInspectable const& newContent) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleSwitchOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleSwitchOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToggleSwitchStatics
{
    Windows::UI::Xaml::DependencyProperty IsOnProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HeaderTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OnContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OnContentTemplateProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OffContentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OffContentTemplateProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToggleSwitchStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToggleSwitchStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToolTip
{
    double HorizontalOffset() const noexcept;
    void HorizontalOffset(double value) const noexcept;
    bool IsOpen() const noexcept;
    void IsOpen(bool value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::PlacementMode Placement() const noexcept;
    void Placement(Windows::UI::Xaml::Controls::Primitives::PlacementMode const& value) const noexcept;
    Windows::UI::Xaml::UIElement PlacementTarget() const noexcept;
    void PlacementTarget(Windows::UI::Xaml::UIElement const& value) const noexcept;
    double VerticalOffset() const noexcept;
    void VerticalOffset(double value) const noexcept;
    Windows::UI::Xaml::Controls::Primitives::ToolTipTemplateSettings TemplateSettings() const noexcept;
    event_token Closed(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using Closed_revoker = event_revoker<Windows::UI::Xaml::Controls::IToolTip>;
    Closed_revoker Closed(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void Closed(event_token const& token) const;
    event_token Opened(Windows::UI::Xaml::RoutedEventHandler const& value) const;
    using Opened_revoker = event_revoker<Windows::UI::Xaml::Controls::IToolTip>;
    Opened_revoker Opened(auto_revoke_t, Windows::UI::Xaml::RoutedEventHandler const& value) const;
    void Opened(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToolTip> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToolTip<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToolTipFactory
{
    Windows::UI::Xaml::Controls::ToolTip CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToolTipFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToolTipFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToolTipService
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IToolTipService> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToolTipService<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToolTipServiceStatics
{
    Windows::UI::Xaml::DependencyProperty PlacementProperty() const noexcept;
    Windows::UI::Xaml::Controls::Primitives::PlacementMode GetPlacement(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetPlacement(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::Primitives::PlacementMode const& value) const;
    Windows::UI::Xaml::DependencyProperty PlacementTargetProperty() const noexcept;
    Windows::UI::Xaml::UIElement GetPlacementTarget(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetPlacementTarget(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::UIElement const& value) const;
    Windows::UI::Xaml::DependencyProperty ToolTipProperty() const noexcept;
    Windows::Foundation::IInspectable GetToolTip(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetToolTip(Windows::UI::Xaml::DependencyObject const& element, Windows::Foundation::IInspectable const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToolTipServiceStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToolTipServiceStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IToolTipStatics
{
    Windows::UI::Xaml::DependencyProperty HorizontalOffsetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty IsOpenProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlacementProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty PlacementTargetProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalOffsetProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IToolTipStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IToolTipStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IUIElementCollection
{
    void Move(uint32_t oldIndex, uint32_t newIndex) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IUIElementCollection> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IUIElementCollection<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IUserControl
{
    Windows::UI::Xaml::UIElement Content() const noexcept;
    void Content(Windows::UI::Xaml::UIElement const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IUserControl> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IUserControl<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IUserControlFactory
{
    Windows::UI::Xaml::Controls::UserControl CreateInstance(Windows::Foundation::IInspectable const& outer, Windows::Foundation::IInspectable& inner) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IUserControlFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IUserControlFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IUserControlStatics
{
    Windows::UI::Xaml::DependencyProperty ContentProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IUserControlStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IUserControlStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVariableSizedWrapGrid
{
    double ItemHeight() const noexcept;
    void ItemHeight(double value) const noexcept;
    double ItemWidth() const noexcept;
    void ItemWidth(double value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalChildrenAlignment() const noexcept;
    void HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalChildrenAlignment() const noexcept;
    void VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
    int32_t MaximumRowsOrColumns() const noexcept;
    void MaximumRowsOrColumns(int32_t value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVariableSizedWrapGrid> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVariableSizedWrapGrid<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVariableSizedWrapGridStatics
{
    Windows::UI::Xaml::DependencyProperty ItemHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalChildrenAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalChildrenAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaximumRowsOrColumnsProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty RowSpanProperty() const noexcept;
    int32_t GetRowSpan(Windows::UI::Xaml::UIElement const& element) const;
    void SetRowSpan(Windows::UI::Xaml::UIElement const& element, int32_t value) const;
    Windows::UI::Xaml::DependencyProperty ColumnSpanProperty() const noexcept;
    int32_t GetColumnSpan(Windows::UI::Xaml::UIElement const& element) const;
    void SetColumnSpan(Windows::UI::Xaml::UIElement const& element, int32_t value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVariableSizedWrapGridStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVariableSizedWrapGridStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IViewbox
{
    Windows::UI::Xaml::UIElement Child() const noexcept;
    void Child(Windows::UI::Xaml::UIElement const& value) const noexcept;
    Windows::UI::Xaml::Media::Stretch Stretch() const noexcept;
    void Stretch(Windows::UI::Xaml::Media::Stretch const& value) const noexcept;
    Windows::UI::Xaml::Controls::StretchDirection StretchDirection() const noexcept;
    void StretchDirection(Windows::UI::Xaml::Controls::StretchDirection const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IViewbox> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IViewbox<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IViewboxStatics
{
    Windows::UI::Xaml::DependencyProperty StretchProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty StretchDirectionProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IViewboxStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IViewboxStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingPanel
{
    Windows::UI::Xaml::Controls::ItemContainerGenerator ItemContainerGenerator() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingPanelFactory
{
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingPanelFactory> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingPanelFactory<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingPanelOverrides
{
    void OnItemsChanged(Windows::Foundation::IInspectable const& sender, Windows::UI::Xaml::Controls::Primitives::ItemsChangedEventArgs const& args) const;
    void OnClearChildren() const;
    void BringIndexIntoView(int32_t index) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingPanelOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingPanelOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingPanelProtected
{
    void AddInternalChild(Windows::UI::Xaml::UIElement const& child) const;
    void InsertInternalChild(int32_t index, Windows::UI::Xaml::UIElement const& child) const;
    void RemoveInternalChildRange(int32_t index, int32_t range) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingPanelProtected> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingPanelProtected<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanel
{
    bool AreScrollSnapPointsRegular() const noexcept;
    void AreScrollSnapPointsRegular(bool value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    event_token CleanUpVirtualizedItemEvent(Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler const& value) const;
    using CleanUpVirtualizedItemEvent_revoker = event_revoker<Windows::UI::Xaml::Controls::IVirtualizingStackPanel>;
    CleanUpVirtualizedItemEvent_revoker CleanUpVirtualizedItemEvent(auto_revoke_t, Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler const& value) const;
    void CleanUpVirtualizedItemEvent(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingStackPanel> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanel<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanelOverrides
{
    void OnCleanUpVirtualizedItem(Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventArgs const& e) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingStackPanelOverrides> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanelOverrides<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanelStatics
{
    Windows::UI::Xaml::DependencyProperty AreScrollSnapPointsRegularProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VirtualizationModeProperty() const noexcept;
    Windows::UI::Xaml::Controls::VirtualizationMode GetVirtualizationMode(Windows::UI::Xaml::DependencyObject const& element) const;
    void SetVirtualizationMode(Windows::UI::Xaml::DependencyObject const& element, Windows::UI::Xaml::Controls::VirtualizationMode const& value) const;
    Windows::UI::Xaml::DependencyProperty IsVirtualizingProperty() const noexcept;
    bool GetIsVirtualizing(Windows::UI::Xaml::DependencyObject const& o) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IVirtualizingStackPanelStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IVirtualizingStackPanelStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebView
{
    Windows::Foundation::Uri Source() const noexcept;
    void Source(Windows::Foundation::Uri const& value) const noexcept;
    [[deprecated("AllowedScriptNotifyUris is unavailable for releases beginning with Windows 8.1. Instead, list URIs under ApplicationContentUriRules in the package manifest. For more info, see the AllowedScriptNotifyUris documentation.")]] Windows::Foundation::Collections::IVector<Windows::Foundation::Uri> AllowedScriptNotifyUris() const noexcept;
    [[deprecated("AllowedScriptNotifyUris is unavailable for releases beginning with Windows 8.1. Instead, list URIs under ApplicationContentUriRules in the package manifest. For more info, see the AllowedScriptNotifyUris documentation.")]] void AllowedScriptNotifyUris(param::vector<Windows::Foundation::Uri> const& value) const noexcept;
    [[deprecated("Use CaptureSelectedContentToDataPackageAsync instead of DataTransferPackage. For more info, see MSDN.")]] Windows::ApplicationModel::DataTransfer::DataPackage DataTransferPackage() const noexcept;
    [[deprecated("LoadCompleted may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] event_token LoadCompleted(Windows::UI::Xaml::Navigation::LoadCompletedEventHandler const& value) const;
    using LoadCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView>;
    [[deprecated("LoadCompleted may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] LoadCompleted_revoker LoadCompleted(auto_revoke_t, Windows::UI::Xaml::Navigation::LoadCompletedEventHandler const& value) const;
    [[deprecated("LoadCompleted may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] void LoadCompleted(event_token const& token) const;
    event_token ScriptNotify(Windows::UI::Xaml::Controls::NotifyEventHandler const& value) const;
    using ScriptNotify_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView>;
    ScriptNotify_revoker ScriptNotify(auto_revoke_t, Windows::UI::Xaml::Controls::NotifyEventHandler const& value) const;
    void ScriptNotify(event_token const& token) const;
    [[deprecated("NavigationFailed may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] event_token NavigationFailed(Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler const& value) const;
    using NavigationFailed_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView>;
    [[deprecated("NavigationFailed may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] NavigationFailed_revoker NavigationFailed(auto_revoke_t, Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler const& value) const;
    [[deprecated("NavigationFailed may be altered or unavailable for releases after Windows 8.1. Instead, use NavigationCompleted.")]] void NavigationFailed(event_token const& token) const;
    [[deprecated("Use InvokeScriptAsync instead of InvokeScript. For more info, see MSDN.")]] hstring InvokeScript(param::hstring const& scriptName, array_view<hstring const> arguments) const;
    void Navigate(Windows::Foundation::Uri const& source) const;
    void NavigateToString(param::hstring const& text) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebView> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebView<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebView2
{
    bool CanGoBack() const noexcept;
    bool CanGoForward() const noexcept;
    hstring DocumentTitle() const noexcept;
    event_token NavigationStarting(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs> const& value) const;
    using NavigationStarting_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    NavigationStarting_revoker NavigationStarting(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs> const& value) const;
    void NavigationStarting(event_token const& token) const;
    event_token ContentLoading(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs> const& value) const;
    using ContentLoading_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    ContentLoading_revoker ContentLoading(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs> const& value) const;
    void ContentLoading(event_token const& token) const;
    event_token DOMContentLoaded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs> const& value) const;
    using DOMContentLoaded_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    DOMContentLoaded_revoker DOMContentLoaded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs> const& value) const;
    void DOMContentLoaded(event_token const& token) const;
    void GoForward() const;
    void GoBack() const;
    void Refresh() const;
    void Stop() const;
    Windows::Foundation::IAsyncAction CapturePreviewToStreamAsync(Windows::Storage::Streams::IRandomAccessStream const& stream) const;
    Windows::Foundation::IAsyncOperation<hstring> InvokeScriptAsync(param::hstring const& scriptName, param::async_iterable<hstring> const& arguments) const;
    Windows::Foundation::IAsyncOperation<Windows::ApplicationModel::DataTransfer::DataPackage> CaptureSelectedContentToDataPackageAsync() const;
    void NavigateToLocalStreamUri(Windows::Foundation::Uri const& source, Windows::Web::IUriToStreamResolver const& streamResolver) const;
    Windows::Foundation::Uri BuildLocalStreamUri(param::hstring const& contentIdentifier, param::hstring const& relativePath) const;
    Windows::UI::Color DefaultBackgroundColor() const noexcept;
    void DefaultBackgroundColor(Windows::UI::Color const& value) const noexcept;
    event_token NavigationCompleted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs> const& value) const;
    using NavigationCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    NavigationCompleted_revoker NavigationCompleted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs> const& value) const;
    void NavigationCompleted(event_token const& token) const;
    event_token FrameNavigationStarting(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs> const& value) const;
    using FrameNavigationStarting_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    FrameNavigationStarting_revoker FrameNavigationStarting(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationStartingEventArgs> const& value) const;
    void FrameNavigationStarting(event_token const& token) const;
    event_token FrameContentLoading(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs> const& value) const;
    using FrameContentLoading_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    FrameContentLoading_revoker FrameContentLoading(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewContentLoadingEventArgs> const& value) const;
    void FrameContentLoading(event_token const& token) const;
    event_token FrameDOMContentLoaded(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs> const& value) const;
    using FrameDOMContentLoaded_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    FrameDOMContentLoaded_revoker FrameDOMContentLoaded(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewDOMContentLoadedEventArgs> const& value) const;
    void FrameDOMContentLoaded(event_token const& token) const;
    event_token FrameNavigationCompleted(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs> const& value) const;
    using FrameNavigationCompleted_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    FrameNavigationCompleted_revoker FrameNavigationCompleted(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNavigationCompletedEventArgs> const& value) const;
    void FrameNavigationCompleted(event_token const& token) const;
    event_token LongRunningScriptDetected(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewLongRunningScriptDetectedEventArgs> const& value) const;
    using LongRunningScriptDetected_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    LongRunningScriptDetected_revoker LongRunningScriptDetected(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewLongRunningScriptDetectedEventArgs> const& value) const;
    void LongRunningScriptDetected(event_token const& token) const;
    event_token UnsafeContentWarningDisplaying(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::Foundation::IInspectable> const& value) const;
    using UnsafeContentWarningDisplaying_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    UnsafeContentWarningDisplaying_revoker UnsafeContentWarningDisplaying(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::Foundation::IInspectable> const& value) const;
    void UnsafeContentWarningDisplaying(event_token const& token) const;
    event_token UnviewableContentIdentified(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewUnviewableContentIdentifiedEventArgs> const& value) const;
    using UnviewableContentIdentified_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView2>;
    UnviewableContentIdentified_revoker UnviewableContentIdentified(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewUnviewableContentIdentifiedEventArgs> const& value) const;
    void UnviewableContentIdentified(event_token const& token) const;
    void NavigateWithHttpRequestMessage(Windows::Web::Http::HttpRequestMessage const& requestMessage) const;
    bool Focus(Windows::UI::Xaml::FocusState const& value) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebView2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebView2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebView3
{
    bool ContainsFullScreenElement() const noexcept;
    event_token ContainsFullScreenElementChanged(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::Foundation::IInspectable> const& value) const;
    using ContainsFullScreenElementChanged_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView3>;
    ContainsFullScreenElementChanged_revoker ContainsFullScreenElementChanged(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::Foundation::IInspectable> const& value) const;
    void ContainsFullScreenElementChanged(event_token const& token) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebView3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebView3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebView4
{
    Windows::UI::Xaml::Controls::WebViewExecutionMode ExecutionMode() const noexcept;
    Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Controls::WebViewDeferredPermissionRequest> DeferredPermissionRequests() const noexcept;
    Windows::UI::Xaml::Controls::WebViewSettings Settings() const noexcept;
    event_token UnsupportedUriSchemeIdentified(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewUnsupportedUriSchemeIdentifiedEventArgs> const& value) const;
    using UnsupportedUriSchemeIdentified_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView4>;
    UnsupportedUriSchemeIdentified_revoker UnsupportedUriSchemeIdentified(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewUnsupportedUriSchemeIdentifiedEventArgs> const& value) const;
    void UnsupportedUriSchemeIdentified(event_token const& token) const;
    event_token NewWindowRequested(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNewWindowRequestedEventArgs> const& value) const;
    using NewWindowRequested_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView4>;
    NewWindowRequested_revoker NewWindowRequested(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewNewWindowRequestedEventArgs> const& value) const;
    void NewWindowRequested(event_token const& token) const;
    event_token PermissionRequested(Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewPermissionRequestedEventArgs> const& value) const;
    using PermissionRequested_revoker = event_revoker<Windows::UI::Xaml::Controls::IWebView4>;
    PermissionRequested_revoker PermissionRequested(auto_revoke_t, Windows::Foundation::TypedEventHandler<Windows::UI::Xaml::Controls::WebView, Windows::UI::Xaml::Controls::WebViewPermissionRequestedEventArgs> const& value) const;
    void PermissionRequested(event_token const& token) const;
    void AddWebAllowedObject(param::hstring const& name, Windows::Foundation::IInspectable const& pObject) const;
    Windows::UI::Xaml::Controls::WebViewDeferredPermissionRequest DeferredPermissionRequestById(uint32_t id) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebView4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebView4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebView5
{
    Windows::UI::Xaml::DependencyObject XYFocusLeft() const noexcept;
    void XYFocusLeft(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusRight() const noexcept;
    void XYFocusRight(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusUp() const noexcept;
    void XYFocusUp(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
    Windows::UI::Xaml::DependencyObject XYFocusDown() const noexcept;
    void XYFocusDown(Windows::UI::Xaml::DependencyObject const& value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebView5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebView5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewBrush
{
    hstring SourceName() const noexcept;
    void SourceName(param::hstring const& value) const noexcept;
    void Redraw() const;
    void SetSource(Windows::UI::Xaml::Controls::WebView const& source) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewBrush> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewBrush<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewBrushStatics
{
    Windows::UI::Xaml::DependencyProperty SourceNameProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewBrushStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewBrushStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewContentLoadingEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewContentLoadingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewDOMContentLoadedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewDOMContentLoadedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewDeferredPermissionRequest
{
    Windows::Foundation::Uri Uri() const noexcept;
    Windows::UI::Xaml::Controls::WebViewPermissionType PermissionType() const noexcept;
    uint32_t Id() const noexcept;
    void Allow() const;
    void Deny() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewDeferredPermissionRequest<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewFactory4
{
    Windows::UI::Xaml::Controls::WebView CreateInstanceWithExecutionMode(Windows::UI::Xaml::Controls::WebViewExecutionMode const& executionMode) const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewFactory4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewFactory4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewLongRunningScriptDetectedEventArgs
{
    Windows::Foundation::TimeSpan ExecutionTime() const noexcept;
    bool StopPageScriptExecution() const noexcept;
    void StopPageScriptExecution(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewLongRunningScriptDetectedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewNavigationCompletedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    bool IsSuccess() const noexcept;
    Windows::Web::WebErrorStatus WebErrorStatus() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewNavigationCompletedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewNavigationFailedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    Windows::Web::WebErrorStatus WebErrorStatus() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewNavigationFailedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewNavigationStartingEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    bool Cancel() const noexcept;
    void Cancel(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewNavigationStartingEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewNewWindowRequestedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    Windows::Foundation::Uri Referrer() const noexcept;
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewNewWindowRequestedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewPermissionRequest
{
    Windows::Foundation::Uri Uri() const noexcept;
    Windows::UI::Xaml::Controls::WebViewPermissionType PermissionType() const noexcept;
    uint32_t Id() const noexcept;
    Windows::UI::Xaml::Controls::WebViewPermissionState State() const noexcept;
    void Defer() const;
    void Allow() const;
    void Deny() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewPermissionRequest> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewPermissionRequest<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewPermissionRequestedEventArgs
{
    Windows::UI::Xaml::Controls::WebViewPermissionRequest PermissionRequest() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewPermissionRequestedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewSettings
{
    bool IsJavaScriptEnabled() const noexcept;
    void IsJavaScriptEnabled(bool value) const noexcept;
    bool IsIndexedDBEnabled() const noexcept;
    void IsIndexedDBEnabled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewSettings> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewSettings<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewStatics
{
    [[deprecated("AnyScriptNotifyUri is unavailable for releases beginning with Windows 8.1. Instead, list URIs under ApplicationContentUriRules in the package manifest. For more info, see the AnyScriptNotifyUri documentation.")]] Windows::Foundation::Collections::IVector<Windows::Foundation::Uri> AnyScriptNotifyUri() const noexcept;
    Windows::UI::Xaml::DependencyProperty SourceProperty() const noexcept;
    [[deprecated("AllowedScriptNotifyUris is unavailable for releases beginning with Windows 8.1. Instead, list URIs under ApplicationContentUriRules in the package manifest. For more info, see the AllowedScriptNotifyUris documentation.")]] Windows::UI::Xaml::DependencyProperty AllowedScriptNotifyUrisProperty() const noexcept;
    [[deprecated("Use CaptureSelectedContentToDataPackageAsync instead of DataTransferPackage. For more info, see MSDN.")]] Windows::UI::Xaml::DependencyProperty DataTransferPackageProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewStatics<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewStatics2
{
    Windows::UI::Xaml::DependencyProperty CanGoBackProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty CanGoForwardProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DocumentTitleProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty DefaultBackgroundColorProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewStatics2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewStatics2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewStatics3
{
    Windows::UI::Xaml::DependencyProperty ContainsFullScreenElementProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewStatics3> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewStatics3<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewStatics4
{
    Windows::UI::Xaml::Controls::WebViewExecutionMode DefaultExecutionMode() const noexcept;
    Windows::Foundation::IAsyncAction ClearTemporaryWebDataAsync() const;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewStatics4> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewStatics4<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewStatics5
{
    Windows::UI::Xaml::DependencyProperty XYFocusLeftProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusRightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusUpProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty XYFocusDownProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewStatics5> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewStatics5<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewUnsupportedUriSchemeIdentifiedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    bool Handled() const noexcept;
    void Handled(bool value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewUnsupportedUriSchemeIdentifiedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewUnviewableContentIdentifiedEventArgs
{
    Windows::Foundation::Uri Uri() const noexcept;
    Windows::Foundation::Uri Referrer() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewUnviewableContentIdentifiedEventArgs<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWebViewUnviewableContentIdentifiedEventArgs2
{
    hstring MediaType() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs2> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWebViewUnviewableContentIdentifiedEventArgs2<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWrapGrid
{
    double ItemWidth() const noexcept;
    void ItemWidth(double value) const noexcept;
    double ItemHeight() const noexcept;
    void ItemHeight(double value) const noexcept;
    Windows::UI::Xaml::Controls::Orientation Orientation() const noexcept;
    void Orientation(Windows::UI::Xaml::Controls::Orientation const& value) const noexcept;
    Windows::UI::Xaml::HorizontalAlignment HorizontalChildrenAlignment() const noexcept;
    void HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment const& value) const noexcept;
    Windows::UI::Xaml::VerticalAlignment VerticalChildrenAlignment() const noexcept;
    void VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment const& value) const noexcept;
    int32_t MaximumRowsOrColumns() const noexcept;
    void MaximumRowsOrColumns(int32_t value) const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWrapGrid> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWrapGrid<D>; };

template <typename D>
struct consume_Windows_UI_Xaml_Controls_IWrapGridStatics
{
    Windows::UI::Xaml::DependencyProperty ItemWidthProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty ItemHeightProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty OrientationProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty HorizontalChildrenAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty VerticalChildrenAlignmentProperty() const noexcept;
    Windows::UI::Xaml::DependencyProperty MaximumRowsOrColumnsProperty() const noexcept;
};
template <> struct consume<Windows::UI::Xaml::Controls::IWrapGridStatics> { template <typename D> using type = consume_Windows_UI_Xaml_Controls_IWrapGridStatics<D>; };

template <> struct abi<Windows::UI::Xaml::Controls::IAppBar>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsOpen(bool value) = 0;
    virtual HRESULT __stdcall get_IsSticky(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSticky(bool value) = 0;
    virtual HRESULT __stdcall add_Opened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Opened(event_token token) = 0;
    virtual HRESULT __stdcall add_Closed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closed(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBar2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClosedDisplayMode(Windows::UI::Xaml::Controls::AppBarClosedDisplayMode* value) = 0;
    virtual HRESULT __stdcall put_ClosedDisplayMode(Windows::UI::Xaml::Controls::AppBarClosedDisplayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBar3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_Opening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Opening(event_token token) = 0;
    virtual HRESULT __stdcall add_Closing(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closing(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBar4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Label(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Label(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Icon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Icon(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarButton3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition* value) = 0;
    virtual HRESULT __stdcall put_LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IconProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsCompactProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarButtonStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelPositionProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsInOverflowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DynamicOverflowOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnClosed(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnOpened(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarOverrides3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnClosing(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnOpening(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarSeparator>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarSeparatorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsCompactProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarSeparatorStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsInOverflowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DynamicOverflowOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsStickyProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClosedDisplayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarToggleButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Label(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Label(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Icon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Icon(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarToggleButton3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition* value) = 0;
    virtual HRESULT __stdcall put_LabelPosition(Windows::UI::Xaml::Controls::CommandBarLabelPosition value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarToggleButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IconProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsCompactProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAppBarToggleButtonStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LabelPositionProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsInOverflowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DynamicOverflowOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxSuggestionListHeight(double* value) = 0;
    virtual HRESULT __stdcall put_MaxSuggestionListHeight(double value) = 0;
    virtual HRESULT __stdcall get_IsSuggestionListOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSuggestionListOpen(bool value) = 0;
    virtual HRESULT __stdcall get_TextMemberPath(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_TextMemberPath(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
    virtual HRESULT __stdcall get_UpdateTextOnSelect(bool* value) = 0;
    virtual HRESULT __stdcall put_UpdateTextOnSelect(bool value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AutoMaximizeSuggestionArea(bool* value) = 0;
    virtual HRESULT __stdcall put_AutoMaximizeSuggestionArea(bool value) = 0;
    virtual HRESULT __stdcall get_TextBoxStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TextBoxStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_SuggestionChosen(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SuggestionChosen(event_token token) = 0;
    virtual HRESULT __stdcall add_TextChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryIcon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_QueryIcon(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_QuerySubmitted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_QuerySubmitted(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBox3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxQuerySubmittedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_ChosenSuggestion(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxSuggestionListHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSuggestionListOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextMemberPathProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_UpdateTextOnSelectProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AutoMaximizeSuggestionAreaProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextBoxStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryIconProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxSuggestionChosenEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectedItem(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Reason(Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason* value) = 0;
    virtual HRESULT __stdcall put_Reason(Windows::UI::Xaml::Controls::AutoSuggestionBoxTextChangeReason value) = 0;
    virtual HRESULT __stdcall CheckCurrent(bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IAutoSuggestBoxTextChangedEventArgsStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ReasonProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBackClickEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIcon>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UriSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_UriSource(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIcon2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowAsMonochrome(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowAsMonochrome(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconSource>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UriSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_UriSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ShowAsMonochrome(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowAsMonochrome(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconSourceFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconSourceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UriSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ShowAsMonochromeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UriSourceProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBitmapIconStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowAsMonochromeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBorder>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Background(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Background(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CornerRadius(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CornerRadius(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Child(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Child(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ChildTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ChildTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IBorderStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CornerRadiusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ChildTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IButtonStaticsWithFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FlyoutProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IButtonWithFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Flyout(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Flyout(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePicker>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Date(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Date(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsCalendarOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsCalendarOpen(bool value) = 0;
    virtual HRESULT __stdcall get_DateFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DateFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CalendarViewStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CalendarViewStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MinDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MinDate(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_MaxDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MaxDate(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_IsTodayHighlighted(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTodayHighlighted(bool value) = 0;
    virtual HRESULT __stdcall get_DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode* value) = 0;
    virtual HRESULT __stdcall put_DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode value) = 0;
    virtual HRESULT __stdcall get_FirstDayOfWeek(Windows::Globalization::DayOfWeek* value) = 0;
    virtual HRESULT __stdcall put_FirstDayOfWeek(Windows::Globalization::DayOfWeek value) = 0;
    virtual HRESULT __stdcall get_DayOfWeekFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DayOfWeekFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_CalendarIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_CalendarIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_IsOutOfScopeEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsOutOfScopeEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsGroupLabelVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsGroupLabelVisible(bool value) = 0;
    virtual HRESULT __stdcall add_CalendarViewDayItemChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CalendarViewDayItemChanging(event_token token) = 0;
    virtual HRESULT __stdcall add_DateChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DateChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_Opened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Opened(event_token token) = 0;
    virtual HRESULT __stdcall add_Closed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closed(event_token token) = 0;
    virtual HRESULT __stdcall SetDisplayDate(Windows::Foundation::DateTime date) = 0;
    virtual HRESULT __stdcall SetYearDecadeDisplayDimensions(int32_t columns, int32_t rows) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePicker2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePickerDateChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_NewDate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OldDate(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePickerFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsCalendarOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DateFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarViewStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinDateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxDateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTodayHighlightedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstDayOfWeekProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayOfWeekFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsOutOfScopeEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsGroupLabelVisibleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarDatePickerStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CalendarIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_CalendarIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_DayOfWeekFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DayOfWeekFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_IsGroupLabelVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsGroupLabelVisible(bool value) = 0;
    virtual HRESULT __stdcall get_DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode* value) = 0;
    virtual HRESULT __stdcall put_DisplayMode(Windows::UI::Xaml::Controls::CalendarViewDisplayMode value) = 0;
    virtual HRESULT __stdcall get_FirstDayOfWeek(Windows::Globalization::DayOfWeek* value) = 0;
    virtual HRESULT __stdcall put_FirstDayOfWeek(Windows::Globalization::DayOfWeek value) = 0;
    virtual HRESULT __stdcall get_IsOutOfScopeEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsOutOfScopeEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsTodayHighlighted(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTodayHighlighted(bool value) = 0;
    virtual HRESULT __stdcall get_MaxDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MaxDate(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_MinDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MinDate(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_NumberOfWeeksInView(int32_t* value) = 0;
    virtual HRESULT __stdcall put_NumberOfWeeksInView(int32_t value) = 0;
    virtual HRESULT __stdcall get_SelectedDates(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionMode(Windows::UI::Xaml::Controls::CalendarViewSelectionMode* value) = 0;
    virtual HRESULT __stdcall put_SelectionMode(Windows::UI::Xaml::Controls::CalendarViewSelectionMode value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FocusBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FocusBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedHoverBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedHoverBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedPressedBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedPressedBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HoverBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HoverBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PressedBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PressedBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CalendarItemBorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OutOfScopeBackground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OutOfScopeBackground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBackground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CalendarItemBackground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PressedForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PressedForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TodayForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TodayForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BlackoutForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BlackoutForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OutOfScopeForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OutOfScopeForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CalendarItemForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CalendarItemForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DayItemFontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_DayItemFontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DayItemFontSize(double* value) = 0;
    virtual HRESULT __stdcall put_DayItemFontSize(double value) = 0;
    virtual HRESULT __stdcall get_DayItemFontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_DayItemFontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_DayItemFontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_DayItemFontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_TodayFontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_TodayFontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FirstOfMonthLabelFontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FirstOfMonthLabelFontSize(double value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FirstOfMonthLabelFontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FirstOfMonthLabelFontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MonthYearItemFontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontSize(double* value) = 0;
    virtual HRESULT __stdcall put_MonthYearItemFontSize(double value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_MonthYearItemFontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_MonthYearItemFontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FirstOfYearDecadeLabelFontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FirstOfYearDecadeLabelFontSize(double value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FirstOfYearDecadeLabelFontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FirstOfYearDecadeLabelFontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_HorizontalDayItemAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalDayItemAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalDayItemAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalDayItemAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
    virtual HRESULT __stdcall get_HorizontalFirstOfMonthLabelAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalFirstOfMonthLabelAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalFirstOfMonthLabelAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalFirstOfMonthLabelAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CalendarItemBorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_CalendarViewDayItemStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CalendarViewDayItemStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_CalendarViewDayItemChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CalendarViewDayItemChanging(event_token token) = 0;
    virtual HRESULT __stdcall add_SelectedDatesChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectedDatesChanged(event_token token) = 0;
    virtual HRESULT __stdcall SetDisplayDate(Windows::Foundation::DateTime date) = 0;
    virtual HRESULT __stdcall SetYearDecadeDisplayDimensions(int32_t columns, int32_t rows) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewDayItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsBlackout(bool* value) = 0;
    virtual HRESULT __stdcall put_IsBlackout(bool value) = 0;
    virtual HRESULT __stdcall get_Date(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall SetDensityColors(::IUnknown* colors) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewDayItemChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_InRecycleQueue(bool* value) = 0;
    virtual HRESULT __stdcall get_Item(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Phase(uint32_t* value) = 0;
    virtual HRESULT __stdcall RegisterUpdateCallback(::IUnknown* callback) = 0;
    virtual HRESULT __stdcall RegisterUpdateCallbackWithPhase(uint32_t callbackPhase, ::IUnknown* callback) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewDayItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewDayItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsBlackoutProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DateProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewSelectedDatesChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AddedDates(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RemovedDates(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICalendarViewStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CalendarIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayOfWeekFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsGroupLabelVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstDayOfWeekProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsOutOfScopeEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTodayHighlightedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxDateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinDateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NumberOfWeeksInViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedDatesProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TemplateSettingsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FocusBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedHoverBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedPressedBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HoverBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PressedBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OutOfScopeBackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PressedForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TodayForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BlackoutForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OutOfScopeForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarItemForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayItemFontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayItemFontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayItemFontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayItemFontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TodayFontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfMonthLabelFontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthYearItemFontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FirstOfYearDecadeLabelFontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalDayItemAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalDayItemAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalFirstOfMonthLabelAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalFirstOfMonthLabelAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarItemBorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarViewDayItemStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICandidateWindowBoundsChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Bounds(Windows::Foundation::Rect* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICanvas>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICanvasFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICanvasStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetLeft(::IUnknown* element, double* length) = 0;
    virtual HRESULT __stdcall SetLeft(::IUnknown* element, double length) = 0;
    virtual HRESULT __stdcall get_TopProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetTop(::IUnknown* element, double* length) = 0;
    virtual HRESULT __stdcall SetTop(::IUnknown* element, double length) = 0;
    virtual HRESULT __stdcall get_ZIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetZIndex(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetZIndex(::IUnknown* element, int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICaptureElement>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICaptureElementStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICheckBox>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICheckBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IChoosingGroupHeaderContainerEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupHeaderContainer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_GroupHeaderContainer(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_GroupIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Group(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IChoosingItemContainerEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Item(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemContainer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemContainer(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsContainerPrepared(bool* value) = 0;
    virtual HRESULT __stdcall put_IsContainerPrepared(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICleanUpVirtualizedItemEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Value(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_UIElement(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColorChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OldColor(struct_of<4>* result) = 0;
    virtual HRESULT __stdcall get_NewColor(struct_of<4>* result) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColorPicker>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Color(struct_of<4>* result) = 0;
    virtual HRESULT __stdcall put_Color(struct_of<4> value) = 0;
    virtual HRESULT __stdcall get_PreviousColor(::IUnknown** result) = 0;
    virtual HRESULT __stdcall put_PreviousColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsAlphaEnabled(bool* result) = 0;
    virtual HRESULT __stdcall put_IsAlphaEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorSpectrumVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsColorSpectrumVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorPreviewVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsColorPreviewVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorSliderVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsColorSliderVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsAlphaSliderVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsAlphaSliderVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsMoreButtonVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsMoreButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorChannelTextInputVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsColorChannelTextInputVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsAlphaTextInputVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsAlphaTextInputVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsHexInputVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsHexInputVisible(bool value) = 0;
    virtual HRESULT __stdcall get_MinHue(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MinHue(int32_t value) = 0;
    virtual HRESULT __stdcall get_MaxHue(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MaxHue(int32_t value) = 0;
    virtual HRESULT __stdcall get_MinSaturation(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MinSaturation(int32_t value) = 0;
    virtual HRESULT __stdcall get_MaxSaturation(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MaxSaturation(int32_t value) = 0;
    virtual HRESULT __stdcall get_MinValue(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MinValue(int32_t value) = 0;
    virtual HRESULT __stdcall get_MaxValue(int32_t* result) = 0;
    virtual HRESULT __stdcall put_MaxValue(int32_t value) = 0;
    virtual HRESULT __stdcall get_ColorSpectrumShape(Windows::UI::Xaml::Controls::ColorSpectrumShape* result) = 0;
    virtual HRESULT __stdcall put_ColorSpectrumShape(Windows::UI::Xaml::Controls::ColorSpectrumShape value) = 0;
    virtual HRESULT __stdcall get_ColorSpectrumComponents(Windows::UI::Xaml::Controls::ColorSpectrumComponents* result) = 0;
    virtual HRESULT __stdcall put_ColorSpectrumComponents(Windows::UI::Xaml::Controls::ColorSpectrumComponents value) = 0;
    virtual HRESULT __stdcall add_ColorChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ColorChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColorPickerFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColorPickerStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PreviousColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsAlphaEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorSpectrumVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorPreviewVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorSliderVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsAlphaSliderVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsMoreButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorChannelTextInputVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsAlphaTextInputVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsHexInputVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinHueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxHueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinSaturationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxSaturationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ColorSpectrumShapeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ColorSpectrumComponentsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColumnDefinition>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Width(struct_of<16>* value) = 0;
    virtual HRESULT __stdcall put_Width(struct_of<16> value) = 0;
    virtual HRESULT __stdcall get_MaxWidth(double* value) = 0;
    virtual HRESULT __stdcall put_MaxWidth(double value) = 0;
    virtual HRESULT __stdcall get_MinWidth(double* value) = 0;
    virtual HRESULT __stdcall put_MinWidth(double value) = 0;
    virtual HRESULT __stdcall get_ActualWidth(double* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IColumnDefinitionStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_WidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinWidthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsDropDownOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsDropDownOpen(bool value) = 0;
    virtual HRESULT __stdcall get_IsEditable(bool* value) = 0;
    virtual HRESULT __stdcall get_IsSelectionBoxHighlighted(bool* value) = 0;
    virtual HRESULT __stdcall get_MaxDropDownHeight(double* value) = 0;
    virtual HRESULT __stdcall put_MaxDropDownHeight(double value) = 0;
    virtual HRESULT __stdcall get_SelectionBoxItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionBoxItemTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_DropDownClosed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DropDownClosed(event_token token) = 0;
    virtual HRESULT __stdcall add_DropDownOpened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DropDownOpened(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBox3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
    virtual HRESULT __stdcall get_IsTextSearchEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextSearchEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBox4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionChangedTrigger(Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger* value) = 0;
    virtual HRESULT __stdcall put_SelectionChangedTrigger(Windows::UI::Xaml::Controls::ComboBoxSelectionChangedTrigger value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBox5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PlaceholderForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PlaceholderForeground(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnDropDownClosed(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDropDownOpened(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsDropDownOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxDropDownHeightProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextSearchEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionChangedTriggerProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IComboBoxStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PlaceholderForegroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBar>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PrimaryCommands(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryCommands(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBar2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CommandBarOverflowPresenterStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CommandBarOverflowPresenterStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CommandBarTemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBar3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultLabelPosition(Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition* value) = 0;
    virtual HRESULT __stdcall put_DefaultLabelPosition(Windows::UI::Xaml::Controls::CommandBarDefaultLabelPosition value) = 0;
    virtual HRESULT __stdcall get_OverflowButtonVisibility(Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility* value) = 0;
    virtual HRESULT __stdcall put_OverflowButtonVisibility(Windows::UI::Xaml::Controls::CommandBarOverflowButtonVisibility value) = 0;
    virtual HRESULT __stdcall get_IsDynamicOverflowEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsDynamicOverflowEnabled(bool value) = 0;
    virtual HRESULT __stdcall add_DynamicOverflowItemsChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DynamicOverflowItemsChanging(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarElement>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsCompact(bool* value) = 0;
    virtual HRESULT __stdcall put_IsCompact(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarElement2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsInOverflow(bool* value) = 0;
    virtual HRESULT __stdcall get_DynamicOverflowOrder(int32_t* value) = 0;
    virtual HRESULT __stdcall put_DynamicOverflowOrder(int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarOverflowPresenterFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PrimaryCommandsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryCommandsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CommandBarOverflowPresenterStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ICommandBarStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultLabelPositionProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OverflowButtonVisibilityProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsDynamicOverflowEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContainerContentChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemContainer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InRecycleQueue(bool* value) = 0;
    virtual HRESULT __stdcall get_ItemIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Item(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Phase(uint32_t* value) = 0;
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
    virtual HRESULT __stdcall RegisterUpdateCallback(::IUnknown* callback) = 0;
    virtual HRESULT __stdcall RegisterUpdateCallbackWithPhase(uint32_t callbackPhase, ::IUnknown* callback) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTemplateSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentControl2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentTemplateRoot(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentControlOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnContentChanged(::IUnknown* oldContent, ::IUnknown* newContent) = 0;
    virtual HRESULT __stdcall OnContentTemplateChanged(::IUnknown* oldContentTemplate, ::IUnknown* newContentTemplate) = 0;
    virtual HRESULT __stdcall OnContentTemplateSelectorChanged(::IUnknown* oldContentTemplateSelector, ::IUnknown* newContentTemplateSelector) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialog>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Title(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Title(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TitleTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TitleTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FullSizeDesired(bool* value) = 0;
    virtual HRESULT __stdcall put_FullSizeDesired(bool value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PrimaryButtonText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SecondaryButtonText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonCommand(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PrimaryButtonCommand(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonCommand(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SecondaryButtonCommand(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonCommandParameter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PrimaryButtonCommandParameter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonCommandParameter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SecondaryButtonCommandParameter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsPrimaryButtonEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPrimaryButtonEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsSecondaryButtonEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSecondaryButtonEnabled(bool value) = 0;
    virtual HRESULT __stdcall add_Closing(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closing(event_token token) = 0;
    virtual HRESULT __stdcall add_Closed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closed(event_token token) = 0;
    virtual HRESULT __stdcall add_Opened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Opened(event_token token) = 0;
    virtual HRESULT __stdcall add_PrimaryButtonClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PrimaryButtonClick(event_token token) = 0;
    virtual HRESULT __stdcall add_SecondaryButtonClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SecondaryButtonClick(event_token token) = 0;
    virtual HRESULT __stdcall Hide() = 0;
    virtual HRESULT __stdcall ShowAsync(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialog2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CloseButtonText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_CloseButtonText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_CloseButtonCommand(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CloseButtonCommand(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CloseButtonCommandParameter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CloseButtonCommandParameter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PrimaryButtonStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SecondaryButtonStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CloseButtonStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CloseButtonStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DefaultButton(Windows::UI::Xaml::Controls::ContentDialogButton* value) = 0;
    virtual HRESULT __stdcall put_DefaultButton(Windows::UI::Xaml::Controls::ContentDialogButton value) = 0;
    virtual HRESULT __stdcall add_CloseButtonClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CloseButtonClick(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialog3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall ShowAsyncWithPlacement(Windows::UI::Xaml::Controls::ContentDialogPlacement placement, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogButtonClickDeferral>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall Complete() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogButtonClickEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
    virtual HRESULT __stdcall GetDeferral(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogClosedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Result(Windows::UI::Xaml::Controls::ContentDialogResult* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogClosingDeferral>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall Complete() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogClosingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Result(Windows::UI::Xaml::Controls::ContentDialogResult* value) = 0;
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
    virtual HRESULT __stdcall GetDeferral(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogOpenedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TitleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TitleTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FullSizeDesiredProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonCommandProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonCommandProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonCommandParameterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonCommandParameterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPrimaryButtonEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSecondaryButtonEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentDialogStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CloseButtonTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CloseButtonCommandProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CloseButtonCommandParameterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PrimaryButtonStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryButtonStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CloseButtonStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultButtonProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenter>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTemplateSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTransitions(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FontStretch(Windows::UI::Text::FontStretch* value) = 0;
    virtual HRESULT __stdcall put_FontStretch(Windows::UI::Text::FontStretch value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacing(int32_t* value) = 0;
    virtual HRESULT __stdcall put_CharacterSpacing(int32_t value) = 0;
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenter2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment* value) = 0;
    virtual HRESULT __stdcall put_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment value) = 0;
    virtual HRESULT __stdcall get_TextLineBounds(Windows::UI::Xaml::TextLineBounds* value) = 0;
    virtual HRESULT __stdcall put_TextLineBounds(Windows::UI::Xaml::TextLineBounds value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenter3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenter4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextWrapping(Windows::UI::Xaml::TextWrapping* value) = 0;
    virtual HRESULT __stdcall put_TextWrapping(Windows::UI::Xaml::TextWrapping value) = 0;
    virtual HRESULT __stdcall get_MaxLines(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLines(int32_t value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy* value) = 0;
    virtual HRESULT __stdcall put_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy value) = 0;
    virtual HRESULT __stdcall get_LineHeight(double* value) = 0;
    virtual HRESULT __stdcall put_LineHeight(double value) = 0;
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_CornerRadius(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CornerRadius(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Background(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Background(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnContentTemplateChanged(::IUnknown* oldContentTemplate, ::IUnknown* newContentTemplate) = 0;
    virtual HRESULT __stdcall OnContentTemplateSelectorChanged(::IUnknown* oldContentTemplateSelector, ::IUnknown* newContentTemplateSelector) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTransitionsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OpticalMarginAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextLineBoundsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContentPresenterStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextWrappingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxLinesProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CornerRadiusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalContentAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalContentAlignmentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IContextMenuEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
    virtual HRESULT __stdcall get_CursorLeft(double* value) = 0;
    virtual HRESULT __stdcall get_CursorTop(double* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FontStretch(Windows::UI::Text::FontStretch* value) = 0;
    virtual HRESULT __stdcall put_FontStretch(Windows::UI::Text::FontStretch value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacing(int32_t* value) = 0;
    virtual HRESULT __stdcall put_CharacterSpacing(int32_t value) = 0;
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsTabStop(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTabStop(bool value) = 0;
    virtual HRESULT __stdcall get_IsEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_TabIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall put_TabIndex(int32_t value) = 0;
    virtual HRESULT __stdcall get_TabNavigation(Windows::UI::Xaml::Input::KeyboardNavigationMode* value) = 0;
    virtual HRESULT __stdcall put_TabNavigation(Windows::UI::Xaml::Input::KeyboardNavigationMode value) = 0;
    virtual HRESULT __stdcall get_Template(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Template(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalContentAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalContentAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
    virtual HRESULT __stdcall get_Background(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Background(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FocusState(Windows::UI::Xaml::FocusState* value) = 0;
    virtual HRESULT __stdcall add_IsEnabledChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsEnabledChanged(event_token token) = 0;
    virtual HRESULT __stdcall ApplyTemplate(bool* returnValue) = 0;
    virtual HRESULT __stdcall Focus(Windows::UI::Xaml::FocusState value, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControl2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControl3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UseSystemFocusVisuals(bool* value) = 0;
    virtual HRESULT __stdcall put_UseSystemFocusVisuals(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControl4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsFocusEngagementEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFocusEngagementEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsFocusEngaged(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFocusEngaged(bool value) = 0;
    virtual HRESULT __stdcall get_RequiresPointer(Windows::UI::Xaml::Controls::RequiresPointer* value) = 0;
    virtual HRESULT __stdcall put_RequiresPointer(Windows::UI::Xaml::Controls::RequiresPointer value) = 0;
    virtual HRESULT __stdcall get_XYFocusLeft(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusLeft(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusRight(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusRight(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusUp(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusUp(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusDown(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusDown(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ElementSoundMode(Windows::UI::Xaml::ElementSoundMode* value) = 0;
    virtual HRESULT __stdcall put_ElementSoundMode(Windows::UI::Xaml::ElementSoundMode value) = 0;
    virtual HRESULT __stdcall add_FocusEngaged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FocusEngaged(event_token token) = 0;
    virtual HRESULT __stdcall add_FocusDisengaged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FocusDisengaged(event_token token) = 0;
    virtual HRESULT __stdcall RemoveFocusEngagement() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControl5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultStyleResourceUri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_DefaultStyleResourceUri(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnPointerEntered(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerPressed(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerMoved(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerReleased(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerExited(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerCaptureLost(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerCanceled(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPointerWheelChanged(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnTapped(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDoubleTapped(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnHolding(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnRightTapped(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnManipulationStarting(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnManipulationInertiaStarting(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnManipulationStarted(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnManipulationDelta(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnManipulationCompleted(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnKeyUp(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnKeyDown(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnGotFocus(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnLostFocus(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDragEnter(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDragLeave(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDragOver(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnDrop(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlOverrides6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnPreviewKeyDown(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnPreviewKeyUp(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnCharacterReceived(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlProtected>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultStyleKey(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_DefaultStyleKey(::IUnknown* value) = 0;
    virtual HRESULT __stdcall GetTemplateChild(HSTRING childName, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTabStopProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TabIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TabNavigationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalContentAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalContentAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultStyleKeyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FocusStateProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UseSystemFocusVisualsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTemplateFocusTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsTemplateFocusTarget(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetIsTemplateFocusTarget(::IUnknown* element, bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsFocusEngagementEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFocusEngagedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RequiresPointerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusLeftProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusRightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusUpProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusDownProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ElementSoundModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultStyleResourceUriProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTemplateKeyTipTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsTemplateKeyTipTarget(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetIsTemplateKeyTipTarget(::IUnknown* element, bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IControlTemplate>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TargetType(struct_of<8,16>* value) = 0;
    virtual HRESULT __stdcall put_TargetType(struct_of<8,16> value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDataTemplateSelector>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectTemplate(::IUnknown* item, ::IUnknown* container, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDataTemplateSelector2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectTemplateForItem(::IUnknown* item, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDataTemplateSelectorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectTemplateCore(::IUnknown* item, ::IUnknown* container, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDataTemplateSelectorOverrides2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectTemplateForItemCore(::IUnknown* item, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OldDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall get_NewDate(Windows::Foundation::DateTime* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePicker>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CalendarIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_CalendarIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Date(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_Date(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_DayVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_DayVisible(bool value) = 0;
    virtual HRESULT __stdcall get_MonthVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_MonthVisible(bool value) = 0;
    virtual HRESULT __stdcall get_YearVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_YearVisible(bool value) = 0;
    virtual HRESULT __stdcall get_DayFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DayFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_MonthFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_MonthFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_YearFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_YearFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_MinYear(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MinYear(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_MaxYear(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MaxYear(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall add_DateChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DateChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePicker2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CalendarIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_CalendarIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Date(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_Date(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_DayVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_DayVisible(bool value) = 0;
    virtual HRESULT __stdcall get_MonthVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_MonthVisible(bool value) = 0;
    virtual HRESULT __stdcall get_YearVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_YearVisible(bool value) = 0;
    virtual HRESULT __stdcall get_MinYear(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MinYear(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall get_MaxYear(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall put_MaxYear(Windows::Foundation::DateTime value) = 0;
    virtual HRESULT __stdcall add_DatePicked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DatePicked(event_token token) = 0;
    virtual HRESULT __stdcall ShowAtAsync(::IUnknown* target, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyout2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DayFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DayFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_MonthFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_MonthFormat(HSTRING value) = 0;
    virtual HRESULT __stdcall get_YearFormat(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_YearFormat(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyoutItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PrimaryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PrimaryText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SecondaryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SecondaryText(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyoutItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PrimaryTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SecondaryTextProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CalendarIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_YearVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinYearProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxYearProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerFlyoutStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DayFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_YearFormatProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CalendarIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_YearVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DayFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MonthFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_YearFormatProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinYearProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxYearProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDatePickerValueChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OldDate(Windows::Foundation::DateTime* value) = 0;
    virtual HRESULT __stdcall get_NewDate(Windows::Foundation::DateTime* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDragItemsCompletedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Items(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DropResult(Windows::ApplicationModel::DataTransfer::DataPackageOperation* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDragItemsStartingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
    virtual HRESULT __stdcall get_Items(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Data(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IDynamicOverflowItemsChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Action(Windows::UI::Xaml::Controls::CommandBarDynamicOverflowAction* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipView>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipView2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UseTouchAnimationsForAllNavigation(bool* value) = 0;
    virtual HRESULT __stdcall put_UseTouchAnimationsForAllNavigation(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipViewItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipViewItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlipViewStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_UseTouchAnimationsForAllNavigationProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FlyoutPresenterStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FlyoutPresenterStyle(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlyoutFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlyoutPresenterFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FlyoutPresenterStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFocusDisengagedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFocusEngagedEventArgs2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIcon>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Glyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Glyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIcon2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIcon3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MirroredWhenRightToLeft(bool* value) = 0;
    virtual HRESULT __stdcall put_MirroredWhenRightToLeft(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconSource>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Glyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Glyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_MirroredWhenRightToLeft(bool* value) = 0;
    virtual HRESULT __stdcall put_MirroredWhenRightToLeft(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconSourceFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconSourceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MirroredWhenRightToLeftProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFontIconStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MirroredWhenRightToLeftProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrame>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CacheSize(int32_t* value) = 0;
    virtual HRESULT __stdcall put_CacheSize(int32_t value) = 0;
    virtual HRESULT __stdcall get_CanGoBack(bool* value) = 0;
    virtual HRESULT __stdcall get_CanGoForward(bool* value) = 0;
    virtual HRESULT __stdcall get_CurrentSourcePageType(struct_of<8,16>* value) = 0;
    virtual HRESULT __stdcall get_SourcePageType(struct_of<8,16>* value) = 0;
    virtual HRESULT __stdcall put_SourcePageType(struct_of<8,16> value) = 0;
    virtual HRESULT __stdcall get_BackStackDepth(int32_t* value) = 0;
    virtual HRESULT __stdcall add_Navigated(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Navigated(event_token token) = 0;
    virtual HRESULT __stdcall add_Navigating(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Navigating(event_token token) = 0;
    virtual HRESULT __stdcall add_NavigationFailed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NavigationFailed(event_token token) = 0;
    virtual HRESULT __stdcall add_NavigationStopped(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NavigationStopped(event_token token) = 0;
    virtual HRESULT __stdcall GoBack() = 0;
    virtual HRESULT __stdcall GoForward() = 0;
    virtual HRESULT __stdcall Navigate(struct_of<8,16> sourcePageType, ::IUnknown* parameter, bool* returnValue) = 0;
    virtual HRESULT __stdcall GetNavigationState(HSTRING* returnValue) = 0;
    virtual HRESULT __stdcall SetNavigationState(HSTRING navigationState) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrame2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BackStack(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForwardStack(::IUnknown** value) = 0;
    virtual HRESULT __stdcall Navigate(struct_of<8,16> sourcePageType, ::IUnknown* parameter, ::IUnknown* infoOverride, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrame3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GoBack(::IUnknown* transitionInfoOverride) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrame4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SetNavigationStateWithNavigationControl(HSTRING navigationState, bool suppressNavigate) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrameFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrameStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CacheSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanGoBackProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanGoForwardProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CurrentSourcePageTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SourcePageTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BackStackDepthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IFrameStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BackStackProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForwardStackProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGrid>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RowDefinitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ColumnDefinitions(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGrid2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_CornerRadius(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CornerRadius(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGrid3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RowSpacing(double* value) = 0;
    virtual HRESULT __stdcall put_RowSpacing(double value) = 0;
    virtual HRESULT __stdcall get_ColumnSpacing(double* value) = 0;
    virtual HRESULT __stdcall put_ColumnSpacing(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetRow(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetRow(::IUnknown* element, int32_t value) = 0;
    virtual HRESULT __stdcall get_ColumnProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetColumn(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetColumn(::IUnknown* element, int32_t value) = 0;
    virtual HRESULT __stdcall get_RowSpanProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetRowSpan(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetRowSpan(::IUnknown* element, int32_t value) = 0;
    virtual HRESULT __stdcall get_ColumnSpanProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetColumnSpan(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetColumnSpan(::IUnknown* element, int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CornerRadiusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RowSpacingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ColumnSpacingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridView>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridViewHeaderItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridViewHeaderItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridViewItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGridViewItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyle>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Panel(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Panel(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContainerStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContainerStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContainerStyleSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContainerStyleSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplateSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HidesIfEmpty(bool* value) = 0;
    virtual HRESULT __stdcall put_HidesIfEmpty(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyle2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderContainerStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderContainerStyle(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyleFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyleSelector>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectGroupStyle(::IUnknown* group, uint32_t level, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyleSelectorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IGroupStyleSelectorOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectGroupStyleCore(::IUnknown* group, uint32_t level, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHub>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_DefaultSectionIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall put_DefaultSectionIndex(int32_t value) = 0;
    virtual HRESULT __stdcall get_Sections(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SectionsInView(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SectionHeaders(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_SectionHeaderClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SectionHeaderClick(event_token token) = 0;
    virtual HRESULT __stdcall add_SectionsInViewChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SectionsInViewChanged(event_token token) = 0;
    virtual HRESULT __stdcall ScrollToSection(::IUnknown* section) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubSection>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ContentTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ContentTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsHeaderInteractive(bool* value) = 0;
    virtual HRESULT __stdcall put_IsHeaderInteractive(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubSectionFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubSectionHeaderClickEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Section(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubSectionStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsHeaderInteractiveProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHubStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultSectionIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SemanticZoomOwnerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsActiveViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomedInViewProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHyperlinkButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_NavigateUri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_NavigateUri(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHyperlinkButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IHyperlinkButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_NavigateUriProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconElement>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconElementFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconElementStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconSource>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconSourceFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIconSourceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IImage>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
    virtual HRESULT __stdcall get_NineGrid(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_NineGrid(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_PlayToSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_ImageFailed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ImageFailed(event_token token) = 0;
    virtual HRESULT __stdcall add_ImageOpened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ImageOpened(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IImage2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetAsCastingSource(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IImage3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetAlphaMask(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IImageStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NineGridProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlayToSourceProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkCanvas>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_InkPresenter(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkCanvasFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbar>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_InitialControls(Windows::UI::Xaml::Controls::InkToolbarInitialControls* value) = 0;
    virtual HRESULT __stdcall put_InitialControls(Windows::UI::Xaml::Controls::InkToolbarInitialControls value) = 0;
    virtual HRESULT __stdcall get_Children(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ActiveTool(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ActiveTool(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_InkDrawingAttributes(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsRulerButtonChecked(bool* value) = 0;
    virtual HRESULT __stdcall put_IsRulerButtonChecked(bool value) = 0;
    virtual HRESULT __stdcall get_TargetInkCanvas(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TargetInkCanvas(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_ActiveToolChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ActiveToolChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_InkDrawingAttributesChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_InkDrawingAttributesChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_EraseAllClicked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_EraseAllClicked(event_token token) = 0;
    virtual HRESULT __stdcall add_IsRulerButtonCheckedChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsRulerButtonCheckedChanged(event_token token) = 0;
    virtual HRESULT __stdcall GetToolButton(Windows::UI::Xaml::Controls::InkToolbarTool tool, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall GetToggleButton(Windows::UI::Xaml::Controls::InkToolbarToggle tool, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbar2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsStencilButtonChecked(bool* value) = 0;
    virtual HRESULT __stdcall put_IsStencilButtonChecked(bool value) = 0;
    virtual HRESULT __stdcall get_ButtonFlyoutPlacement(Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement* value) = 0;
    virtual HRESULT __stdcall put_ButtonFlyoutPlacement(Windows::UI::Xaml::Controls::InkToolbarButtonFlyoutPlacement value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall add_IsStencilButtonCheckedChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsStencilButtonCheckedChanged(event_token token) = 0;
    virtual HRESULT __stdcall GetMenuButton(Windows::UI::Xaml::Controls::InkToolbarMenuKind menu, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarBallpointPenButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPen>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInkDrawingAttributes(::IUnknown* brush, double strokeWidth, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CustomPen(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CustomPen(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ConfigurationContent(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ConfigurationContent(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPenButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CustomPenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ConfigurationContentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPenFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomPenOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInkDrawingAttributesCore(::IUnknown* brush, double strokeWidth, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomToggleButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ConfigurationContent(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ConfigurationContent(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarCustomToolButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ConfigurationContentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarEraserButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarEraserButton2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsClearAllVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsClearAllVisible(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarEraserButtonStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsClearAllVisibleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Kind(Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind* value) = 0;
    virtual HRESULT __stdcall put_Kind(Windows::UI::Xaml::Controls::InkToolbarFlyoutItemKind value) = 0;
    virtual HRESULT __stdcall get_IsChecked(bool* value) = 0;
    virtual HRESULT __stdcall put_IsChecked(bool value) = 0;
    virtual HRESULT __stdcall add_Checked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Checked(event_token token) = 0;
    virtual HRESULT __stdcall add_Unchecked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Unchecked(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarFlyoutItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_KindProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsCheckedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarHighlighterButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarIsStencilButtonCheckedChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_StencilButton(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StencilKind(Windows::UI::Xaml::Controls::InkToolbarStencilKind* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarMenuButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MenuKind(Windows::UI::Xaml::Controls::InkToolbarMenuKind* value) = 0;
    virtual HRESULT __stdcall get_IsExtensionGlyphShown(bool* value) = 0;
    virtual HRESULT __stdcall put_IsExtensionGlyphShown(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarMenuButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsExtensionGlyphShownProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Palette(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Palette(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MinStrokeWidth(double* value) = 0;
    virtual HRESULT __stdcall put_MinStrokeWidth(double value) = 0;
    virtual HRESULT __stdcall get_MaxStrokeWidth(double* value) = 0;
    virtual HRESULT __stdcall put_MaxStrokeWidth(double value) = 0;
    virtual HRESULT __stdcall get_SelectedBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedBrushIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall put_SelectedBrushIndex(int32_t value) = 0;
    virtual HRESULT __stdcall get_SelectedStrokeWidth(double* value) = 0;
    virtual HRESULT __stdcall put_SelectedStrokeWidth(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenButtonFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PaletteProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinStrokeWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxStrokeWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedBrushIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedStrokeWidthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PenButton(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPenConfigurationControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PenButtonProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPencilButton>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarPencilButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarRulerButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Ruler(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarRulerButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RulerProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_InitialControlsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ChildrenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ActiveToolProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InkDrawingAttributesProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsRulerButtonCheckedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TargetInkCanvasProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsStencilButtonCheckedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ButtonFlyoutPlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarStencilButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Ruler(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Protractor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedStencil(Windows::UI::Xaml::Controls::InkToolbarStencilKind* value) = 0;
    virtual HRESULT __stdcall put_SelectedStencil(Windows::UI::Xaml::Controls::InkToolbarStencilKind value) = 0;
    virtual HRESULT __stdcall get_IsRulerItemVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsRulerItemVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsProtractorItemVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsProtractorItemVisible(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarStencilButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_RulerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ProtractorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedStencilProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsRulerItemVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsProtractorItemVisibleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarToggleButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ToggleKind(Windows::UI::Xaml::Controls::InkToolbarToggle* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarToggleButtonFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarToolButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ToolKind(Windows::UI::Xaml::Controls::InkToolbarTool* value) = 0;
    virtual HRESULT __stdcall get_IsExtensionGlyphShown(bool* value) = 0;
    virtual HRESULT __stdcall put_IsExtensionGlyphShown(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarToolButtonFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInkToolbarToolButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsExtensionGlyphShownProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IInsertionPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetInsertionIndexes(Windows::Foundation::Point position, int32_t* first, int32_t* second) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IIsTextTrimmedChangedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemClickEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClickedItem(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemContainerGenerator>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_ItemsChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ItemsChanged(event_token token) = 0;
    virtual HRESULT __stdcall ItemFromContainer(::IUnknown* container, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ContainerFromItem(::IUnknown* item, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall IndexFromContainer(::IUnknown* container, int32_t* returnValue) = 0;
    virtual HRESULT __stdcall ContainerFromIndex(int32_t index, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall GetItemContainerGeneratorForPanel(::IUnknown* panel, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall StartAt(struct_of<8> position, Windows::UI::Xaml::Controls::Primitives::GeneratorDirection direction, bool allowStartAtRealizedItem) = 0;
    virtual HRESULT __stdcall Stop() = 0;
    virtual HRESULT __stdcall GenerateNext(bool* isNewlyRealized, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall PrepareItemContainer(::IUnknown* container) = 0;
    virtual HRESULT __stdcall RemoveAll() = 0;
    virtual HRESULT __stdcall Remove(struct_of<8> position, int32_t count) = 0;
    virtual HRESULT __stdcall GeneratorPositionFromIndex(int32_t itemIndex, struct_of<8>* returnValue) = 0;
    virtual HRESULT __stdcall IndexFromGeneratorPosition(struct_of<8> position, int32_t* returnValue) = 0;
    virtual HRESULT __stdcall Recycle(struct_of<8> position, int32_t count) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemContainerMapping>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall ItemFromContainer(::IUnknown* container, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ContainerFromItem(::IUnknown* item, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall IndexFromContainer(::IUnknown* container, int32_t* returnValue) = 0;
    virtual HRESULT __stdcall ContainerFromIndex(int32_t index, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemsSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemsSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Items(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ItemTemplateSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemTemplateSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ItemsPanel(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemsPanel(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DisplayMemberPath(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DisplayMemberPath(HSTRING value) = 0;
    virtual HRESULT __stdcall get_ItemContainerStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemContainerStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ItemContainerStyleSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemContainerStyleSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ItemContainerGenerator(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemContainerTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemContainerTransitions(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_GroupStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_GroupStyleSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_GroupStyleSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsGrouping(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControl2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemsPanelRoot(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControl3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GroupHeaderContainerFromItemContainer(::IUnknown* itemContainer, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControlOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall IsItemItsOwnContainerOverride(::IUnknown* item, bool* returnValue) = 0;
    virtual HRESULT __stdcall GetContainerForItemOverride(::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ClearContainerForItemOverride(::IUnknown* element, ::IUnknown* item) = 0;
    virtual HRESULT __stdcall PrepareContainerForItemOverride(::IUnknown* element, ::IUnknown* item) = 0;
    virtual HRESULT __stdcall OnItemsChanged(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnItemContainerStyleChanged(::IUnknown* oldItemContainerStyle, ::IUnknown* newItemContainerStyle) = 0;
    virtual HRESULT __stdcall OnItemContainerStyleSelectorChanged(::IUnknown* oldItemContainerStyleSelector, ::IUnknown* newItemContainerStyleSelector) = 0;
    virtual HRESULT __stdcall OnItemTemplateChanged(::IUnknown* oldItemTemplate, ::IUnknown* newItemTemplate) = 0;
    virtual HRESULT __stdcall OnItemTemplateSelectorChanged(::IUnknown* oldItemTemplateSelector, ::IUnknown* newItemTemplateSelector) = 0;
    virtual HRESULT __stdcall OnGroupStyleSelectorChanged(::IUnknown* oldGroupStyleSelector, ::IUnknown* newGroupStyleSelector) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemsSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemTemplateSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemsPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayMemberPathProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemContainerStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemContainerStyleSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemContainerTransitionsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_GroupStyleSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsGroupingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetItemsOwner(::IUnknown* element, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ItemsControlFromItemContainer(::IUnknown* container, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPanelTemplate>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPickedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AddedItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RemovedItems(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPresenter>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTransitions(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPresenter2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Footer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Footer(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FooterTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FooterTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FooterTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FooterTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPresenterStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTransitionsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsPresenterStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FooterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FooterTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FooterTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsStackPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupPadding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_GroupPadding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_FirstCacheIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_FirstVisibleIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_LastVisibleIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_LastCacheIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_ScrollingDirection(Windows::UI::Xaml::Controls::PanelScrollingDirection* value) = 0;
    virtual HRESULT __stdcall get_GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement* value) = 0;
    virtual HRESULT __stdcall put_GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement value) = 0;
    virtual HRESULT __stdcall get_ItemsUpdatingScrollMode(Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode* value) = 0;
    virtual HRESULT __stdcall put_ItemsUpdatingScrollMode(Windows::UI::Xaml::Controls::ItemsUpdatingScrollMode value) = 0;
    virtual HRESULT __stdcall get_CacheLength(double* value) = 0;
    virtual HRESULT __stdcall put_CacheLength(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsStackPanel2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreStickyGroupHeadersEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_AreStickyGroupHeadersEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsStackPanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupPaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_GroupHeaderPlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CacheLengthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsStackPanelStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreStickyGroupHeadersEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsWrapGrid>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupPadding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_GroupPadding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumns(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaximumRowsOrColumns(int32_t value) = 0;
    virtual HRESULT __stdcall get_ItemWidth(double* value) = 0;
    virtual HRESULT __stdcall put_ItemWidth(double value) = 0;
    virtual HRESULT __stdcall get_ItemHeight(double* value) = 0;
    virtual HRESULT __stdcall put_ItemHeight(double value) = 0;
    virtual HRESULT __stdcall get_FirstCacheIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_FirstVisibleIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_LastVisibleIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_LastCacheIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_ScrollingDirection(Windows::UI::Xaml::Controls::PanelScrollingDirection* value) = 0;
    virtual HRESULT __stdcall get_GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement* value) = 0;
    virtual HRESULT __stdcall put_GroupHeaderPlacement(Windows::UI::Xaml::Controls::Primitives::GroupHeaderPlacement value) = 0;
    virtual HRESULT __stdcall get_CacheLength(double* value) = 0;
    virtual HRESULT __stdcall put_CacheLength(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsWrapGrid2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreStickyGroupHeadersEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_AreStickyGroupHeadersEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsWrapGridStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupPaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumnsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_GroupHeaderPlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CacheLengthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IItemsWrapGridStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreStickyGroupHeadersEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectedItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionMode(Windows::UI::Xaml::Controls::SelectionMode* value) = 0;
    virtual HRESULT __stdcall put_SelectionMode(Windows::UI::Xaml::Controls::SelectionMode value) = 0;
    virtual HRESULT __stdcall ScrollIntoView(::IUnknown* item) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SingleSelectionFollowsFocus(bool* value) = 0;
    virtual HRESULT __stdcall put_SingleSelectionFollowsFocus(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBoxItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBoxItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SingleSelectionFollowsFocusProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListPickerFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemsSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemsSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ItemTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DisplayMemberPath(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DisplayMemberPath(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectionMode(Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode* value) = 0;
    virtual HRESULT __stdcall put_SelectionMode(Windows::UI::Xaml::Controls::ListPickerFlyoutSelectionMode value) = 0;
    virtual HRESULT __stdcall get_SelectedIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall put_SelectedIndex(int32_t value) = 0;
    virtual HRESULT __stdcall get_SelectedItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedItem(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedValue(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedValue(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedValuePath(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SelectedValuePath(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectedItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_ItemsPicked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ItemsPicked(event_token token) = 0;
    virtual HRESULT __stdcall ShowAtAsync(::IUnknown* target, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListPickerFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListPickerFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemsSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayMemberPathProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedItemProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedValuePathProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListView>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectedItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionMode(Windows::UI::Xaml::Controls::ListViewSelectionMode* value) = 0;
    virtual HRESULT __stdcall put_SelectionMode(Windows::UI::Xaml::Controls::ListViewSelectionMode value) = 0;
    virtual HRESULT __stdcall get_IsSwipeEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSwipeEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_CanDragItems(bool* value) = 0;
    virtual HRESULT __stdcall put_CanDragItems(bool value) = 0;
    virtual HRESULT __stdcall get_CanReorderItems(bool* value) = 0;
    virtual HRESULT __stdcall put_CanReorderItems(bool value) = 0;
    virtual HRESULT __stdcall get_IsItemClickEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsItemClickEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_DataFetchSize(double* value) = 0;
    virtual HRESULT __stdcall put_DataFetchSize(double value) = 0;
    virtual HRESULT __stdcall get_IncrementalLoadingThreshold(double* value) = 0;
    virtual HRESULT __stdcall put_IncrementalLoadingThreshold(double value) = 0;
    virtual HRESULT __stdcall get_IncrementalLoadingTrigger(Windows::UI::Xaml::Controls::IncrementalLoadingTrigger* value) = 0;
    virtual HRESULT __stdcall put_IncrementalLoadingTrigger(Windows::UI::Xaml::Controls::IncrementalLoadingTrigger value) = 0;
    virtual HRESULT __stdcall add_ItemClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ItemClick(event_token token) = 0;
    virtual HRESULT __stdcall add_DragItemsStarting(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DragItemsStarting(event_token token) = 0;
    virtual HRESULT __stdcall ScrollIntoView(::IUnknown* item) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
    virtual HRESULT __stdcall LoadMoreItemsAsync(::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ScrollIntoViewWithAlignment(::IUnknown* item, Windows::UI::Xaml::Controls::ScrollIntoViewAlignment alignment) = 0;
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowsScrollingPlaceholders(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowsScrollingPlaceholders(bool value) = 0;
    virtual HRESULT __stdcall add_ContainerContentChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContainerContentChanging(event_token token) = 0;
    virtual HRESULT __stdcall SetDesiredContainerUpdateDuration(Windows::Foundation::TimeSpan duration) = 0;
    virtual HRESULT __stdcall get_Footer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Footer(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FooterTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FooterTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FooterTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FooterTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ReorderMode(Windows::UI::Xaml::Controls::ListViewReorderMode* value) = 0;
    virtual HRESULT __stdcall put_ReorderMode(Windows::UI::Xaml::Controls::ListViewReorderMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectedRanges(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsMultiSelectCheckBoxEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsMultiSelectCheckBoxEnabled(bool value) = 0;
    virtual HRESULT __stdcall add_DragItemsCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DragItemsCompleted(event_token token) = 0;
    virtual HRESULT __stdcall add_ChoosingItemContainer(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ChoosingItemContainer(event_token token) = 0;
    virtual HRESULT __stdcall add_ChoosingGroupHeaderContainer(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ChoosingGroupHeaderContainer(event_token token) = 0;
    virtual HRESULT __stdcall SelectRange(::IUnknown* itemIndexRange) = 0;
    virtual HRESULT __stdcall DeselectRange(::IUnknown* itemIndexRange) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SingleSelectionFollowsFocus(bool* value) = 0;
    virtual HRESULT __stdcall put_SingleSelectionFollowsFocus(bool value) = 0;
    virtual HRESULT __stdcall IsDragSource(bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBase6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall TryStartConnectedAnimationAsync(::IUnknown* animation, ::IUnknown* item, HSTRING elementName, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall PrepareConnectedAnimation(HSTRING key, ::IUnknown* item, HSTRING elementName, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseHeaderItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseHeaderItemFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSwipeEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanDragItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanReorderItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsItemClickEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DataFetchSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IncrementalLoadingThresholdProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IncrementalLoadingTriggerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SemanticZoomOwnerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsActiveViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomedInViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowsScrollingPlaceholdersProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FooterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FooterTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FooterTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ReorderModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsMultiSelectCheckBoxEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewBaseStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SingleSelectionFollowsFocusProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewHeaderItem>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewHeaderItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewPersistenceHelper>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IListViewPersistenceHelperStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetRelativeScrollPosition(::IUnknown* listViewBase, ::IUnknown* itemToKeyHandler, HSTRING* returnValue) = 0;
    virtual HRESULT __stdcall SetRelativeScrollPositionAsync(::IUnknown* listViewBase, HSTRING relativeScrollPosition, ::IUnknown* keyToItemHandler, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaElement>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PosterSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PosterSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsMuted(bool* value) = 0;
    virtual HRESULT __stdcall put_IsMuted(bool value) = 0;
    virtual HRESULT __stdcall get_IsAudioOnly(bool* value) = 0;
    virtual HRESULT __stdcall get_AutoPlay(bool* value) = 0;
    virtual HRESULT __stdcall put_AutoPlay(bool value) = 0;
    virtual HRESULT __stdcall get_Volume(double* value) = 0;
    virtual HRESULT __stdcall put_Volume(double value) = 0;
    virtual HRESULT __stdcall get_Balance(double* value) = 0;
    virtual HRESULT __stdcall put_Balance(double value) = 0;
    virtual HRESULT __stdcall get_NaturalVideoHeight(int32_t* value) = 0;
    virtual HRESULT __stdcall get_NaturalVideoWidth(int32_t* value) = 0;
    virtual HRESULT __stdcall get_NaturalDuration(struct_of<16>* value) = 0;
    virtual HRESULT __stdcall get_Position(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall put_Position(Windows::Foundation::TimeSpan value) = 0;
    virtual HRESULT __stdcall get_DownloadProgress(double* value) = 0;
    virtual HRESULT __stdcall get_BufferingProgress(double* value) = 0;
    virtual HRESULT __stdcall get_DownloadProgressOffset(double* value) = 0;
    virtual HRESULT __stdcall get_CurrentState(Windows::UI::Xaml::Media::MediaElementState* value) = 0;
    virtual HRESULT __stdcall get_Markers(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanSeek(bool* value) = 0;
    virtual HRESULT __stdcall get_CanPause(bool* value) = 0;
    virtual HRESULT __stdcall get_AudioStreamCount(int32_t* value) = 0;
    virtual HRESULT __stdcall get_AudioStreamIndex(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_AudioStreamIndex(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaybackRate(double* value) = 0;
    virtual HRESULT __stdcall put_PlaybackRate(double value) = 0;
    virtual HRESULT __stdcall get_IsLooping(bool* value) = 0;
    virtual HRESULT __stdcall put_IsLooping(bool value) = 0;
    virtual HRESULT __stdcall get_PlayToSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultPlaybackRate(double* value) = 0;
    virtual HRESULT __stdcall put_DefaultPlaybackRate(double value) = 0;
    virtual HRESULT __stdcall get_AspectRatioWidth(int32_t* value) = 0;
    virtual HRESULT __stdcall get_AspectRatioHeight(int32_t* value) = 0;
    virtual HRESULT __stdcall get_RealTimePlayback(bool* value) = 0;
    virtual HRESULT __stdcall put_RealTimePlayback(bool value) = 0;
    virtual HRESULT __stdcall get_AudioCategory(Windows::UI::Xaml::Media::AudioCategory* value) = 0;
    virtual HRESULT __stdcall put_AudioCategory(Windows::UI::Xaml::Media::AudioCategory value) = 0;
    virtual HRESULT __stdcall get_AudioDeviceType(Windows::UI::Xaml::Media::AudioDeviceType* value) = 0;
    virtual HRESULT __stdcall put_AudioDeviceType(Windows::UI::Xaml::Media::AudioDeviceType value) = 0;
    virtual HRESULT __stdcall get_ProtectionManager(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ProtectionManager(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stereo3DVideoPackingMode(Windows::UI::Xaml::Media::Stereo3DVideoPackingMode* value) = 0;
    virtual HRESULT __stdcall put_Stereo3DVideoPackingMode(Windows::UI::Xaml::Media::Stereo3DVideoPackingMode value) = 0;
    virtual HRESULT __stdcall get_Stereo3DVideoRenderMode(Windows::UI::Xaml::Media::Stereo3DVideoRenderMode* value) = 0;
    virtual HRESULT __stdcall put_Stereo3DVideoRenderMode(Windows::UI::Xaml::Media::Stereo3DVideoRenderMode value) = 0;
    virtual HRESULT __stdcall get_IsStereo3DVideo(bool* value) = 0;
    virtual HRESULT __stdcall add_MediaOpened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_MediaOpened(event_token token) = 0;
    virtual HRESULT __stdcall add_MediaEnded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_MediaEnded(event_token token) = 0;
    virtual HRESULT __stdcall add_MediaFailed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_MediaFailed(event_token token) = 0;
    virtual HRESULT __stdcall add_DownloadProgressChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DownloadProgressChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_BufferingProgressChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_BufferingProgressChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_CurrentStateChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CurrentStateChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_MarkerReached(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_MarkerReached(event_token token) = 0;
    virtual HRESULT __stdcall add_RateChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_RateChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_VolumeChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_VolumeChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_SeekCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SeekCompleted(event_token token) = 0;
    virtual HRESULT __stdcall Stop() = 0;
    virtual HRESULT __stdcall Play() = 0;
    virtual HRESULT __stdcall Pause() = 0;
    virtual HRESULT __stdcall CanPlayType(HSTRING type, Windows::UI::Xaml::Media::MediaCanPlayResponse* returnValue) = 0;
    virtual HRESULT __stdcall SetSource(::IUnknown* stream, HSTRING mimeType) = 0;
    virtual HRESULT __stdcall GetAudioStreamLanguage(::IUnknown* index, HSTRING* returnValue) = 0;
    virtual HRESULT __stdcall AddAudioEffect(HSTRING effectID, bool effectOptional, ::IUnknown* effectConfiguration) = 0;
    virtual HRESULT __stdcall AddVideoEffect(HSTRING effectID, bool effectOptional, ::IUnknown* effectConfiguration) = 0;
    virtual HRESULT __stdcall RemoveAllEffects() = 0;
    virtual HRESULT __stdcall get_ActualStereo3DVideoPackingMode(Windows::UI::Xaml::Media::Stereo3DVideoPackingMode* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaElement2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreTransportControlsEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_AreTransportControlsEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
    virtual HRESULT __stdcall get_IsFullWindow(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFullWindow(bool value) = 0;
    virtual HRESULT __stdcall SetMediaStreamSource(::IUnknown* source) = 0;
    virtual HRESULT __stdcall get_PlayToPreferredSourceUri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PlayToPreferredSourceUri(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaElement3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TransportControls(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TransportControls(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_PartialMediaFailureDetected(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PartialMediaFailureDetected(event_token token) = 0;
    virtual HRESULT __stdcall SetPlaybackSource(::IUnknown* source) = 0;
    virtual HRESULT __stdcall GetAsCastingSource(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaElementStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PosterSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsMutedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsAudioOnlyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AutoPlayProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VolumeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BalanceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NaturalVideoHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NaturalVideoWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NaturalDurationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PositionProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DownloadProgressProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BufferingProgressProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DownloadProgressOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CurrentStateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanSeekProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanPauseProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AudioStreamCountProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AudioStreamIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaybackRateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsLoopingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlayToSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultPlaybackRateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AspectRatioWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AspectRatioHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RealTimePlaybackProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AudioCategoryProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AudioDeviceTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ProtectionManagerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Stereo3DVideoPackingModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Stereo3DVideoRenderModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsStereo3DVideoProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ActualStereo3DVideoPackingModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaElementStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreTransportControlsEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFullWindowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlayToPreferredSourceUriProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerElement>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TransportControls(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TransportControls(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AreTransportControlsEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_AreTransportControlsEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_PosterSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PosterSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
    virtual HRESULT __stdcall get_AutoPlay(bool* value) = 0;
    virtual HRESULT __stdcall put_AutoPlay(bool value) = 0;
    virtual HRESULT __stdcall get_IsFullWindow(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFullWindow(bool value) = 0;
    virtual HRESULT __stdcall get_MediaPlayer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetMediaPlayer(::IUnknown* mediaPlayer) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerElementFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerElementStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AreTransportControlsEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PosterSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AutoPlayProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFullWindowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MediaPlayerProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerPresenter>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MediaPlayer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MediaPlayer(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
    virtual HRESULT __stdcall get_IsFullWindow(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFullWindow(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerPresenterFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaPlayerPresenterStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MediaPlayerProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFullWindowProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControls>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsFullWindowButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFullWindowButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsFullWindowEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFullWindowEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsZoomButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsZoomEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsFastForwardButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFastForwardButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsFastForwardEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFastForwardEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsFastRewindButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFastRewindButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsFastRewindEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsFastRewindEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsStopButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsStopButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsStopEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsStopEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsVolumeButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsVolumeButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsVolumeEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsVolumeEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsPlaybackRateButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPlaybackRateButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsPlaybackRateEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPlaybackRateEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsSeekBarVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSeekBarVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsSeekEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSeekEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsCompact(bool* value) = 0;
    virtual HRESULT __stdcall put_IsCompact(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControls2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsSkipForwardButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSkipForwardButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsSkipForwardEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSkipForwardEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsSkipBackwardButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSkipBackwardButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsSkipBackwardEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSkipBackwardEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsNextTrackButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsNextTrackButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsPreviousTrackButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPreviousTrackButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_FastPlayFallbackBehaviour(Windows::UI::Xaml::Media::FastPlayFallbackBehaviour* value) = 0;
    virtual HRESULT __stdcall put_FastPlayFallbackBehaviour(Windows::UI::Xaml::Media::FastPlayFallbackBehaviour value) = 0;
    virtual HRESULT __stdcall add_ThumbnailRequested(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ThumbnailRequested(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControls3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowAndHideAutomatically(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowAndHideAutomatically(bool value) = 0;
    virtual HRESULT __stdcall get_IsRepeatEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsRepeatEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsRepeatButtonVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_IsRepeatButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall Show() = 0;
    virtual HRESULT __stdcall Hide() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsHelper>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsHelperStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DropoutOrderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetDropoutOrder(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetDropoutOrder(::IUnknown* element, ::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsFullWindowButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFullWindowEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFastForwardButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFastForwardEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFastRewindButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsFastRewindEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsStopButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsStopEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsVolumeButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsVolumeEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPlaybackRateButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPlaybackRateEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSeekBarVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSeekEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsCompactProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsSkipForwardButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSkipForwardEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSkipBackwardButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSkipBackwardEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsNextTrackButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPreviousTrackButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FastPlayFallbackBehaviourProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMediaTransportControlsStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ShowAndHideAutomaticallyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsRepeatEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsRepeatButtonVisibleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Items(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuFlyoutPresenterStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuFlyoutPresenterStyle(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyout2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall ShowAt(::IUnknown* targetElement, Windows::Foundation::Point point) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Command(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Command(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CommandParameter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CommandParameter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_Click(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Click(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItem2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Icon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Icon(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItemBase>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItemBaseFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CommandProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CommandParameterProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutItemStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IconProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutPresenter2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutPresenterFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSeparator>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSeparatorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MenuFlyoutPresenterStyleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Items(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSubItem2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Icon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Icon(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IMenuFlyoutSubItemStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IconProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigate>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall Navigate(struct_of<8,16> sourcePageType, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsPaneOpen(bool* result) = 0;
    virtual HRESULT __stdcall put_IsPaneOpen(bool value) = 0;
    virtual HRESULT __stdcall get_CompactModeThresholdWidth(double* result) = 0;
    virtual HRESULT __stdcall put_CompactModeThresholdWidth(double value) = 0;
    virtual HRESULT __stdcall get_ExpandedModeThresholdWidth(double* result) = 0;
    virtual HRESULT __stdcall put_ExpandedModeThresholdWidth(double value) = 0;
    virtual HRESULT __stdcall get_PaneFooter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PaneFooter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DisplayMode(Windows::UI::Xaml::Controls::NavigationViewDisplayMode* result) = 0;
    virtual HRESULT __stdcall get_IsSettingsVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsSettingsVisible(bool value) = 0;
    virtual HRESULT __stdcall get_IsPaneToggleButtonVisible(bool* result) = 0;
    virtual HRESULT __stdcall put_IsPaneToggleButtonVisible(bool value) = 0;
    virtual HRESULT __stdcall get_AlwaysShowHeader(bool* result) = 0;
    virtual HRESULT __stdcall put_AlwaysShowHeader(bool value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLength(double* result) = 0;
    virtual HRESULT __stdcall put_CompactPaneLength(double value) = 0;
    virtual HRESULT __stdcall get_OpenPaneLength(double* result) = 0;
    virtual HRESULT __stdcall put_OpenPaneLength(double value) = 0;
    virtual HRESULT __stdcall get_PaneToggleButtonStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PaneToggleButtonStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedItem(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MenuItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemsSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuItemsSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SettingsItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AutoSuggestBox(::IUnknown** result) = 0;
    virtual HRESULT __stdcall put_AutoSuggestBox(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MenuItemTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuItemTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MenuItemTemplateSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuItemTemplateSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MenuItemContainerStyle(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuItemContainerStyle(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MenuItemContainerStyleSelector(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_MenuItemContainerStyleSelector(::IUnknown* value) = 0;
    virtual HRESULT __stdcall MenuItemFromContainer(::IUnknown* container, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall ContainerFromMenuItem(::IUnknown* item, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ItemInvoked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ItemInvoked(event_token token) = 0;
    virtual HRESULT __stdcall add_DisplayModeChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DisplayModeChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewDisplayModeChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DisplayMode(Windows::UI::Xaml::Controls::NavigationViewDisplayMode* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Icon(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Icon(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLength(double* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemBase>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemBaseFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemHeader>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemHeaderFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemInvokedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_InvokedItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSettingsInvoked(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemSeparator>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemSeparatorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IconProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLengthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewList>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewListFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewSelectionChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectedItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSettingsSelected(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INavigationViewStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsPaneOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CompactModeThresholdWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ExpandedModeThresholdWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaneFooterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSettingsVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPaneToggleButtonVisibleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AlwaysShowHeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLengthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OpenPaneLengthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaneToggleButtonStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemsSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedItemProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SettingsItemProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AutoSuggestBoxProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemTemplateSelectorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemContainerStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MenuItemContainerStyleSelectorProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INotifyEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Value(HSTRING* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::INotifyEventArgs2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CallingUri(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPage>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Frame(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_NavigationCacheMode(Windows::UI::Xaml::Navigation::NavigationCacheMode* value) = 0;
    virtual HRESULT __stdcall put_NavigationCacheMode(Windows::UI::Xaml::Navigation::NavigationCacheMode value) = 0;
    virtual HRESULT __stdcall get_TopAppBar(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TopAppBar(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BottomAppBar(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BottomAppBar(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPageFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPageOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnNavigatedFrom(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnNavigatedTo(::IUnknown* e) = 0;
    virtual HRESULT __stdcall OnNavigatingFrom(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPageStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FrameProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TopAppBarProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BottomAppBarProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Children(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Background(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Background(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsItemsHost(bool* value) = 0;
    virtual HRESULT __stdcall get_ChildrenTransitions(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ChildrenTransitions(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPanelFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsItemsHostProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ChildrenTransitionsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IParallaxView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Child(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Child(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HorizontalShift(double* value) = 0;
    virtual HRESULT __stdcall put_HorizontalShift(double value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceEndOffset(double* value) = 0;
    virtual HRESULT __stdcall put_HorizontalSourceEndOffset(double value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind* value) = 0;
    virtual HRESULT __stdcall put_HorizontalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceStartOffset(double* value) = 0;
    virtual HRESULT __stdcall put_HorizontalSourceStartOffset(double value) = 0;
    virtual HRESULT __stdcall get_IsHorizontalShiftClamped(bool* value) = 0;
    virtual HRESULT __stdcall put_IsHorizontalShiftClamped(bool value) = 0;
    virtual HRESULT __stdcall get_IsVerticalShiftClamped(bool* value) = 0;
    virtual HRESULT __stdcall put_IsVerticalShiftClamped(bool value) = 0;
    virtual HRESULT __stdcall get_MaxHorizontalShiftRatio(double* value) = 0;
    virtual HRESULT __stdcall put_MaxHorizontalShiftRatio(double value) = 0;
    virtual HRESULT __stdcall get_MaxVerticalShiftRatio(double* value) = 0;
    virtual HRESULT __stdcall put_MaxVerticalShiftRatio(double value) = 0;
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_VerticalShift(double* value) = 0;
    virtual HRESULT __stdcall put_VerticalShift(double value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceEndOffset(double* value) = 0;
    virtual HRESULT __stdcall put_VerticalSourceEndOffset(double value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind* value) = 0;
    virtual HRESULT __stdcall put_VerticalSourceOffsetKind(Windows::UI::Xaml::Controls::ParallaxSourceOffsetKind value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceStartOffset(double* value) = 0;
    virtual HRESULT __stdcall put_VerticalSourceStartOffset(double value) = 0;
    virtual HRESULT __stdcall RefreshAutomaticHorizontalOffsets() = 0;
    virtual HRESULT __stdcall RefreshAutomaticVerticalOffsets() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IParallaxViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IParallaxViewStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ChildProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceEndOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceOffsetKindProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalSourceStartOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxHorizontalShiftRatioProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalShiftProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsHorizontalShiftClampedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsVerticalShiftClampedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceEndOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceOffsetKindProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalSourceStartOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxVerticalShiftRatioProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalShiftProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Password(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Password(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PasswordChar(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PasswordChar(HSTRING value) = 0;
    virtual HRESULT __stdcall get_IsPasswordRevealButtonEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPasswordRevealButtonEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_MaxLength(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLength(int32_t value) = 0;
    virtual HRESULT __stdcall add_PasswordChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PasswordChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ContextMenuOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContextMenuOpening(event_token token) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocus(bool* value) = 0;
    virtual HRESULT __stdcall put_PreventKeyboardDisplayOnProgrammaticFocus(bool value) = 0;
    virtual HRESULT __stdcall add_Paste(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Paste(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBox3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PasswordRevealMode(Windows::UI::Xaml::Controls::PasswordRevealMode* value) = 0;
    virtual HRESULT __stdcall put_PasswordRevealMode(Windows::UI::Xaml::Controls::PasswordRevealMode value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder* value) = 0;
    virtual HRESULT __stdcall put_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder value) = 0;
    virtual HRESULT __stdcall get_InputScope(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_InputScope(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBox4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_PasswordChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PasswordChanging(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBoxPasswordChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsContentChanging(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PasswordProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PasswordCharProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPasswordRevealButtonEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxLengthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocusProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPasswordBoxStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PasswordRevealModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InputScopeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIcon>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Data(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Data(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIconFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIconSource>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Data(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Data(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIconSourceFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIconSourceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DataProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPathIconStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DataProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPersonPicture>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BadgeNumber(int32_t* value) = 0;
    virtual HRESULT __stdcall put_BadgeNumber(int32_t value) = 0;
    virtual HRESULT __stdcall get_BadgeGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_BadgeGlyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_BadgeImageSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BadgeImageSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BadgeText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_BadgeText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_IsGroup(bool* value) = 0;
    virtual HRESULT __stdcall put_IsGroup(bool value) = 0;
    virtual HRESULT __stdcall get_Contact(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Contact(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DisplayName(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DisplayName(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Initials(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Initials(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PreferSmallImage(bool* value) = 0;
    virtual HRESULT __stdcall put_PreferSmallImage(bool value) = 0;
    virtual HRESULT __stdcall get_ProfilePicture(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ProfilePicture(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPersonPictureFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPersonPictureStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BadgeNumberProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BadgeGlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BadgeImageSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BadgeTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsGroupProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContactProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayNameProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InitialsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PreferSmallImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ProfilePictureProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPickerConfirmedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPickerFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ConfirmationButtonsVisible(bool* value) = 0;
    virtual HRESULT __stdcall put_ConfirmationButtonsVisible(bool value) = 0;
    virtual HRESULT __stdcall add_Confirmed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Confirmed(event_token token) = 0;
    virtual HRESULT __stdcall ShowAtAsync(::IUnknown* target, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPickerFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPickerFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ConfirmationButtonsVisibleProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivot>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Title(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Title(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TitleTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TitleTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_SelectedIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall put_SelectedIndex(int32_t value) = 0;
    virtual HRESULT __stdcall get_SelectedItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectedItem(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsLocked(bool* value) = 0;
    virtual HRESULT __stdcall put_IsLocked(bool value) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_PivotItemLoading(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PivotItemLoading(event_token token) = 0;
    virtual HRESULT __stdcall add_PivotItemLoaded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PivotItemLoaded(event_token token) = 0;
    virtual HRESULT __stdcall add_PivotItemUnloading(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PivotItemUnloading(event_token token) = 0;
    virtual HRESULT __stdcall add_PivotItemUnloaded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PivotItemUnloaded(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivot2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftHeader(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_LeftHeader(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_LeftHeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_LeftHeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_RightHeader(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_RightHeader(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_RightHeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_RightHeaderTemplate(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivot3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderFocusVisualPlacement(Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement* value) = 0;
    virtual HRESULT __stdcall put_HeaderFocusVisualPlacement(Windows::UI::Xaml::Controls::PivotHeaderFocusVisualPlacement value) = 0;
    virtual HRESULT __stdcall get_IsHeaderItemsCarouselEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsHeaderItemsCarouselEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotItemEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Item(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Item(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TitleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TitleTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedIndexProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedItemProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsLockedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SlideInAnimationGroupProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetSlideInAnimationGroup(::IUnknown* element, Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup* value) = 0;
    virtual HRESULT __stdcall SetSlideInAnimationGroup(::IUnknown* element, Windows::UI::Xaml::Controls::PivotSlideInAnimationGroup value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftHeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LeftHeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RightHeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RightHeaderTemplateProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IPivotStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderFocusVisualPlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsHeaderItemsCarouselEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IProgressBar>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsIndeterminate(bool* value) = 0;
    virtual HRESULT __stdcall put_IsIndeterminate(bool value) = 0;
    virtual HRESULT __stdcall get_ShowError(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowError(bool value) = 0;
    virtual HRESULT __stdcall get_ShowPaused(bool* value) = 0;
    virtual HRESULT __stdcall put_ShowPaused(bool value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IProgressBarFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IProgressBarStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsIndeterminateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ShowErrorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ShowPausedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IProgressRing>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsActive(bool* value) = 0;
    virtual HRESULT __stdcall put_IsActive(bool value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IProgressRingStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsActiveProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRadioButton>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupName(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_GroupName(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRadioButtonFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRadioButtonStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_GroupNameProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Caption(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Caption(HSTRING value) = 0;
    virtual HRESULT __stdcall get_InitialSetValue(int32_t* value) = 0;
    virtual HRESULT __stdcall put_InitialSetValue(int32_t value) = 0;
    virtual HRESULT __stdcall get_IsClearEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsClearEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsReadOnly(bool* value) = 0;
    virtual HRESULT __stdcall put_IsReadOnly(bool value) = 0;
    virtual HRESULT __stdcall get_MaxRating(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxRating(int32_t value) = 0;
    virtual HRESULT __stdcall get_PlaceholderValue(double* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderValue(double value) = 0;
    virtual HRESULT __stdcall get_ItemInfo(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ItemInfo(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Value(double* value) = 0;
    virtual HRESULT __stdcall put_Value(double value) = 0;
    virtual HRESULT __stdcall add_ValueChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ValueChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CaptionProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InitialSetValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsClearEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsReadOnlyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxRatingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemInfoProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ValueProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemFontInfo>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DisabledGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_DisabledGlyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Glyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Glyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PointerOverGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PointerOverGlyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PointerOverPlaceholderGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PointerOverPlaceholderGlyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PlaceholderGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderGlyph(HSTRING value) = 0;
    virtual HRESULT __stdcall get_UnsetGlyph(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_UnsetGlyph(HSTRING value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemFontInfoFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemFontInfoStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DisabledGlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_GlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderGlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PointerOverGlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PointerOverPlaceholderGlyphProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_UnsetGlyphProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemImageInfo>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DisabledImage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_DisabledImage(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Image(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Image(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaceholderImage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PlaceholderImage(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PointerOverImage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PointerOverImage(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PointerOverPlaceholderImage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PointerOverPlaceholderImage(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_UnsetImage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_UnsetImage(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemImageInfoFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemImageInfoStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DisabledImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PointerOverImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PointerOverPlaceholderImageProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_UnsetImageProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemInfo>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRatingItemInfoFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRelativePanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_CornerRadius(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CornerRadius(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRelativePanelFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRelativePanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftOfProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetLeftOf(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetLeftOf(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AboveProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAbove(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAbove(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_RightOfProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetRightOf(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetRightOf(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BelowProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetBelow(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetBelow(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignHorizontalCenterWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignHorizontalCenterWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignHorizontalCenterWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignVerticalCenterWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignVerticalCenterWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignVerticalCenterWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignLeftWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignLeftWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignLeftWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignTopWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignTopWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignTopWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignRightWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignRightWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignRightWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignBottomWithProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignBottomWith(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetAlignBottomWith(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AlignLeftWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignLeftWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignLeftWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_AlignTopWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignTopWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignTopWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_AlignRightWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignRightWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignRightWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_AlignBottomWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignBottomWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignBottomWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_AlignHorizontalCenterWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignHorizontalCenterWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignHorizontalCenterWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_AlignVerticalCenterWithPanelProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetAlignVerticalCenterWithPanel(::IUnknown* element, bool* value) = 0;
    virtual HRESULT __stdcall SetAlignVerticalCenterWithPanel(::IUnknown* element, bool value) = 0;
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CornerRadiusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsReadOnly(bool* value) = 0;
    virtual HRESULT __stdcall put_IsReadOnly(bool value) = 0;
    virtual HRESULT __stdcall get_AcceptsReturn(bool* value) = 0;
    virtual HRESULT __stdcall put_AcceptsReturn(bool value) = 0;
    virtual HRESULT __stdcall get_TextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_TextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_TextWrapping(Windows::UI::Xaml::TextWrapping* value) = 0;
    virtual HRESULT __stdcall put_TextWrapping(Windows::UI::Xaml::TextWrapping value) = 0;
    virtual HRESULT __stdcall get_IsSpellCheckEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSpellCheckEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsTextPredictionEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextPredictionEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_Document(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InputScope(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_InputScope(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_TextChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ContextMenuOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContextMenuOpening(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocus(bool* value) = 0;
    virtual HRESULT __stdcall put_PreventKeyboardDisplayOnProgrammaticFocus(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsColorFontEnabled(bool value) = 0;
    virtual HRESULT __stdcall add_Paste(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Paste(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_TextCompositionStarted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionStarted(event_token token) = 0;
    virtual HRESULT __stdcall add_TextCompositionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_TextCompositionEnded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionEnded(event_token token) = 0;
    virtual HRESULT __stdcall get_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder* value) = 0;
    virtual HRESULT __stdcall put_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder value) = 0;
    virtual HRESULT __stdcall get_DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment* value) = 0;
    virtual HRESULT __stdcall put_DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment value) = 0;
    virtual HRESULT __stdcall add_CandidateWindowBoundsChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CandidateWindowBoundsChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_TextChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextChanging(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetLinguisticAlternativesAsync(::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall get_ClipboardCopyFormat(Windows::UI::Xaml::Controls::RichEditClipboardFormat* value) = 0;
    virtual HRESULT __stdcall put_ClipboardCopyFormat(Windows::UI::Xaml::Controls::RichEditClipboardFormat value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColorWhenNotFocused(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColorWhenNotFocused(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MaxLength(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLength(int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBox6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing* value) = 0;
    virtual HRESULT __stdcall put_CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing value) = 0;
    virtual HRESULT __stdcall get_DisabledFormattingAccelerators(Windows::UI::Xaml::Controls::DisabledFormattingAccelerators* value) = 0;
    virtual HRESULT __stdcall put_DisabledFormattingAccelerators(Windows::UI::Xaml::Controls::DisabledFormattingAccelerators value) = 0;
    virtual HRESULT __stdcall add_CopyingToClipboard(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CopyingToClipboard(event_token token) = 0;
    virtual HRESULT __stdcall add_CuttingToClipboard(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CuttingToClipboard(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsReadOnlyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AcceptsReturnProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextWrappingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSpellCheckEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextPredictionEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InputScopeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DesiredCandidateWindowAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClipboardCopyFormatProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColorWhenNotFocusedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxLengthProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxStatics6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalTextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterCasingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisabledFormattingAcceleratorsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichEditBoxTextChangingEventArgs2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsContentChanging(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlock>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FontStretch(Windows::UI::Text::FontStretch* value) = 0;
    virtual HRESULT __stdcall put_FontStretch(Windows::UI::Text::FontStretch value) = 0;
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TextWrapping(Windows::UI::Xaml::TextWrapping* value) = 0;
    virtual HRESULT __stdcall put_TextWrapping(Windows::UI::Xaml::TextWrapping value) = 0;
    virtual HRESULT __stdcall get_TextTrimming(Windows::UI::Xaml::TextTrimming* value) = 0;
    virtual HRESULT __stdcall put_TextTrimming(Windows::UI::Xaml::TextTrimming value) = 0;
    virtual HRESULT __stdcall get_TextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_TextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_Blocks(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_LineHeight(double* value) = 0;
    virtual HRESULT __stdcall put_LineHeight(double value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy* value) = 0;
    virtual HRESULT __stdcall put_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacing(int32_t* value) = 0;
    virtual HRESULT __stdcall put_CharacterSpacing(int32_t value) = 0;
    virtual HRESULT __stdcall get_OverflowContentTarget(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OverflowContentTarget(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsTextSelectionEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextSelectionEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_HasOverflowContent(bool* value) = 0;
    virtual HRESULT __stdcall get_SelectedText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_ContentStart(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentEnd(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionStart(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionEnd(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BaselineOffset(double* value) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ContextMenuOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContextMenuOpening(event_token token) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
    virtual HRESULT __stdcall Select(::IUnknown* start, ::IUnknown* end) = 0;
    virtual HRESULT __stdcall GetPositionFromPoint(Windows::Foundation::Point point, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall Focus(Windows::UI::Xaml::FocusState value, bool* returnValue) = 0;
    virtual HRESULT __stdcall get_TextIndent(double* value) = 0;
    virtual HRESULT __stdcall put_TextIndent(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlock2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxLines(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLines(int32_t value) = 0;
    virtual HRESULT __stdcall get_TextLineBounds(Windows::UI::Xaml::TextLineBounds* value) = 0;
    virtual HRESULT __stdcall put_TextLineBounds(Windows::UI::Xaml::TextLineBounds value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment* value) = 0;
    virtual HRESULT __stdcall put_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsColorFontEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder* value) = 0;
    virtual HRESULT __stdcall put_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlock3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlock4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextDecorations(Windows::UI::Text::TextDecorations* value) = 0;
    virtual HRESULT __stdcall put_TextDecorations(Windows::UI::Text::TextDecorations value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlock5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmed(bool* value) = 0;
    virtual HRESULT __stdcall get_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_TextHighlighters(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_IsTextTrimmedChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsTextTrimmedChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflow>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OverflowContentTarget(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OverflowContentTarget(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_ContentSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HasOverflowContent(bool* value) = 0;
    virtual HRESULT __stdcall get_ContentStart(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentEnd(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BaselineOffset(double* value) = 0;
    virtual HRESULT __stdcall GetPositionFromPoint(Windows::Foundation::Point point, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall Focus(Windows::UI::Xaml::FocusState value, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflow2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxLines(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLines(int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflow3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmed(bool* value) = 0;
    virtual HRESULT __stdcall add_IsTextTrimmedChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsTextTrimmedChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OverflowContentTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HasOverflowContentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxLinesProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockOverflowStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextWrappingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextTrimmingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OverflowContentTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextSelectionEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HasOverflowContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextIndentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MaxLinesProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextLineBoundsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OpticalMarginAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextDecorationsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRichTextBlockStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalTextAlignmentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRowDefinition>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Height(struct_of<16>* value) = 0;
    virtual HRESULT __stdcall put_Height(struct_of<16> value) = 0;
    virtual HRESULT __stdcall get_MaxHeight(double* value) = 0;
    virtual HRESULT __stdcall put_MaxHeight(double value) = 0;
    virtual HRESULT __stdcall get_MinHeight(double* value) = 0;
    virtual HRESULT __stdcall put_MinHeight(double value) = 0;
    virtual HRESULT __stdcall get_ActualHeight(double* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IRowDefinitionStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinHeightProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollContentPresenter>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CanVerticallyScroll(bool* value) = 0;
    virtual HRESULT __stdcall put_CanVerticallyScroll(bool value) = 0;
    virtual HRESULT __stdcall get_CanHorizontallyScroll(bool* value) = 0;
    virtual HRESULT __stdcall put_CanHorizontallyScroll(bool value) = 0;
    virtual HRESULT __stdcall get_ExtentWidth(double* value) = 0;
    virtual HRESULT __stdcall get_ExtentHeight(double* value) = 0;
    virtual HRESULT __stdcall get_ViewportWidth(double* value) = 0;
    virtual HRESULT __stdcall get_ViewportHeight(double* value) = 0;
    virtual HRESULT __stdcall get_HorizontalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_VerticalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_ScrollOwner(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ScrollOwner(::IUnknown* value) = 0;
    virtual HRESULT __stdcall LineUp() = 0;
    virtual HRESULT __stdcall LineDown() = 0;
    virtual HRESULT __stdcall LineLeft() = 0;
    virtual HRESULT __stdcall LineRight() = 0;
    virtual HRESULT __stdcall PageUp() = 0;
    virtual HRESULT __stdcall PageDown() = 0;
    virtual HRESULT __stdcall PageLeft() = 0;
    virtual HRESULT __stdcall PageRight() = 0;
    virtual HRESULT __stdcall MouseWheelUp() = 0;
    virtual HRESULT __stdcall MouseWheelDown() = 0;
    virtual HRESULT __stdcall MouseWheelLeft() = 0;
    virtual HRESULT __stdcall MouseWheelRight() = 0;
    virtual HRESULT __stdcall SetHorizontalOffset(double offset) = 0;
    virtual HRESULT __stdcall SetVerticalOffset(double offset) = 0;
    virtual HRESULT __stdcall MakeVisible(::IUnknown* visual, Windows::Foundation::Rect rectangle, Windows::Foundation::Rect* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewer>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility* value) = 0;
    virtual HRESULT __stdcall put_HorizontalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility value) = 0;
    virtual HRESULT __stdcall get_VerticalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility* value) = 0;
    virtual HRESULT __stdcall put_VerticalScrollBarVisibility(Windows::UI::Xaml::Controls::ScrollBarVisibility value) = 0;
    virtual HRESULT __stdcall get_IsHorizontalRailEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsHorizontalRailEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsVerticalRailEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsVerticalRailEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsHorizontalScrollChainingEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsHorizontalScrollChainingEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsVerticalScrollChainingEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsVerticalScrollChainingEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsZoomChainingEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomChainingEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsScrollInertiaEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsScrollInertiaEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsZoomInertiaEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomInertiaEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_HorizontalScrollMode(Windows::UI::Xaml::Controls::ScrollMode* value) = 0;
    virtual HRESULT __stdcall put_HorizontalScrollMode(Windows::UI::Xaml::Controls::ScrollMode value) = 0;
    virtual HRESULT __stdcall get_VerticalScrollMode(Windows::UI::Xaml::Controls::ScrollMode* value) = 0;
    virtual HRESULT __stdcall put_VerticalScrollMode(Windows::UI::Xaml::Controls::ScrollMode value) = 0;
    virtual HRESULT __stdcall get_ZoomMode(Windows::UI::Xaml::Controls::ZoomMode* value) = 0;
    virtual HRESULT __stdcall put_ZoomMode(Windows::UI::Xaml::Controls::ZoomMode value) = 0;
    virtual HRESULT __stdcall get_HorizontalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalSnapPointsAlignment(Windows::UI::Xaml::Controls::Primitives::SnapPointsAlignment value) = 0;
    virtual HRESULT __stdcall get_HorizontalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType* value) = 0;
    virtual HRESULT __stdcall put_HorizontalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType value) = 0;
    virtual HRESULT __stdcall get_VerticalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType* value) = 0;
    virtual HRESULT __stdcall put_VerticalSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType value) = 0;
    virtual HRESULT __stdcall get_ZoomSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType* value) = 0;
    virtual HRESULT __stdcall put_ZoomSnapPointsType(Windows::UI::Xaml::Controls::SnapPointsType value) = 0;
    virtual HRESULT __stdcall get_HorizontalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_ViewportWidth(double* value) = 0;
    virtual HRESULT __stdcall get_ScrollableWidth(double* value) = 0;
    virtual HRESULT __stdcall get_ComputedHorizontalScrollBarVisibility(Windows::UI::Xaml::Visibility* value) = 0;
    virtual HRESULT __stdcall get_ExtentWidth(double* value) = 0;
    virtual HRESULT __stdcall get_VerticalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_ViewportHeight(double* value) = 0;
    virtual HRESULT __stdcall get_ScrollableHeight(double* value) = 0;
    virtual HRESULT __stdcall get_ComputedVerticalScrollBarVisibility(Windows::UI::Xaml::Visibility* value) = 0;
    virtual HRESULT __stdcall get_ExtentHeight(double* value) = 0;
    virtual HRESULT __stdcall get_MinZoomFactor(float* value) = 0;
    virtual HRESULT __stdcall put_MinZoomFactor(float value) = 0;
    virtual HRESULT __stdcall get_MaxZoomFactor(float* value) = 0;
    virtual HRESULT __stdcall put_MaxZoomFactor(float value) = 0;
    virtual HRESULT __stdcall get_ZoomFactor(float* value) = 0;
    virtual HRESULT __stdcall get_ZoomSnapPoints(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_ViewChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ViewChanged(event_token token) = 0;
    virtual HRESULT __stdcall ScrollToHorizontalOffset(double offset) = 0;
    virtual HRESULT __stdcall ScrollToVerticalOffset(double offset) = 0;
    virtual HRESULT __stdcall ZoomToFactor(float factor) = 0;
    virtual HRESULT __stdcall InvalidateScrollInfo() = 0;
    virtual HRESULT __stdcall get_IsDeferredScrollingEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsDeferredScrollingEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_BringIntoViewOnFocusChange(bool* value) = 0;
    virtual HRESULT __stdcall put_BringIntoViewOnFocusChange(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewer2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TopLeftHeader(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TopLeftHeader(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_LeftHeader(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_LeftHeader(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TopHeader(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TopHeader(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_ViewChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ViewChanging(event_token token) = 0;
    virtual HRESULT __stdcall ChangeView(::IUnknown* horizontalOffset, ::IUnknown* verticalOffset, ::IUnknown* zoomFactor, bool* returnValue) = 0;
    virtual HRESULT __stdcall ChangeViewWithOptionalAnimation(::IUnknown* horizontalOffset, ::IUnknown* verticalOffset, ::IUnknown* zoomFactor, bool disableAnimation, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewer3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_DirectManipulationStarted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DirectManipulationStarted(event_token token) = 0;
    virtual HRESULT __stdcall add_DirectManipulationCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DirectManipulationCompleted(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewerStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalSnapPointsAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalSnapPointsAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalSnapPointsTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalSnapPointsTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ZoomSnapPointsTypeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ViewportWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ScrollableWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ComputedHorizontalScrollBarVisibilityProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ExtentWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ViewportHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ScrollableHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ComputedVerticalScrollBarVisibilityProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ExtentHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinZoomFactorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxZoomFactorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ZoomFactorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ZoomSnapPointsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalScrollBarVisibilityProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetHorizontalScrollBarVisibility(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollBarVisibility* horizontalScrollBarVisibility) = 0;
    virtual HRESULT __stdcall SetHorizontalScrollBarVisibility(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollBarVisibility horizontalScrollBarVisibility) = 0;
    virtual HRESULT __stdcall get_VerticalScrollBarVisibilityProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetVerticalScrollBarVisibility(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollBarVisibility* verticalScrollBarVisibility) = 0;
    virtual HRESULT __stdcall SetVerticalScrollBarVisibility(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollBarVisibility verticalScrollBarVisibility) = 0;
    virtual HRESULT __stdcall get_IsHorizontalRailEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsHorizontalRailEnabled(::IUnknown* element, bool* isHorizontalRailEnabled) = 0;
    virtual HRESULT __stdcall SetIsHorizontalRailEnabled(::IUnknown* element, bool isHorizontalRailEnabled) = 0;
    virtual HRESULT __stdcall get_IsVerticalRailEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsVerticalRailEnabled(::IUnknown* element, bool* isVerticalRailEnabled) = 0;
    virtual HRESULT __stdcall SetIsVerticalRailEnabled(::IUnknown* element, bool isVerticalRailEnabled) = 0;
    virtual HRESULT __stdcall get_IsHorizontalScrollChainingEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsHorizontalScrollChainingEnabled(::IUnknown* element, bool* isHorizontalScrollChainingEnabled) = 0;
    virtual HRESULT __stdcall SetIsHorizontalScrollChainingEnabled(::IUnknown* element, bool isHorizontalScrollChainingEnabled) = 0;
    virtual HRESULT __stdcall get_IsVerticalScrollChainingEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsVerticalScrollChainingEnabled(::IUnknown* element, bool* isVerticalScrollChainingEnabled) = 0;
    virtual HRESULT __stdcall SetIsVerticalScrollChainingEnabled(::IUnknown* element, bool isVerticalScrollChainingEnabled) = 0;
    virtual HRESULT __stdcall get_IsZoomChainingEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsZoomChainingEnabled(::IUnknown* element, bool* isZoomChainingEnabled) = 0;
    virtual HRESULT __stdcall SetIsZoomChainingEnabled(::IUnknown* element, bool isZoomChainingEnabled) = 0;
    virtual HRESULT __stdcall get_IsScrollInertiaEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsScrollInertiaEnabled(::IUnknown* element, bool* isScrollInertiaEnabled) = 0;
    virtual HRESULT __stdcall SetIsScrollInertiaEnabled(::IUnknown* element, bool isScrollInertiaEnabled) = 0;
    virtual HRESULT __stdcall get_IsZoomInertiaEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsZoomInertiaEnabled(::IUnknown* element, bool* isZoomInertiaEnabled) = 0;
    virtual HRESULT __stdcall SetIsZoomInertiaEnabled(::IUnknown* element, bool isZoomInertiaEnabled) = 0;
    virtual HRESULT __stdcall get_HorizontalScrollModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetHorizontalScrollMode(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollMode* horizontalScrollMode) = 0;
    virtual HRESULT __stdcall SetHorizontalScrollMode(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollMode horizontalScrollMode) = 0;
    virtual HRESULT __stdcall get_VerticalScrollModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetVerticalScrollMode(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollMode* verticalScrollMode) = 0;
    virtual HRESULT __stdcall SetVerticalScrollMode(::IUnknown* element, Windows::UI::Xaml::Controls::ScrollMode verticalScrollMode) = 0;
    virtual HRESULT __stdcall get_ZoomModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetZoomMode(::IUnknown* element, Windows::UI::Xaml::Controls::ZoomMode* zoomMode) = 0;
    virtual HRESULT __stdcall SetZoomMode(::IUnknown* element, Windows::UI::Xaml::Controls::ZoomMode zoomMode) = 0;
    virtual HRESULT __stdcall get_IsDeferredScrollingEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsDeferredScrollingEnabled(::IUnknown* element, bool* isDeferredScrollingEnabled) = 0;
    virtual HRESULT __stdcall SetIsDeferredScrollingEnabled(::IUnknown* element, bool isDeferredScrollingEnabled) = 0;
    virtual HRESULT __stdcall get_BringIntoViewOnFocusChangeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetBringIntoViewOnFocusChange(::IUnknown* element, bool* bringIntoViewOnFocusChange) = 0;
    virtual HRESULT __stdcall SetBringIntoViewOnFocusChange(::IUnknown* element, bool bringIntoViewOnFocusChange) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewerStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TopLeftHeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LeftHeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TopHeaderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewerView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_VerticalOffset(double* value) = 0;
    virtual HRESULT __stdcall get_ZoomFactor(float* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewerViewChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsIntermediate(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IScrollViewerViewChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_NextView(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FinalView(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsInertial(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SearchHistoryEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_SearchHistoryEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_SearchHistoryContext(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SearchHistoryContext(HSTRING value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_QueryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_QueryText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_FocusOnKeyboardInput(bool* value) = 0;
    virtual HRESULT __stdcall put_FocusOnKeyboardInput(bool value) = 0;
    virtual HRESULT __stdcall get_ChooseSuggestionOnEnter(bool* value) = 0;
    virtual HRESULT __stdcall put_ChooseSuggestionOnEnter(bool value) = 0;
    virtual HRESULT __stdcall add_QueryChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_QueryChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_SuggestionsRequested(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SuggestionsRequested(event_token token) = 0;
    virtual HRESULT __stdcall add_QuerySubmitted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_QuerySubmitted(event_token token) = 0;
    virtual HRESULT __stdcall add_ResultSuggestionChosen(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ResultSuggestionChosen(event_token token) = 0;
    virtual HRESULT __stdcall add_PrepareForFocusOnKeyboardInput(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PrepareForFocusOnKeyboardInput(event_token token) = 0;
    virtual HRESULT __stdcall SetLocalContentSuggestionSettings(::IUnknown* settings) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxQueryChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_Language(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_LinguisticDetails(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxQuerySubmittedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_Language(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_LinguisticDetails(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_KeyModifiers(Windows::System::VirtualKeyModifiers* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxResultSuggestionChosenEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Tag(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_KeyModifiers(Windows::System::VirtualKeyModifiers* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SearchHistoryEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SearchHistoryContextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_QueryTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FocusOnKeyboardInputProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ChooseSuggestionOnEnterProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISearchBoxSuggestionsRequestedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_QueryText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_Language(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_LinguisticDetails(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Request(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AddedSections(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RemovedSections(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISectionsInViewChangedEventArgsFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISelectionChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AddedItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RemovedItems(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISelectionChangedEventArgsFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstanceWithRemovedItemsAndAddedItems(::IUnknown* removedItems, ::IUnknown* addedItems, ::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISemanticZoom>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ZoomedInView(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ZoomedInView(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ZoomedOutView(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ZoomedOutView(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsZoomedInViewActive(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomedInViewActive(bool value) = 0;
    virtual HRESULT __stdcall get_CanChangeViews(bool* value) = 0;
    virtual HRESULT __stdcall put_CanChangeViews(bool value) = 0;
    virtual HRESULT __stdcall add_ViewChangeStarted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ViewChangeStarted(event_token token) = 0;
    virtual HRESULT __stdcall add_ViewChangeCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ViewChangeCompleted(event_token token) = 0;
    virtual HRESULT __stdcall ToggleActiveView() = 0;
    virtual HRESULT __stdcall get_IsZoomOutButtonEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomOutButtonEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISemanticZoomInformation>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SemanticZoomOwner(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SemanticZoomOwner(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsActiveView(bool* value) = 0;
    virtual HRESULT __stdcall put_IsActiveView(bool value) = 0;
    virtual HRESULT __stdcall get_IsZoomedInView(bool* value) = 0;
    virtual HRESULT __stdcall put_IsZoomedInView(bool value) = 0;
    virtual HRESULT __stdcall InitializeViewChange() = 0;
    virtual HRESULT __stdcall CompleteViewChange() = 0;
    virtual HRESULT __stdcall MakeVisible(::IUnknown* item) = 0;
    virtual HRESULT __stdcall StartViewChangeFrom(::IUnknown* source, ::IUnknown* destination) = 0;
    virtual HRESULT __stdcall StartViewChangeTo(::IUnknown* source, ::IUnknown* destination) = 0;
    virtual HRESULT __stdcall CompleteViewChangeFrom(::IUnknown* source, ::IUnknown* destination) = 0;
    virtual HRESULT __stdcall CompleteViewChangeTo(::IUnknown* source, ::IUnknown* destination) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISemanticZoomLocation>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Item(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Item(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Bounds(Windows::Foundation::Rect* value) = 0;
    virtual HRESULT __stdcall put_Bounds(Windows::Foundation::Rect value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISemanticZoomStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ZoomedInViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ZoomedOutViewProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomedInViewActiveProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanChangeViewsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsZoomOutButtonEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISemanticZoomViewChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsSourceZoomedInView(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSourceZoomedInView(bool value) = 0;
    virtual HRESULT __stdcall get_SourceItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SourceItem(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DestinationItem(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_DestinationItem(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISettingsFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Title(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Title(HSTRING value) = 0;
    virtual HRESULT __stdcall get_HeaderBackground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderBackground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IconSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_IconSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_BackClick(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_BackClick(event_token token) = 0;
    virtual HRESULT __stdcall Show() = 0;
    virtual HRESULT __stdcall ShowIndependent() = 0;
    virtual HRESULT __stdcall Hide() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISettingsFlyoutFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISettingsFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TitleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderBackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IconSourceProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISlider>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IntermediateValue(double* value) = 0;
    virtual HRESULT __stdcall put_IntermediateValue(double value) = 0;
    virtual HRESULT __stdcall get_StepFrequency(double* value) = 0;
    virtual HRESULT __stdcall put_StepFrequency(double value) = 0;
    virtual HRESULT __stdcall get_SnapsTo(Windows::UI::Xaml::Controls::Primitives::SliderSnapsTo* value) = 0;
    virtual HRESULT __stdcall put_SnapsTo(Windows::UI::Xaml::Controls::Primitives::SliderSnapsTo value) = 0;
    virtual HRESULT __stdcall get_TickFrequency(double* value) = 0;
    virtual HRESULT __stdcall put_TickFrequency(double value) = 0;
    virtual HRESULT __stdcall get_TickPlacement(Windows::UI::Xaml::Controls::Primitives::TickPlacement* value) = 0;
    virtual HRESULT __stdcall put_TickPlacement(Windows::UI::Xaml::Controls::Primitives::TickPlacement value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_IsDirectionReversed(bool* value) = 0;
    virtual HRESULT __stdcall put_IsDirectionReversed(bool value) = 0;
    virtual HRESULT __stdcall get_IsThumbToolTipEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsThumbToolTipEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_ThumbToolTipValueConverter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_ThumbToolTipValueConverter(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISlider2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISliderFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISliderStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IntermediateValueProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StepFrequencyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SnapsToProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TickFrequencyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TickPlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsDirectionReversedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsThumbToolTipEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ThumbToolTipValueConverterProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISliderStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Pane(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Pane(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_IsPaneOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsPaneOpen(bool value) = 0;
    virtual HRESULT __stdcall get_OpenPaneLength(double* value) = 0;
    virtual HRESULT __stdcall put_OpenPaneLength(double value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLength(double* value) = 0;
    virtual HRESULT __stdcall put_CompactPaneLength(double value) = 0;
    virtual HRESULT __stdcall get_PanePlacement(Windows::UI::Xaml::Controls::SplitViewPanePlacement* value) = 0;
    virtual HRESULT __stdcall put_PanePlacement(Windows::UI::Xaml::Controls::SplitViewPanePlacement value) = 0;
    virtual HRESULT __stdcall get_DisplayMode(Windows::UI::Xaml::Controls::SplitViewDisplayMode* value) = 0;
    virtual HRESULT __stdcall put_DisplayMode(Windows::UI::Xaml::Controls::SplitViewDisplayMode value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaneBackground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PaneBackground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_PaneClosing(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PaneClosing(event_token token) = 0;
    virtual HRESULT __stdcall add_PaneClosed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PaneClosed(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitView2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitView3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_PaneOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PaneOpening(event_token token) = 0;
    virtual HRESULT __stdcall add_PaneOpened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PaneOpened(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitViewFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitViewPaneClosingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitViewStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaneProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsPaneOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OpenPaneLengthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CompactPaneLengthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PanePlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DisplayModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TemplateSettingsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaneBackgroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISplitViewStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreScrollSnapPointsRegular(bool* value) = 0;
    virtual HRESULT __stdcall put_AreScrollSnapPointsRegular(bool value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanel2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrush(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BorderBrush(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BorderThickness(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_BorderThickness(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_CornerRadius(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_CornerRadius(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanel4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Spacing(double* value) = 0;
    virtual HRESULT __stdcall put_Spacing(double value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanelFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreScrollSnapPointsRegularProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanelStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_BorderBrushProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BorderThicknessProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CornerRadiusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStackPanelStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SpacingProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStyleSelector>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectStyle(::IUnknown* item, ::IUnknown* container, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStyleSelectorFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IStyleSelectorOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall SelectStyleCore(::IUnknown* item, ::IUnknown* container, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanel2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateCoreIndependentInputSource(Windows::UI::Core::CoreInputDeviceTypes deviceTypes, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainBackgroundPanelFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CompositionScaleX(float* value) = 0;
    virtual HRESULT __stdcall get_CompositionScaleY(float* value) = 0;
    virtual HRESULT __stdcall add_CompositionScaleChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CompositionScaleChanged(event_token token) = 0;
    virtual HRESULT __stdcall CreateCoreIndependentInputSource(Windows::UI::Core::CoreInputDeviceTypes deviceTypes, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainPanelFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwapChainPanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CompositionScaleXProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CompositionScaleYProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_LeftItems(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_RightItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_RightItems(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TopItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_TopItems(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BottomItems(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_BottomItems(::IUnknown* value) = 0;
    virtual HRESULT __stdcall Close() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LeftItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RightItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TopItemsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BottomItemsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
    virtual HRESULT __stdcall get_IconSource(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_IconSource(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Background(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Background(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Command(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Command(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_CommandParameter(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_CommandParameter(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_BehaviorOnInvoked(Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked* value) = 0;
    virtual HRESULT __stdcall put_BehaviorOnInvoked(Windows::UI::Xaml::Controls::SwipeBehaviorOnInvoked value) = 0;
    virtual HRESULT __stdcall add_Invoked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Invoked(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItemInvokedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SwipeControl(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IconSourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BackgroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CommandProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CommandParameterProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BehaviorOnInvokedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItems>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Mode(Windows::UI::Xaml::Controls::SwipeMode* value) = 0;
    virtual HRESULT __stdcall put_Mode(Windows::UI::Xaml::Controls::SwipeMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItemsFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISwipeItemsStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIcon>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Symbol(Windows::UI::Xaml::Controls::Symbol* value) = 0;
    virtual HRESULT __stdcall put_Symbol(Windows::UI::Xaml::Controls::Symbol value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIconFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstanceWithSymbol(Windows::UI::Xaml::Controls::Symbol symbol, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIconSource>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Symbol(Windows::UI::Xaml::Controls::Symbol* value) = 0;
    virtual HRESULT __stdcall put_Symbol(Windows::UI::Xaml::Controls::Symbol value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIconSourceFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIconSourceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SymbolProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ISymbolIconStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SymbolProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSize(double* value) = 0;
    virtual HRESULT __stdcall put_FontSize(double value) = 0;
    virtual HRESULT __stdcall get_FontFamily(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_FontFamily(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_FontWeight(struct_of<2>* value) = 0;
    virtual HRESULT __stdcall put_FontWeight(struct_of<2> value) = 0;
    virtual HRESULT __stdcall get_FontStyle(Windows::UI::Text::FontStyle* value) = 0;
    virtual HRESULT __stdcall put_FontStyle(Windows::UI::Text::FontStyle value) = 0;
    virtual HRESULT __stdcall get_FontStretch(Windows::UI::Text::FontStretch* value) = 0;
    virtual HRESULT __stdcall put_FontStretch(Windows::UI::Text::FontStretch value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacing(int32_t* value) = 0;
    virtual HRESULT __stdcall put_CharacterSpacing(int32_t value) = 0;
    virtual HRESULT __stdcall get_Foreground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Foreground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TextWrapping(Windows::UI::Xaml::TextWrapping* value) = 0;
    virtual HRESULT __stdcall put_TextWrapping(Windows::UI::Xaml::TextWrapping value) = 0;
    virtual HRESULT __stdcall get_TextTrimming(Windows::UI::Xaml::TextTrimming* value) = 0;
    virtual HRESULT __stdcall put_TextTrimming(Windows::UI::Xaml::TextTrimming value) = 0;
    virtual HRESULT __stdcall get_TextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_TextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Inlines(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Padding(struct_of<32>* value) = 0;
    virtual HRESULT __stdcall put_Padding(struct_of<32> value) = 0;
    virtual HRESULT __stdcall get_LineHeight(double* value) = 0;
    virtual HRESULT __stdcall put_LineHeight(double value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy* value) = 0;
    virtual HRESULT __stdcall put_LineStackingStrategy(Windows::UI::Xaml::LineStackingStrategy value) = 0;
    virtual HRESULT __stdcall get_IsTextSelectionEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextSelectionEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_SelectedText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_ContentStart(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ContentEnd(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionStart(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionEnd(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_BaselineOffset(double* value) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ContextMenuOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContextMenuOpening(event_token token) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
    virtual HRESULT __stdcall Select(::IUnknown* start, ::IUnknown* end) = 0;
    virtual HRESULT __stdcall Focus(Windows::UI::Xaml::FocusState value, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_MaxLines(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLines(int32_t value) = 0;
    virtual HRESULT __stdcall get_TextLineBounds(Windows::UI::Xaml::TextLineBounds* value) = 0;
    virtual HRESULT __stdcall put_TextLineBounds(Windows::UI::Xaml::TextLineBounds value) = 0;
    virtual HRESULT __stdcall get_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment* value) = 0;
    virtual HRESULT __stdcall put_OpticalMarginAlignment(Windows::UI::Xaml::OpticalMarginAlignment value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsColorFontEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder* value) = 0;
    virtual HRESULT __stdcall put_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextScaleFactorEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetAlphaMask(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextDecorations(Windows::UI::Text::TextDecorations* value) = 0;
    virtual HRESULT __stdcall put_TextDecorations(Windows::UI::Text::TextDecorations value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlock6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmed(bool* value) = 0;
    virtual HRESULT __stdcall get_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_TextHighlighters(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_IsTextTrimmedChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_IsTextTrimmedChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlockStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_FontSizeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontFamilyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontWeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStyleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_FontStretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterSpacingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ForegroundProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextWrappingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextTrimmingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PaddingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_LineStackingStrategyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextSelectionEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectedTextProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlockStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxLinesProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextLineBoundsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OpticalMarginAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlockStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextScaleFactorEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlockStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextDecorationsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBlockStatics6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsTextTrimmedProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalTextAlignmentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Text(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_Text(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectedText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SelectedText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectionLength(int32_t* value) = 0;
    virtual HRESULT __stdcall put_SelectionLength(int32_t value) = 0;
    virtual HRESULT __stdcall get_SelectionStart(int32_t* value) = 0;
    virtual HRESULT __stdcall put_SelectionStart(int32_t value) = 0;
    virtual HRESULT __stdcall get_MaxLength(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaxLength(int32_t value) = 0;
    virtual HRESULT __stdcall get_IsReadOnly(bool* value) = 0;
    virtual HRESULT __stdcall put_IsReadOnly(bool value) = 0;
    virtual HRESULT __stdcall get_AcceptsReturn(bool* value) = 0;
    virtual HRESULT __stdcall put_AcceptsReturn(bool value) = 0;
    virtual HRESULT __stdcall get_TextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_TextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_TextWrapping(Windows::UI::Xaml::TextWrapping* value) = 0;
    virtual HRESULT __stdcall put_TextWrapping(Windows::UI::Xaml::TextWrapping value) = 0;
    virtual HRESULT __stdcall get_IsSpellCheckEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsSpellCheckEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsTextPredictionEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsTextPredictionEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_InputScope(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_InputScope(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_TextChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_SelectionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_SelectionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_ContextMenuOpening(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContextMenuOpening(event_token token) = 0;
    virtual HRESULT __stdcall Select(int32_t start, int32_t length) = 0;
    virtual HRESULT __stdcall SelectAll() = 0;
    virtual HRESULT __stdcall GetRectFromCharacterIndex(int32_t charIndex, bool trailingEdge, Windows::Foundation::Rect* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PlaceholderText(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_PlaceholderText(HSTRING value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColor(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColor(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocus(bool* value) = 0;
    virtual HRESULT __stdcall put_PreventKeyboardDisplayOnProgrammaticFocus(bool value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsColorFontEnabled(bool value) = 0;
    virtual HRESULT __stdcall add_Paste(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Paste(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall add_TextCompositionStarted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionStarted(event_token token) = 0;
    virtual HRESULT __stdcall add_TextCompositionChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_TextCompositionEnded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextCompositionEnded(event_token token) = 0;
    virtual HRESULT __stdcall get_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder* value) = 0;
    virtual HRESULT __stdcall put_TextReadingOrder(Windows::UI::Xaml::TextReadingOrder value) = 0;
    virtual HRESULT __stdcall get_DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment* value) = 0;
    virtual HRESULT __stdcall put_DesiredCandidateWindowAlignment(Windows::UI::Xaml::Controls::CandidateWindowAlignment value) = 0;
    virtual HRESULT __stdcall add_CandidateWindowBoundsChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CandidateWindowBoundsChanged(event_token token) = 0;
    virtual HRESULT __stdcall add_TextChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TextChanging(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall GetLinguisticAlternativesAsync(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColorWhenNotFocused(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_SelectionHighlightColorWhenNotFocused(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBox6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalTextAlignment(Windows::UI::Xaml::TextAlignment value) = 0;
    virtual HRESULT __stdcall get_CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing* value) = 0;
    virtual HRESULT __stdcall put_CharacterCasing(Windows::UI::Xaml::Controls::CharacterCasing value) = 0;
    virtual HRESULT __stdcall get_PlaceholderForeground(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PlaceholderForeground(::IUnknown* value) = 0;
    virtual HRESULT __stdcall add_CopyingToClipboard(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CopyingToClipboard(event_token token) = 0;
    virtual HRESULT __stdcall add_CuttingToClipboard(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CuttingToClipboard(event_token token) = 0;
    virtual HRESULT __stdcall add_BeforeTextChanging(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_BeforeTextChanging(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxBeforeTextChangingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_NewText(HSTRING* value) = 0;
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_TextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaxLengthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsReadOnlyProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AcceptsReturnProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextWrappingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSpellCheckEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsTextPredictionEnabledProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_InputScopeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderTextProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SelectionHighlightColorProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PreventKeyboardDisplayOnProgrammaticFocusProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsColorFontEnabledProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DesiredCandidateWindowAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TextReadingOrderProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SelectionHighlightColorWhenNotFocusedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxStatics6>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalTextAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CharacterCasingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlaceholderForegroundProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextBoxTextChangingEventArgs2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsContentChanging(bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextChangedEventArgs>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextCompositionChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_StartIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Length(int32_t* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextCompositionEndedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_StartIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Length(int32_t* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextCompositionStartedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_StartIndex(int32_t* value) = 0;
    virtual HRESULT __stdcall get_Length(int32_t* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextControlCopyingToClipboardEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextControlCuttingToClipboardEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITextControlPasteEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OldTime(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall get_NewTime(Windows::Foundation::TimeSpan* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePicker>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ClockIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_ClockIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_MinuteIncrement(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MinuteIncrement(int32_t value) = 0;
    virtual HRESULT __stdcall get_Time(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall put_Time(Windows::Foundation::TimeSpan value) = 0;
    virtual HRESULT __stdcall add_TimeChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TimeChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePicker2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode* value) = 0;
    virtual HRESULT __stdcall put_LightDismissOverlayMode(Windows::UI::Xaml::Controls::LightDismissOverlayMode value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerFlyout>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClockIdentifier(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_ClockIdentifier(HSTRING value) = 0;
    virtual HRESULT __stdcall get_Time(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall put_Time(Windows::Foundation::TimeSpan value) = 0;
    virtual HRESULT __stdcall get_MinuteIncrement(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MinuteIncrement(int32_t value) = 0;
    virtual HRESULT __stdcall add_TimePicked(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_TimePicked(event_token token) = 0;
    virtual HRESULT __stdcall ShowAtAsync(::IUnknown* target, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerFlyoutPresenter>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerFlyoutStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ClockIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TimeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinuteIncrementProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ClockIdentifierProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MinuteIncrementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_TimeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_LightDismissOverlayModeProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ITimePickerValueChangedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_OldTime(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall get_NewTime(Windows::Foundation::TimeSpan* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItem>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsChecked(bool* value) = 0;
    virtual HRESULT __stdcall put_IsChecked(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleMenuFlyoutItemStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsCheckedProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleSwitch>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsOn(bool* value) = 0;
    virtual HRESULT __stdcall put_IsOn(bool value) = 0;
    virtual HRESULT __stdcall get_Header(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Header(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_HeaderTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OnContent(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OnContent(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OnContentTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OnContentTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OffContent(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OffContent(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_OffContentTemplate(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_OffContentTemplate(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_Toggled(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Toggled(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleSwitchOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnToggled() = 0;
    virtual HRESULT __stdcall OnOnContentChanged(::IUnknown* oldContent, ::IUnknown* newContent) = 0;
    virtual HRESULT __stdcall OnOffContentChanged(::IUnknown* oldContent, ::IUnknown* newContent) = 0;
    virtual HRESULT __stdcall OnHeaderChanged(::IUnknown* oldContent, ::IUnknown* newContent) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToggleSwitchStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsOnProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HeaderTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OnContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OnContentTemplateProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OffContentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OffContentTemplateProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToolTip>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalOffset(double* value) = 0;
    virtual HRESULT __stdcall put_HorizontalOffset(double value) = 0;
    virtual HRESULT __stdcall get_IsOpen(bool* value) = 0;
    virtual HRESULT __stdcall put_IsOpen(bool value) = 0;
    virtual HRESULT __stdcall get_Placement(Windows::UI::Xaml::Controls::Primitives::PlacementMode* value) = 0;
    virtual HRESULT __stdcall put_Placement(Windows::UI::Xaml::Controls::Primitives::PlacementMode value) = 0;
    virtual HRESULT __stdcall get_PlacementTarget(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_PlacementTarget(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_VerticalOffset(double* value) = 0;
    virtual HRESULT __stdcall put_VerticalOffset(double value) = 0;
    virtual HRESULT __stdcall get_TemplateSettings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_Closed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Closed(event_token token) = 0;
    virtual HRESULT __stdcall add_Opened(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_Opened(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToolTipFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToolTipService>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToolTipServiceStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetPlacement(::IUnknown* element, Windows::UI::Xaml::Controls::Primitives::PlacementMode* value) = 0;
    virtual HRESULT __stdcall SetPlacement(::IUnknown* element, Windows::UI::Xaml::Controls::Primitives::PlacementMode value) = 0;
    virtual HRESULT __stdcall get_PlacementTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetPlacementTarget(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetPlacementTarget(::IUnknown* element, ::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_ToolTipProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetToolTip(::IUnknown* element, ::IUnknown** value) = 0;
    virtual HRESULT __stdcall SetToolTip(::IUnknown* element, ::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IToolTipStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_HorizontalOffsetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsOpenProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlacementProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PlacementTargetProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalOffsetProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IUIElementCollection>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall Move(uint32_t oldIndex, uint32_t newIndex) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IUserControl>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Content(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Content(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IUserControlFactory>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstance(::IUnknown* outer, ::IUnknown** inner, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IUserControlStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContentProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVariableSizedWrapGrid>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemHeight(double* value) = 0;
    virtual HRESULT __stdcall put_ItemHeight(double value) = 0;
    virtual HRESULT __stdcall get_ItemWidth(double* value) = 0;
    virtual HRESULT __stdcall put_ItemWidth(double value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumns(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaximumRowsOrColumns(int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVariableSizedWrapGridStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalChildrenAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalChildrenAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumnsProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_RowSpanProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetRowSpan(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetRowSpan(::IUnknown* element, int32_t value) = 0;
    virtual HRESULT __stdcall get_ColumnSpanProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetColumnSpan(::IUnknown* element, int32_t* value) = 0;
    virtual HRESULT __stdcall SetColumnSpan(::IUnknown* element, int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IViewbox>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Child(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Child(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_Stretch(Windows::UI::Xaml::Media::Stretch* value) = 0;
    virtual HRESULT __stdcall put_Stretch(Windows::UI::Xaml::Media::Stretch value) = 0;
    virtual HRESULT __stdcall get_StretchDirection(Windows::UI::Xaml::Controls::StretchDirection* value) = 0;
    virtual HRESULT __stdcall put_StretchDirection(Windows::UI::Xaml::Controls::StretchDirection value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IViewboxStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_StretchProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_StretchDirectionProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemContainerGenerator(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingPanelFactory>{ struct type : ::IInspectable
{
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingPanelOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnItemsChanged(::IUnknown* sender, ::IUnknown* args) = 0;
    virtual HRESULT __stdcall OnClearChildren() = 0;
    virtual HRESULT __stdcall BringIndexIntoView(int32_t index) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingPanelProtected>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall AddInternalChild(::IUnknown* child) = 0;
    virtual HRESULT __stdcall InsertInternalChild(int32_t index, ::IUnknown* child) = 0;
    virtual HRESULT __stdcall RemoveInternalChildRange(int32_t index, int32_t range) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingStackPanel>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreScrollSnapPointsRegular(bool* value) = 0;
    virtual HRESULT __stdcall put_AreScrollSnapPointsRegular(bool value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall add_CleanUpVirtualizedItemEvent(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_CleanUpVirtualizedItemEvent(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingStackPanelOverrides>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall OnCleanUpVirtualizedItem(::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IVirtualizingStackPanelStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AreScrollSnapPointsRegularProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VirtualizationModeProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetVirtualizationMode(::IUnknown* element, Windows::UI::Xaml::Controls::VirtualizationMode* value) = 0;
    virtual HRESULT __stdcall SetVirtualizationMode(::IUnknown* element, Windows::UI::Xaml::Controls::VirtualizationMode value) = 0;
    virtual HRESULT __stdcall get_IsVirtualizingProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall GetIsVirtualizing(::IUnknown* o, bool* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebView>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Source(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_Source(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_AllowedScriptNotifyUris(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_AllowedScriptNotifyUris(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_DataTransferPackage(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_LoadCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_LoadCompleted(event_token token) = 0;
    virtual HRESULT __stdcall add_ScriptNotify(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ScriptNotify(event_token token) = 0;
    virtual HRESULT __stdcall add_NavigationFailed(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NavigationFailed(event_token token) = 0;
    virtual HRESULT __stdcall InvokeScript(HSTRING scriptName, uint32_t __argumentsSize, HSTRING* arguments, HSTRING* returnValue) = 0;
    virtual HRESULT __stdcall Navigate(::IUnknown* source) = 0;
    virtual HRESULT __stdcall NavigateToString(HSTRING text) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebView2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CanGoBack(bool* value) = 0;
    virtual HRESULT __stdcall get_CanGoForward(bool* value) = 0;
    virtual HRESULT __stdcall get_DocumentTitle(HSTRING* value) = 0;
    virtual HRESULT __stdcall add_NavigationStarting(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NavigationStarting(event_token token) = 0;
    virtual HRESULT __stdcall add_ContentLoading(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContentLoading(event_token token) = 0;
    virtual HRESULT __stdcall add_DOMContentLoaded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_DOMContentLoaded(event_token token) = 0;
    virtual HRESULT __stdcall GoForward() = 0;
    virtual HRESULT __stdcall GoBack() = 0;
    virtual HRESULT __stdcall Refresh() = 0;
    virtual HRESULT __stdcall Stop() = 0;
    virtual HRESULT __stdcall CapturePreviewToStreamAsync(::IUnknown* stream, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall InvokeScriptAsync(HSTRING scriptName, ::IUnknown* arguments, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall CaptureSelectedContentToDataPackageAsync(::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall NavigateToLocalStreamUri(::IUnknown* source, ::IUnknown* streamResolver) = 0;
    virtual HRESULT __stdcall BuildLocalStreamUri(HSTRING contentIdentifier, HSTRING relativePath, ::IUnknown** returnValue) = 0;
    virtual HRESULT __stdcall get_DefaultBackgroundColor(struct_of<4>* value) = 0;
    virtual HRESULT __stdcall put_DefaultBackgroundColor(struct_of<4> value) = 0;
    virtual HRESULT __stdcall add_NavigationCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NavigationCompleted(event_token token) = 0;
    virtual HRESULT __stdcall add_FrameNavigationStarting(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FrameNavigationStarting(event_token token) = 0;
    virtual HRESULT __stdcall add_FrameContentLoading(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FrameContentLoading(event_token token) = 0;
    virtual HRESULT __stdcall add_FrameDOMContentLoaded(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FrameDOMContentLoaded(event_token token) = 0;
    virtual HRESULT __stdcall add_FrameNavigationCompleted(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_FrameNavigationCompleted(event_token token) = 0;
    virtual HRESULT __stdcall add_LongRunningScriptDetected(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_LongRunningScriptDetected(event_token token) = 0;
    virtual HRESULT __stdcall add_UnsafeContentWarningDisplaying(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_UnsafeContentWarningDisplaying(event_token token) = 0;
    virtual HRESULT __stdcall add_UnviewableContentIdentified(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_UnviewableContentIdentified(event_token token) = 0;
    virtual HRESULT __stdcall NavigateWithHttpRequestMessage(::IUnknown* requestMessage) = 0;
    virtual HRESULT __stdcall Focus(Windows::UI::Xaml::FocusState value, bool* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebView3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContainsFullScreenElement(bool* value) = 0;
    virtual HRESULT __stdcall add_ContainsFullScreenElementChanged(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_ContainsFullScreenElementChanged(event_token token) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebView4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ExecutionMode(Windows::UI::Xaml::Controls::WebViewExecutionMode* value) = 0;
    virtual HRESULT __stdcall get_DeferredPermissionRequests(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Settings(::IUnknown** value) = 0;
    virtual HRESULT __stdcall add_UnsupportedUriSchemeIdentified(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_UnsupportedUriSchemeIdentified(event_token token) = 0;
    virtual HRESULT __stdcall add_NewWindowRequested(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_NewWindowRequested(event_token token) = 0;
    virtual HRESULT __stdcall add_PermissionRequested(::IUnknown* value, event_token* token) = 0;
    virtual HRESULT __stdcall remove_PermissionRequested(event_token token) = 0;
    virtual HRESULT __stdcall AddWebAllowedObject(HSTRING name, ::IUnknown* pObject) = 0;
    virtual HRESULT __stdcall DeferredPermissionRequestById(uint32_t id, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebView5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_XYFocusLeft(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusLeft(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusRight(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusRight(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusUp(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusUp(::IUnknown* value) = 0;
    virtual HRESULT __stdcall get_XYFocusDown(::IUnknown** value) = 0;
    virtual HRESULT __stdcall put_XYFocusDown(::IUnknown* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewBrush>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SourceName(HSTRING* value) = 0;
    virtual HRESULT __stdcall put_SourceName(HSTRING value) = 0;
    virtual HRESULT __stdcall Redraw() = 0;
    virtual HRESULT __stdcall SetSource(::IUnknown* source) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewBrushStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_SourceNameProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewContentLoadingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewDOMContentLoadedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewDeferredPermissionRequest>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PermissionType(Windows::UI::Xaml::Controls::WebViewPermissionType* value) = 0;
    virtual HRESULT __stdcall get_Id(uint32_t* value) = 0;
    virtual HRESULT __stdcall Allow() = 0;
    virtual HRESULT __stdcall Deny() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewFactory4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall CreateInstanceWithExecutionMode(Windows::UI::Xaml::Controls::WebViewExecutionMode executionMode, ::IUnknown** instance) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewLongRunningScriptDetectedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ExecutionTime(Windows::Foundation::TimeSpan* value) = 0;
    virtual HRESULT __stdcall get_StopPageScriptExecution(bool* value) = 0;
    virtual HRESULT __stdcall put_StopPageScriptExecution(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewNavigationCompletedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_IsSuccess(bool* value) = 0;
    virtual HRESULT __stdcall get_WebErrorStatus(Windows::Web::WebErrorStatus* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewNavigationFailedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_WebErrorStatus(Windows::Web::WebErrorStatus* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewNavigationStartingEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Cancel(bool* value) = 0;
    virtual HRESULT __stdcall put_Cancel(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewNewWindowRequestedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Referrer(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewPermissionRequest>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_PermissionType(Windows::UI::Xaml::Controls::WebViewPermissionType* value) = 0;
    virtual HRESULT __stdcall get_Id(uint32_t* value) = 0;
    virtual HRESULT __stdcall get_State(Windows::UI::Xaml::Controls::WebViewPermissionState* value) = 0;
    virtual HRESULT __stdcall Defer() = 0;
    virtual HRESULT __stdcall Allow() = 0;
    virtual HRESULT __stdcall Deny() = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewPermissionRequestedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_PermissionRequest(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewSettings>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_IsJavaScriptEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsJavaScriptEnabled(bool value) = 0;
    virtual HRESULT __stdcall get_IsIndexedDBEnabled(bool* value) = 0;
    virtual HRESULT __stdcall put_IsIndexedDBEnabled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_AnyScriptNotifyUri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_SourceProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_AllowedScriptNotifyUrisProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DataTransferPackageProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewStatics2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_CanGoBackProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_CanGoForwardProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DocumentTitleProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_DefaultBackgroundColorProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewStatics3>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ContainsFullScreenElementProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewStatics4>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_DefaultExecutionMode(Windows::UI::Xaml::Controls::WebViewExecutionMode* value) = 0;
    virtual HRESULT __stdcall ClearTemporaryWebDataAsync(::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewStatics5>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_XYFocusLeftProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusRightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusUpProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_XYFocusDownProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewUnsupportedUriSchemeIdentifiedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Handled(bool* value) = 0;
    virtual HRESULT __stdcall put_Handled(bool value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_Uri(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_Referrer(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWebViewUnviewableContentIdentifiedEventArgs2>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_MediaType(HSTRING* value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWrapGrid>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemWidth(double* value) = 0;
    virtual HRESULT __stdcall put_ItemWidth(double value) = 0;
    virtual HRESULT __stdcall get_ItemHeight(double* value) = 0;
    virtual HRESULT __stdcall put_ItemHeight(double value) = 0;
    virtual HRESULT __stdcall get_Orientation(Windows::UI::Xaml::Controls::Orientation* value) = 0;
    virtual HRESULT __stdcall put_Orientation(Windows::UI::Xaml::Controls::Orientation value) = 0;
    virtual HRESULT __stdcall get_HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment* value) = 0;
    virtual HRESULT __stdcall put_HorizontalChildrenAlignment(Windows::UI::Xaml::HorizontalAlignment value) = 0;
    virtual HRESULT __stdcall get_VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment* value) = 0;
    virtual HRESULT __stdcall put_VerticalChildrenAlignment(Windows::UI::Xaml::VerticalAlignment value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumns(int32_t* value) = 0;
    virtual HRESULT __stdcall put_MaximumRowsOrColumns(int32_t value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::IWrapGridStatics>{ struct type : ::IInspectable
{
    virtual HRESULT __stdcall get_ItemWidthProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_ItemHeightProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_OrientationProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_HorizontalChildrenAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_VerticalChildrenAlignmentProperty(::IUnknown** value) = 0;
    virtual HRESULT __stdcall get_MaximumRowsOrColumnsProperty(::IUnknown** value) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::BackClickEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::CalendarViewDayItemChangingEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::CleanUpVirtualizedItemEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ContextMenuOpeningEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::DragItemsStartingEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::HubSectionHeaderClickEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ItemClickEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ListViewItemToKeyHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* item, HSTRING* returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::ListViewKeyToItemHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(HSTRING key, ::IUnknown** returnValue) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::NotifyEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::SectionsInViewChangedEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::SelectionChangedEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::SemanticZoomViewChangedEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::TextChangedEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::TextControlPasteEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

template <> struct abi<Windows::UI::Xaml::Controls::WebViewNavigationFailedEventHandler>{ struct type : ::IUnknown
{
    virtual HRESULT __stdcall Invoke(::IUnknown* sender, ::IUnknown* e) = 0;
};};

}
